#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================
os=`uname -s`
otab=/etc/oratab
host=`hostname | awk -F'.' '{print $1}'`

SU_OPT=-m

if [ "$os" != "Linux" ]; then
    SU_OPT=
fi

awkc=awk
ZOPT=-e
if [ $os = "SunOS" ]; then
   otab=/var/opt/oracle/oratab
   awkc=nawk
   GBLZONE=`zoneadm list -v 2>/dev/null |grep global |wc -l`
   PS_ZOPT="-e"
   if [ $GBLZONE -ne 0 ];
   then
       ZOPT=-z0
   fi
fi

if [ ! -f "$otab" ]; then
   otab=/act/act_scripts/actoratab
fi

if [ ! -z "$orahome" ]; then
    oraclehome=$orahome
else
   inst_pid=`ps -f $ZOPT | grep -w ora_pmon_"$instid" | grep -vw grep | sort | head -1 | $awkc '{print $2}'`
   if [ $os = "AIX" ]; then
       full_path=`ls -l /proc/$inst_pid/cwd | $awkc '{print $NF}'`
       oraclehome=`dirname $full_path`
   else
       if [ $os = "HP-UX" ]; then
           oraclehome=`pfiles $inst_pid | grep '/bin/' |grep $inst_pid | $awkc '{print $NF}' | $awkc -F'/bin/' '{print $1}'`
       else
           full_path=`pwdx $inst_pid | $awkc '{print $NF}'`
           oraclehome=`dirname $full_path`
       fi
   fi
fi

ohlen=`echo $oraclehome | wc -c`
if [ $ohlen -lt 3 ]; then
   oraclehome=''
fi

if [ -z "$oraclehome" ]; then
    for inst_pid in `ps -f $ZOPT | grep -i pmon_"$sid" | grep -vw grep | $awkc '{print $2}'`
    do

        if [ $os = "AIX" ]; then
            full_path=`ls -l /proc/$inst_pid/cwd | $awkc '{print $NF}'`
            oraclehome=`dirname $full_path`
        elif [ $os = "HP-UX" ]; then
            oraclehome=`pfiles $inst_pid | grep '/bin/' |grep -w $inst_pid | $awkc '{print $NF}' | $awkc -F'/bin/' '{print $1}'`
        else
            full_path=`pwdx $inst_pid | $awkc '{print $NF}'`
            oraclehome=`dirname $full_path`
        fi
        export PATH=$oraclehome/bin:$PATH
        export ORACLE_HOME=$oraclehome

        # Run the SRVCTL command to get the instance

        inst_name=`srvctl status database -d $sid| grep $host | awk '{print $2}'`
        retval=$?
        if [ "$inst_name" == "$instid" ]; then
            break;
        fi
        if [ "$retval" -ne 0 ]; then
            oraclehome=""
            continue;
        else
            newpid=`ps -f $ZOPT | grep -w ora_pmon_"$instid" |grep -vw grep | head -1 | $awkc '{print $2}'`
            if [ $os = "AIX" ]; then
                full_path=`ls -l /proc/$newpid/cwd | $awkc '{print $NF}'`
                oraclehomenew=`dirname $full_path`
            elif [ $os = "HP-UX" ]; then
                oraclehomenew=`pfiles $newpid | grep '/bin/' |grep $newpid | $awkc '{print $NF}' | $awkc -F'/bin/' '{print $1}'`
            else
                full_path=`pwdx $newpid | $awkc '{print $NF}'`
                oraclehomenew=`dirname $full_path`
            fi
            if [ "$oraclehome" != "$oraclehomenew" ]; then
                oraclehome=$oraclehomenew
                break;
            fi
        fi
    done
fi

if [ -z "$oraclehome" ]; then
   inst_pid=`ps -f $ZOPT | grep -i pmon_"$sid" | grep -vw grep | sort | head -1 | $awkc '{print $2}'`
   if [ $os = "AIX" ]; then
       full_path=`ls -l /proc/$inst_pid/cwd | $awkc '{print $NF}'`
       oraclehome=`dirname $full_path`
   else
       if [ $os = "HP-UX" ]; then
           oraclehome=`pfiles $inst_pid | grep '/bin/' |grep $inst_pid | $awkc '{print $NF}' | $awkc -F'/bin/' '{print $1}'`
       else
           full_path=`pwdx $inst_pid | $awkc '{print $NF}'`
           oraclehome=`dirname $full_path`
       fi
   fi
fi

if [ -z "$oraclehome" ]; then
   inst_pid=`ps -f $ZOPT | grep -i pmon_"$sid" | grep -vw grep | sort | head -1 | $awkc '{print $2}'`
   if [ $os = "AIX" ]; then
       full_path=`ls -l /proc/$inst_pid/cwd | $awkc '{print $NF}'`
       oraclehome=`dirname $full_path`
   else
       if [ $os = "HP-UX" ]; then
           oraclehome=`pfiles $inst_pid | grep '/bin/' |grep $inst_pid | $awkc '{print $NF}' | $awkc -F'/bin/' '{print $1}'`
       else
           full_path=`pwdx $inst_pid | $awkc '{print $NF}'`
           oraclehome=`dirname $full_path`
       fi
   fi
fi

nllen=`echo $nlistener | wc -c`
if [ $nllen -lt 3 ]; then
   nlistener=''
fi
TNSDIR=''
if [ -z "$nlistener" ]; then
   TNSDIR=`ps -f $ZOPT | grep tns | grep -v grep | grep -i listener | $awkc NR==1 | $awkc -F"/bin" '{print $(NF-1)}' | awk '{print $NF}'`
else
   TNSDIR=`ps -f $ZOPT | grep tns | grep -v grep | grep -i $nlistener | $awkc NR==1 | $awkc -F"/bin" '{print $(NF-1)}' | awk '{print $NF}'`
   if [ ! -d "$TNSDIR" ]; then
      TNSDIR=`ps -f $ZOPT | grep tns | grep -v grep | grep -i -w $nlistener | $awkc NR==1 |  $awkc -F"/bin" '{print $(NF-1)}' | awk '{print $NF}'`
   fi
fi

TNS_ADMIN=$TNSDIR/network/admin
tnsdir="/act/act_scripts/TNSADMIN_"$sid".tns"
if [ -f $tnsdir ]; then
   TNS_ADMIN=`cat $tnsdir`
fi

if [ -z "$ORACLE_BASE" ]; then
   oraclebase=`sed -n '/<PROPERTY NAME="ORACLE_BASE"/s/.*VAL="\(.*\)"[^\n]*/\1/p' $oraclehome/inventory/ContentsXML/oraclehomeproperties.xml`
   ORACLE_BASE=$oraclebase
fi

PATH=$oraclehome/bin:$PATH
ORACLE_HOME=$oraclehome
ORACLE_SID=$instid
if [ $os = "SunOS" ]; then
    LD_LIBRARY_PATH_64=$oraclehome/lib${LD_LIBRARY_PATH_64:+:$LD_LIBRARY_PATH_64}
    export LD_LIBRARY_PATH_64
fi
LD_LIBRARY_PATH=$oraclehome/lib${LD_LIBRARY_PATH:+:$LD_LIBRARY_PATH}
export PATH
export ORACLE_SID
export ORACLE_HOME
export ORACLE_BASE
export TNS_ADMIN
export LD_LIBRARY_PATH
