#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#
LIMIT=$1
FROM_DATE=$2
FROM_TIME=$3
END_DATE=$4
END_TIME=$5

if [ -z "$LIMIT" ]; then
    LIMIT=20
fi

if [ $LIMIT -lt 20 ]; then
    LIMIT=20
fi

LOGBASEPATH=/var/act/log/cafEnvDetail
SCRIPTPATH=/act/act_scripts/diag

set -x
### HANA ####
ps -ef | grep -i hdbnameserver | grep -v grep | awk '{print $1}' | while read line
do
    #get dbsid
    DBSID=`echo $line | cut -c 1-3`
    if [ ! -z "$DBSID" ]; then
        if [ ! -z "$FROM_TIME" ] && [ ! -z "$END_TIME" ]; then
            ${SCRIPTPATH}/hanaEnvDetail.sh HANA $DBSID $LOGBASEPATH $LIMIT "$FROM_DATE $FROM_TIME" "$END_DATE $END_TIME"
        else
            ${SCRIPTPATH}/hanaEnvDetail.sh HANA $DBSID $LOGBASEPATH $LIMIT
         fi
    fi
done

#### DB2 ####
#for OSUSERS in $(ps -ef | grep db2sysc |grep -v grep|awk '{print $1}' |xargs);do
# echo " CALL DB2 diag collection "
#done

rm -f ${LOGBASEPATH}.tar.gz
tar -czvf ${LOGBASEPATH}.tar.gz ${LOGBASEPATH}
#rm -rf ${LOGBASEPATH}

#echo "Full DUMP is located : ${LOGBASEPATH}.tar.gz"
exit 0
