#!/bin/sh
set +x

dbsid=$1
dbid=$2
oraclehome=$3
#dbsid=satdb2
#dbid=satdb

if [ "$#" -lt 3 ]; then
 echo "This script needs 3 input parameter"
 echo "usage: oraEnvDetail.sh <database sid name> <database name> <oracleHome>"
exit 1
fi


os=`uname -s`
otab=/etc/oratab

orauser=`ps -ef | grep ora_pmon_"$dbsid" | grep -vw grep | head -1 | sed -e 's/^[ \t]*//' | cut -d" " -f1`

awkc=awk
if [ $os = "SunOS" ]; then
   otab=/var/opt/oracle/oratab
   awkc=nawk
fi

#oraclehome=`grep -wi "$dbsid:"  $otab | grep "^$dbsid" | head -n1 | cut -f2 -d":"`
#if [ -z "$oraclehome" ]; then
#oraclehome=`grep -wi "$dbid:"  $otab | grep "^$dbid" | head -n1 | cut -f2 -d":"`
#fi

PATH=$oraclehome/bin:$PATH
ORACLE_HOME=$oraclehome
ORACLE_SID=$dbsid
LD_LIBRARY_PATH=$oraclehome/lib${LD_LIBRARY_PATH:+:$LD_LIBRARY_PATH}
export PATH
export ORACLE_SID
export ORACLE_HOME
export LD_LIBRARY_PATH


echo "********** ORACLE running process result (ps -ef) ************" 

ps -ef | grep pmon 

echo "********** ORACLE oratab entry (cat /etc/oratab) ************" 

cat $otab 


echo "********** Protected ORACLE database details ************" 


if [ "$os" != "Linux" ]; then
su $orauser -c "$ORACLE_HOME/bin/sqlplus -s / as sysdba @/act/act_scripts/oraEnvDetail.sql"
else
su -m $orauser -c "$ORACLE_HOME/bin/sqlplus -s / as sysdba @/act/act_scripts/oraEnvDetail.sql" 
fi

echo "********** Protected ORACLE database RMAN details ************" 

if [ "$os" != "Linux" ]; then
su $orauser -c "$ORACLE_HOME/bin/rman target / " << EOF
show all;
EOF
else
su -m $orauser -c "$ORACLE_HOME/bin/rman target / " << EOF
show all;
EOF
fi

echo "********** Protected ORACLE database Opatch inventory Details ************"

if [ "$os" != "Linux" ]; then
su $orauser -c "$ORACLE_HOME/OPatch/opatch lsinventory" 
else
su -m $orauser -c "$ORACLE_HOME/OPatch/opatch lsinventory" 
fi

echo "********** Protected ORACLE database ASM Details ************" 

isGridExists=`ps -ef | grep "asm_pmon_+ASM" |grep -vw grep| wc -l`
if [ $isGridExists -eq 0 ]; then
   echo "********** ASM process not running ************"
   exit
else
    ASMS=`ps -ef | grep asm_pmon_+ASM | grep -vw grep | sort | head -1 | sed 's/.*asm_pmon_//g'`
    inst_pid=`ps -ef | grep asm_pmon_+ASM | grep -vw grep | sort | head -1 | $awkc '{print $2}'`
    if [ $os = "AIX" ]; then
        full_path=`ls -l /proc/$inst_pid/cwd | $awkc '{print $NF}'`
        ASMHOME=`dirname $full_path`
    else
        if [ $os = "HP-UX" ]; then
            ASMHOME=`pfiles $inst_pid | grep '/bin/' |grep $inst_pid | $awkc '{print $NF}' | $awkc -F'/bin/' '{print $1}'`
        else
            full_path=`pwdx $inst_pid | $awkc '{print $NF}'`
            ASMHOME=`dirname $full_path`
        fi
    fi
fi

if [ -z "$ASMS" ]; then
   echo "********** ASM Details not available ************"
   ASMHOME=''
fi

if [ -z "$ASMHOME" ]; then
   echo "********** ASM Details not available ************" 
   exit
else
    echo "asm home:$ASMHOME"
fi

ORACLE_HOME=$ASMHOME
LD_LIBRARY_PATH=$ASMHOME/lib:/usr/lib:/lib
PATH=$ASMHOME/bin:$PATH
ORACLE_SID="$ASMS"
asmcmd=$ASMHOME/bin/asmcmd
export ORACLE_HOME
export LD_LIBRARY_PATH
export PATH
export ORACLE_SID

guser=`ps -ef | grep _pmon_ | grep $ORACLE_SID | grep -vw grep | head -1 | sed -e 's/^[ \t]*//' | cut -d" " -f1`
echo "********** Protected ORACLE database ASM lsdg  ************" 

echo $ASMHOME
echo $LD_LIBRARY_PATH
echo $ORACLE_SID
echo $guser

if [ "$os" != "Linux" ]; then
su $guser -c "$asmcmd lsdg" 
else
su -m $guser -c "$asmcmd lsdg" 
fi
echo "********** Protected ORACLE database ASM diskgroup status  ************" 

if [ "$os" != "Linux" ]; then
su $guser -c "$ORACLE_HOME/bin/sqlplus -s / as sysasm @/act/act_scripts/asmEnvDetail.sql"  
else
su -m $guser -c "$ORACLE_HOME/bin/sqlplus -s / as sysasm @/act/act_scripts/asmEnvDetail.sql"  
fi

echo "********** Protected ORACLE database ASM disk link (/dev/actifio/asm  ************" 
ls -ltr /dev/actifio/asm 
echo "********** Protected ORACLE database RAC CRS details" 
crsctl stat res -t

exit;
