#!/bin/sh

if [ "$#" -ne 1 ]; then
 echo "This script needs 1 input parameter"
 echo "usage: osEnvDetail.sh <0/1>, where 1 => Do not run any blocking commands and 0 => Run all diagnostic commands"
exit 1
fi

nonblock=$1

echo "Start collecting OS environment diagnostic details"

echo
echo "********** (env) ************"
env

echo
echo "********** (uname -a) ************"
uname -a

echo
echo "********** (Fetch /etc/os-release) ************"
cat /etc/os-release

echo
echo "********** (Fetch /etc/redhat-release) ************"
cat /etc/redhat-release

echo
echo "********** (Fetch /etc/SuSE-release) ************"
cat /etc/SuSE-release

echo
echo "********** (Fetch multipath.conf file) ************"
cat /etc/multipath.conf

echo
echo "********** (Fetch lvm.conf file) ************"
cat /etc/lvm/lvm.conf

echo
echo "********** (ls -l /dev/disk/by-id) ************"
ls -l /dev/disk/by-id

echo
echo "********** (ls -l /dev/disk/by-path) ************"
ls -l /dev/disk/by-path

echo
echo "********** (ls -l /dev/disk/by-uuid) ************"
ls -l /dev/disk/by-uuid

echo
echo "********** (dmsetup info) ************"
dmsetup info

echo
echo "********** (ls -l /dev/actifio/asm) ************"
ls -l /dev/actifio/asm

echo
echo "********** (lvm version) ************"
lvm version

echo
echo "********** (ps -aux) ************"
ps -aux

echo
echo "********** (cat /proc/meminfo) ************"
cat /proc/meminfo

echo
echo "********** (cat /proc/cpuinfo) ************"
cat /proc/cpuinfo

echo
echo "********** (cat /proc/mounts) ************"
cat /proc/mounts

echo
echo "********** (cat /etc/mtab) ************"
cat /etc/mtab

echo
echo "********** (lspci) ************"
lspci

echo
echo "********** (cat /proc/scsi/scsi) ************"
cat /proc/scsi/scsi

echo
echo "********** (ls -l /sys/block) ************"
ls -l /sys/block

echo
echo "************ (free -g) ***************"
free -g

echo
echo "********** (/etc/iscsi/initiatorname.iscsi) ***********"
cat /etc/iscsi/initiatorname.iscsi

echo
echo "********** (iscsiadm -m discovery -P 1) ***********"
iscsiadm -m discovery -P 1

echo
echo "********** (iscsiadm -m node -P 1) ***********"
iscsiadm -m node -P 1

echo
echo "*********** (iscsiadm -m session -P 1) *********"
iscsiadm -m session  -P 1


if [ "$nonblock" = "0" ]; then
  echo
  echo "********** (fdisk -l) ************"
  fdisk -l

  echo
  echo "********** (multipath -l) ************"
  multipath -l

  echo
  echo "********** (blkid) ************"
  blkid

  echo
  echo "********** (pvs -a) ************"
  pvs -a

  echo
  echo "********** (vgs -a) ************"
  vgs -a

  echo
  echo "********** (lvs -a) ************"
  lvs -a

  echo
  echo "********** (pvdisplay) ************"
  pvdisplay

  echo
  echo "********** (vgdisplay) ************"
  vgdisplay

  echo
  echo "********** (lvdisplay) ************"
  lvdisplay

  echo
  echo "********** (df) **************"
  df

  echo
  echo "************ (pvs -o +uuid) *************"
  pvs -o +uuid

  echo
  echo "************ (/opt/act/bin/udsagent liststaledevices) *************"
  /opt/act/bin/udsagent liststaledevices

  echo
  echo "************ (/proc/sys/net/ipv4/ip_local_port_range) *************"
  cat /proc/sys/net/ipv4/ip_local_port_range

  echo
  echo "************ (netstat -atpn | wc -l) *************"
  netstat -atpn | wc -l

fi
echo
echo "*********** (list installed packages) *********"
if command -v rpm >/dev/null ; then
    rpm -qa
fi
if command -v dpkg >/dev/null ; then
    dpkg -l
fi

echo
echo "End collecting OS environment diagnostic details"

