#!/bin/sh
# This script will take care of the following tasks:
# 1) Login to appliance to get Session ID.
# 2) Remove Vdisk from sky to host .
# 3) Rescan iscsi services.
#########################################################################

vdiskname=$1

SkyUserName="admin"
VendorKey="act"
echo "-------Starting remove vdisk script------"

echo "vdiskname :" $vdiskname

if [ -z $vdiskname ]; then
   echo "vdiskname should not be empty"
   exit 1
fi

# Step 1: Login to appliance and get session id
set +x
loginURL="https://$SkyIP/actifio/api/login?name=$SkyUserName&password=$SkyPassword&vendorkey=$VendorKey"
sessionid=$(curl -w "\n" -s -k -XPOST $loginURL | jq -r '.sessionid')
set -x

# Step 2: Remove vdisk
removeVdiskURL="https://$SkyIP/actifio/api/task/rmvdiskmap"

inputParamsvDisk='{
"sessionid":'"$sessionid"',
"vdiskname":'"$vdiskname"'
}'
removevdiskResponse=$(curl -s -k  -H 'Content-Type: application/json' -X POST $removeVdiskURL -d "$inputParamsvDisk")
echo "removevdiskResponse :" $removevdiskResponse
if [[ $removevdiskResponse == *errormessage* ]]; then
   echo  $removevdiskResponse: | jq -cr '.errormessage'
   exit 1
fi
# Step 3: Rescan iscsi services
iscsiSessionId=`iscsiadm -m session | grep $SkyIP':' | awk -F" " '{print $2}' | cut -d "[" -f2 | cut -d "]" -f1`
iscsiadm -m session -r $iscsiSessionId --rescan
echo "Successfully removed vdisk."
