#!/bin/sh
set -x

TARGET_PATH=$2

SOURCE_PATH=`echo $ACT_MOUNT_POINTS | cut -d';' -f1`
if [ -z $SOURCE_PATH ]; then
  echo "Source Path cannot be null"
  exit 1
fi

if [ -z "$TARGET_PATH" ]; then
  TARGET_PATH=`echo $ACT_APPNAME | cut -d ':' -f2`
fi

TARGET_PATH=`echo $TARGET_PATH | sed 's/"//g' | sed "s/'//g"`
mkdir -p $TARGET_PATH
/opt/act/bin/udsagent smartcopy --source $SOURCE_PATH --target $TARGET_PATH --report-progress

retval=$?
if [ $retval -ne 0 ]; then
  echo "*** ERROR: Smart Copy has failed to Target $TARGET_PATH from source $SOURCE_PATH ************"
  exit $retval
fi

exit
