#!/bin/sh

sessionExists=$(iscsiadm -m session | grep -w $SkyIP:3260)
if [ -z "$sessionExists" ]; then
  #targetIQN=`iscsiadm -m discovery -t st -p $SkyIP:3260 2> /dev/null | tail -n 1 | awk '{print $NF}'`
  #iscsiadm -m node -T $targetIQN -p $SkyIP:3260 -l
  iscsiadm -m iface -I actifiosap -o new

  iscsiadm --mode discoverydb --type sendtargets -I actifiosap --portal $SkyIP:3260 -o new

  iscsiadm --mode discoverydb --type sendtargets -I actifiosap --portal $SkyIP:3260 -o update -n discovery.sendtargets.auth.authmethod -v CHAP

  iqnName=$(grep iqn /etc/iscsi/initiatorname.iscsi | cut -d '=' -f 2)

  iscsiadm -m iface -I actifiosap --op=update -n iface.initiatorname -v $iqnName

  iscsiadm -m iface -I actifiosap --op=update -n iface.discovery_auth -v none

  iscsiadm -m iface -I actifiosap --op=update -n iface.bidi_chap -v none

  iscsiadm --mode discoverydb --type sendtargets -I actifiosap --portal $SkyIP:3260 -o update -n discovery.sendtargets.auth.username -v $CHAPUsername

  set +x
  iscsiadm --mode discoverydb --type sendtargets -I actifiosap --portal $SkyIP:3260 -o update -n discovery.sendtargets.auth.password -v $CHAPPassword
  set -x
  targetIQN=$(iscsiadm --mode discoverydb --type sendtargets -I actifiosap --portal $SkyIP:3260 --discover 2>/dev/null | tail -n 1 | awk '{print $NF}')
  if [ -z "$targetIQN" ]; then
    echo "********** Error discovering Sky Portal $SkyIP: $targetIQN *************"
    exit 1
  fi

  iscsiadm -m node -T $targetIQN --portal=$SkyIP:3260 -o update -n node.session.auth.authmethod -v CHAP

  iscsiadm -m node -T $targetIQN --portal=$SkyIP:3260 -o update -n node.session.auth.username -v $CHAPUsername

  set +x
  iscsiadm -m node -T $targetIQN --portal=$SkyIP:3260 -o update -n node.session.auth.password -v $CHAPPassword
  set -x
  iscsiadm -m node -T $targetIQN --portal=$SkyIP:3260 -o update -n node.session.auth.username_in -v ''

  iscsiadm -m node -T $targetIQN --portal=$SkyIP:3260 -o update -n node.session.auth.password_in -v ''

  iscsiadm -m node -T $targetIQN --portal=$SkyIP:3260 -o update -n node.startup -v automatic

  iscsiadm -m node -T $targetIQN --portal=$SkyIP:3260 -o update -n node.conn[0].startup -v automatic

  iscsiadm -m node -T $targetIQN --login --portal=$SkyIP:3260 -I actifiosap
  retval=$?
  if [ $retval -ne 0 ]; then
    if [ $retval -eq 15 ]; then
      echo "*** Session Already Exists****"
    else
      echo "*** ERROR: Iscsi Login to $SkyIP has Failed************"
      exit $retval
    fi
  fi

fi
