/* ============================================================
 * Actifio VirtualData Pipeline
 * Copyright (c) 2013 Actifio Inc. All Rights Reserved
 *
 * This program code contains trade secrets of Actifio Inc. that
 * (i) derive independent economic value, actual or potential, from not being
 * generally known to, and not being readily ascertainable by proper means by
 * other persons who can obtain economic value from their disclosure or use and;
 * (ii) are the subject of efforts by Actifio Inc that are reasonable under the
 * circumstances to maintain their secrecy. You may not use this program code
 * without prior written authorization from Actifio Inc.
 *
 * Filename       : getArchiveReferenceTime.sql
 *
 * Description:   get unix epoch time in seconds for first_time of lowest firt_time among max sequence of all thread
 *
 * =============================================================
 */

set pages 0
set head off
set feed off
set timing off
set numwidth 18
WHENEVER SQLERROR EXIT SQL.SQLCODE
select (to_date(to_char(min(first_time), 'DD-MM-YYYYHH24:MI:SS'), 'DD-MM-YYYYHH24:MI:SS') - to_date('01-01-1970 00:00:00', 'DD-MM-YYYY HH24:MI:SS'))*86400 
from v$archived_log 
where (thread#, sequence#) in (select thread#,max(sequence#) from v$archived_log group by thread#);
exit;

