/* ============================================================
 * Actifio VirtualData Pipeline
 * Copyright (c) 2011 Actifio Inc. All Rights Reserved
 *
 * This program code contains trade secrets of Actifio Inc. that
 * (i) derive independent economic value, actual or potential, from not being
 * generally known to, and not being readily ascertainable by proper means by
 * other persons who can obtain economic value from their disclosure or use and;
 * (ii) are the subject of efforts by Actifio Inc that are reasonable under the
 * circumstances to maintain their secrecy. You may not use this program code
 * without prior written authorization from Actifio Inc.
 *
 * Filename       : getArchivelogNextFTime.sql
 *
 * Description:   get minimum of the first_time in the format of yyyy-mm-dd hh24:mi:ss given a set of (thread#, sequence#)
 *
 * =============================================================
 */

set pages 0
set head off
set feed off
set timing off
set echo off
SET VERIFY OFF
WHENEVER SQLERROR EXIT SQL.SQLCODE
select to_char(min(first_time), 'yyyy-mm-dd hh24:mi:ss')
from v$archived_log where FIRST_TIME > (select max(resetlogs_time) from v$archived_log)
and thread# in (select thread# from v$thread where status = 'OPEN')
and (thread#, sequence#) in (&1);
exit;
