/* ============================================================
 * Actifio VirtualData Pipeline
 * Copyright (c) 2018 Actifio Inc. All Rights Reserved
 *
 * This program code contains trade secrets of Actifio Inc. that
 * (i) derive independent economic value, actual or potential, from not being
 * generally known to, and not being readily ascertainable by proper means by
 * other persons who can obtain economic value from their disclosure or use and;
 * (ii) are the subject of efforts by Actifio Inc that are reasonable under the
 * circumstances to maintain their secrecy. You may not use this program code
 * without prior written authorization from Actifio Inc.
 *
 * Filename       : getDuplicateCopyPaths.sql
 *
 * Description:   get all datafile backup copy path except latest one given file# 
 *
 * =============================================================
 */

set lin 120
set pages 0
set head off
set feed off
set timing off
set echo off
SET VERIFY OFF
WHENEVER SQLERROR EXIT SQL.SQLCODE
select NAME from v$datafile_copy
where FILE# = &1 and STATUS = 'A'
and COMPLETION_TIME < (select max(COMPLETION_TIME) from v$datafile_copy where FILE# = &2);
exit;

