/* ============================================================
 * Actifio VirtualData Pipeline
 * Copyright (c) 2011 Actifio Inc. All Rights Reserved
 *
 * This program code contains trade secrets of Actifio Inc. that
 * (i) derive independent economic value, actual or potential, from not being
 * generally known to, and not being readily ascertainable by proper means by
 * other persons who can obtain economic value from their disclosure or use and;
 * (ii) are the subject of efforts by Actifio Inc that are reasonable under the
 * circumstances to maintain their secrecy. You may not use this program code
 * without prior written authorization from Actifio Inc.
 *
 * Filename       : getLastArchivelogBackupInputbytes.sql
 *
 * Description:   get input bytes for last RMAN archivelog backup using start_time and end_time parameter 
 *                in the format of yyyy-mm-dd hh24:mi:ss
 *
 * =============================================================
 */

set pages 0
set head off
set feed off
set timing off
set echo off
set numwidth 18
SET VERIFY OFF
WHENEVER SQLERROR EXIT SQL.SQLCODE 
select sum(input_bytes) from v$rman_backup_job_details where input_type='ARCHIVELOG' and start_time >= &1 and end_time <= &2;
exit;
