/* ============================================================
 * Actifio VirtualData Pipeline
 * Copyright (c) 2011 Actifio Inc. All Rights Reserved
 *
 * This program code contains trade secrets of Actifio Inc. that
 * (i) derive independent economic value, actual or potential, from not being
 * generally known to, and not being readily ascertainable by proper means by
 * other persons who can obtain economic value from their disclosure or use and;
 * (ii) are the subject of efforts by Actifio Inc that are reasonable under the
 * circumstances to maintain their secrecy. You may not use this program code
 * without prior written authorization from Actifio Inc.
 *
 * Filename       : getLobBackupTime.sql
 *
 * Description:   get first_time of the latest archived log being backed up 
 *
 * =============================================================
 */

set pages 0
set head off
set feed off
set timing off
set echo off
set numwidth 48
set verify off
WHENEVER SQLERROR EXIT SQL.SQLCODE
select to_char(min(first_time), 'yyyy-mm-dd hh24:mi:ss') from v$backup_archivelog_details a,
(select thread#,max(sequence#) maxseq, max(RESETLOGS_CHANGE#) maxchange from v$backup_archivelog_details
where (thread#, RESETLOGS_CHANGE#) in (select thread#, max(RESETLOGS_CHANGE#) from v$backup_archivelog_details group by thread#) group by thread#) z,
(select bs_key from v$backup_files where tag = '&1') y
where y.bs_key=a.btype_key
and a.thread#=z.thread#
and a.sequence#=z.maxseq
and a.RESETLOGS_CHANGE#=z.maxchange;
exit;
