/* ============================================================
 * Actifio VirtualData Pipeline
 * Copyright (c) 2011 Actifio Inc. All Rights Reserved
 *
 * This program code contains trade secrets of Actifio Inc. that
 * (i) derive independent economic value, actual or potential, from not being
 * generally known to, and not being readily ascertainable by proper means by
 * other persons who can obtain economic value from their disclosure or use and;
 * (ii) are the subject of efforts by Actifio Inc that are reasonable under the
 * circumstances to maintain their secrecy. You may not use this program code
 * without prior written authorization from Actifio Inc.
 *
 * Filename       : getPrimaryBaselineTime.sql
 *
 * Description:   get minimum complete_time from archived log on primary 
 *                in the format of yyyy-mm-dd hh24:mi:ss
 *
 * =============================================================
 */

set pages 0
set head off
set feed off
set timing off
set echo off
set numwidth 18
SET VERIFY OFF
WHENEVER SQLERROR EXIT SQL.SQLCODE
select to_char(min(COMPLETION_TIME), 'yyyy-mm-dd HH24:MI:SS') 
from v$archived_log al, 
(select thread#,max(sequence#) maxseq 
  from v$archived_log
  where RESETLOGS_CHANGE# = (select max(RESETLOGS_CHANGE#) from v$archived_log) group by thread#) seq 
where al.thread#=seq.thread# and al.sequence#=seq.maxseq;
exit;
