/* ============================================================
 * Actifio VirtualData Pipeline
 * Copyright (c) 2011 Actifio Inc. All Rights Reserved
 *
 * This program code contains trade secrets of Actifio Inc. that
 * (i) derive independent economic value, actual or potential, from not being
 * generally known to, and not being readily ascertainable by proper means by
 * other persons who can obtain economic value from their disclosure or use and;
 * (ii) are the subject of efforts by Actifio Inc that are reasonable under the
 * circumstances to maintain their secrecy. You may not use this program code
 * without prior written authorization from Actifio Inc.
 *
 * Filename       : getStandbyArchivedLogDetails.sql
 *
 * Description:   get (thread#, sequence#) from standby node given a baseline time and end time
 *
 * =============================================================
 */

set pages 0
set head off
set feed off
set timing off
set echo off
set numwidth 18
SET VERIFY OFF
WHENEVER SQLERROR EXIT SQL.SQLCODE
select thread#, max(sequence#) from v$archived_log where completion_time >= to_date('&1', 'yyyy-mm-dd HH24:MI:SS') 
and completion_time <= to_date('&2', 'yyyy-mm-dd HH24:MI:SS') 
and status ='A' group by thread#;
exit;

