#!/bin/sh

distro="unknown"
distro_ver="unknown"
if [ -e /etc/redhat-release ]; then
    if [ $(cat /etc/redhat-release | grep "Red Hat Enterprise Linux" -i | wc -l) -gt 0 ]; then
        distro="redhat"
    elif [ $(cat /etc/redhat-release | grep "CentOS" -i | wc -l) -gt 0 ]; then
        distro="centos"
    fi
    input=$(cat /etc/redhat-release |grep release)
    # used on RHEL 4
    old_style_regex=".+release\s([0-9])\s\(.+([0-9]).+\)"
    new_style_regex=".*release\s([0-9]+\.[0-9]+).*"
    if [[ $input =~ $new_style_regex ]]; then
        distro_ver="${BASH_REMATCH[1]}"
    elif [[ $input =~ $old_style_regex ]]; then
        distro_ver="${BASH_REMATCH[1]}.${BASH_REMATCH[2]}"
    fi
elif [ -e /etc/SuSE-release ]; then
    if [ $(cat /etc/SuSE-release | grep "SUSE" -i | wc -l) -gt 0 ]; then
        distro="sles"
        distro_ver=$(cat /etc/SuSE-release | grep VERSION | tr -t '=' ' ' | awk {'print $2'})
        distro_ver="$distro_ver.$(cat /etc/SuSE-release | grep PATCHLEVEL | tr -t '=' ' ' | awk {'print $2'})"
    fi
elif [ -e /etc/os-release ]; then
    . /etc/os-release
    distro=$(echo "$ID" | tr '[:upper:]' '[:lower:]')
    if [ "$NAME" = "SLES" ] && [ "$VERSION_ID" = "${VERSION_ID/./}" ] ; then
        # If we're on SLES and there's no . in the version, assume SP0
        distro_ver=$VERSION_ID.0
    else
        distro_ver=$VERSION_ID
    fi
fi

regex="([0-9]+)\.([0-9]+)"
distro_ver_major="0"
distro_ver_minor="0"
if [[ "$distro_ver" =~ $regex ]]; then
    distro_ver_major=${BASH_REMATCH[1]}
    distro_ver_minor=${BASH_REMATCH[2]}
fi
