#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#
set +x

addedHostID=$1
MAXDBCONFIG="/act/scripts/act_MaxDB_src.conf"
set -x
# Create Actifio In-band disk for the complete MaxDB Full Backup which is required for Log Backups to work.
vdiskmountpoint="/justForLog"
source /act/act_scripts/maxdb/automation/Backup/addVdisk.sh $vdiskmountpoint $addedHostID

source /act/act_scripts/maxdb/automation/Backup/dbHelper.sh
dbTemplateSuffix=actFullDbTemplate
echo "creating MaxDB data backup template *********"
createCompleteDataTemplate $vdiskmountpoint $dbTemplateSuffix

echo "********** Take a complete data backup for Log Backups to happen************"

executeDbTemplate $dbTemplateSuffix

echo "********** Done complete data backup************"

echo -e "# MaxDB config " > $MAXDBCONFIG

#Fetch Lvm Locations for the Data/Log Volumes
getDbVolumes
if [ -z "$lvmlist" ]; then
   echo "No Data and Log mounts found..Exiting from Backup process !!"
   exit 1
fi

protectedLvm=""
count=1
protectedLvm="["
for i in $lvmlist
do
  lv=`echo ${i%/*}`
  if [ "$count" -eq 1 ]; then
    protectedLvm+=\"$lv\"
  else
    lvexist=`echo "$protectedLvm" | grep -w $lv`
    if [ -z $lvexist ]; then
      protectedLvm+=","\"$lv\"
    fi
  fi
  count=$(($count + 1));
done
protectedLvm+="]"

if [ -z $LOG_BKP_LOC ]; then
  LOGBKPLOC=$LogBackupFS
else
  LOGBKPLOC=$LOG_BKP_LOC
fi

#Creating config file with values.

echo -e "OSUSER='$OSUSER'" >> $MAXDBCONFIG
echo -e "SRC_MAXDB_DBMCLI_PATH='$SRC_MAXDB_DBMCLI_PATH'" >> $MAXDBCONFIG
echo -e "SRC_DBNAME_KEY_PREFIX='$SRC_DBNAME_KEY_PREFIX'" >> $MAXDBCONFIG
echo -e "PROTECTED_LVM_LIST='$protectedLvm'" >> $MAXDBCONFIG
echo -e "LOG_BKP_LOC='$LOGBKPLOC'" >> $MAXDBCONFIG
echo -e "SRC_DBNAME='$SRC_DBNAME'" >> $MAXDBCONFIG
echo -e "ACTIFIO_DISK_LOC='$vdiskmountpoint'" >> $MAXDBCONFIG
echo -e "SkyIP='$SkyIP'" >> $MAXDBCONFIG
echo -e "ProfileName='$ProfileName'" >> $MAXDBCONFIG
echo -e "SRC_HOSTNAME='$SRC_HOSTNAME'" >> $MAXDBCONFIG
chmod 755 $MAXDBCONFIG
