#!/bin/sh
set -x
PWDS=/act/scripts
appid=$1

tmp_loc=/act/touch
if [ ! -d $tmp_loc ]; then
 mkdir -p $tmp_loc
fi
chmod -R 777 /act

conffile=$PWDS/act_MaxDB_src.conf
if [ -f $conffile ]; then
 source $conffile
else
 echo "Configuration File does not Exist..!!"
 exit 1
fi

TYPE=${DUMPSCHEDULE:`date +%w`:1}

ORIG_TYPE=$TYPE
CHECK_FULL_BKP=`ls $ACTIFIO_DISK_LOC | grep -i "fullDataBackup" | wc -l`
if [ "$CHECK_FULL_BKP" -eq "0" ]; then
	TYPE="F"
	if [ "$ORIG_TYPE" != "$TYPE" ]; then
		echo "WARNINGMSG: Performing Full backup as previous Full backup is not found in $ACTIFIO_DISK_LOC!"
	fi
fi

if [ ! -d $PWDS ]; then
   echo "could not found $PWDS script folder. exiting ...."
   exit 1
fi

$PWDS/validateVdisk.sh
retval=$?
if [ $retval -ne 0 ]; then
   echo "*******ERROR: Failed Maxdb Vdisk Validation ************"
   exit $retval
fi

echo "********************************************************************"
echo "Database filesystem dump backup: `date`"

echo "Starting MaxDB full database backup dump"

source /act/act_scripts/maxdb/automation/Backup/dbHelper.sh

isDatabaseOnline

case $TYPE in
   I)
dbTemplateSuffix=actincrementalTemplate
createIncrementMultiDataTemplate $ACTIFIO_DISK_LOC $dbTemplateSuffix $dumpthreadcount
echo "********** Take a incremental data backup ************"
executeDbTemplate $dbTemplateSuffix
;;
F)
dbTemplateSuffix=actfullDBTemplate
createCompleteMultiDataTemplate $ACTIFIO_DISK_LOC $dbTemplateSuffix $dumpthreadcount
echo "**** Delete old databackup Files in Staging Disk ****"
FILES=`ls -lr $ACTIFIO_DISK_LOC | grep -i DataBackup | awk -F" " '{print $NF}'`
# Delete the files
for i in `echo $FILES`; do
 rm -f $ACTIFIO_DISK_LOC/$i
done
echo "********** Take a full data backup ************"
executeDbTemplate $dbTemplateSuffix
;;
*)
echo No idea what Im going to do
 exit 1
;;
esac

tsname=`date +%Y%m%d%H%M%S`
mkdir -p $LOG_BKP_LOC
OSGROUP=`id -ngr $OSUSER | cut -d" " -f1`
chown -R $OSUSER:$OSGROUP $LOG_BKP_LOC
echo "$tsname" > $LOG_BKP_LOC/dbfreezedate.dat
chmod 775 $LOG_BKP_LOC/dbfreezedate.dat
chown -R $OSUSER:$OSGROUP $LOG_BKP_LOC/dbfreezedate.dat

exit
