 /* ============================================================
 * Filename       : minFirsttimeOnBackupcount0.sql
 *
 * Description:   get min(first_time) of the archived log with backup_count = 0 across all threads
 * Parameters:    1: last log backup's from time
 *                2: min(first_time) of backed up logs on the staging
 *
 * =============================================================
 */

set pages 0
set head off
set feed off
set timing off
set echo off
set numwidth 48
set verify off
WHENEVER SQLERROR EXIT SQL.SQLCODE
select to_char(min(first_time), 'yyyy-mm-dd hh24:mi:ss') from v$archived_log
where first_time >= &1
and first_time <= &2
and backup_count = 0;
exit;
