#!/bin/sh
set


set -x
conffile=$2;
######################
#osuser=oracle
#conffile=act_testuser_refresh.conf
#databasesid=schdb
#orahome=/home/18.0.0/oracle/product/dbhome_1
#####################

cd /act/scripts
tmp_dump=/act/touch/db_dump
. /act/scripts/$conffile
#source /act/scripts/act_testuser_refresh.conf
osuser=$username
export osuser
TARGET_SID=$TARGET_SID
export TARGET_SID
target_dbuser=$TARGET_SCHEMA_NAME
export target_dbuser
src_dbuser=$SOURCE_SCHEMA_NAME
export src_dbuser
ORACLE_HOME=$orahome
export ORACLE_HOME
PATH=$ORACLE_HOME/bin:$PATH
export PATH
TNS_ADMIN=$ORACLE_HOME/network/admin
export TNS_ADMIN


echo "***************** POSTSKJOB_TYPE= $ACT_JOBTYPE *********************"
#ACT_JOBTYPE=mount
#ACT_PHASE=post

if [ $ACT_JOBTYPE == "unmount" ] || [ $ACT_MULTI_OPNAME == "unmount" ] ; then
   echo "NO-OP for post-script when unmount"
   exit 0
fi
if [ $ACT_JOBTYPE == "mount" ] || [ $ACT_MULTI_OPNAME == "mount" ] ; then
   if [ $ACT_PHASE == "pre" ] ; then
        echo "** No op for pre during unmount **"
      exit
   fi
   if [ $ACT_LOGSMART_TYPE == "log" ] ; then
        echo "** No op for log during unmount **"
     exit
   fi
   if [ $ACT_PHASE == "post" ] ; then
        echo "************************* start post during mount ************************"

ORACLE_SID=$databasesid
export ORACLE_SID

if [ ! -z "$SOURCE_PDB_NAME" ]; then
   /act/act_scripts/oracleclone/updateTNSNames.sh $SOURCE_PDB_NAME $ORACLE_HOME $LISTENER_IP
fi
echo "************starting *************"
date

call_droptbs() {
username=
for x in $(echo $target_dbuser | tr ',' ' ')
do
  if [ "$multipleuserscount" -gt 0 ]; then
     username=`echo $x | awk -F":" '{print $2}'`
  else
      username=$x
  fi
su $osuser -c "$ORACLE_HOME/bin/sqlplus -s / as sysdba" << EOF
set head off;
$setcontainer
begin
    for rec in (select distinct TABLESPACE_NAME from dba_segments where owner = upper('$username'))
     loop
        execute immediate 'drop tablespace '||rec.tablespace_name||' including contents and datafiles';
     end loop;
end;
/
alter session set "_oracle_script"=true;
drop user $username cascade;
exit;
EOF
done

for username in $(echo $createdusers | tr ',' ' ')
do
su $osuser -c "$ORACLE_HOME/bin/sqlplus -s / as sysdba" << EOF
set head off;
$setcontainer
alter session set "_oracle_script"=true;
drop user $username cascade;
exit;
EOF
done
}

######### Main ###########
osgrp=`id -gnr $osuser`
if [ -d $tmp_dump ]; then
   rm -rf $tmp_dump/*
   chown -R $osuser:$osgrp $tmp_dump
   chmod 755 /act/touch
   chmod 755 -R $tmp_dump
else
   mkdir -p $tmp_dump
   chown -R $osuser:$osgrp $tmp_dump
   chmod 755 /act/touch
   chmod 755 -R $tmp_dump
fi

if [ ! -z "$SOURCE_PDB_NAME" ]; then
   setcontainer="alter session set container=$SOURCE_PDB_NAME;"
   createuser="create user ACTIFIO_EXP_TEMP identified by abc#12345 default tablespace users;"
   grantprivs="grant create session, connect, resource, dba to ACTIFIO_EXP_TEMP;"
   quota="alter user ACTIFIO_EXP_TEMP quota unlimited on USERS;"
   granttts="grant execute on DBMS_TTS to ACTIFIO_EXP_TEMP;"
   grantreadwrite="grant read, write ON DIRECTORY dmpdir TO ACTIFIO_EXP_TEMP;"
fi
echo "************creating dumpdir *************"
su $osuser -c "$ORACLE_HOME/bin/sqlplus -s / as sysdba" << EOF
$setcontainer
$createuser
$grantprivs
$quota
$granttts
CREATE or REPLACE DIRECTORY dmpdir as '$tmp_dump';
GRANT read, write ON DIRECTORY dmpdir TO sys, system;
$grantreadwrite
exit;
EOF


if [ ! -z "$SOURCE_PDB_NAME" ]; then
   TWO_TASK=$SOURCE_PDB_NAME
   export TWO_TASK
   vsqlplus="$ORACLE_HOME/bin/sqlplus -S ACTIFIO_EXP_TEMP/abc#12345"
else
   vsqlplus="$ORACLE_HOME/bin/sqlplus -S / as sysdba"
fi

if [ $? -ne 0 ]; then
   echo "failed to create dmpdir direcotry"
   exit 1
fi

src_dbuser=`echo $src_dbuser | tr '[a-z]' '[A-Z]'`
target_dbuser=`echo $target_dbuser | tr '[a-z]' '[A-Z]'`

src_dbuser_list=`echo $src_dbuser |awk -F"," -v quote="'" -v OFS="','" '$1=$1 {print quote $0 quote}'|tr [a-z] [A-Z]`


echo "############ Generating tablespae List ################"
for src_username in $(echo $src_dbuser | tr ',' ' ')
do
     tmp_tblist=`su -m $osuser -c "$vsqlplus @/act/scripts/tablespaces.sql $src_username"`

echo $tmp_tblist

if [ -z $tmp_tblist ]; then
  echo "Tablespace list is empty"
  exit 1
fi

if [ -z "$tblist" ]; then
   tblist=$tmp_tblist
else
   tbs_exists=`echo $tblist | grep "$tmp_tblist" | wc -l`
   if [ "$tbs_exists" -eq 0 ]; then
      tblist=$tblist','$tmp_tblist
   fi
fi

done

echo "########### Select EXCLUDE USERS ################"

for name in $(echo $tblist | tr ',' ' ')
do
   EXCLUDE_LIST=`su -m $osuser -c "$vsqlplus @/act/scripts/excludeuser.sql $name"`
   
   if [ -z "$EXCLUDE" ]; then
       EXCLUDE=$EXCLUDE_LIST
   else
       EXCLUDE=$EXCLUDE','$EXCLUDE_LIST
   fi
done
if [ "$?" -gt 0 ]; then
   echo "Failed to get other user details under this tablespace!"
   exit 1
fi

EXCLUDE=`echo $EXCLUDE | sed 's/\,/ /'g`
for i in $(echo $src_dbuser_list| tr ',' ' ')
do
   i=`echo $i | sed "s/'//g"`
   EXCLUDE=`echo $EXCLUDE | sed -e s"/\b$i\b//g" | xargs |sed 's/ /,/g'`
   echo $EXCLUDE
done

#################### END ##################

echo "************Running TRANSPORT_SET_CHECK *************"

for tbsname in $(echo $tblist | tr ',' ' ')
do
    su $osuser -c "$vsqlplus @/act/scripts/transport_check.sql $tbsname"

echo "************checking violations *************"

errcnt=`su $osuser -c "$vsqlplus " << 'EOF1'
set head off;
select count(*) from SYS.TRANSPORT_SET_VIOLATIONS;
exit;
EOF1`

if [ "$errcnt" -gt "0" ]; then
echo "please check the violation under transport_set_violations table and correct it"
exit 1;
fi
done

date



echo "###########* Rename Tablespace #############"
multipleuserscount=`echo $src_dbuser | grep "," | wc -l`
if [ "$multipleuserscount" -gt 0 ]; then
   multipleusers=$target_dbuser
else
   multipleusers=$src_dbuser
fi
for username in $(echo $multipleusers | tr ',' ' ')
do
 if [ "$multipleuserscount" -gt 0 ]; then
    source_username=`echo $username | awk -F":" '{print $1}'`
    target_username=`echo $username | awk -F":" '{print $2}'`
 else
    target_username=$target_dbuser
    source_username=$src_dbuser
 fi
su $osuser -c "$vsqlplus" << EOF
set head off;
declare
i number :=0;
begin
    for rec in (select distinct TABLESPACE_NAME from dba_segments where owner in upper('$source_username'))
     loop
        i:=i+1;
        execute immediate 'alter tablespace '||rec.tablespace_name||' rename to $target_username'||'_DATA'||i;
     end loop;
end;
/
exit;
EOF
if [ $? -ne 0 ]; then
   echo "failed to rename tablespace"
   exit 1
fi
done

echo "############alter tablespace as read only #############"

su $osuser -c "$vsqlplus" << EOF
set head off;
begin
    for rec in (select distinct TABLESPACE_NAME from dba_segments where owner in ($src_dbuser_list))
     loop
        execute immediate 'alter tablespace '||rec.tablespace_name||' read only';
     end loop;
end;
/
exit;
EOF
if [ $? -ne 0 ]; then
   echo "failed to make tablespace read only"
   exit 1
fi

echo "############export metadata #############"

tblist=
for src_username in $(echo $src_dbuser | tr ',' ' ')
do
tmp_tblist=`su -m $osuser -c "$vsqlplus @/act/scripts/tablespaces.sql $src_username"`

echo $tmp_tblist

if [ -z $tmp_tblist ]; then
  echo "Tablespace list is empty"
  exit 1
fi

if [ -z "$tblist" ]; then
   tblist=$tmp_tblist
else
   tbs_exists=`echo $tblist | grep "$tmp_tblist" | wc -l`
   if [ "$tbs_exists" -eq 0 ]; then
      tblist=$tblist','$tmp_tblist
   fi
fi
done


DFILE=$databasesid'_dbmetaexp.dmp'
LFILE=$databasesid'_exp_ttswf.log'
OBJFILE=$databasesid'_objects.dmp'

if [ ! -z "$SOURCE_PDB_NAME" ]; then
   echo "expdp 'ACTIFIO_EXP_TEMP/*********' DUMPFILE=$OBJFILE DIRECTORY=dmpdir logfile=$LFILE CONTENT=METADATA_ONLY SCHEMAS=$src_dbuser"
   set +x
   su $osuser -c "expdp 'ACTIFIO_EXP_TEMP/abc#12345' DUMPFILE=$OBJFILE DIRECTORY=dmpdir logfile=$LFILE CONTENT=METADATA_ONLY SCHEMAS=$src_dbuser"
   set -x
   echo "expdp 'ACTIFIO_EXP_TEMP/*********' DUMPFILE=$DFILE DIRECTORY=dmpdir TRANSPORT_TABLESPACES=$tblist logfile=$LFILE"
   set +x
   su $osuser -c "expdp 'ACTIFIO_EXP_TEMP/abc#12345' DUMPFILE=$DFILE DIRECTORY=dmpdir TRANSPORT_TABLESPACES=$tblist logfile=$LFILE "
   set -x
else
   su $osuser -c "expdp '\"/ as sysdba\"' DUMPFILE=$OBJFILE DIRECTORY=dmpdir logfile=$LFILE CONTENT=METADATA_ONLY SCHEMAS=$src_dbuser"
   su $osuser -c "expdp '\"/ as sysdba\"' DUMPFILE=$DFILE DIRECTORY=dmpdir TRANSPORT_TABLESPACES=$tblist logfile=$LFILE "
fi

if [ $? -eq 1 ]; then
   echo "failed to export metadata. Check $tmp_dump/$LFILE"
   exit 1
fi

echo "set pages 0" >$tmp_dump/datafiles.sql
echo "set head off" >> $tmp_dump/datafiles.sql
echo "set feed off" >> $tmp_dump/datafiles.sql
echo "set timing off" >> $tmp_dump/datafiles.sql
echo "set verify off" >> $tmp_dump/datafiles.sql
echo "set echo off" >> $tmp_dump/datafiles.sql
echo "set lin 32000" >> $tmp_dump/datafiles.sql
echo "spool $tmp_dump/$databasesid_datafiles.txt" >> $tmp_dump/datafiles.sql
echo "select file_NAME from dba_data_files where tablespace_name in (select distinct tablespace_name from dba_segments where owner in ($src_dbuser_list));" >> $tmp_dump/datafiles.sql
echo "spool off" >> $tmp_dump/datafiles.sql
echo "exit;" >> $tmp_dump/datafiles.sql
chown $osuser:$osgrp $tmp_dump/datafiles.sql
su -m $osuser -c "$vsqlplus @$tmp_dump/datafiles.sql"

datafiles=`cat $tmp_dump/$databasesid_datafiles.txt |xargs |sed 's/ /,/g'`
echo "datafiles: $datafiles"

unset TWO_TASK
su $osuser -c "$ORACLE_HOME/bin/sqlplus -s / as sysdba" << EOF
shutdown immediate;
exit;
EOF
if [ $? -ne 0 ]; then
   echo "failed to shutdown the database"
   exit 1
fi
mv $ORACLE_HOME/dbs/init"$ORACLE_SID".ora $ORACLE_HOME/dbs/init"$ORACLE_SID".ora.old

ORACLE_SID=$TARGET_SID
export ORACLE_SID
if [ ! -z "$TARGET_ORACLE_HOME" ]; then
   ORACLE_HOME=$TARGET_ORACLE_HOME
   export ORACLE_HOME
   PATH=$ORACLE_HOME/bin:$PATH
   export PATH
fi

if [ ! -z "$TARGET_PDB_NAME" ]; then
   setcontainer="alter session set container=$TARGET_PDB_NAME;"
   createuserpdb="create user ACTIFIO_IMP_TEMP identified by abc#12345 default tablespace users;"
   grantprivs="grant create session, connect, resource, dba to ACTIFIO_IMP_TEMP;"
   quota="alter user ACTIFIO_IMP_TEMP quota unlimited on USERS;"
   grantreadwrite="grant read, write ON DIRECTORY dmpdir TO ACTIFIO_IMP_TEMP;"
fi

for createuser in $(echo $target_dbuser | tr ',' ' ')
do
  if [ "$multipleuserscount" -gt 0 ]; then
     username=`echo $createuser | awk -F":" '{print $2}'`
  else
     username=$target_dbuser
  fi
su $osuser -c "$ORACLE_HOME/bin/sqlplus -s / as sysdba" << EOF
set head off;
alter session set "_oracle_script"=true;
$setcontainer
$createuserpdb
$grantprivs
$quota
declare
v_user varchar2(4);
begin
select count(1) into v_user from dba_users where username='$username';
if (v_user = 0)
then
   execute immediate 'create user $username identified by abc#1234';
   execute immediate 'grant connect, resource to $username';
end if;
end;
/
exit;
EOF
done

su $osuser -c "$ORACLE_HOME/bin/sqlplus -s / as sysdba" << EOF
$setcontainer
CREATE or REPLACE DIRECTORY actdmpdir as '$tmp_dump';
GRANT read, write ON DIRECTORY actdmpdir TO sys, system,ACTIFIO_IMP_TEMP;
$grantreadwrite
exit;
EOF


LFILE=$databasesid'_imp_ttswf.log'

for username in $(echo $EXCLUDE | tr ',' ' ')
do
su $osuser -c "$ORACLE_HOME/bin/sqlplus -s / as sysdba" << EOF
set head off;
alter session set "_oracle_script"=true;
$setcontainer
WHENEVER SQLERROR EXIT SQL.SQLCODE;
create user $username identified by abc#1234;
exit;
EOF
retval=$?
if [ "$retval" -eq 0 ]; then
    if [ -z "$createdusers" ]; then
       createdusers=$username
    else
       createdusers=$createdusers','$username
    fi
fi
done

echo "############import metadata #############"


for remapusername in $(echo $target_dbuser | tr ',' ' ' )
do
  if [ "$multipleuserscount" -gt 0 ]; then
      source_username=`echo $remapusername | awk -F":" '{print $1}'`
      target_username=`echo $remapusername | awk -F":" '{print $2}'`
      
      if [ -z "$remapschema" ]; then
         remapschema="remap_schema=$source_username:$target_username"
      else
         remapschema="$remapschema"' '"remap_schema=$source_username:$target_username"
      fi
  else
      remapschema="remap_schema=$src_dbuser:$target_username"
  fi

done
if [ ! -z "$TARGET_PDB_NAME" ]; then
    TWO_TASK=$TARGET_PDB_NAME
    export TWO_TASK
    echo "impdp 'ACTIFIO_IMP_TEMP/*********' DUMPFILE=$DFILE DIRECTORY=actdmpdir TRANSPORT_DATAFILES='$datafiles' logfile=$LFILE $remapschema"
    set +x
    su $osuser -c "impdp 'ACTIFIO_IMP_TEMP/abc#12345' DUMPFILE=$DFILE DIRECTORY=actdmpdir TRANSPORT_DATAFILES='$datafiles' logfile=$LFILE $remapschema"
    retval=$?
    set -x
    if [ $retval -eq 1 ]; then
       echo "failed to import  metadata. Check $tmp_dump/$LFILE"
       call_droptbs
       exit 1
    fi
    echo "impdp 'ACTIFIO_IMP_TEMP/abc#12345' DUMPFILE=$OBJFILE DIRECTORY=actdmpdir TRANSFORM=oid:n logfile=$LFILE $remapschema TABLE_EXISTS_ACTION=SKIP"
    set +x
    su $osuser -c "impdp 'ACTIFIO_IMP_TEMP/abc#12345' DUMPFILE=$OBJFILE DIRECTORY=actdmpdir TRANSFORM=oid:n logfile=$LFILE $remapschema TABLE_EXISTS_ACTION=SKIP"
    retval=$?
    set -x
    if [ $retval -eq 1 ]; then
       echo "failed to import  metadata. Check $tmp_dump/$LFILE"
       call_droptbs
       exit 1
    fi
   unset TWO_TASK
else
   su $osuser -c "impdp '\"/ as sysdba\"' DUMPFILE=$DFILE DIRECTORY=actdmpdir TRANSPORT_DATAFILES='$datafiles' logfile=$LFILE $remapschema"

   if [ $? -eq 1 ]; then
      echo "failed to import  metadata. Check $tmp_dump/$LFILE"
      call_droptbs
      exit 1
   fi

   su $osuser -c "impdp '\"/ as sysdba\"' DUMPFILE=$OBJFILE DIRECTORY=actdmpdir TRANSFORM=oid:n logfile=$LFILE $remapschema TABLE_EXISTS_ACTION=SKIP"
   if [ $? -eq 1 ]; then
      echo "failed to import  metadata. Check $tmp_dump/$LFILE"
      call_droptbs
      exit 1
   fi
   unset TWO_TASK
fi
target_dbuser_list=
for tusername in $(echo $target_dbuser | tr ',' ' ')
do
    if [ "$multipleuserscount" -gt 0 ]; then
       name=`echo $tusername | awk -F":" '{print $2}'`
    else
       name=$tusername
    fi
    if [ -z "$target_dbuser_list" ]; then
       target_dbuser_list=$name
    else
       target_dbuser_list=$target_dbuser_list','$name
    fi
done

target_dbuser_list=`echo $target_dbuser_list |awk -F"," -v quote="'" -v OFS="','" '$1=$1 {print quote $0 quote}'|tr [a-z] [A-Z]`
su $osuser -c "$ORACLE_HOME/bin/sqlplus -s / as sysdba" << EOF
set head off;
$setcontainer
begin
    for rec in (select distinct TABLESPACE_NAME from dba_segments where owner in ($target_dbuser_list))
     loop
        execute immediate 'alter tablespace '||rec.tablespace_name||' read write';
     end loop;
end;
/
exit;
EOF

if [ $? -ne 0 ]; then
   echo "failed to make tablespace read write!"
   call_droptbs
   exit 1
fi

for username in $(echo $createdusers | tr ',' ' ')
do
su $osuser -c "$ORACLE_HOME/bin/sqlplus -s / as sysdba" << EOF
set head off;
alter session set "_oracle_script"=true;
$setcontainer
drop user $username cascade;
exit;
EOF
done

if [ ! -z "$TARGET_PDB_NAME" ]; then
su $osuser -c "$ORACLE_HOME/bin/sqlplus -s / as sysdba" << EOF
set head off;
alter session set "_oracle_script"=true;
$setcontainer
drop user ACTIFIO_IMP_TEMP cascade;
exit;
EOF
fi

for x in $(echo $target_dbuser | tr ',' ' ')
do
  if [ "$multipleuserscount" -gt 0 ]; then
     username=`echo $x | awk -F":" '{print $2}'`
  else
      username=$x
  fi
su $osuser -c "$ORACLE_HOME/bin/sqlplus -s / as sysdba" << EOF
set head off;
$setcontainer
begin
    for rec in (select distinct TABLESPACE_NAME from dba_segments where owner in ('$username') and rownum<2)
     loop
        execute immediate 'alter user $username default tablespace '||rec.tablespace_name||'';
     end loop;
end;
/
exit;
EOF
done
fi
fi

echo "Schema Refresh is complete..!!"
