#!/bin/sh

set -x
INPUT_VAR=$2

#ACT_JOBTYPE="unmount"
#ACT_PHASE=pre
echo "****************** PRESK_JOBTYPE $ACT_JOBTYPE ***************"

if [ $ACT_JOBTYPE == "unmount" ] || [ $ACT_MULTI_OPNAME == "unmount" ] ; then
   if [ $ACT_PHASE == "post" ] ; then
        echo "NO-OP for post-script when unmount"
        echo "** no op exit **"
      exit
   fi
   if [ $ACT_LOGSMART_TYPE == "log" ] ; then
	echo "** no op exit **"
     exit
   fi
   if [ $ACT_PHASE == "pre" ] ; then
	echo "************************* start pre during unmount ************************"


osuser=$username
ORACLE_HOME=$orahome
export ORACLE_HOME
PATH=$ORACLE_HOME/bin:$PATH
TNS_ADMIN=$ORACLE_HOME/network/admin
export TNS_ADMIN
TARGET_SID=`echo $INPUT_VAR | awk -F"_" '{print $1}'`
HOSTNAME=`hostname | awk -F'.' '{print $1}'`

TSID=`srvctl status database -d $TARGET_SID | grep -wi $HOSTNAME | awk '{print $2}'`
if [ -z "$TSID" ]; then
   TSID=$TARGET_SID
fi


echo " ORACLE_SID IS: $TSID"

export ORACLE_SID=$TSID

if [ -f /act/scripts/pdb_post_scripts.conf ]; then
   TARGET_ORACLE_HOME=`grep TARGET_ORACLE_HOME /act/scripts/pdb_post_scripts.conf | awk -F":" '{print $2}'`
   if [ ! -z "$TARGET_ORACLE_HOME" ]; then
      ORACLE_HOME=$TARGET_ORACLE_HOME
      export ORACLE_HOME
      PATH=$ORACLE_HOME/bin:$PATH
   fi
fi


for pdbname in $(echo $INPUT_VAR | sed "s/_/ /g")
do
  if [ "$pdbname" = "$TARGET_SID" ]; then
      :
  else
     PDB_TMP=`echo $pdbname | awk -F "-" '{print $2}'`
     if [ -z "$PDB_NAME" ]; then
         PDB_NAME=$PDB_TMP
     else
        PDB_NAME=$PDB_NAME,$PDB_TMP
     fi
  fi
done


PDB_NAME=`echo $PDB_NAME |awk -F"," -v quote="'" -v OFS="','" '$1=$1 {print quote $0 quote}'|tr [a-z] [A-Z]`

su $osuser -c "$ORACLE_HOME/bin/sqlplus -s / as sysdba" <<EOF
set head off;
set serveroutput on
begin

 for rec in (select name from v\$pdbs where upper(name) in ($PDB_NAME)) loop
   for i in (select name from v\$pdbs where upper(name)=rec.name and open_mode='READ WRITE') loop
     execute immediate 'alter pluggable database '|| i.name||' close immediate instances=all';
   end loop;
  execute immediate 'drop pluggable database '||rec.name||' including datafiles';
 end loop;
end;
/
EOF


if [ $? -ne 0 ]; then
   echo "Failed to drop pluggable database"
   exit 1
fi
fi
fi
exit $?

