#!/bin/sh

set -x

#ACT_JOBTYPE="unmount"
#ACT_PHASE=pre
echo "****************** PRESK_JOBTYPE $ACT_JOBTYPE ***************"

if [ $ACT_JOBTYPE == "unmount" ] || [ $ACT_MULTI_OPNAME == "unmount" ] ; then
   if [ $ACT_PHASE == "post" ] ; then
        echo "NO-OP for post-script when unmount"
        echo "** no op exit **"
      exit
   fi
   if [ $ACT_LOGSMART_TYPE == "log" ] ; then
	echo "** no op exit **"
     exit
   fi
   if [ $ACT_PHASE == "pre" ] ; then
	echo "************************* start pre during unmount ************************"

conffile=act_pdb_config.conf
. /act/scripts/$conffile

osuser=$OS_USER
ORACLE_HOME=$ORACLE_HOME
export ORACLE_HOME
PATH=$ORACLE_HOME/bin:$PATH
TNS_ADMIN=$ORACLE_HOME/network/admin
export TNS_ADMIN
export ORACLE_SID=$TARGET_SID
PDB_NAME=`echo $PDB_NAME| sed -E 's/([^,]+)/\1_NEW/g'`
PDB_NAME=`echo $PDB_NAME |awk -F"," -v quote="'" -v OFS="','" '$1=$1 {print quote $0 quote}'|tr [a-z] [A-Z]`

su $osuser -c "$ORACLE_HOME/bin/sqlplus -s / as sysdba" <<EOF
set head off;
set serveroutput on
begin

 for rec in (select name from v\$pdbs where upper(name) in ($PDB_NAME)) loop
   for i in (select name from v\$pdbs where upper(name)=rec.name and open_mode='READ WRITE') loop
     execute immediate 'alter pluggable database '|| i.name||' close immediate';
   end loop;
  execute immediate 'drop pluggable database '||rec.name||' including datafiles';
 end loop;
end;
/
EOF


if [ $? -ne 0 ]; then
   echo "Failed to drop pluggable database"
   exit 1
fi
fi
fi
exit $?

