#!/bin/bash
# act_Pre_AddToMaster_Slave.sh
set -x

#export ACT_JOBTYPE="unmount"
#export ACT_PHASE="pre"

SWD=/act/scripts

if [ ! -d $SPWD ]; then
   echo "could not found $SPWD script folder. exiting ...."
   exit 1
fi

echo "****************** PRESK_JOBTYPE $ACT_JOBTYPE ***************"

if [ $ACT_JOBTYPE = "unmount" ] || [ $ACT_MULTI_OPNAME = "unmount" ] ; then
   if [ $ACT_PHASE = "post" ] ; then
        echo "NO-OP for post-script when unmount"
        echo "** no op exit **"
        exit
   fi
   if [ "$ACT_LOGSMART_TYPE" = "log" ] ; then
	    echo "** no op exit **"
      exit
   fi
   if [ $ACT_PHASE = "pre" ] ; then
	    echo "************************* start pre during unmount ************************"

source /act/scripts/act_Conf_AddToMaster_Slave.conf

###Check /act/scripts/act_Conf_AddToMaster_Slave.conf file
if [ -z $TARGET_SLAVE_NODE ]; then
  echo "********************* ERROR ******************************"
  echo "TARGET_SLAVE_NODE not set. Please check config file: /act/scripts/act_Conf_AddToMaster_Slave.conf"
  exit 1
fi
if [ -z $TARGET_SLAVE_PORT ]; then
  echo "********************* ERROR ******************************"
  echo "TARGET_SLAVE_PORT not set. Please check config file: /act/scripts/act_Conf_AddToMaster_Slave.conf"
  exit 1
fi
if [ -z $TARGET_POSTGRES_HOME ]; then
  echo "********************* ERROR ******************************"
  echo "TARGET_POSTGRES_HOME not set. Please check config file: /act/scripts/act_Conf_AddToMaster_Slave.conf"
  exit 1
fi
if [ -z $POSTGRES_MASTER_NODE ]; then
  echo "********************* ERROR ******************************"
  echo "POSTGRES_MASTER_NODE not set. Please check config file: /act/scripts/act_Conf_AddToMaster_Slave.conf"
  exit 1
fi
if [ -z $POSTGRES_MASTER_PORT ]; then
  echo "********************* ERROR ******************************"
  echo "POSTGRES_MASTER_PORT not set. Please check config file: /act/scripts/act_Conf_AddToMaster_Slave.conf"
  exit 1
fi
if [ -z $POSTGRES_MASTER_DATA_PATH ]; then
  echo "********************* ERROR ******************************"
  echo "POSTGRES_MASTER_DATA_PATH not set. Please check config file: /act/scripts/act_Conf_AddToMaster_Slave.conf"
  exit 1
fi
if [ -z $POSTGRES_MASTER_HOME ]; then
  echo "********************* ERROR ******************************"
  echo "POSTGRES_MASTER_HOME not set. Please check config file: /act/scripts/act_Conf_AddToMaster_Slave.conf"
  exit 1
fi
if [ -z $POSTGRES_MASTER_OS_USER ]; then
  echo "********************* ERROR ******************************"
  echo "POSTGRES_MASTER_OS_USER not set. Please check config file: /act/scripts/act_Conf_AddToMaster_Slave.conf"
  exit 1
fi
if [ -z $TARGET_SLAVE_MOUNTPOINT ]; then
  echo "********************* ERROR ******************************"
  echo "TARGET_SLAVE_MOUNTPOINT not set. Please check config file: /act/scripts/act_Conf_AddToMaster_Slave.conf"
  exit 1
fi
if [ -z $TARGET_POSTGRES_DATA_PATH ]; then
  echo "********************* ERROR ******************************"
  echo "TARGET_POSTGRES_DATA_PATH not set. Please check config file: /act/scripts/act_Conf_AddToMaster_Slave.conf"
  exit 1
fi

###Find PostgreSQL owner and group
TARGET_SLAVE_OS_USER=`ps -eo user:20,pid,stime,time,args | grep "postgres: " | grep -v -w grep | head -1 | awk {'print $1'}`

if [ -z $TARGET_SLAVE_OS_USER ]; then
TARGET_SLAVE_OS_USER=`ls -ld $TARGET_POSTGRES_HOME | awk '{print $3}'`
fi

if [ $TARGET_SLAVE_OS_USER == "root" ]; then
  echo "ERROR: not able to find postgres user"
  exit 1
fi

id $TARGET_SLAVE_OS_USER
if [[ $? -ne 0 ]]; then
  echo "ERROR: not able to find postgres user"
  exit 1
fi

TARGET_SLAVE_OS_GROUP=`id $TARGET_SLAVE_OS_USER | awk '{print $2}' |cut -d"(" -f2 | cut -d")" -f1`
echo "Postgres user: $TARGET_SLAVE_OS_USER, Postgres group: $TARGET_SLAVE_OS_GROUP"

# Set environment for PostgreSQL
PATH=$TARGET_POSTGRES_HOME/bin:$PATH
LD_LIBRARY_PATH=$TARGET_POSTGRES_HOME/lib:$LD_LIBRARY_PATH

retval=0
if [[ -d $TARGET_POSTGRES_DATA_PATH && -f $TARGET_POSTGRES_DATA_PATH/postmaster.pid ]]; then
  PGSTATUS=$(su -m $TARGET_SLAVE_OS_USER -c 'echo "START__RS"; pg_ctl status -D '$TARGET_POSTGRES_DATA_PATH'; echo "END__RS"')
  PGSTATUS=`echo $PGSTATUS | awk -F"START__RS" '{print $2}' | awk -F"END__RS" '{print $1}'`
  if [ ! "$PGSTATUS" == "pg_ctl: no server running" ]; then
    su -m $TARGET_SLAVE_OS_USER -c 'pg_ctl stop -D '$TARGET_POSTGRES_DATA_PATH''
    retval=$?
  fi
fi
echo "************************* end pre during unmount ************************"
fi
fi

exit $?
