/* ============================================================
 * Actifio VirtualData Pipeline
 * Copyright (c) 2012 Actifio Inc. All Rights Reserved
 *
 * This program code contains trade secrets of Actifio Inc. that
 * (i) derive independent economic value, actual or potential, from not being
 * generally known to, and not being readily ascertainable by proper means by
 * other persons who can obtain economic value from their disclosure or use and;
 * (ii) are the subject of efforts by Actifio Inc that are reasonable under the
 * circumstances to maintain their secrecy. You may not use this program code
 * without prior written authorization from Actifio Inc.
 *
 * Filename       : rmanIgnorableError.sql
 *
 * Description:   get RMAN output for last completed session with ignorable errors
 *
 * =============================================================
 */
set pages 0
set head off
set feed off
set timing off
set echo off
WHENEVER SQLERROR EXIT SQL.SQLCODE
select a.rmancnt, b.oracnt
from
(select trim(count(output)) rmancnt
from v$rman_output
where session_recid = (select max(session_recid)
      from v$rman_status
      where status like '%ERRORS' or status like '%WARNINGS')
      and output like '%RMAN-06012%') a,
(select trim(count(output)) oracnt
from v$rman_output
where session_recid = (select max(session_recid)
      from v$rman_status
      where status like '%ERRORS' or status like '%WARNINGS')
      and output like '%ORA-%') b
/

