/* ============================================================
 * Actifio VirtualData Pipeline
 * Copyright (c) 2012 Actifio Inc. All Rights Reserved
 *
 * This program code contains trade secrets of Actifio Inc. that
 * (i) derive independent economic value, actual or potential, from not being
 * generally known to, and not being readily ascertainable by proper means by
 * other persons who can obtain economic value from their disclosure or use and;
 * (ii) are the subject of efforts by Actifio Inc that are reasonable under the
 * circumstances to maintain their secrecy. You may not use this program code
 * without prior written authorization from Actifio Inc.
 *
 * Filename       : rmanRetriableError.sql
 *
 * Description:   get RMAN output for last completed session with retriable errors
 *
 * =============================================================
 */
set pages 0
set head off
set feed off
set timing off
set echo off
WHENEVER SQLERROR EXIT SQL.SQLCODE
select trim(count(output))
from v$rman_output 
where session_recid = (select max(session_recid) 
      from v$rman_status 
      where status like '%ERRORS' or status like '%WARNINGS') 
and (output like '%ORA-19935%' 
)
order by recid;
exit;
