/* ============================================================
 * Actifio VirtualData Pipeline
 * Copyright (c) 2012 Actifio Inc. All Rights Reserved
 *
 * This program code contains trade secrets of Actifio Inc. that
 * (i) derive independent economic value, actual or potential, from not being
 * generally known to, and not being readily ascertainable by proper means by
 * other persons who can obtain economic value from their disclosure or use and;
 * (ii) are the subject of efforts by Actifio Inc that are reasonable under the
 * circumstances to maintain their secrecy. You may not use this program code
 * without prior written authorization from Actifio Inc.
 *
 * Filename       : rmanStatus.sql
 *
 * Description:   get RMAN job status for last completed session
 *                status will be any of the followings: COMPLETED; COMPLETED with WARNINGS; COMPLETED with ERRORS; FAILED
 *
 * =============================================================
 */
set pages 0
set head off
set feed off
set timing off
set echo off
WHENEVER SQLERROR EXIT SQL.SQLCODE
alter session set optimizer_mode=RULE;
select status
from v$rman_status
where end_time = (select max(end_time)
     from v$rman_status where command_id like 'ACT_%' and status != 'RUNNING') and status != 'RUNNING' and command_id like 'ACT_%';
exit;
