#!/bin/sh

# Script to check Pre-Requisites.

if [ "$#" -lt 1 ]; then
echo " This script need 1 input parameter"
echo " usage: preRequisites.sh <Sky IP address>"
echo " For example: preRequisites.sh 172.23.16.6"
exit 1
fi

skyIP=$1
# Check if connector is installed.

isConnectorInstalled=$(rpm -q udsagent)

if [[ $isConnectorInstalled == *udsagent-* ]]; then
   echo "Connector is Installed. Connector Version is : $isConnectorInstalled"
else
  if [[ $isConnectorInstalled == *"package udsagent is not installed"* ]]; then
   echo "Connector is not installed"
   if ! type "wget" 2> /dev/null; then
     echo "Error : wget is not installed. Cannnot download Connector."
     exit 1
   fi
   echo "Downloading and installing the connector now"
   wget --no-check-certificate https://$skyIP/connector-Linux-latestversion.rpm
   sudo -Ss rpm -i connector-Linux-latestversion.rpm
   echo "Connector installed now !!"
  fi
fi

# Check if UDSAgent is running

isUDSAgentRunning=$(pgrep udsagent)

if [[ -z "$isUDSAgentRunning" ]]; then
   echo "UDSAgent is stopped. Kindly start the UDSAgent service using the command /opt/act/bin/udsagent start"
   exit 1
else
   echo "UDSAgent is running."
fi

# Check if ISCSI service is configured/runnning
source /act/act_scripts/saphana/automation/Backup/configureIscsi.sh

isIscsiRunning=$(systemctl status iscsid | grep Active)
if [[ $isIscsiRunning == *"Active: active"* ]]; then
   echo "ISCSI service is running"
else
   echo "ISCSI service is stopped"
   exit 1
fi
