#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#
set +x
SYBASECONFIG="/act/scripts/act_Sybase_Src.conf"
#Creating config file with values.
echo -e "# sybase ASE config " > $SYBASECONFIG
echo -e "OSUSER='$OSUSER'" >> $SYBASECONFIG
echo -e "SRC_SYBASE_SQLD='$SRC_SYBASE_SQLD'" >> $SYBASECONFIG
echo -e "SRC_BACKUP_USER='$SRC_BACKUP_USER'" >> $SYBASECONFIG
echo -e "SRC_DBNAME='$SRC_DBNAME'" >> $SYBASECONFIG
echo -e "SRC_SERVER_NAME='$SRC_SERVER_NAME'" >> $SYBASECONFIG
echo -e "SRC_BACKUP_LOCATION='$SYBASEBACKUPPATH'" >> $SYBASECONFIG
echo -e "SkyIP='$SkyIP'" >> $SYBASECONFIG
echo -e "STRIPEON='$STRIPEON'" >> $SYBASECONFIG
echo -e "BACKUP_TYPE='$BACKUP_TYPE'" >> $SYBASECONFIG
echo -e "ProfileName='$ProfileName'" >> $SYBASECONFIG
echo -e "SRC_HOSTNAME='$SRC_HOSTNAME'" >> $SYBASECONFIG

chmod 755 $SYBASECONFIG

if [ "$SRC_DBNAME" != "" ]; then
  srcdbnamelist=$(echo $SRC_USER_PASSWD |  su - $OSUSER -c "sh /act/act_scripts/sybase/automation/Backup/dbHelper.sh handleDbNameCaseSensitive")
  retval=$?
  if [ $retval -gt 0 ]; then
    echo "***** ERRORMSG: failed to execute handleDbNameCaseSensitive function ******"
    exit 1
  fi
  SRC_DBNAME=`echo $srcdbnamelist | awk '{sub(/^.*handleDbNameCaseSensitive/,""); print $1}'`
  sed -i 's/^SRC_DBNAME.*/SRC_DBNAME='"$SRC_DBNAME"'/' $SYBASECONFIG
fi
source $SYBASECONFIG
if [ "$SRC_DBNAME" == "" ] || [ "$BACKUP_TYPE" == "LVMSnapshot" ]; then
  notificationDbList=$(echo $SRC_USER_PASSWD |  su - $OSUSER -c "sh /act/act_scripts/sybase/automation/Backup/dbHelper.sh notificationDbList")
  retval=$?
  if [ $retval -gt 0 ]; then
    echo "***** ERRORMSG: failed to execute notificationDbList function *****"
    exit 1
  fi
  notificationDbList=`echo $notificationDbList | awk '{sub(/^.*notificationDbListQuery/,""); print $1}'`
fi

lognotificationDbList=$(echo $SRC_USER_PASSWD |  su - $OSUSER -c "sh /act/act_scripts/sybase/automation/Backup/dbHelper.sh notificationlogDbList")
retval=$?
if [ $retval -gt 0 ]; then
  echo "***** ERRORMSG: failed to execute notificationlogDbList function *****"
  exit 1
fi
lognotificationDbList=`echo $lognotificationDbList | awk '{sub(/^.*dbnameslistForLogQuery/,""); print $1}'`


#Fetch DB name to pass in the query for fetching LVM

if [ "$BACKUP_TYPE" == "LVMSnapshot" ]; then
  lvmlist=$(echo $SRC_USER_PASSWD |  su - $OSUSER -c "sh /act/act_scripts/sybase/automation/Backup/dbHelper.sh lvmList")
  retval=$?
  if [ $retval -gt 0 ]; then
    echo "***** ERRORMSG: failed to execute lvmList function *****"
    exit 1
  fi
  lvmlist=`echo $lvmlist | awk '{sub(/^.*lvmListQuery/,""); print}'`
  if [ -z "$lvmlist" ]; then
     echo "No Data and Log mounts found..Exiting from Backup process !!"
     exit 1
  fi

  protectedLvm=""
  count=1
  protectedLvm="["
  for i in $lvmlist
  do
   echo $i
   datf=`echo "$i" | grep -i .dat`
   echo $datf
   if [ ! -z "$datf" ]; then
      lv=`echo ${i%/*}`
      if [ "$count" -eq 1 ]; then
      protectedLvm+=\"$lv\"
      else
      lvexist=`echo "$protectedLvm" | grep -w $lv`
       if [ -z $lvexist ]; then
         protectedLvm+=","\"$lv\"
       fi
      fi
   count=$(($count + 1));
   fi
  done

  protectedLvm+="]"

  manifestFileLoc=`echo $protectedLvm | cut -d, -f1 | sed 's/^.//' | cut -d\" -f2 | cut -d\" -f1`

  if [ -z "$manifestFileLoc" ];then
     echo "Manifest file location cannot be empty."
     exit 1
  fi

  #Update config file with values.
  echo -e "PROTECTED_LVM_LIST='$protectedLvm'" >> $SYBASECONFIG
  echo -e "MANIFEST_FILE_LOC='$manifestFileLoc'" >> $SYBASECONFIG
fi
set -x
