#!/bin/sh

tmp_loc=/act/touch
if [ ! -d "$tmp_loc" ]; then
   mkdir -p $tmp_loc
fi
chmod 777 /act/touch

set -x
conffile=/act/scripts/act_sybase_lvm_restore_config.conf
source $conffile
if [ -z "$TARGET_DBUSER_PASSWD" ]; then
TARGET_DBUSER_PASSWD=`su - $OSUSER -c "/sybase/$TARGET_SERVER_NAME/dba/bin/dbbp MaGiCpW"`
if [ -z "$TARGET_DBUSER_PASSWD" ]; then
  echo " Error : ISQL Password cannot be empty."
  exit 1
fi
fi

cd /act/scripts


mntpt=$TARGET_MNT_PNT

mntsearch=`echo $TARGET_MNT_PNT | awk -F"/" '{print $2}'`

echo search:$mntsearch

dbQuery="select distinct sda.name from master..sysdatabases sda, master..sysdevices sde, master..sysusages su where su.dbid=sda.dbid and su.vdevno=sde.vdevno"
echo  "dbQuery : $dbQuery"


if [ ! -z $mntsearch ]; then
  mntQuery=$dbQuery" and sde.phyname like \"%$mntsearch%\" and sda.name not in('master','tempdb','model','sybsystemdb','sybsystemprocs')"
  #else
  #mntQuery=$dbQuery" and sda.name not in('master','tempdb','model','sybsystemdb','sybsystemprocs')"
fi

su - $OSUSER -c "$TARGET_SYBASE_SQLD/bin/isql -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X  -n -b -o $tmp_loc/db_pre.txt" <<EOF
set nocount on
go
$mntQuery
go
quit
EOF

isFileEmpty=$(find $tmp_loc -empty -name db_pre.txt)

while read line
do
if [ -z $dbnamelist ]; then
    dbnamelist=$line
else
    dbnamelist=$dbnamelist","$line
fi
DBNAMES1="${DBNAMES1}${DBNAMES1:+,}'$line'"
done < $tmp_loc/db_pre.txt

echo $dbnamelist

#dbnamelist=$SRC_DBNAME

#if [ ! -z "$dbnamelist" ]; then
if [ -z $isFileEmpty ]; then
su - $OSUSER -c "$TARGET_SYBASE_SQLD/bin/isql -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X --retserverror" <<EOF
unmount database $dbnamelist to '$tmp_loc/manifest_pre'
go
EOF
fi

if [ -z "$DBNAMES1" ]; then
   DBNAMES1="''"
fi


if [ "$SRC_DBNAME" != "" ]; then
  for i in $(echo $SRC_DBNAME | sed "s/,/ /g")
  do
    dbname=$i
    DBNAMES="${DBNAMES}${DBNAMES:+,}'$dbname'"
  done
    #dbQuery+=" and sda.name in ($DBNAMES) and sda.name not in ($DBNAMES1)"
    dbQuery+=" and sda.name not in ('master','tempdb','model','sybsystemdb','sybsystemprocs') and sda.name not in ($DBNAMES1) and sda.name in($DBNAMES)"
 else
    dbQuery+=" and sda.name not in('master','tempdb','model','sybsystemdb','sybsystemprocs',"$DBNAMES1")"
fi

#echo "Final db Query ::  $dbQuery"


su - $OSUSER -c "$TARGET_SYBASE_SQLD/bin/isql -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X  -n -b -o $tmp_loc/db_pre.txt" <<EOF
set nocount on
go
$dbQuery
go
quit
EOF

while read line
do
if [ -z "$dbnamelist1" ]; then
    dbnamelist1=$line
else
    dbnamelist1=$dbnamelist1","$line
fi
done < $tmp_loc/db_pre.txt

#echo $dbnamelist1

#cat /act/touch/db_pre.txt

isFileEmpty=$(find $tmp_loc -empty -name db_pre.txt)


if [ -z $isFileEmpty ]; then
#if [ ! -z "$dbnamelist" ]; then
su - $OSUSER -c "$TARGET_SYBASE_SQLD/bin/isql -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X --retserverror" <<EOF
unmount database $dbnamelist1 to '$tmp_loc/manifest_pre'
go
EOF
fi
retval=$?


if [ $retval -gt "0" ]; then
 echo "ERROR: Unmount database command Failed!"
 exit 1
fi


if [ -e $tmp_loc/manifest_pre ]; then
 rm -f $tmp_loc/manifest_pre
fi

if [ -e $tmp_loc/db_pre.txt ]; then
 rm -f $tmp_loc/db_pre.txt
fi

exit $?
