#!/bin/sh
set +x
source /act/scripts/act_sybase_dump_restore_config.conf
read -r TARGET_DBUSER_PASSWD

if [ -z "$TARGET_DBUSER_PASSWD" ]; then
  TARGET_DBUSER_PASSWD=`/sybase/"$TARGET_SERVER_NAME"/dba/bin/dbbp MaGiCpW`
  if [ -z "$TARGET_DBUSER_PASSWD" ]; then
    echo "******** RESTORE_STATUS=$TARGET_SERVER_NAME:fail  *********"
    echo " Error : ISQL Password cannot be empty."
    exit 1
  fi
fi

user_inputdbnames=$DATABASE_NAME

if [ "x$DATABASE_NAME" = "x" ]; then
$TARGET_SYBASE_SQLD/bin/isql -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X -n -b -w 1000 -o $DB_BACKUP_LOCATION/source_dbname.txt --retserverror <<EOF
set nocount on
go
select distinct sda.name from master..sysdatabases sda where sda.name not in ('master','model','pubs2','pubs3','sybmgmtdb','sybpcidb','sybsystemdb','sybsystemprocs','tempdb','saptempdb','sapsatempdb','sybsecurity','dbccdb')
go
EOF
retval=$?
if [ $retval -gt 0 ]; then
  echo "******** RESTORE_STATUS=$TARGET_SERVER_NAME:fail  *********"
  echo "ERRORMSG: failed to getsourcedbnames `cat $DB_BACKUP_LOCATION/source_dbname.txt`"
  exit 1
fi
while read line
do
  set -- $line
  if [ -z $db_list ]; then
  db_list=$line
  else
  db_list=$db_list,$line
  fi
done < $DB_BACKUP_LOCATION/source_dbname.txt
DATABASE_NAME=$db_list
fi

dumpscript=$DB_BACKUP_LOCATION"/syb_restore_db_dump"
dumpmasterscript=$DB_BACKUP_LOCATION"/syb_restore_db_master_dump"
logdumpscript=$LOG_BACKUP_LOCATION"/syb_restore_trans_dump"

if [ -e "$dumpscript" ]; then
  echo "removing dump script file"
  rm -f $dumpscript
  rm -f $dumpmasterscript
  rm -f $LOG_BACKUP_LOCATION/tran_dump_*.txt
fi

if [ -e "$logdumpscript" ]; then
  echo "removing log dump script file"
  rm -f $logdumpscript
fi

if [ ! -z "$LOG_BACKUP_LOCATION" ]; then
  rm -f $LOG_BACKUP_LOCATION/tran_dump_*.txt
  if [ ! -z "$UNTIL_TIME" ]; then
    recovery_from=`cat $DB_BACKUP_LOCATION/logbackup.dat`
    recoverytime=`date -d "$UNTIL_TIME" +'%b %d %Y %H:%M:%S'`
    UNTIL_TIME=`date -d "$UNTIL_TIME" +'%Y%m%d%H%M%S'`
  fi
fi

touch $DB_BACKUP_LOCATION/syb_restore_db_master_dump
touch $DB_BACKUP_LOCATION/syb_restore_db_dump

for i in $(echo $DATABASE_NAME | sed "s/,/ /g")
do
dbname=$i
if [ $dbname == "master" ]; then
  continue
fi
i=$dbname
a="load database $dbname from "
b=""
c="STRIPE ON"

files=(`ls $DB_BACKUP_LOCATION | grep -e "^$dbname"_full | awk '{print $NF}' | sort -n`)
len=`echo "${#files[@]}"`

if [ $len -gt 0 ]; then
for (( j=0; j<$len; j++ ));
do
count=$((len-1))
if [ "$j" -eq "$count" ];then
          b=`echo "$b \"$DB_BACKUP_LOCATION"/${files[$j]}"\""`
    else
          b=`echo "$b \"$DB_BACKUP_LOCATION"/${files[$j]}"\" $c"`
fi
done
echo use master >> $DB_BACKUP_LOCATION/syb_restore_db_dump
echo go >> $DB_BACKUP_LOCATION/syb_restore_db_dump
echo "$a" "$b" >> $DB_BACKUP_LOCATION/syb_restore_db_dump
echo go >> $DB_BACKUP_LOCATION/syb_restore_db_dump
fi
done

restoremaster=`echo $DATABASE_NAME | grep -iw master`
if [ ! -z "$restoremaster" ]; then
  dbname=master
  i=$dbname
  a="load database $dbname from "
  b=""
  c="STRIPE ON"

  files=(`ls $DB_BACKUP_LOCATION | grep -e "^$dbname"_full | awk '{print $NF}' | sort -n`)
  len=`echo "${#files[@]}"`

  if [ $len -gt 0 ]; then
  for (( j=0; j<$len; j++ ));
  do
  count=$((len-1))
  if [ "$j" -eq "$count" ];then
            b=`echo "$b \"$DB_BACKUP_LOCATION"/${files[$j]}"\""`
      else
            b=`echo "$b \"$DB_BACKUP_LOCATION"/${files[$j]}"\" $c"`
  fi
  done
  echo use master >> $DB_BACKUP_LOCATION/syb_restore_db_master_dump
  echo go >> $DB_BACKUP_LOCATION/syb_restore_db_master_dump
  echo "$a" "$b" >> $DB_BACKUP_LOCATION/syb_restore_db_master_dump
  echo go >> $DB_BACKUP_LOCATION/syb_restore_db_master_dump
  fi
fi

for i in $(echo $DATABASE_NAME | sed "s/,/ /g")
do
dbname=$i
i=$dbname
c="STRIPE ON"
TRANS="load transaction $dbname from "
transFiles=""

if [ ! -z "$LOG_BACKUP_LOCATION" ]; then
  if [ ! -z "$UNTIL_TIME" ]; then
    cdmpFiles=(`find $LOG_BACKUP_LOCATION/ -newer $DB_BACKUP_LOCATION/logbackup.dat | sort -n | grep -Ew "$dbname""_trans_[0-9]{8}_[0-9]{6}_.*.cdmp"`)
    dump_file=$LOG_BACKUP_LOCATION/tran_dump_$i.txt

    if [ "$UNTIL_TIME" -gt "$recovery_from" ]; then
     rollforwardtime=`date -d "${UNTIL_TIME:0:8} ${UNTIL_TIME:8:2}:${UNTIL_TIME:10:2}:${UNTIL_TIME:12:2}" +"%Y-%m-%d %H:%M:%S"`
     echo "rollforward:$rollforwardtime"
     echo "Check for the TRANSACTIONAL LOGS"
     echo "DBNAME :: " $dbname
     len=`echo "${#cdmpFiles[@]}"`
     echo "Total No: Transaction FiLes:$len for DBNAME:$dbname"

    if [ $len -gt 0 ]; then
      for (( j=0; j<$len; j++ ));
       do
         echo "${cdmpFiles[$j]}" >> $LOG_BACKUP_LOCATION/tran_dump_$i.txt
       done
    else
     continue
    fi

     dump_file=$LOG_BACKUP_LOCATION/tran_dump_$i.txt
    else
      echo "******** RESTORE_STATUS=$TARGET_SERVER_NAME:fail  *********"
      echo "ERROR: UNTIL TIME: $UNTIL_TIME is less than Recovery Time: $recovery_from"
      exit 1
    fi

    STRIPEON=`ls $LOG_BACKUP_LOCATION | grep -E "*_trans_[0-9]{8}_[0-9]{6}_.*.cdmp" | awk -F"_" '{print $5}' | awk -F"-" '{print $1}' | sort | uniq | wc -l`

    lastlogfile=`ls -lrt $LOG_BACKUP_LOCATION | grep -Ew "$dbname""_trans_[0-9]{8}_[0-9]{6}_.*.cdmp" | tail -n 1`
    if [ ! -z "$lastlogfile" ]; then
      lastlogfiletstamp=`echo "$lastlogfile" | rev | awk -F "_" '{print $2$3}' | rev`
    fi

    transFiles=""
    counter="1"
    c="STRIPE ON"
    finallogtstamp=""
    echo use master >> $LOG_BACKUP_LOCATION/syb_restore_trans_dump
    echo go >> $LOG_BACKUP_LOCATION/syb_restore_trans_dump
    while read line
    do
        logfiletstamp=`echo "$line" | rev | awk -F "_" '{print $2$3}' | rev`

        if [ "$logfiletstamp" -gt "$UNTIL_TIME" ]; then
            finallogtstamp="$logfiletstamp"
        fi

        if [ "$logfiletstamp" -gt "$recovery_from" -a "$logfiletstamp" -le "$lastlogfiletstamp" ]; then
          if [ ! -z $line ]; then
              if [ "$counter" -eq "$STRIPEON" ]; then
                    transFiles=`echo "$transFiles \"$line"\"`
                    if [ ! -z "$transFiles" ];then
                    if [ ! -z "$finallogtstamp" ];then
                      if [ "$finallogtstamp" -gt "$UNTIL_TIME" ];then
                        transFiles=`echo "$transFiles with until_time=\"$recoverytime\""`
                      fi
                    fi
                    echo "$TRANS""$transFiles" >> $LOG_BACKUP_LOCATION/syb_restore_trans_dump
                    counter=0
                    transFiles=""
                    echo go >> $LOG_BACKUP_LOCATION/syb_restore_trans_dump
                    if [ ! -z "$finallogtstamp" ];then
                      if [ "$finallogtstamp" -gt "$UNTIL_TIME" ]; then
                        break;
                      fi
                    fi
                  fi
                else
                    transFiles=`echo "$transFiles "\"$line"\" $c"`
            fi
            counter=$((counter+1))
          fi
        fi

      done < $dump_file

  fi
fi
done

# Validate if user input database is present in backup or not
if [ ! -z $user_inputdbnames ]; then
  for i in $(echo $user_inputdbnames | sed "s/,/ /g")
  do
  dbname=$i
  grep -ow "load database $dbname" $DB_BACKUP_LOCATION/syb_restore_db_dump $DB_BACKUP_LOCATION/syb_restore_db_master_dump > /dev/null 2>&1
  retval=$?
  if [ $retval -gt 0 ]; then
    echo "*** ERRORMSG Restore cannot be done for database:$dbname since no backup was found.."
    echo "******** RESTORE_STATUS=$TARGET_SERVER_NAME:fail  *********"
    exit 1
  fi
  done
fi

if [ ! -f "$DB_BACKUP_LOCATION/syb_restore_db_master_dump" ] && [ ! -f "$DB_BACKUP_LOCATION/syb_restore_db_dump" ]; then
  echo "ERRORMSG: Load Database SQL's for Dump restore are not generated"
  echo "******** RESTORE_STATUS=$TARGET_SERVER_NAME:fail  *********"
  exit 1
fi

echo "***************** Start of database dump *****************" > /var/act/log/UDSAgent-"$TARGET_SERVER_NAME"_recovery.log

grep -ow "load database master" $DB_BACKUP_LOCATION/syb_restore_db_master_dump > /dev/null 2>&1
retval=$?
if [ $retval -eq 0 ]; then
echo "--------------------------- Start Master database Recovery---------------------"
$TARGET_SYBASE_SQLD/bin/isql -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X --retserverror <<EOF
use master
go
shutdown $BACKUP_SERVER_NAME
go
shutdown
go
EOF

  if [ $? -gt "0" ]; then
    echo "ERROR: While Shutting down servers.. May be there are already down!"
    backupserverPID=$(su - $OSUSER -c "showserver" | grep -i backupserver | grep -iw "\-s$BACKUP_RUN_PROCESS_NAME" | awk -F" " '{print $4}')
    if [ ! -z "$backupserverPID" ]; then
      echo "WARNING: Running ASE backupserver. Kill it!"
      kill $backupserverPID
    fi
  fi

  sleep 60

  sybaseStatus=$(showserver | grep -i dataserver | grep -iw "\-s$TARGET_SERVER_NAME")
  if [ ! -z "$sybaseStatus" ]; then
    echo "ERROR: Running ASE dataserver. Exiting!"
    exit 1
  fi

  sybasebackupStatus=$(showserver | grep -i backupserver | grep -iw "\-s$BACKUP_RUN_PROCESS_NAME")
  if [ ! -z "$sybasebackupStatus" ]; then
    echo "ERROR: Running ASE backupserver. Exiting!"
    exit 1
  fi

  rundata=$SYBASE_ASE_PATH"/install/RUNQ_"$TARGET_SERVER_NAME
  rundatatmp=$SYBASE_ASE_PATH"/install/RUNQ_"$TARGET_SERVER_NAME"_temp"
  echo "OS user is $OSUSER"
  userGroup=`ls -lrt $TARGET_SYBASE_SQLD | grep $OSUSER | tail -n 1 | awk -F" " '{print $4}'`
  rm -f $SYBASE_ASE_PATH/install/RUNQ_$TARGET_SERVER_NAME

  cp $SYBASE_ASE_PATH/install/RUN_$TARGET_SERVER_NAME $SYBASE_ASE_PATH/install/RUNQ_$TARGET_SERVER_NAME

  rm -f $rundatatmp

  sed "$(( $( wc -l < $SYBASE_ASE_PATH/install/RUNQ_$TARGET_SERVER_NAME) -2 ))s/$/\n-q \\\/" $SYBASE_ASE_PATH/install/RUNQ_$TARGET_SERVER_NAME > $rundatatmp
  mv $rundatatmp $SYBASE_ASE_PATH/install/RUNQ_$TARGET_SERVER_NAME
  chmod 755 $SYBASE_ASE_PATH/install/RUNQ_$TARGET_SERVER_NAME
  chown $OSUSER:$userGroup $SYBASE_ASE_PATH/install/RUNQ_$TARGET_SERVER_NAME

   cmd="$SYBASE_ASE_PATH/bin/startserver -f $SYBASE_ASE_PATH/install/RUNQ_$TARGET_SERVER_NAME -m"
   nohup $cmd >& $SYBASE_ASE_PATH/install/logfiledataserver.out &
   sleep 60
   backupServercmd="$SYBASE_ASE_PATH/bin/startserver -f $SYBASE_ASE_PATH/install/RUN_$BACKUP_RUN_PROCESS_NAME"
   nohup $backupServercmd >& $SYBASE_ASE_PATH/install/logfilebackupserver.out &
   sleep 60

   sybaseStatus=$(showserver | grep -i dataserver | grep -iw "\-s$TARGET_SERVER_NAME")
   if [ -z "$sybaseStatus" ]; then
     echo "ERROR: ASE dataserver is not up.!"
     #exit 1
   fi

   sybasebackupStatus=$(showserver | grep -i backupserver | grep -iw "\-s$BACKUP_RUN_PROCESS_NAME")
   if [ -z "$sybasebackupStatus" ]; then
     echo "ERROR: ASE backupserver is not up.!"
     #exit 1
   fi

  echo "*** Executing $DB_BACKUP_LOCATION/syb_restore_db_master_dump for recovering master from database dump"
  $TARGET_SYBASE_SQLD/bin/isql -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X -o $DB_BACKUP_LOCATION/db_recoveryoutput.txt -i $DB_BACKUP_LOCATION/syb_restore_db_master_dump --retserverror
  retval=$?
  cp -f $DB_BACKUP_LOCATION/syb_restore_db_master_dump /var/act/log/UDSAgent-db_master_dump_sql.log
  cat $DB_BACKUP_LOCATION/db_recoveryoutput.txt >> /var/act/log/UDSAgent-"$TARGET_SERVER_NAME"_recovery.log
  tail -20 $DB_BACKUP_LOCATION/db_recoveryoutput.txt
  if [ $retval -gt 0 ]; then
    echo "******** RESTORE_STATUS=$TARGET_SERVER_NAME:fail  *********"
    echo "ERRORMSG: There was an error while recovering master database... .Check for complete execution details in /var/act/log/UDSAgent-"$TARGET_SERVER_NAME"_recovery.log"
    exit 1
  fi
  echo "------ Finshed Applying Master Db Dump...Check for complete execution details in /var/act/log/UDSAgent-"$TARGET_SERVER_NAME"_recovery.log"

  #shutdown Data server if not automatically shutdown.
$TARGET_SYBASE_SQLD/bin/isql -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X <<EOF
use master
go
shutdown
go
EOF

  #if [ $? -gt "0" ]; then
   #echo "ERROR: Shutting down Backup Server $BACKUP_SERVER_NAME Failed!"
   #echo "Try Killing the backup server process!"
   #backupserverPID=$(su - $OSUSER -c "showserver" | grep -i backupserver | grep -iw "\-s$BACKUP_RUN_PROCESS_NAME" | awk -F" " '{print $4}')
   #if [ ! -z "$backupserverPID" ]; then
     #echo "WARNING: Running ASE backupserver. Kill it!"
     #kill $backupserverPID
   #fi
  #fi

  sybaseStatus=$(showserver | grep -i dataserver | grep -iw "\-s$TARGET_SERVER_NAME")
  if [ ! -z "$sybaseStatus" ]; then
    echo "ERROR: Running ASE dataserver. Exiting!"
    exit 1
  fi

  #sybasebackupStatus=$(showserver | grep -i backupserver | grep -iw "\-s$BACKUP_RUN_PROCESS_NAME")
  #if [ ! -z "$sybasebackupStatus" ]; then
    #echo "WARNING: Still Running ASE backupserver!"
  #fi

  sleep 30

  cmd="$SYBASE_ASE_PATH/bin/startserver -f $SYBASE_ASE_PATH/install/RUN_$TARGET_SERVER_NAME"
  nohup $cmd >& $SYBASE_ASE_PATH/install/logfiledataserver.out &
  sleep 60
  #backupServercmd="$SYBASE_ASE_PATH/bin/startserver -f $SYBASE_ASE_PATH/install/RUN_$BACKUP_RUN_PROCESS_NAME"
  #nohup $backupServercmd >& $SYBASE_ASE_PATH/install/logfilebackupserver.out &
  #sleep 60

  sybaseStatus=$(showserver | grep -i dataserver | grep -iw "\-s$TARGET_SERVER_NAME")
  if [ -z "$sybaseStatus" ]; then
   echo "ERROR: ASE dataserver is not up.!"
   #exit 1
  fi

  #sybasebackupStatus=$(showserver | grep -i backupserver | grep -iw "\-s$BACKUP_RUN_PROCESS_NAME")
  #if [ -z "$sybasebackupStatus" ]; then
   #echo "ERROR: ASE backupserver is not up!"
   #exit 1
  #fi
echo "--------------------------- End of Master database Recovery---------------------"
fi

grep -ow "load database" $DB_BACKUP_LOCATION/syb_restore_db_dump > /dev/null 2>&1
retval=$?
if [ $retval -eq 0 ]; then
  echo "--------------------------- Start of db(other than master) dump Recovery---------------------"
  echo "*** Executing $DB_BACKUP_LOCATION/syb_restore_db_dump for recovering from database dump"
  $TARGET_SYBASE_SQLD/bin/isql -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X -o $DB_BACKUP_LOCATION/db_recoveryoutput.txt -i $DB_BACKUP_LOCATION/syb_restore_db_dump --retserverror
  retval=$?
  cp -f $DB_BACKUP_LOCATION/syb_restore_db_dump /var/act/log/UDSAgent-db_dump_sql.log
  cat $DB_BACKUP_LOCATION/db_recoveryoutput.txt >> /var/act/log/UDSAgent-"$TARGET_SERVER_NAME"_recovery.log
  tail -20 $DB_BACKUP_LOCATION/db_recoveryoutput.txt
  if [ $retval -gt 0 ]; then
    echo "******** RESTORE_STATUS=$TARGET_SERVER_NAME:fail  *********"
    echo "ERRORMSG: There was an error while recovering database... .Check for complete execution details in /var/act/log/UDSAgent-"$TARGET_SERVER_NAME"_recovery.log"
    exit 1
  fi
    echo "--------------------------- End of db(other than master) dump Recovery---------------------"
  echo "------ Finshed Applying Db Dump...Check for complete execution details in /var/act/log/UDSAgent-"$TARGET_SERVER_NAME"_recovery.log"
fi

echo "***************** End of all database dump  *****************" >> /var/act/log/UDSAgent-"$TARGET_SERVER_NAME"_recovery.log

if [ -e "$logdumpscript" ]; then
    echo "--------------------------- Start of TRANSACTIONAL RECOVERY---------------------"
  echo "*** Executing $LOG_BACKUP_LOCATION/syb_restore_trans_dump for recovering from transaction files ***"
  if [ ! -f "$LOG_BACKUP_LOCATION/syb_restore_trans_dump" ]; then
    echo "ERRORMSG: Load Transaction SQL's for log restore is not generated"
    echo "******** RESTORE_STATUS=$TARGET_SERVER_NAME:fail  *********"
    exit 1
  fi
  $TARGET_SYBASE_SQLD/bin/isql -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X -o $LOG_BACKUP_LOCATION/log_recoveryoutput.txt -i $LOG_BACKUP_LOCATION/syb_restore_trans_dump --retserverror
  retval=$?
  cp -f $LOG_BACKUP_LOCATION/syb_restore_trans_dump /var/act/log/UDSAgent-trans_log_sql.log
  echo "***************** Start of transaction logs *****************" >> /var/act/log/UDSAgent-"$TARGET_SERVER_NAME"_recovery.log
  cat $LOG_BACKUP_LOCATION/log_recoveryoutput.txt >> /var/act/log/UDSAgent-"$TARGET_SERVER_NAME"_recovery.log
  echo "***************** End of transaction logs *****************" >> /var/act/log/UDSAgent-"$TARGET_SERVER_NAME"_recovery.log
  tail -20 $LOG_BACKUP_LOCATION/log_recoveryoutput.txt
  if [ $retval -gt 0 ]; then
    echo "********  RESTORE_STATUS=$TARGET_SERVER_NAME:fail  *********"
    echo "ERRORMSG: There was an error while applying Log transactions... .Check for complete execution details in /var/act/log/UDSAgent-"$TARGET_SERVER_NAME"_recovery.log"
    exit 1
  fi
    echo "--------------------------- End of TRANSACTIONAL Recovery---------------------"
  echo "----- Finished Applying Log Transactions...Check for complete execution details in /var/act/log/UDSAgent-"$TARGET_SERVER_NAME"_recovery.log"
fi

echo "--- Going to Bring All the DB Online ----"

atleast_singledb_restore_success=false
for i in $(echo $DATABASE_NAME | sed "s/,/ /g")
do
dbname=$i
grep -ow "load database $dbname" $DB_BACKUP_LOCATION/syb_restore_db_dump $DB_BACKUP_LOCATION/syb_restore_db_master_dump > /dev/null 2>&1
retval=$?
if [ $retval -gt 0 ]; then
  echo "*** Skipping Restore for database:$dbname since no backup was found"
  continue
fi
atleast_singledb_restore_success=true
echo "Going to bring database:$dbname online"
$TARGET_SYBASE_SQLD/bin/isql -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X --retserverror <<EOF
use master
go
online database $dbname
go
EOF
retval=$?
if [ $retval -gt 0 ]; then
  echo "******** RESTORE_STATUS=$TARGET_SERVER_NAME:fail  *********"
  echo "***** ERRORMSG: failed to make database:$i online post recovery ****"
  exit 1
fi
if [ "$atleast_singledb_restore_success" == "false" ]; then
  echo "******** RESTORE_STATUS=$TARGET_SERVER_NAME:fail  *********"
  echo "***** ERRORMSG: Not even one dbname matching Backup was Found for Restoration ****"
  exit 1
fi


if [ -f "$LOG_BACKUP_LOCATION/tran_dump_$dbname.txt" ]; then
 rm -f $LOG_BACKUP_LOCATION/tran_dump_$dbname.txt
fi

done

echo "******** RESTORE_STATUS=$TARGET_SERVER_NAME:success  *********"

exit 0
