#!/bin/sh
set +x
WPWD=/act/scripts
source $WPWD/act_Sybase_logbackup.conf
SYBACKUP_SCHED=$1

set -x

if [ -z $LOG_BKP_LOC ]; then
  SRC_BACKUP_LOCATION=$LogBackupFS
else
  SRC_BACKUP_LOCATION=$LOG_BKP_LOC
fi

userGroup=`ls -lrt $SRC_SYBASE_SQLD | grep $OSUSER | tail -n 1 | awk -F" " '{print $4}'`
chown -R $OSUSER:$userGroup $SRC_BACKUP_LOCATION

echo "SCHEDULE NAME = ${SYBACKUP_SCHED}"
if [ $SYBACKUP_SCHED = "INCREMENTAL" ]; then
 DUMP_TYPE=TRANSACTION
else
 DUMP_TYPE=DATABASE
fi

echo "DUMP TYPE = ${DUMP_TYPE}"

set +x
echo $SRC_USER_PASSWD |  su - $OSUSER -c "sh /act/act_scripts/sybase/automation/Backup/dbHelper.sh configureLogOptions $SRC_BACKUP_LOCATION"
retval=$?
if [ $retval -gt 0 ]; then
  echo "***** ERRORMSG: failed to execute configureLogOptions function *****"
    echo "*********** BACKUP_TYPE = transactionalLog and BACKUP_STATUS = fail ***************"
  exit 1
fi
set -x

dumpscript=$SRC_BACKUP_LOCATION"/syb_trans_dump"

if [ -e "$dumpscript" ]; then
echo "removing dump script file"
rm -f $dumpscript
fi

#rm -f "$SRC_BACKUP_LOCATION/*.cdmp"

if [ "x$SRC_DBNAME" != "x" ]; then
for i in $(echo $SRC_DBNAME | sed "s/,/ /g")
do
dbname=$i
tsname=`date +%Y%m%d`
tsname1=`date +%H%M%S`
c="STRIPE ON"
if [ $DUMP_TYPE = "DATABASE" ]; then
a="dump $DUMP_TYPE $dbname to"
lf="$dbname"_full_"$tsname"_"$tsname1"
  #Iterating on number of STRIPE ON
  if [ -z "$STRIPEON" ]; then
    STRIPEON=4
  fi
  b=""
  c="STRIPE ON"
  if [ -z "$STRIPEON" ]; then
   STRIPEON=4
  fi
  for (( j=1;  j<= $STRIPEON; ++j ))
  do
      if [ "$STRIPEON" -le "9" ]; then
        if [ "$j" -eq "$STRIPEON" ];then
          b=`echo "$b \"$SRC_BACKUP_LOCATION"/"$lf"_S0"$j"-0"$STRIPEON".cdmp"\""`
        else
           b=`echo "$b \"$SRC_BACKUP_LOCATION"/"$lf"_S0"$j"-0"$STRIPEON".cdmp"\" $c"`
        fi
      else
          if [ "$j" -le "9" ];then
           if [ "$j" -eq "$STRIPEON" ];then
            b=`echo "$b \"$SRC_BACKUP_LOCATION"/"$lf"_S0"$j"-"$STRIPEON".cdmp"\""`
           else
            b=`echo "$b \"$SRC_BACKUP_LOCATION"/"$lf"_S0"$j"-"$STRIPEON".cdmp"\" $c"`
           fi
          else
           if [ "$j" -eq "$STRIPEON" ];then
            b=`echo "$b \"$SRC_BACKUP_LOCATION"/"$lf"_S"$j"-"$STRIPEON".cdmp"\""`
           else
            b=`echo "$b \"$SRC_BACKUP_LOCATION"/"$lf"_S"$j"-"$STRIPEON".cdmp"\" $c"`
           fi
          fi
      fi
   done
echo "$a" "$b" >> $SRC_BACKUP_LOCATION/syb_trans_dump
#echo dump $DUMP_TYPE $dbname to \"$SRC_BACKUP_LOCATION"/"$dbname".dmp"\" >> $SRC_BACKUP_LOCATION/syb_trans_dump
else
#tsname=`date +%Y%m%d%H%M%S`
#logfile=$dbname'_'$tsname.dat
#echo dump $DUMP_TYPE $dbname to \"$SRC_BACKUP_LOCATION"/"$logfile\" >> $SRC_BACKUP_LOCATION/syb_trans_dump
if [ $dbname != "saptools" ]; then
if [ $dbname != "scbtools" ]; then
a="dump $DUMP_TYPE $dbname to"
lf="$dbname"_trans_"$tsname"_"$tsname1"
  c="STRIPE ON"
  for (( j=1;  j<= $STRIPEON; ++j ))
  do
    if [ "$STRIPEON" -le "9" ]; then
        if [ "$j" -eq "$STRIPEON" ];then
          b=`echo "$b \"$SRC_BACKUP_LOCATION"/"$lf"_S0"$j"-0"$STRIPEON".cdmp"\""`
          echo $b
        else
           b=`echo "$b \"$SRC_BACKUP_LOCATION"/"$lf"_S0"$j"-0"$STRIPEON".cdmp"\" $c"`
          echo $b
        fi
      else
          if [ "$j" -le "9" ];then
           if [ "$j" -eq "$STRIPEON" ];then
             b=`echo "$b \"$SRC_BACKUP_LOCATION"/"$lf"_S0"$j"-"$STRIPEON".cdmp"\""`
           else
              b=`echo "$b \"$SRC_BACKUP_LOCATION"/"$lf"_S0"$j"-"$STRIPEON".cdmp"\" $c"`
           fi
          else
           if [ "$j" -eq "$STRIPEON" ];then
            b=`echo "$b \"$SRC_BACKUP_LOCATION"/"$lf"_S"$j"-"$STRIPEON".cdmp"\""`
           else
            b=`echo "$b \"$SRC_BACKUP_LOCATION"/"$lf"_S"$j"-"$STRIPEON".cdmp"\" $c"`
           fi
          fi
      fi
    done
echo "$a" "$b" >> $SRC_BACKUP_LOCATION/syb_trans_dump
b=""
fi
echo go >> $SRC_BACKUP_LOCATION/syb_trans_dump
fi
fi
done
else
while read line
do
    set -- $line
    dbname=$1
        echo "outside if $dbname"
        if [ "x$dbname" != "x" ]; then
        echo "inside if $dbname"

if [ $DUMP_TYPE = "DATABASE" ]; then
#echo dump $DUMP_TYPE $dbname to \"$SRC_BACKUP_LOCATION"/"$dbname".dmp"\" >> $SRC_BACKUP_LOCATION/syb_trans_dump
tsname=`date +%Y%m%d`
tsname1=`date +%H%M%S`
if [ $DUMP_TYPE = "DATABASE" ]; then
a="dump $DUMP_TYPE $dbname to"
lf="$dbname"_full_"$tsname"_"$tsname1"
  #Iterating on number of STRIPE ON
  b=""
  c="STRIPE ON"
  if [ -z "$STRIPEON" ]; then
   STRIPEON=4
  fi
  for (( j=1;  j<= $STRIPEON; ++j ))
  do
      if [ "$STRIPEON" -le "9" ]; then
        if [ "$j" -eq "$STRIPEON" ];then
          b=`echo "$b \"$SRC_BACKUP_LOCATION"/"$lf"_S0"$j"-0"$STRIPEON".cdmp"\""`
        else
           b=`echo "$b \"$SRC_BACKUP_LOCATION"/"$lf"_S0"$j"-0"$STRIPEON".cdmp"\" $c"`
        fi
      else
          if [ "$j" -le "9" ];then
           if [ "$j" -eq "$STRIPEON" ];then
             b=`echo "$b \"$SRC_BACKUP_LOCATION"/"$lf"_S0"$j"-"$STRIPEON".cdmp"\""`
           else
              b=`echo "$b \"$SRC_BACKUP_LOCATION"/"$lf"_S0"$j"-"$STRIPEON".cdmp"\" $c"`
           fi
          else
           if [ "$j" -eq "$STRIPEON" ];then
            b=`echo "$b \"$SRC_BACKUP_LOCATION"/"$lf"_S"$j"-"$STRIPEON".cdmp"\""`
           else
              b=`echo "$b \"$SRC_BACKUP_LOCATION"/"$lf"_S"$j"-"$STRIPEON".cdmp"\" $c"`
           fi
          fi
      fi
   done
echo "$a" "$b" >> $SRC_BACKUP_LOCATION/syb_trans_dump
fi
else
#tsname=`date +%Y%m%d%H%M%S`
#logfile=$dbname'_'$tsname.dat
#echo dump $DUMP_TYPE $dbname to \"$SRC_BACKUP_LOCATION"/"$logfile\" >> $SRC_BACKUP_LOCATION/syb_trans_dump
if [ $dbname != "saptools" ]; then
if [ $dbname != "scbtools" ]; then
tsname=`date +%Y%m%d`
tsname1=`date +%H%M%S`
a="dump $DUMP_TYPE $dbname to"
lf="$dbname"_trans_"$tsname"_"$tsname1"
  #Iterating on number of STRIPE ON
  if [ -z "$STRIPEON" ]; then
    STRIPEON=4
  fi
  c="STRIPE ON"
  for (( j=1;  j<= $STRIPEON; ++j ))
  do
      if [ "$STRIPEON" -le "9" ]; then
        if [ "$j" -eq "$STRIPEON" ];then
          b=`echo "$b \"$SRC_BACKUP_LOCATION"/"$lf"_S0"$j"-0"$STRIPEON".cdmp"\""`
          echo $b
        else
           b=`echo "$b \"$SRC_BACKUP_LOCATION"/"$lf"_S0"$j"-0"$STRIPEON".cdmp"\" $c"`
          echo $b
        fi
      else
          if [ "$j" -le "9" ];then
           if [ "$j" -eq "$STRIPEON" ];then
             b=`echo "$b \"$SRC_BACKUP_LOCATION"/"$lf"_S0"$j"-"$STRIPEON".cdmp"\""`
           else
              b=`echo "$b \"$SRC_BACKUP_LOCATION"/"$lf"_S0"$j"-"$STRIPEON".cdmp"\" $c"`
           fi
          else
           if [ "$j" -eq "$STRIPEON" ];then
            b=`echo "$b \"$SRC_BACKUP_LOCATION"/"$lf"_S"$j"-"$STRIPEON".cdmp"\""`
           else
              b=`echo "$b \"$SRC_BACKUP_LOCATION"/"$lf"_S"$j"-"$STRIPEON".cdmp"\" $c"`
           fi
          fi
      fi
   done
echo "$a" "$b" >> $SRC_BACKUP_LOCATION/syb_trans_dump
b=""
fi
echo go >> $SRC_BACKUP_LOCATION/syb_trans_dump
  fi
fi
fi
done < $SRC_BACKUP_LOCATION/source_dbname.txt
fi

chown -R $OSUSER:$userGroup $SRC_BACKUP_LOCATION/syb_trans_dump
set +x
echo $SRC_USER_PASSWD |  su - $OSUSER -c "sh /act/act_scripts/sybase/automation/Backup/dbHelper.sh executeLogDumpTransaction $SRC_BACKUP_LOCATION"
retval=$?
if [ $retval -gt 0 ]; then
  echo "***** ERRORMSG: Transactional Log Backup has Failed *********"
  exit 1
fi
set -x
