#!/bin/sh
set -x

post_script=$1
tmp_loc=/act/touch
chmod 775 /act/touch

conffile=/act/scripts/act_Conf_Target_Primary.conf
if [ -f $conffile ]; then
 source $conffile
else
 echo "ERROR: Configuration file for Log Recovery does not exist!."
fi

#Get the recovery time from Manifest file location

recovery_from=`cat $TARGET_MNT_PNT/$MANIFEST_FILE_LOC/logbackup.dat`

################Identify the transaction dumps needed for recovery#######################

for i in $(echo $SRC_DBNAME | sed "s/,/ /g")
do
find $LOG_BKP_MNTPT/ -newer $TARGET_MNT_PNT/$MANIFEST_FILE_LOC/logbackup.dat |sort -n | grep $i > $tmp_loc/tran_dump_$i.txt
dump_file=$tmp_loc/tran_dump_$i.txt
if [ ! -z "$UNTIL_TIME" ]; then
 if [ "$UNTIL_TIME" -gt "$recovery_from" ]; then
   rollforwardtime=`date -d "${UNTIL_TIME:0:8} ${UNTIL_TIME:8:2}:${UNTIL_TIME:10:2}:${UNTIL_TIME:12:2}" +"%Y-%m-%d %H:%M:%S"`
   echo "rollforward:$rollforwardtime"
 find $LOG_BKP_MNTPT/ -newer $TARGET_MNT_PNT/$MANIFEST_FILE_LOC/logbackup.dat ! -newerct "$rollforwardtime" | sort -n | grep $i > $tmp_loc/tran_dump_$i.txt
 sed -i '/dummyend/d' $tmp_loc/tran_dump_$i.txt 
 dump_file=$tmp_loc/tran_dump_$i.txt
 else 
  echo "ERROR: UNTIL TIME: $UNTIL_TIME is less than Recovery Time: $recovery_from"
  exit 1
 fi 

########### Compare the timstamp of last dump file to match until time ###############
   lastlogfilename=`tail -n 1 $dump_file`
   lastlogfiletstamp=`tail -n 1 $dump_file | awk -F "_" '{print $2}' | awk -F "." '{print $1}'`
   if [ "$UNTIL_TIME" -gt "$lastlogfiletstamp" ]; then
       find $LOG_BKP_MNTPT/ -newer $lastlogfilename -type f |sort -n |grep $i| head -n 1 >> $dump_file
       lastlogfilename=`tail -n 1 $dump_file`
   fi
fi

i=$i'_act'
while read line
do
if [ ! -z "$UNTIL_TIME" ]; then
if [ "$line" = "$lastlogfilename" ]; then
su - $OSUSER -c "$TARGET_SYBASE_SQLD/bin/isql -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X" <<EOF
load transaction $i from '$line' with until_time='$rollforwardtime'
go
EOF
  else
su - $OSUSER -c "$TARGET_SYBASE_SQLD/bin/isql -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X" <<EOF
load transaction $i from '$line'
go
EOF
fi
else
su - $OSUSER -c "$TARGET_SYBASE_SQLD/bin/isql -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X" <<EOF
load transaction $i from '$line'
go
EOF
fi
done < $dump_file
done

if [ -z $post_script ]; then
for i in $(echo $SRC_DBNAME | sed "s/,/ /g")
do
i=$i'_act'
su - $OSUSER -c "$TARGET_SYBASE_SQLD/bin/isql -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X" <<EOF
online database $i
go
EOF
done
fi

if [ -f $tmp_loc/dummybegin ]; then
 rm -f $tmp_loc/dummybegin
fi

if [ -f $tmp_loc/dummyend ]; then
 rm -f $tmp_loc/dummyend 
fi 

if [ -f "$tmp_loc/tran_dump_*.txt" ]; then
 rm -f $tmp_loc/tran_dump_*.txt
fi
