#!/bin/sh
set -x

getDbSize()
{
    dbSize=0;
    dbSpace=()
    for i in $(echo "$SRC_DBNAME" | sed "s/,/ /g")
    do
        dbname=$i
        dbisqlpath=$(echo $SRC_SYBASEIQ_SQLD | sed "s/,/\n/g" | grep -w $dbname | head -n 1 | cut -d ':' -f 2)
        if [ -z $dbisqlpath ]; then
            dbisql=$SRC_SYBASEIQ_SQLD
        fi
        if [ ! -d $dbisql ]; then
          echo "Error: $dbisql does not exist"
          exit 1
        fi
        #Finding sybase IQ home
        sybiq_home_tmp=$dbisqlpath
        SYBIQ_HOME=$(dirname "$sybiq_home_tmp")
        echo "SYBIQ_HOME = $SYBIQ_HOME"
        version=$(echo "$sybiq_home_tmp" | awk -F"/" '{print $NF}')
        echo "Version= $version"

    set +x
    . "$SYBIQ_HOME/$version/$version".sh
    set -x


        dbuser=$(echo "$SRC_BACKUP_USER" | sed "s/,/\n/g" | grep -w "$dbname" | cut -d ':' -f 2)
        if [ -z "$dbuser" ]; then
            dbuser=$SRC_BACKUP_USER
        fi
        set +x
        dbpasswd=$(echo "$SRC_USER_PASSWD" | sed "s/,/\n/g" | grep -w "$dbname" | cut -d ':' -f 2)
        if [ -z "$dbpasswd" ]; then
            dbpasswd=$SRC_USER_PASSWD
        fi

        dbSpace+=$(su - "$OSUSER" -c "dbisql -nogui -onerror exit -c 'uid=$dbuser;pwd=$dbpasswd; eng=$dbname; dbn=$dbname' "sp_iqdbspace" | sed 's/$/ACTIFIO_UNIQUE/'" | grep ACTIFIO_UNIQUE | sed -e "s/ACTIFIO_UNIQUE//g" | sed -n '3,5p' | awk '{print $6,"\n"}')
        if [ -z "$dbSpace" ]; then
            echo " Error : Query Failure to get DB size for DB:$dbname"
            exit 1
        fi
        set -x
    done
    dbSize=$(convertDbSizeToBytes "${dbSpace[@]}")
    echo "$dbSize"
}


convertDbSizeToBytes()
{
    dbSpace=($@)

    space_output=()

    for i in "${dbSpace[@]}"
    do
        # add bytes as it is
        if [ "${i: -1}" = 'B' ]
        then
            space_output+=(${i%?})
        # convert KB to Bytes
        elif [ "${i: -1}" = 'K' ]
        then
            space_output+=($(echo ${i%?}*1024|bc))
        # convert MB to Bytes
        elif [ "${i: -1}" = 'M' ]
        then
            space_output+=($(echo ${i%?}*1024*1024|bc))
        # convert GB to Bytes
        elif [ "${i: -1}" = 'G' ]
        then
            space_output+=($(echo ${i%?}*1024*1024*1024|bc))
        # convert TB to Bytes
        elif  [ "${i: -1}" = 'T' ]
        then
            space_output+=($(echo ${i%?}*1024*1024*1024*1024|bc))
        fi
    done

    # echo "${space_output[@]}"

    total=0

    # Get total value by sum of space_output array content
    for space in "${space_output[@]}"
    do
        total=`echo $total + $space | bc`
    done

    # convert float to int
    total=${total%.*}
    # This echo is the return value from this function
    echo "$total"
}
