/* ============================================================
 * Actifio VirtualData Pipeline
 * Copyright (c) 2020 Actifio Inc. All Rights Reserved
 *
 * This program code contains trade secrets of Actifio Inc. that
 * (i) derive independent economic value, actual or potential, from not being
 * generally known to, and not being readily ascertainable by proper means by
 * other persons who can obtain economic value from their disclosure or use and;
 * (ii) are the subject of efforts by Actifio Inc that are reasonable under the
 * circumstances to maintain their secrecy. You may not use this program code
 * without prior written authorization from Actifio Inc.
 *
 * Filename       : temptbsCatalog.sql
 *
 * Description:   retrieve temp tablespace info for multi-tenantent database
 *
 * =============================================================
 */

set pages 0
set head off
set feed off
set timing off
set echo off
set lin 320
WHENEVER SQLERROR EXIT SQL.SQLCODE
select 'CDB$ROOT' || ':' || a.name || ':' || count(*) from v$tablespace a, v$tempfile b where a.ts#=b.ts# and a.con_id=b.con_id and a.con_id = 1 group by a.con_id, a.name
union
select p.name || ':' || a.name || ':' || count(*) from v$tablespace a, v$tempfile b, v$pdbs p  where a.ts#=b.ts# and a.con_id=b.con_id and p.con_id = a.con_id group by p.name, a.name
union
select 'NONCDB' || ':' || a.name || ':' || count(*) from v$tablespace a, v$tempfile b where a.ts#=b.ts#  and a.con_id=b.con_id and a.con_id = 0 group by a.con_id, a.name order by 1;
exit;
