/* ============================================================
 * Actifio VirtualData Pipeline
 * Copyright (c) 2020 Actifio Inc. All Rights Reserved
 *
 * This program code contains trade secrets of Actifio Inc. that
 * (i) derive independent economic value, actual or potential, from not being
 * generally known to, and not being readily ascertainable by proper means by
 * other persons who can obtain economic value from their disclosure or use and;
 * (ii) are the subject of efforts by Actifio Inc that are reasonable under the
 * circumstances to maintain their secrecy. You may not use this program code
 * without prior written authorization from Actifio Inc.
 *
 * Filename       : undoCatalog.sql
 *
 * Description:   retrieve undo  tablespace info for multi-tenantent database
 *
 * =============================================================
 */

set pages 0
set head off
set feed off
set timing off
set echo off
set lin 320
WHENEVER SQLERROR EXIT SQL.SQLCODE
select container_name || ':' || tbsname || ':' || count(file_no) from (select distinct f.file# as file_no, f.con_id as con_id, t.name as tbsname, 'CDB$ROOT' as container_name from v$datafile f, v$tablespace t where f.ts# = t.ts# and t.con_id = 1 and t.name like '%UNDO%') group by container_name, tbsname
union
select  container_name || ':' || tbsname || ':' || count(file_no) from (select distinct f.file# as file_no, f.con_id as con_id, t.name as tbsname, p.name as container_name from v$datafile f, v$tablespace t, v$pdbs p where f.ts# = t.ts# and f.con_id = t.con_id and t.name like '%UNDO%' and p.con_id = t.con_id) group by container_name, tbsname order by 1 asc;
exit;
