#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
#                  !!!Actifio Private Script. DO NOT MODIFY!!!
#
# ==============================================================================#

usage() {
  echo "Usage: "
  echo "/act/custom_apps/db2/CALL_ACT_DB2_mountrecover.sh \"\" \"  <TARGET_INSTANCE>  <TARGET_MNT>  <TARGET_DBNAME_LIST>   [<UNTIL_TIME>] \" "
}

isProvided() {
  local varName=$1
  local varVal=$2
  if [ -z "$varVal" ]; then
    echo "ERRORMSG: $varName is empty."
    usage
    exit 1
  fi
}

set -x

TARGET_INSTANCE=$2
TARGET_MNT=$3
TARGET_DBNAME_LIST=$4
UNTIL_TIME=$5

TARGET_DBNAME_LIST=`echo $TARGET_DBNAME_LIST|sed 's/::/,/g'`	

TARGET_INSTANCE=$TARGET_INSTANCE		# (User need to give)
TARGET_DBNAME_LIST=$TARGET_DBNAME_LIST		# Comma seperated list of <SRC_DBNAME>:<new_dbname> (User need to give)
UNTIL_TIME="$UNTIL_TIME"			# Recover time (User need to give)
TARGET_MNT=$TARGET_MNT		         	# Target mount point provided during simple mount (Connector can pass)

if [ ! -z "$ACT_JOBNAME" ]; then
  JOBID=$ACT_JOBNAME
fi

isProvided TARGET_INSTANCE $TARGET_INSTANCE
isProvided TARGET_DBNAME_LIST $TARGET_DBNAME_LIST
isProvided TARGET_MNT $TARGET_MNT
isProvided JOBID $JOBID

if [ ! -z "$UNTIL_TIME" ]; then
  isProvided UNTIL_TIME $UNTIL_TIME
fi


echo "***** Calling /act/custom_apps/db2/clone/ACT_DB2_mountrecover.sh for MountRecovery *****"
/act/custom_apps/db2/clone/ACT_DB2_mountrecover.sh TARGET_INSTANCE=$TARGET_INSTANCE  TARGET_MNT=$TARGET_MNT  TARGET_DBNAME_LIST=$TARGET_DBNAME_LIST  JOBID=$JOBID UNTIL_TIME=$UNTIL_TIME
if [ $? -ne 0 ]; then
  echo "ERRORMSG: MountRecover operation failed"
  exit 1
fi
exit 0
