#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
#                  !!!Actifio Private Script. DO NOT MODIFY!!!
#
# ==============================================================================#

isProvided() {
  local varName=$1
  local varVal=$2
  if [ -z "$varVal" ]; then
    echo "ERRORMSG: $varName is empty."
    usage
    exit 1
  fi
}


usage() {
  echo "Usage: "
  echo "/act/custom_apps/db2/CALL_ACT_DB2_singledbrestore.sh \"\" \" <DB_NAME> <TARGET_MNT> <DATA_MAPPING>  [ <UNTIL_TIME> ]\" "
  exit 1 
}

set -x

echo "***************** POSTSKJOB_TYPE= $ACT_JOBTYPE *********************"

if [ "$ACT_JOBTYPE" = "unmount" ] || [ "$ACT_MULTI_OPNAME" = "unmount" ] ; then
   echo "NO-OP for post-script when unmount"
   exit 0
fi
if [ "$ACT_JOBTYPE" = "mount" ] || [ "$ACT_MULTI_OPNAME" = "mount" ] ; then
   if [ "$ACT_PHASE" = "pre" ] ; then
        echo "** No op for pre during unmount **"
      exit
   fi
   if [ "$ACT_PHASE" = "post" ] ; then
        echo "************************* start post during mount ************************"


DB_NAME=$2
TARGET_MNT=$3
DATA_MAPPING=$4
UNTIL_TIME=$5

set -x
JOBID=$ACT_JOBNAME
DB2_INSTANCE_NAME=$SOURCE_INSTANCE
DB_NAME=$DB_NAME
RECOVERYTIME=$UNTIL_TIME
ARCHIVELOG_MNT=$ARCHIVELOG_MNT
TARGET_MNT=$TARGET_MNT
DATA_MAPPING=$DATA_MAPPING

set +x
isProvided DB_NAME $DB_NAME
isProvided TARGET_MNT $TARGET_MNT
isProvided ACT_JOBNAME  $ACT_JOBNAME
isProvided DATA_MAPPING  $DATA_MAPPING

if [ ! -z "$UNTIL_TIME" ]; then
  isProvided UNTIL_TIME $UNTIL_TIME
fi
set -x

dbName=$DB_NAME
CONF_FILE=/act/touch/"$dbName"_"$JOBID"_params
     if [ ! -f $CONF_FILE ]; then
        echo "ERRORMSG: Configuration  file $CONF_FILE is not created!"
        exit 1
     else
         SOURCE_INSTANCE=`cat $CONF_FILE | grep SOURCE_INSTANCE | cut -d= -f2`
         SOURCE_LOGARCHMETH1=`cat $CONF_FILE | grep SOURCE_LOGARCHMETH1 | cut -d= -f2`
         ARCHIVELOG_MNT=`cat $CONF_FILE | grep ARCHIVELOGMOUNTPATH |cut -d= -f2`
         SOURCE_VERSION=`cat $CONF_FILE |grep SOURCE_VERSION | cut -d= -f2`
     fi
export SOURCE_INSTANCE
export SOURCE_LOGARCHMETH1
export ARCHIVELOG_MNT
export SOURCE_VERSION


DATA_MAPPING=`echo $DATA_MAPPING | sed 's/::/,/g'`

echo "********** call DB2 recovery ************"
/act/custom_apps/db2/restore/act_db2_lvm_singledb_recovery.sh JOBID=$JOBID DATA_MAPPING=$DATA_MAPPING TARGET_MNT=$TARGET_MNT  DB_NAME=$DB_NAME  UNTIL_TIME=$UNTIL_TIME
retval=$?

if [ $retval -ne 0 ]; then
    echo "ERRORMSG: fail to perform Single database restore in target "
    exit $retval
fi

echo "********** end DB2  recover with exit code: $retval ************"
exit 0
fi
fi

