#!/bin/sh



DBINSTANCE=$1
DBNAME=$2
OSUSER=$DBINSTANCE
if [ "$#" -lt 2 ]; then
   echo "/act/custom_apps/db2/act_db_getarchlocation.sh <DB2INSTANCE> <DBNAME>"
   exit 1
fi

if [ "$DBINSTANCE" = "" ]; then
  echo "ERRORMSG: Db2 Instance name (DB2INSTNAME) is not provided."
  exit 1
fi

if [ "$DBNAME" = "" ]; then
  echo "ERRORMSG: Database  name (DBNAME) is not provided"
  exit 1
fi

#finding Instance Home
proc_id=`ps aux | grep -w $OSUSER |grep -w  db2sysc|grep -v grep|awk '{print $2}'`
 if [ -z "$proc_id" ];then
     echo "ERRORMSG: DB2 Instance $OSUSER is not running! Please check logs for more details"
     exit 1
 fi

 db2home=`ps eww $proc_id |tr ' ' '\n'|grep -w DB2_HOME|cut -d "=" -f2`
 INSTHOME=`ps eww $proc_id |tr ' ' '\n'|grep -w HOME|cut -d "=" -f2`
 DB2LIB=`ps eww $proc_id |tr ' ' '\n'|grep -w DB2LIB|cut -d "=" -f2`

   if [ -z "$db2home" ] && [ -z "$INSTHOME" ] && [ -z "$DB2LIB" ]; then
       db2home=`cat /etc/passwd | grep -w $OSUSER | awk -F : '{print $6}'`
       db2home="$db2home"/sqllib
       if [ -f "$db2home/db2profile" ]; then
       set +x
       . "$db2home"/db2profile
       set -x
       db2bin=$db2home"/bin"
       fi
  elif [ -f "$INSTHOME/sqllib/db2profile" ] ;then
       db2home="$INSTHOME"/sqllib
       set +x
       . "$db2home"/db2profile
       set -x
       db2bin=$db2home"/bin"
  elif [ ! -z "$DB2LIB" ]; then
       db2home=`dirname $DB2LIB`
       if [ -f "$db2home/db2profile" ]; then
       set +x
       . "$db2home"/db2profile
       set -x
       db2bin=$db2home"/bin"
       fi
  else
       if [ -f "$db2home/db2profile" ]; then
       set +x
       . "$db2home"/db2profile
       set -x
       db2bin=$db2home"/bin"
       fi
  fi




db_part_nums=`awk '{print $1}' $db2home/db2nodes.cfg | awk '{sub(/^[ \t]+/, "")};1' | grep -v "^#" | sort -nr`

su  $DBINSTANCE -c "db2 connect to $DBNAME > /dev/null"

log_path=`su  $DBINSTANCE -c "db2 get db cfg for $DBNAME|grep LOGARCHMETH1 |awk '{print $7}'|cut -d ":" -f2"`

cd $log_path$DBINSTANCE/$DBNAME

Node=`ls -lrt|awk '{print $9}'|sed -n '$p'`

cd $log_path$DBINSTANCE/$DBNAME/$Node/LOGSTREAM0000


Node_contain=`ls -lrt|awk '{print $9}'|sed -n '$p'`

cd $log_path$DBINSTANCE/$DBNAME/$Node/LOGSTREAM0000/$Node_contain

echo "$DBNAME:`pwd` "



