#!/bin/sh
set -x

PWDS=/act/custom_apps/db2

DB2INSTNAME=$DB2_INSTANCE_NAME
DATABASE_LIST=$DB_DATABASE_LIST

OSUSER=$DB2INSTNAME
#DB2INSTNAME=db2inst1
#DATABASE_LIST=SAK1,VIN1

if [ "$DB2INSTNAME" = "" ]; then
  echo "ERRORMSG: Db2 Instance name (DB2INSTNAME) is not provided."
  exit 1
fi

if [ "$DATABASE_LIST" = "" ]; then
  echo "ERRORMSG: Database list (DATABASE_LIST) is not provided"
  exit 1
fi

if [ "$OSUSER" = "" ]; then
  echo "ERRORMSG: Db2 os username (OSUSER) is not provided "
  exit 1
fi

 proc_id=`ps aux | grep -w $OSUSER |grep -w  db2sysc|grep -v grep|awk '{print $2}'`
 if [ -z "$proc_id" ];then
     echo "ERRORMSG: DB2 Instance $OSUSER is not running! Please check logs for more details"
     exit 1
 fi
 db2home=`ps eww $proc_id |tr ' ' '\n'|grep -w DB2_HOME|cut -d "=" -f2`
 INSTHOME=`ps eww $proc_id |tr ' ' '\n'|grep -w HOME|cut -d "=" -f2`
 DB2LIB=`ps eww $proc_id |tr ' ' '\n'|grep -w DB2LIB|cut -d "=" -f2`
  if [ -z "$db2home" ] && [ -z "$INSTHOME" ] && [ -z "$DB2LIB" ]; then
       db2home=`cat /etc/passwd | grep -w $OSUSER | awk -F : '{print $6}'`
       db2home="$db2home"/sqllib
       if [ -f "$db2home/db2profile" ]; then
       set +x
       . "$db2home"/db2profile
       set -x
       db2bin=$db2home"/bin"
       fi
  elif [ -f "$INSTHOME/sqllib/db2profile" ] ;then
       db2home="$INSTHOME"/sqllib
       set +x
       . "$db2home"/db2profile
       set -x
       db2bin=$db2home"/bin"
  elif [ ! -z "$DB2LIB" ]; then
       db2home=`dirname $DB2LIB`
       if [ -f "$db2home/db2profile" ]; then
       set +x
       . "$db2home"/db2profile
       set -x
       db2bin=$db2home"/bin"
       fi
  else
       if [ -f "$db2home/db2profile" ]; then
       set +x
       . "$db2home"/db2profile
       set -x
       db2bin=$db2home"/bin"
       fi
  fi

OLDIFS=IFS

IFS=','

for dbname in $DATABASE_LIST
do
  logarch_status=`su  $OSUSER -c "db2 get db cfg for $dbname" | grep LOGARCHMETH1`
  logarch_status=`echo $logarch_status | awk -F"=" '{print $2}' | xargs`
  if [ "$logarch_status" = "" ] || [ "$logarch_status" = "OFF" ] || [ "$logarch_status" = "LOGRETAIN" ]; then
     echo "ERRORMSG: $dbname LOGARCHMETH1 is not configured "
     exit 1
  fi
done

exit 0

