#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================
set -x

PWDS=/act/custom_apps/db2

DB2INSTNAME=$SOURCE_INSTANCE
DATABASE_LIST=$DB_LIST
OSUSER=$DB2INSTNAME
DB_LIST=`echo $DATABASE_LIST | tr [:lower:] [:upper:]`
echo "$DB_LIST"

#Instance status

find_inst=$(ps -ef | grep [d]b2sys | awk '{print $1}' | grep -w $DB2INSTNAME | wc -l)
                  
if [[ $find_inst -ne 1 ]] ; then
    echo " ERRORMSG: Instance is not running "
    exit 1
fi

#db2 Instance home

#identify db2_home
   proc_id=`ps aux | grep -w $OSUSER |grep -w  db2sysc|grep -v grep|awk '{print $2}'`
   if [ -z "$proc_id" ];then
       echo "ERRORMSG: DB2 Instance $OSUSER is not running! Please check logs for more details"
       exit 1
   fi

 db2home=`ps eww $proc_id |tr ' ' '\n'|grep -w DB2_HOME|cut -d "=" -f2`
 INSTHOME=`ps eww $proc_id |tr ' ' '\n'|grep -w HOME|cut -d "=" -f2`
 DB2LIB=`ps eww $proc_id |tr ' ' '\n'|grep -w DB2LIB|cut -d "=" -f2`

   if [ -z "$db2home" ] && [ -z "$INSTHOME" ] && [ -z "$DB2LIB" ]; then
       db2home=`cat /etc/passwd | grep -w $OSUSER | awk -F : '{print $6}'`
       db2home="$db2home"/sqllib
       if [ -f "$db2home/db2profile" ]; then
       set +x
       . "$db2home"/db2profile
       set -x
       db2bin=$db2home"/bin"
       fi
  elif [ -f "$INSTHOME/sqllib/db2profile" ] ;then
       db2home="$INSTHOME"/sqllib
       set +x
       . "$db2home"/db2profile
       set -x
       db2bin=$db2home"/bin"
  elif [ ! -z "$DB2LIB" ]; then
       db2home=`dirname $DB2LIB`
       if [ -f "$db2home/db2profile" ]; then
       set +x
       . "$db2home"/db2profile
       set -x
       db2bin=$db2home"/bin"
       fi
  else
       if [ -f "$db2home/db2profile" ]; then
       set +x
       . "$db2home"/db2profile
       set -x
       db2bin=$db2home"/bin"
       fi
  fi

#OLDIFS=IFS

#IFS=','

for dbname in $(echo $DB_LIST| tr "," " ")
do
  db_part_nums=`awk '{print $1}' $db2home/db2nodes.cfg | awk '{sub(/^[ \t]+/, "")};1' | grep -v "^#" | sort -nr`
 # dbstatus=`db2 "connect to $dbname">/dev/null;db2 -x "select db_status FROM SYSIBMADM.SNAPDB" | grep -v "selected"|xargs`
  if [ "$dbstatus" = "ACTIVE" ]; then      
     #Deactivating Databases                
     for DB_PART_NUM in $db_part_nums; do
        export DB2NODE=$DB_PART_NUM
        su $OSUSER <<EOF
        db2 connect to $dbname
        db2 terminate
        db2 deactivate database $dbname
EOF
        retval=$?
        if [ "$retval" -gt 0 ]; then
           echo "ERRORMSG: Failed to deactivate database $dbname!"
           exit 1
        fi
     done
  fi
done

exit 0


