#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#
set -x
XMLFILE="/act/custom_apps/SAPHANA.xml"
SCRIPTS="/act/custom_apps/saphana/CustomApp_SAPHANA.sh"
FTYPE="SAPHANA"
DBUSER=""
DBSID=""
KEYNAME=""
INSTANCENUM=""
HVERSION=""
VERSION=""
DATAVOL=""
DATAPATH=""
LOGVOL=""
LOGPATH=""
DATAVOLUMEOWNER=""
PYTHONPATH=""



remove_file()
{
  fname=$1
  if [ -f "$fname" ]; then
     rm -f $fname
  fi
}

timeout=1
while [ $timeout -lt 10 ]
do
  if [ -f /act/touch/globaliniupdate ]; then
     sleep 10
  else
     break;
  fi
  timeout=$(($timeout+1))
done

echo -e "<applications>" > $XMLFILE
#getting SAPHANA dbuser
#ps -ef | grep -i hdbindexserver | grep -v grep | awk '{print $1}'
#DBUSER=`ps -ef | grep -i hdbindexserver | grep -v grep | awk '{print $1}'` 
ps -ef | grep -i hdbnameserver | grep -v grep | awk '{print $1}' | while read line
do
DBUSER=$line

if [ -z "$DBUSER" ]; then
   echo "failed to find any running instance"
#   exit 1
fi

#get dbsid
DBSID=`echo $DBUSER | cut -c 1-3`

INSTANCENUM=`su - $DBUSER -c 'env | grep TINSTANCE= | cut -d"=" -f2'`

if [ -z "$INSTANCENUM" ]; then
   INSTANCENUM=`su - $DBUSER -c 'basename $DIR_INSTANCE | rev | cut -c 1-2 | rev'`
fi

HVERSION=`su - $DBUSER -c "HDB version | grep -i version: | cut -d':' -f2 | sed -e 's/^[ \t]*//'"`
VERSION=`echo $HVERSION | cut -c1-3`

#globalinipath=`locate global.ini | grep -i "custom/config/global.ini" | grep -i $DBSID`

globalpath=`su - $DBUSER -c 'echo $DIR_INSTANCE'`
globalpath=`dirname $globalpath`
globalinipath=$globalpath/SYS/global/hdb/custom/config/global.ini
configpath=$globalpath/SYS/global/hdb/custom/config

DATAVOL=`grep -iw ^basepath_datavolumes $globalinipath | cut -d"=" -f2 | sed -e 's/^[ \t]*//'`
LOGVOL=`grep -iw ^basepath_logvolumes $globalinipath | cut -d"=" -f2 | sed -e 's/^[ \t]*//'`
LOGBACKUPPATH=`grep -iw ^basepath_logbackup $globalinipath | cut -d"=" -f2 | sed -e 's/^[ \t]*//'|sort|uniq`
CATLOGBACKUPPATH=`grep -iw ^basepath_catalogbackup $globalinipath | cut -d"=" -f2 | sed -e 's/^[ \t]*//'|sort|uniq`
CATLOGBACKUPPATH_UNQCNT=`grep -iw ^basepath_catalogbackup $globalinipath|uniq | wc -l`
CATLOGBACKUPPATH_CNT=`grep -iw ^basepath_catalogbackup $globalinipath | wc -l`

DATAVOL_MNT_EXISTS=`df -P $DATAVOL |tail -1 | wc -l`
LOGVOL_MNT_EXISTS=`df -P $LOGVOL |tail -1 | wc -l`

if [ "$DATAVOL_MNT_EXISTS" -eq 0 ] && [ "$LOGVOL_MNT_EXISTS" -eq 0 ]; then
   echo "ERRORMSG: No mounted volumes found for DATA/LOG. Please check!"
   continue
elif [ "$DATAVOL_MNT_EXISTS" -eq 0 ]; then 
     echo "ERRORMSG: No mounted volumes found for DATA. Please check!"
     continue
elif [ "$LOGVOL_MNT_EXISTS" -eq 0 ]; then
     echo "ERRORMSG: No mounted volumes found for LOG. Please check!"
     continue
fi

if [ ! -d "$LOGBACKUPPATH" ]; then
   TMPLOGBACKUPPATH=`dirname $LOGBACKUPPATH`
   if [ ! -d "$TMPLOGBACKUPPATH" ]; then
      echo "WARNINGMSG: Log Backup Path $LOGBACKUPPATH does not exist for $DBSID! Please check!"
      continue
   fi
fi

if [ ! -z "$LOGBACKUPPATH" ] && [ "$CATLOGBACKUPPATH_UNQCNT" -gt 1 ]; then
    sed -i "/basepath_catalogbackup/d" $globalinipath
    sed -i "/\bpersistence\b/a basepath_catalogbackup = $LOGBACKUPPATH" $globalinipath
elif [ ! -z "$LOGBACKUPPATH" ] && [ -z "$CATLOGBACKUPPATH" ]; then
    sed -i "/\bpersistence\b/a basepath_catalogbackup = $LOGBACKUPPATH" $globalinipath
fi

CATLOGBACKUPPATH=`grep -iw ^basepath_catalogbackup $globalinipath | cut -d"=" -f2 | sed -e 's/^[ \t]*//'`
LOGMODE=`grep -i log_mode $globalinipath | cut -d"=" -f2 | sed -e 's/^[ \t]*//'`

HANANODE=`cat $configpath/nameserver.ini | grep -w "^worker" | awk -F "=" '{print $2}'`
MASTERNODE=`cat $configpath/nameserver.ini | grep -w "^active_master" | awk -F "=" '{print $2}' | awk -F ":" '{print $1}'`
STANDBYNODE=`cat $configpath/nameserver.ini | grep -w "^standby" | awk -F "=" '{print $2}' | awk -F ":" '{print $1}'`
SITENAME=`cat $configpath/global.ini | grep -w "^site_name" | awk -F "=" '{print $2}' | awk -F ":" '{print $1}'`
HARDWAREKEY=`cat $configpath/nameserver.ini | grep -w "^id" | awk -F "=" '{print $2}' | awk -F ":" '{print $1}'`

dbuser=`echo $DBSID | tr '[A-Z]' '[a-z]'`
dbuser="$dbuser"adm

if [ ! -d /act/touch ]; then
   mkdir -p /act/touch
   chmod 755 /act/touch
else
   chmod 755 /act/touch
fi

HANANODE_COUNT=`echo $HANANODE |wc -w`
if [ "$HANANODE_COUNT" -ge 1 ] && [ ! -z "$STANDBYNODE" ]; then
   CLUSTERTYPE="scaleout"
elif [ "$HANANODE_COUNT" -gt 1 ]; then
     CLUSTERTYPE="scaleout"
fi

if [ "$CLUSTERTYPE" != "scaleout" ]; then
   CHECK_REPLICATION_FILE=/act/touch/replica_$DBSID.txt
   remove_file $CHECK_REPLICATION_FILE
   if [ ! -f $CHECK_REPLICATION_FILE ]; then
      touch $CHECK_REPLICATION_FILE
      chown $dbuser:sapsys $CHECK_REPLICATION_FILE
   fi
   REPLICATION_ENABLED=`su - $dbuser -c "hdbnsutil -sr_state>$CHECK_REPLICATION_FILE "`
   REPLICATION_ENABLED=`grep -w "operation mode:" $CHECK_REPLICATION_FILE |awk -F":" '{print $2}'|xargs`
   
   if [ "$REPLICATION_ENABLED" = "logreplay" ] || [ "$REPLICATION_ENABLED" = "logreplay_readaccess" ] || [ "$REPLICATION_ENABLED" = "sync" ] || [ "$REPLICATION_ENABLED" = "delta_datashipping" ]; then
      MASTERNODE=`grep -w "primary masters" $CHECK_REPLICATION_FILE | awk -F":" '{print $2}'|xargs`
      REPLICATEDNODES=`cat $CHECK_REPLICATION_FILE | awk '/Site Mappings:/{f=0} f; /Host Mappings:/{f=2}' |awk -F"]" '{print $2}' |xargs`
      REPLICATEDNODES=`echo $REPLICATEDNODES |sed "s/$MASTERNODE//g"`
      CLUSTERTYPE="replication"
   elif [ "$REPLICATION_ENABLED" = "primary" ]; then
        MASTERNODE=`su - $DBUSER -c 'HDBSettings.sh landscapeHostConfiguration.py --sapcontrol=1 | grep -iw host  | awk -F"=" '"'"'{print $2}'"'"' '`
        REPLICATEDNODES=`cat $CHECK_REPLICATION_FILE | awk '/Site Mappings:/{f=0} f; /Host Mappings:/{f=2}' |awk -F"]" '{print $2}' |xargs`
        REPLICATEDNODES=`echo $REPLICATEDNODES |sed "s/$MASTERNODE//g"`
        CLUSTERTYPE="replication"
   fi 
   remove_file "$CHECK_REPLICATION_FILE"
   
   if [ ! -z "$REPLICATEDNODES" ]; then
       HANANODE=$MASTERNODE' '$REPLICATEDNODES
   fi
   
   EXTENDED_WORKER=`cat $configpath/nameserver.ini | grep -w "extended_storage_worker" |awk -F"=" '{print $1}' |awk -F"_" '{print $2}' |xargs`
   HANANODE=$HANANODE' '$STANDBYNODE
   HANANODE=$HANANODE' '$EXTENDED_WORKER
   
   if [ ! -z "$EXTENDED_WORKER" ]; then
      CLUSTERTYPE="dynamictiering"
   fi
fi
SSLENFORCE=`grep "sslenforce" $globalpath/SYS/global/hdb/custom/config/global.ini`
SSLENFORCE=`echo $SSLENFORCE | awk -F "=" '{print $2}'|xargs`

if [ "$SSLENFORCE" = "true" ]; then
   hdbsql="hdbsql -e -sslprovider commoncrypto -sslkeystore $SECUDIR/sapsrv.pse -ssltruststore $SECUDIR/sapsrv.pse"
else
   hdbsql="hdbsql"
fi

### Added for MDL Calculation ####
if [ "$VERSION" = "1.0" ]; then
   MULTIDB=`grep "mode" $globalpath/SYS/global/hdb/custom/config/global.ini | grep -iw multidb |awk -F"=" '{print $2}'`
   MULTIDB=`echo $MULTIDB | tr '[A-Z]' '[a-z]'|xargs`
fi

if [ "$VERSION" = "1.0" ] && [ "$MULTIDB" != "multidb" ]; then
   MDLSQL="select sum(TOTAL_SIZE) from M_VOLUME_FILES where file_type='DATA'"
else
   MDLSQL="select sum(TOTAL_SIZE) from sys_databases.M_VOLUME_FILES where file_type='DATA'"
fi

localnode=`hostname`
uuidsql="select top 1 FILE_NAME from sys_databases.M_DATA_VOLUMES where host='$localnode'"
uuid=`su - $dbuser -c "$hdbsql -U $USERSTOREKEY -a -j -x \"$uuidsql\""`
uuid=`dirname $uuid`
uuid=`dirname $uuid`
uuid=`basename $uuid`
if [ "$CLUSTERTYPE" = "scaleout" ]; then
    DATAVOL=$DATAVOL"/"$uuid;
    LOGVOL=$LOGVOL"/"$uuid;
fi

CHECKDATAMNT=`df -P $DATAVOL | awk 'NR==2{print $NF}'`
if [ ! -z "$CHECKDATAMNT" ]; then
  DATAPATH=$CHECKDATAMNT
else
  DATAPATH=${DATAVOL::-4}
fi
CHECKDATAPATH=`df -P $DATAPATH | awk 'NR==2{print $NF}'`
if [ -z "$CHECKDATAPATH" ]; then
  echo "ERRORMSG: Could not get the DATA mount path"
fi

CHECKLOGMNT=`df -P $LOGVOL |awk 'NR==2{print $NF}'`
if [ ! -z "$CHECKLOGMNT" ]; then
  LOGPATH=$CHECKLOGMNT
else
  LOGPATH=${LOGVOL::-4}
fi
CHECKLOGPATH=`df -P $LOGPATH | awk 'NR==2{print $NF}'`
if [ -z "$CHECKLOGPATH" ]; then
  echo "ERRORMSG: Could not get the LOG mount path" 
fi

DATAVOLUMEOWNER=`ls -l $DATAPATH |grep -iw "$DBSID" |grep -v "grep" | awk '{print $3":"$4}'`



echo "DBUSER=$DBUSER DBSID=$DBSID  INSTANCENUM=$INSTANCENUM HVERSION=$HVERSION VERSION=$VERSION"
echo "DATAVOL=$DATAVOL LOGVOL=$LOGVOL"
echo "DATAPATH=$DATAPATH LOGPATH=$LOGPATH"
echo "LOGBACKUPPATH=$LOGBACKUPPATH"

PORT=$INSTANCENUM
DBPORT='HDB'$PORT

if [ ! -z "$USERSTOREKEY" ]; then
   SQL="select string_agg(database_name,',')  from m_databases"
   dbuser=`echo $DBSID | tr '[A-Z]' '[a-z]'`
   dbuser="$dbuser"adm
   dbnames=`su - $dbuser -c "$hdbsql -U $USERSTOREKEY -a -j -x \"$SQL\""`
   dbnames=`echo $dbnames | sed 's/"//g'`
   DBSIZE=`su - $dbuser -c "$hdbsql -U $USERSTOREKEY -a -j -x \"$MDLSQL\""`
   DBSIZE=`echo $DBSIZE | sed 's/"//g'`
   SQL="SELECT HARDWARE_KEY FROM M_LICENSE WHERE PRODUCT_NAME='SAP-HANA'"
   HARDWAREKEY=`su - $dbuser -c "$hdbsql -U $USERSTOREKEY -a -j -x \"$SQL\""`
   HARDWAREKEY=`echo $HARDWAREKEY | sed 's/"//g'`
   SQL="select distinct SITE_NAME  from PUBLIC.M_SYSTEM_REPLICATION"
   SITENAME=`su - $dbuser -c "$hdbsql -U $USERSTOREKEY -a -j -x \"$SQL\""`
   SITENAME=`echo $SITENAME | sed 's/"//g'`
fi

echo "*****************: data path: $DATAPATH ***********"

localnode=`hostname`
#uuidsql="select top 1 FILE_NAME from sys_databases.M_DATA_VOLUMES where host='$localnode'"
#uuidsql="select top 1 FILE_NAME from M_DATA_VOLUMES"
#uuid=`su - $dbuser -c "$hdbsql -U $USERSTOREKEY -a -j -x \"$uuidsql\""`
#uuid=`dirname $uuid`
#uuid=`dirname $uuid`
#uuid=`basename $uuid`

uuidcheck=`echo $DATAVOL |grep mnt |wc -l`
if [ "$uuidcheck" -gt 0 ]; then
   uuid=`basename $DATAVOL`
else
   uuid=`ls -l $DATAVOL | grep mnt | awk '{print $9}'`
fi

if [ "$CLUSTERTYPE" = "scaleout" ]; then
   STANDBYNODE=`su - $dbuser -c "HDBSettings.sh landscapeHostConfiguration.py --sapcontrol=1 | grep hostActualRoles | grep standby | awk -F'/' '{print \\$2}' |xargs"`
fi
echo -e "\t<application name=\"$DBSID\" friendlytype=\"$FTYPE\" instance=\"$INSTANCENUM\" DBSID=\"$DBSID\" PORT=\"$INSTANCENUM\" DBPORT=\"$DBPORT\" version=\"$VERSION\" datavolowner=\"$DATAVOLUMEOWNER\" hananodes=\"$HANANODE\" masternode=\"$MASTERNODE\" standbynode=\"$STANDBYNODE\" extendedworker=\"$EXTENDED_WORKER\" keyname=\"$KEYNAME\" dbnames=\"$dbnames\" uuid=\"$uuid\" hardwarekey=\"$HARDWAREKEY\" sitename=\"$SITENAME\" clustertype=\"$CLUSTERTYPE\" replication_nodes=\"$REPLICATEDNODES\" >" >> $XMLFILE
echo -e "\t\t<files>" >> $XMLFILE
if [ -d $DATAPATH ]; then
###### Modified for LVM CAF Cluster ######
############# GENERATE VOLUME for each  NODE ###################
   echo -e "\t\t\t<file path=\"$DATAPATH\" datavol=\"$DATAVOL\" >" >> $XMLFILE
   if [ ! -z "$USERSTOREKEY" ]; then
#      nodelist=`echo $HANANODE |sed "s/$STANDBYNODE//g"`
       nodelist=`su - $dbuser -c "HDBSettings.sh landscapeHostConfiguration.py --sapcontrol=1 | grep hostActualRoles | grep worker | awk -F'/' '{print \\$2}' |xargs"`
#       nodelist=`echo $nodelist |awk -F"/" '{print $2}' |xargs`
      for nodename in $(echo $nodelist)
      do
        sql="select top 1 FILE_NAME from sys_databases.M_DATA_VOLUMES where host='$nodename'"
        datapath=`su - $dbuser -c "$hdbsql -U $USERSTOREKEY -a -j -x \"$sql\""`
 	datapath=`dirname $datapath`
        datapath=`dirname $datapath`
        datapath=`echo $datapath | sed 's/"//g'`
        echo -e "\t\t\t\t<cluster nodename=\"$nodename\" path=\"$datapath\" />" >>$XMLFILE
      done
   fi
   echo -e "\t\t\t</file>" >>$XMLFILE
fi
if [ -d $LOGPATH ]; then
   echo -e "\t\t\t<file path=\"$LOGPATH\" logvol=\"$LOGVOL\" >" >>$XMLFILE
   if [ ! -z "$USERSTOREKEY" ]; then
      # nodelist=`echo $HANANODE |sed "s/$STANDBYNODE//g"`
       nodelist=`su - $dbuser -c "HDBSettings.sh landscapeHostConfiguration.py --sapcontrol=1 | grep hostActualRoles | grep worker | awk -F'/' '{print \\$2}' |xargs"`
      for nodename in $(echo $nodelist)
      do
        sql="select top 1 FILE_NAME from sys_databases.m_log_segments where host='$nodename'"
        logpath=`su - $dbuser -c "$hdbsql -U $USERSTOREKEY -a -j -x \"$sql\""`
        logpath=`dirname $logpath`
        logpath=`dirname $logpath`
        logpath=`echo $logpath | sed 's/"//g'`
        echo -e "\t\t\t\t<cluster nodename=\"$nodename\" path= \"$logpath\" />" >>$XMLFILE
      done
   fi
   echo -e "\t\t\t</file>" >>$XMLFILE
fi
echo -e "\t\t</files>" >> $XMLFILE
############# GENERATE DATABASE MASTER NODE INFO ###################
if [ ! -z "$USERSTOREKEY" ]; then
   echo -e "\t\t<databases>" >> $XMLFILE
   sql=
   dbnameslist=`echo $dbnames | sed 's/SYSTEMDB//g'`
   for dbname in $(echo $dbnameslist | tr ',' ' ')
   do
     echo -e "\t\t\t<database name=\"$dbname\">" >> $XMLFILE
     sql="select distinct host from sys_databases.m_services where database_name='$dbname' and DETAIL='master'"
     masterdbnode=`su - $dbuser -c "$hdbsql -U $USERSTOREKEY -a -j -x \"$sql\""`
     masterdbnode=`echo $masterdbnode | sed 's/"//g'`
     sql="select string_agg(host,',')  from sys_databases.m_services where database_name='$dbname' and DETAIL<>'master' and SQL_PORT<>0"
     othernodes=`su - $dbuser -c "$hdbsql -U $USERSTOREKEY -a -j -x \"$sql\""`
     othernodes=`echo $othernodes | sed 's/"//g'`
     if [ ! -z "$masterdbnode" ]; then
        echo -e "\t\t\t\t<cluster nodename=\"$masterdbnode\" master=\"yes\" />" >> $XMLFILE
     fi
     if [ ! -z "$othernodes" ] && [ "$othernodes" != "?" ]; then
        for worker in $(echo $othernodes | tr ',' ' ' )
        do
          echo -e "\t\t\t\t<cluster nodename=\"$worker\" master=\"no\" />" >> $XMLFILE
        done
     fi 
     echo -e "\t\t\t</database>" >> $XMLFILE
   done
   echo -e "\t\t</databases>" >> $XMLFILE
fi

############### Generate Cluster Process Info ####################
if [ ! -z "$USERSTOREKEY" ]; then
   echo -e "\t\t<clusternodes>" >> $XMLFILE
   node=
   for node in $(echo $nodelist)
   do
      echo -e "\t\t\t<cluster nodename=\"$node\">" >> $XMLFILE
      sql=
      sql="select COORDINATOR_TYPE from sys_Databases.m_services where host='$node' and service_name='indexserver'"
      indexservertype=`su - $dbuser -c "$hdbsql -U $USERSTOREKEY -a -j -x \"$sql\""`
      indexservertype=`echo $indexservertype | xargs`
      for idx in $(echo $indexservertype)
      do
        echo -e "\t\t\t\t<service name=\"indexserver\" type=\"$idx\" /> " >> $XMLFILE        
      done
      sql="select service_name||'-'||DATABASE_NAME||'-'||PORT||'-'||SQL_PORT||'-'||COORDINATOR_TYPE from sys_databases.m_services where host='$node' and service_name not in ('indexserver')"
      servicenames=`su - $dbuser -c "$hdbsql -U $USERSTOREKEY -a -j -x \"$sql\""`
      servicenames=`echo $servicenames | xargs`
      for service in $(echo $servicenames)
      do
        servicename=`echo $service | awk -F"-" '{print $1}'`
        DBNAME=`echo $service | awk -F"-" '{print $2}'`
        PORT=`echo $service | awk -F"-" '{print $3}'`
        SQL_PORT=`echo $service | awk -F"-" '{print $4}'`
        COORDINATOR_TYPE=`echo $service | awk -F"-" '{print $5}'`
        echo -e "\t\t\t\t<service name=\"$servicename\" databasename=\"$DBNAME\" port=\"$PORT\" sqlport=\"$SQL_PORT\" coordinatortype=\"$COORDINATOR_TYPE\" />" >> $XMLFILE
      done
      echo -e "\t\t\t</cluster>" >> $XMLFILE
   done
   echo -e "\t\t</clusternodes>" >> $XMLFILE

fi
echo -e "\t\t<logbackuppath>" >> $XMLFILE
echo -e "\t\t\t<file path=\"$LOGBACKUPPATH\" />" >>$XMLFILE
echo -e "\t\t</logbackuppath>" >> $XMLFILE
echo -e "\t\t<globalinipath>" >> $XMLFILE
if [ -d $globalpath ]; then
   echo -e "\t\t\t<file path=\"$globalinipath\" />" >>$XMLFILE
fi
echo -e "\t\t</globalinipath>" >> $XMLFILE
echo -e "\t\t<catalogbackuppath>" >> $XMLFILE
if [ -d $CATLOGBACKUPPATH ]; then
   echo -e "\t\t\t<file path=\"$CATLOGBACKUPPATH\" />" >>$XMLFILE
fi
echo -e "\t\t</catalogbackuppath>" >> $XMLFILE
echo -e "\t\t<logmode " >> $XMLFILE
if [ ! -z $LOGMODE ]; then
   echo -e "\t\t\tmode=\"$LOGMODE\" " >>$XMLFILE
fi
echo -e "\t\t/>" >> $XMLFILE
echo -e "\t\t<scripts>" >> $XMLFILE
echo -e "\t\t\t<script phase=\"all\" path=\"$SCRIPTS\" />" >> $XMLFILE
echo -e "\t\t</scripts>" >> $XMLFILE
echo -e "\t</application>" >>$XMLFILE
#echo -e "</applications>" >> $XMLFILE
#echo -e "" >> $XMLFILE


DBSID=`echo $DBSID | tr '[a-z]' '[A-Z]'`
DBADM=`echo $DBSID | tr '[A-Z]' '[a-z]'`
DBADM=$DBADM'adm'

PORT=$INSTANCENUM
DBPORT='HDB'$PORT

done
echo -e "</applications>" >> $XMLFILE
echo -e "" >> $XMLFILE
exit 0
