#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================
# SYBASE IQ script for discovery
set -x
XMLFILE="/act/custom_apps/SYBASEIQ.xml"
SCRIPTS="/act/custom_apps/sybaseiq/CustomApp_SYBASEIQ.sh"
FTYPE="SYBASEIQ"
SHALLOW_DISCOVERY=$SHALLOW_DISCOVERY

DEV_TYPE="datavol"
LOG_TYPE="logvol"
VERSION=""

OSUSER=$OSUSER
DBA_USER="$SRC_BACKUP_USER"
set +x
DBA_PWD="$SRC_USER_PASSWD"
set -x

#Deleting temp files 
function Deltmpfiles {
  rm -f /act/touch/$dbname.pitrstatus.txt
  rm -f /act/touch/$dbname.txt
  rm -f /act/touch/$dbname.pitrlogfile.txt
}

#finding os user
OSUSER=`ps -ef | grep /iqsrv | awk '{print $1,$8}' | grep -v grep | uniq | awk '{print $1}' | xargs`
OSGROUP=`id -ngr $OSUSER`

# Globals
AUTHID_STR="SQL authorization ID"

#Finding sybase IQ home
sybiq_home_tmp=`ps -ef | grep /iqsrv | awk '{print $8}' | grep -v grep | uniq | awk -F"iqsrv" '{print $1}' | grep -v awk|uniq`
sybiq_home_tmp=`dirname $sybiq_home_tmp`
SYBIQ_HOME=`dirname $sybiq_home_tmp`
echo "SYBIQ_HOME = $SYBIQ_HOME"
version=`echo "$sybiq_home_tmp" | awk -F"/" '{print $NF}'`
echo "Version= $version"
set +x
. $SYBIQ_HOME/$version/$version.sh
#csh $SYBIQ_HOME/$version/$version.csh
set -x


#Extracting DBPATH  and Log paths for DB's
DB_PATH_LIST=`ps -ef | grep /iqsrv | grep -vw utility_db | grep -vw iqdemo | grep -v grep | awk '{print $9}' | xargs`
if [ ! -d /act/touch ] ;then
  mkdir -p /act/touch
fi


shallowDiscovery() {
  #echo -e "\t<application name=\"$dbname\" friendlytype=\"$FTYPE\" SYBIQ_HOME=\"$SYBIQ_HOME\" OSUSER=\"$OSUSER\" VERSION=\"$version\" DBCATALOGFILE=\"$dbcatalog\"  IQFILES=\"$IQ_PATH_TMP\" LOGFILE=\"$log\" PITR_STATUS=\"$PITR_STATUS\"  PITRLOG_DIR=\"$PITR_LOGFILE\" PORTNO=\"$PORTNO\" TLS_ENABLED=\"$TLS_ENABLED\" DB_ENG=\"$db_eng\" SIZE=\"$dbSize\" >" >> $XMLFILE
  echo -e "\t<application name=\"$dbname\" friendlytype=\"$FTYPE\" SYBIQ_HOME=\"$SYBIQ_HOME\" OSUSER=\"$OSUSER\" VERSION=\"$version\" PORTNO=\"$PORTNO\" TLS_ENABLED=\"$TLS_ENABLED\" DB_ENG=\"$db_eng\" >" >> $XMLFILE
  echo -e "\t</application>" >>$XMLFILE
}


getdbdetails() {
  dbDir=`dirname $dbPath`
  dbPath=`cat /act/touch/$dbname.txt | awk -F"," '{print $3}' | sed  "s/'//g"`
  DB_DIR=`dirname $dbPath`
  DB_MNTPNT=`df -P $DB_DIR | tail -1 | awk '{print $NF}'`
  db_eng=`cat /act/touch/sybdblocate.txt | grep -w $dbname | xargs | awk '{print $1}'`
  set +x
  IQ_PATH_TEMP=`su -m $OSUSER  -c "dbisql -nogui -onerror exit -c 'uid=$DBA_USER;pwd=$DBA_PWD;dbn=$dbname;eng=$db_eng;$TLS_ENC' -host $HOSTNAME -port $PORTNO 'sp_iqfile' " | grep -w "IQ_SYSTEM_MAIN" | awk '{print $3}'|xargs`
  set -x
  logpath=`cat /act/touch/$dbname.txt | awk -F"," '{print $6}' | sed  "s/'//g"`
  LOG_DIR=`dirname $logpath`
  LOG_MNTPNT=`df -P $LOG_DIR | tail -1 | awk '{print $NF}'`

  echo -e "\t\t<files>" >>$XMLFILE
  echo -e "\t\t\t<file path=\"$DB_MNTPNT\" datavol=\"$DB_DIR\" />" >>$XMLFILE
  for iqfiles in $IQ_PATH_TEMP
  do
    IQ_DIR=`dirname $iqfiles`
    IQ_MNTPNT=`df -P $IQ_DIR | tail -1 | awk '{print $NF}'`
    echo -e "\t\t\t<file path=\"$IQ_MNTPNT\" datavol=\"$IQ_DIR\" />" >>$XMLFILE
  done
  echo -e "\t\t\t<file path=\"$LOG_MNTPNT\" datavol=\"$LOG_DIR\" />" >>$XMLFILE
  echo -e "\t\t</files>" >>$XMLFILE

  echo -e "\t\t<scripts>" >> $XMLFILE
  echo -e "\t\t\t<script phase=\"all\" path=\"$SCRIPTS\" />" >> $XMLFILE
  echo -e "\t\t</scripts>" >> $XMLFILE
}


dblocate -d -n | tail -n +4 | head -n -2 | grep -w "127.0.0.1\|$(hostname -i)" > /act/touch/sybdblocate.txt
DB_LIST=`grep -vw "iqdemo\|utility_db" /act/touch/sybdblocate.txt | awk '{print $3}' | xargs`
chmod -R 777 /act/touch

#set DiscoveryFlag
flagAnySuccess="FALSE"
flagALLSuccess="TRUE"

# Prepare XML
echo -e "<applications>" > $XMLFILE
for dbname in $DB_LIST
do
  touch /act/touch/$dbname.pitrstatus.txt
  touch /act/touch/$dbname.txt
  touch /act/touch/$dbname.pitrlogfile.txt
  chown -R $OSUSER:$OSGROUP /act/touch
  db_eng=`cat /act/touch/sybdblocate.txt | grep -w $dbname | xargs | awk '{print $1}'`
  PORTNO=`cat /act/touch/sybdblocate.txt | grep -w $dbname | xargs | awk '{print $2}' | cut -d: -f2`
  HOSTNAME=`cat /act/touch/sybdblocate.txt | grep -w $dbname | xargs | awk '{print $2}' | cut -d: -f1`

  #Check connection to find TLS enable or not
  su -m $OSUSER -c  "dbisql -nogui -onerror exit   -c 'uid=$DBA_USER;pwd=$DBA_PWD; eng=$db_eng; dbn=$dbname' -host $HOSTNAME -port $PORTNO 'exit;'"
  if [ $? -eq 0 ]; then
    TLS_ENABLED="FALSE"
    TLS_ENC=	#Need to be empty if no TLS configured
  else
    TLS_ENC="Encryption=TLS(trusted_certificates=NONE)"
    su -m $OSUSER -c  "dbisql -nogui -onerror exit   -c 'uid=$DBA_USER;pwd=$DBA_PWD; eng=$db_eng; dbn=$dbname;$TLS_ENC' -host $HOSTNAME -port $PORTNO"
    if [ $? -eq 0 ]; then
      TLS_ENABLED="TRUE"
    else
      TLS_ENC=
      echo "WARNINGMSG: Fail to connect to database $dbname"
      flagALLSuccess="FALSE"
      continue
    fi
  fi

  if [ "$SHALLOW_DISCOVERY" = "TRUE" ]; then
    shallowDiscovery
    continue
  fi

  set +x
  su -m $OSUSER -c  "dbisql -nogui -onerror exit   -c 'uid=$DBA_USER;pwd=$DBA_PWD; eng=$db_eng; dbn=$dbname;$TLS_ENC' -host $HOSTNAME -port $PORTNO 'select * from sa_db_info ();OUTPUT TO '/act/touch/$dbname.txt' format ascii;exit;' "
  su -m $OSUSER -c  "dbisql -nogui -onerror exit  -c \"uid=$DBA_USER;pwd=$DBA_PWD; eng=$db_eng; dbn=$dbname;$TLS_ENC\" -host $HOSTNAME -port $PORTNO \"select db_property('IQPointInTimeRecoveryLogStatus');OUTPUT TO \"/act/touch/$dbname.pitrstatus.txt\" format ascii;exit;\""
  su -m $OSUSER -c  "dbisql -nogui -onerror exit   -c \"uid=$DBA_USER;pwd=$DBA_PWD; eng=$db_eng; dbn=$dbname;$TLS_ENC\" -host $HOSTNAME -port $PORTNO \"select db_property('IQPointInTimeRecoveryLogFilename');OUTPUT TO \"/act/touch/$dbname.pitrlogfile.txt\" format ascii;exit;\""
  set -x

  PITR_STATUS=`cat /act/touch/$dbname.pitrstatus.txt | sed "s/'//g" |sed '1s/^\xEF\xBB\xBF//'`
  PITR_LOGFILE_TMP=`cat /act/touch/$dbname.pitrlogfile.txt | sed "s/'//g" | sed '1s/^\xEF\xBB\xBF//'`
  PITR_LOGFILE=`dirname $PITR_LOGFILE_TMP`
  dbcatalog=`cat /act/touch/$dbname.txt | awk -F"," '{print $3}' | sed  "s/'//g"`
  log=`cat /act/touch/$dbname.txt | awk -F"," '{print $6}' | sed  "s/'//g"`
  if [ "$PITR_STATUS" = "On" ] || [ "$PITR_STATUS" = "Requested" ]; then
    echo "continue"
  elif [ "$PITR_STATUS" = "Off" ]; then
    echo "WARNINGMSG: IQ_POINT_IN_TIME_RECOVERY_LOGGING status is OFF for the database $dbname"
  else
    echo "WARNINGMSG: fail to discover database $dbname"
    flagALLSuccess="FALSE"
    continue
  fi
  set +x
  IQ_PATH_TMP=`su -m $OSUSER  -c "dbisql -nogui -onerror exit -c 'uid=$DBA_USER;pwd=$DBA_PWD;dbn=$dbname;eng=$db_eng;$TLS_ENC' -host $HOSTNAME -port $PORTNO 'sp_iqfile' " | grep -w "IQ_SYSTEM_MAIN" | awk '{print $3}' | xargs|sed 's. .,.g'`
  set -x
  dbPath=`cat /act/touch/$dbname.txt | awk -F"," '{print $3}' | sed  "s/'//g"`

  #Find SizeInBytes
  set +x
  blockSize=`su -m $OSUSER  -c "dbisql -nogui -onerror exit -c 'uid=$DBA_USER;pwd=$DBA_PWD;dbn=$dbname;eng=$db_eng;$TLS_ENC' -host $HOSTNAME -port $PORTNO \"select block_size from SYSIQINFO\" " |awk 'NR==3{print $1}'`
  dbTotalBlocks=`su -m $OSUSER  -c "dbisql -nogui -onerror exit -c 'uid=$DBA_USER;pwd=$DBA_PWD;dbn=$dbname;eng=$db_eng;$TLS_ENC' -host $HOSTNAME -port $PORTNO sp_iqdbsize" | awk 'NR==3{print $2}'`
  set -x
  echo "blockSize: $blockSize, dbTotalBlocks: $dbTotalBlocks"
  dbSize=`expr $blockSize "*" $dbTotalBlocks`

  echo -e "\t<application name=\"$dbname\" friendlytype=\"$FTYPE\" SYBIQ_HOME=\"$SYBIQ_HOME\" OSUSER=\"$OSUSER\" VERSION=\"$version\" DBCATALOGFILE=\"$dbcatalog\"  IQFILES=\"$IQ_PATH_TMP\" LOGFILE=\"$log\" PITR_STATUS=\"$PITR_STATUS\"  PITRLOG_DIR=\"$PITR_LOGFILE\" PORTNO=\"$PORTNO\" TLS_ENABLED=\"$TLS_ENABLED\" DB_ENG=\"$db_eng\" SIZE=\"$dbSize\" >" >> $XMLFILE
  getdbdetails
  echo -e "\t</application>" >>$XMLFILE

  # At-least one discovery is success
  flagAnySuccess="TRUE"
done
echo -e "</applications>" >>$XMLFILE

#Delete Temporary text files
Deltmpfiles

#Deleting dbrelocatefile
rm -f /act/touch/sybdblocate.txt

exit 0

