#!/bin/sh

set -x
OSUSER=$OSUSER
DBUSER=$DBUSER
set +x
DBPASSWORD="$DBPASSWORD"
set -x
BASEDIR=$BASEDIR
SOCKETFILE=$SOCKET_FILE
SRV_TYPE=$SRV_TYPE
PORTNO=$PORTNO

# Get Common functions
. /act/custom_apps/mariadb/act_mariadb_common_functions.sh

# Prepare MySQL Command
set +x
prepare_MARIADBCMD "$DBUSER" "$DBPASSWORD" "$SOCKETFILE" "$BASEDIR"
set -x

## UN-Freeze MySQL
if [ "$SRV_TYPE" != "Slave" ]; then
   isBkpRunning=`ps -ef | grep "FLUSH TABLES WITH READ LOCK" | grep "ACT___bkp_$PORTNO" | grep -vw grep | awk '{print$2}'`
   if [ -z $isBkpRunning ]; then
      echo "INFOMSG: No backup in progress"
      exit 0
   fi
   kill -9 $isBkpRunning
   retval=$?
else
   execMySQL "START SLAVE"
fi

if [ $retval -ne 0 ]; then
  echo "ERRORMSG: Failed to UN-freeze MariaDB server"
  exit 0
fi

echo "MariaDB UN-Freezed successfully"
exit 0
