#!/bin/sh

set -x
OSUSER=$OSUSER
DBUSER=$DBUSER
set +x
DBPASSWORD="$DBPASSWORD"
set -x
BASEDIR=$BASEDIR
SOCKETFILE=$SOCKET_FILE
SRV_TYPE=$SRV_TYPE
DELETE_LOGFILES_HOURS=$DELETE_LOGFILES_HOURS

# Get Common functions
. /act/custom_apps/mariadb/act_mariadb_common_functions.sh

# Prepare MySQL Command
set +x
prepare_MARIADBCMD "$DBUSER" "$DBPASSWORD" "$SOCKETFILE" "$BASEDIR"
set -x

#Check connection to MySQL
checkMySQL
if [ $? -ne 0 ]; then
  echo "ERRORMSG: failed to connect to MariaDB"
  exit 1
fi

#Convert DELETE_LOGFILES_HOURS to BEFORE
if [ -z $DELETE_LOGFILES_HOURS ]; then
  DELETE_LOGFILES_HOURS=4
fi
BEFORE_TIME=`date --date="$DELETE_LOGFILES_HOURS hour ago" +"%Y"-"%m"-"%d"\ "%H":"%M":"%S"`

#Purge the log file after backup
su -m $OSUSER -c "$MARIADB_CMD -e \"purge binary logs BEFORE '$BEFORE_TIME';\""
if [ $? -ne 0 ]; then
  echo "ERRORMSG: failed to purge MariaDB logs from source "
  exit 1
fi
echo "Successfully purged logs before '$BEFORE_TIME'"
