#!/bin/sh

set -x
OSUSER=$OSUSER
BASEDIR=$BASEDIR
DBUSER=$DBUSER
set +x
DBPASSWORD="$DBPASSWORD"
set -x
SOCKETFILE=$SOCKET_FILE

if [ "$OSUSER" = "" ]; then
  echo "ERRORMSG: OSUSER is not provided"
  exit 1
fi

if [ "$BASEDIR" = "" ]; then
  echo "ERRORMSG: BASEDIR is not provided"
  exit 1
fi

if [ "$DBUSER" = "" ]; then
  echo "WARNINGMSG: DBUSER is not provided. Assuming default DBUSER is 'root' "
fi

set +x
if [ "$DBPASSWORD" = "" ]; then
  echo "WARNINGMSG: DBPASSWORD is not provided"
fi
set -x

if [ "$SOCKETFILE" = "" ]; then
  echo "WARNINGMSG: SOCKETFILE is not provided"
fi

## Verification
id $OSUSER
if [ $? -ne 0 ]; then
  echo "ERRORMSG: No such user $OSUSER"
  exit 1
fi

if [ ! -d $BASEDIR ]; then
  echo "ERRORMSG: Not a directory - $BASEDIR "
  exit 1
fi

if [ ! -d $BASEDIR/bin ]; then
  echo "ERRORMSG: bin directory not found in - $BASEDIR "
  exit 1
fi

if [ ! -f $BASEDIR/bin/mysql ]; then
  if [ ! -f $BASEDIR/bin/mariadb ]; then
    echo "ERRORMSG: mysql/mariadb not found in - $BASEDIR/bin "
    exit 1
  fi
fi
