#!/bin/sh

set -x
SRC_DATADIR=$SRC_DATADIR
SRC_VERSION=$SRC_VERSION
SRC_TMPDIR=$SRC_TMPDIR
MESSAGES_DIR=$MESSAGES_DIR
TARGET_MNT_PNT=$TARGET_MNT_PNT
BASEDIR=$BASEDIR
PORT=$PORT
OSUSER=$OSUSER
DBUSER=$DBUSER
set +x
DBPASSWORD=$DBPASSWORD
set -x
BEGIN_TIME=$BEGIN_TIME
UNTIL_TIME=$UNTIL_TIME
LOG_BKP_MNTPT=$LOG_BKP_MNTPT
TARGET_DB_NAME=$TARGET_DB_NAME
ACT_JOBNAME=$JOBID
REMOUNT_CONFIG_file=$CONFIG_FILE_LOC #Don't change this order as it may over-write CONFIG_FILE_LOC
CONFIG_FILE_LOC=$CONFIG_FILE

# Get Common functions
. /act/custom_apps/mariadb/act_mariadb_common_functions.sh

#Child restore
if [ "$ACT_MOUNT_REPLACERESTORE" = "TRUE" ]; then
   TARGET_MNT_PNT=
fi

OSGROUP=`id -gn $OSUSER`
SOCKFILE=/tmp/.MariaDb_Sock.$PORT
PIDFILE=$TARGET_MNT_PNT$SRC_DATADIR/act_mariadb.pid
ERRORLOG=$TARGET_MNT_PNT$SRC_DATADIR/act_mariadb.log
MARIADB_CNF=$TARGET_MNT_PNT$SRC_DATADIR/mysqld-auto.cnf
DATETIME=`date +%Y%m%d`_`date +%H%M%S`

#Create temp location
mkdir -p /act/touch/$ACT_JOBNAME
chown -R $OSUSER:$OSGROUP /act/touch/$ACT_JOBNAME
#find /act -type d -exec chmod 755 {} +

#Change mount point permissions
if [ "$ACT_MOUNT_REPLACERESTORE" != "TRUE" ]; then
  if [ -z "$TARGET_MNT_PNT" ]; then
    echo "ERRORMSG: TARGET_MNT_PNT is empty"
    exit 1
  fi
  chown -R $OSUSER:$OSGROUP $TARGET_MNT_PNT
  chmod -R 750 $TARGET_MNT_PNT
  TRG_MNT_BASE=`echo $TARGET_MNT_PNT | cut -d/ -f2`
  if [ ! -z "$TRG_MNT_BASE" ]; then
    find /$TRG_MNT_BASE -type d -exec chmod 755 {} +
  fi
fi

if [ "$MESSAGES_DIR" = "" ]; then
  MESSAGES_DIR=$BASEDIR/share
fi

if [ ! -e $CONFIG_FILE_LOC ] || [ -z "$CONFIG_FILE_LOC" ]; then
  echo "ERRORMSG: Config file not provided"
  exit 1
fi
removeFile $SOCKFILE
removeFile $PIDFILE
removeFile $ERRORLOG

#Make a cope of config file and edit it
cp $CONFIG_FILE_LOC $CONFIG_FILE_LOC.bkp_${ACT_JOBNAME}
CONFIG_FILE_LOC_orig=$CONFIG_FILE_LOC
CONFIG_FILE_LOC=$CONFIG_FILE_LOC.bkp_${ACT_JOBNAME}

#remove blankspaces
tr -d ' ' < $CONFIG_FILE_LOC > $CONFIG_FILE_LOC.tmp
tr -d '[:blank:]' < $CONFIG_FILE_LOC > $CONFIG_FILE_LOC.tmp
mv $CONFIG_FILE_LOC.tmp $CONFIG_FILE_LOC

## Edit config file ##
SOCKFILE_sed=`echo $SOCKFILE | sed 's./.\\\/.g' `
PIDFILE_sed=`echo $PIDFILE | sed 's./.\\\/.g' `
ERRORLOG_sed=`echo $ERRORLOG | sed 's./.\\\/.g' `
BASEDIR_sed=`echo $BASEDIR |sed 's./.\\\/.g' `
sed -i "s/socket=.*/socket=$SOCKFILE_sed/g" $CONFIG_FILE_LOC
sed -i "s/port=.*/port=$PORT/g" $CONFIG_FILE_LOC
sed -i "s/server_id=.*/server_id=5106$PORT/g" $CONFIG_FILE_LOC
sed -i "s/server-id=.*/server-id=5106$PORT/g" $CONFIG_FILE_LOC
sed -i "s/pid_file=.*/pid_file=$PIDFILE_sed/g" $CONFIG_FILE_LOC
sed -i "s/pid-file=.*/pid-file=$PIDFILE_sed/g" $CONFIG_FILE_LOC
sed -i "s/log_error=.*/log_error=$ERRORLOG_sed/g" $CONFIG_FILE_LOC
sed -i "s/log-error=.*/log-error=$ERRORLOG_sed/g" $CONFIG_FILE_LOC
sed -i "s/basedir=.*/basedir=$BASEDIR_sed/g" $CONFIG_FILE_LOC
sed -i "s/tmpdir=.*/tmpdir=\/tmp/g" $CONFIG_FILE_LOC
sed -i "s/log_bin=.*/log_bin=mariadb-bin/g" $CONFIG_FILE_LOC
sed -i "s/bind-address=.*/bind-address=localhost/g" $CONFIG_FILE_LOC
sed -i "s/bind_address=.*/bind-address=localhost/g" $CONFIG_FILE_LOC
sed -i "s/log-basename=.*/log-basename=master-$PORT/g" $CONFIG_FILE_LOC
sed -i "s/log_basename=.*/log_basename=master-$PORT/g" $CONFIG_FILE_LOC
#sed -i "s/\[mariadb\]/\[mysqld_safe\]/g" $CONFIG_FILE_LOC

#Add missing, required options
#Find version
mariaVer=`mysql -V | awk -F" for" '{print $1}' | awk '{print $NF}' | cut -d, -f1 | cut -d. -f1,2 | sed 's/\.//g'`
if [ $mariaVer -lt 105 ]; then
  mariadbStanza=mysqld
else
  mariadbStanza=mariadb
fi

isMysqlD_specified=`grep -w "^\[$mariadbStanza\]" $CONFIG_FILE_LOC | wc -l`
if [ $isMysqlD_specified -lt 1 ]; then
  echo "[$mariadbStanza]" >> $CONFIG_FILE_LOC
fi
isDataDir_specified=`grep "^datadir=" $CONFIG_FILE_LOC | wc -l`
if [ $isDataDir_specified -lt 1 ]; then
  DATADIR_sed=`echo $TARGET_MNT_PNT$SRC_DATADIR | sed 's./.\\\/.g' `
  sed -i "/^\[$mariadbStanza\]/a datadir=$DATADIR_sed" $CONFIG_FILE_LOC
fi
isPort_specified=`grep "^port=" $CONFIG_FILE_LOC | wc -l`
if [ $isPort_specified -lt 1 ]; then
  sed -i "/^\[$mariadbStanza\]/a port=$PORT" $CONFIG_FILE_LOC
fi
isServerId_specified=`grep "^server_id=" $CONFIG_FILE_LOC | wc -l`
if [ $isServerId_specified -lt 1 ]; then
  sed -i "/^\[$mariadbStanza\]/a server_id=5106$PORT" $CONFIG_FILE_LOC
fi
isLogbin_specified=`grep "^log_bin=" $CONFIG_FILE_LOC | wc -l`
if [ $isLogbin_specified -lt 1 ]; then
  sed -i "/^\[$mariadbStanza\]/a log_bin=mariadb-bin" $CONFIG_FILE_LOC
fi
isLogError_specified=$(( `grep "^log-error=" $CONFIG_FILE_LOC | wc -l ` + `grep "^log_error=" $CONFIG_FILE_LOC | wc -l ` ))
if [ $isLogError_specified -lt 1 ]; then
  sed -i "/^\[$mariadbStanza\]/a log_error=$ERRORLOG_sed" $CONFIG_FILE_LOC
fi
isPID_specified=`grep "^pid-file=" $CONFIG_FILE_LOC | wc -l`
if [ $isPID_specified -lt 1 ]; then
  sed -i "/^\[$mariadbStanza\]/a pid-file=$PIDFILE_sed" $CONFIG_FILE_LOC
fi

#Remove skip-grant-tables options
sed -i '/skip-networking/d' $CONFIG_FILE_LOC
sed -i '/skip-grant-tables/d' $CONFIG_FILE_LOC

#Prepare actual config file
if [ -e $MARIADB_CNF ]; then
  cp $MARIADB_CNF ${MARIADB_CNF}_bkp_${DATETIME}
fi
cp $CONFIG_FILE_LOC $MARIADB_CNF
chown $OSUSER:$OSGROUP $MARIADB_CNF

# Set default DB crediantials: root@loaclhost with null password
if [ "$DBUSER" = "" ]; then 
  DBUSER=root
fi

#Set env
export PATH=$BASEDIR/bin:$PATH

#Reset credentials
RESET_CREDS=/act/touch/$ACT_JOBNAME/RESET_CRED.sql
set +x
echo "GRANT ALL PRIVILEGES ON *.* TO '$DBUSER'@'localhost' IDENTIFIED BY '$DBPASSWORD' WIth GRANT OPTION;" > $RESET_CREDS
set -x
echo "flush privileges;" >> $RESET_CREDS
chmod 755 /act/touch/$ACT_JOBNAME/RESET_CRED.sql
chown $OSUSER:$OSGROUP $RESET_CREDS

#Prepare MYSQLD_SAFE cmd
export PATH=$PATH:/sbin:$BASEDIR/sbin
MYSQLD_SAFE=mysqld_safe
which mysqld_safe
if [ $? -ne 0 ]; then
  MYSQLD_SAFE=mysqld
  which mysqld
  if [ $? -ne 0 ]; then
    echo "ERRORMSG: Fail to find mysqld(_safe) binary"
    exit 1
  fi
fi

## Start server
echo "INFOMSG: Starting MariaDB with config details: "
cat $MARIADB_CNF | grep -v "^#" | sed '/^\t/d' | sed '/^$/d'
su -m $OSUSER -c "$MYSQLD_SAFE --defaults-file=$MARIADB_CNF --init-file=$RESET_CREDS &"
retval=$?

if [ $retval -ne 0 ]; then
  echo "ERRORMSG: Failed to start MariaDB server !"
  exit 1
fi

#Check MariaDB started successfully or not
sleep 60
isSrvStarted=`ps -ef | grep "mysqld\|mariadbd" | grep -w "\-\-defaults-file=$MARIADB_CNF" | grep -vw grep |wc -l `
if [ $isSrvStarted -lt 1 ] || [ ! -e $ERRORLOG ]; then
  echo "ERRORMSG: Failed to bringup the MariaDB server !"
  exit 1
fi

waitForMariaDB "$ERRORLOG" 10
if [ $? -ne 0 ]; then
  echo "ERRORMSG: Failed to bringup the MariaDB server !"
  cp $ERRORLOG /act/touch/errorLog_$ACT_JOBNAME.log
  exit 1
fi

# Prepare MariaDB Command
set +x
prepare_MARIADBCMD "$DBUSER" "$DBPASSWORD" "$SOCKFILE" "$BASEDIR"
set -x

#Check instance connectivity
checkMySQL
if [ $? -ne 0 ]; then
  echo "ERRORMSG: Fail to start the MariaDB instance successfully."
  cleanUpMount
  exit 1
fi
echo "MariaDB server started successfully"

# Recover if needed
if [ "$UNTIL_TIME" != "" ]; then
  /act/custom_apps/mariadb/clone/ACT_MARIADB_recover.sh $SOCKFILE
  if [ $? -ne 0 ]; then 
    echo "ERRORMSG: Failed to recover MariaDB server!"
    /act/custom_apps/mariadb/clone/ACT_MARIADB_premount.sh
    #cleanUpMount
    exit 1
  fi
fi


#----------------------------------------------------------------
if [ "$APPREMOUNT" = "TRUE" ]; then
  update_TRG_DBLIST $REMOUNT_CONFIG_file
fi
#----------------------------------------------------------------


#------------------------------------------------------------
# Rename databases
#------------------------------------------------------------
#USERDBLIST=`su -m $OSUSER -c "$MARIADB_CMD -e 'show databases' | grep -v -w sys | grep -v -w mysql | grep -vw information_schema | grep -vw performance_schema | grep -vw act_logbin | grep -vw act_tmp | xargs"`
USERDBLIST=`su -m $OSUSER -c "$MARIADB_CMD -e 'show databases' | grep -v -w sys | grep -v -w mysql | grep -vw information_schema | grep -vw performance_schema| grep -v "^#" | xargs"`
echo "USERDBLIST=$USERDBLIST"
DELETE_DBLIST=

for dbName in $USERDBLIST
do
  flag=0
  newName=

  for dbPair in $(echo $TARGET_DB_NAME | sed 's/,/ /g')
  do
    odb=`echo $dbPair | cut -d: -f1`
    ndb=`echo $dbPair | cut -d: -f2`
    if [ "$odb" = "$dbName" ]; then
      newName=$ndb
      flag=1; break
    fi
  done

  if [ "$flag" = 0 ]; then
    DELETE_DBLIST="$DELETE_DBLIST,$dbName"
    continue
  fi

  echo "dbName: $dbName newName: $newName"
  renameDB $dbName $newName
  if [ $? -ne 0 ]; then
    echo "ERRORMSG: Failed to rename database $dbName to $newName"
    /act/custom_apps/mariadb/clone/ACT_MARIADB_premount.sh
    #cleanUpMount
    exit 1
  fi

done
#------------------------------------------------------------

#------------------------------------------------------------
# Drop databases
#------------------------------------------------------------
echo "Deleting databases: $DELETE_DBLIST"
for dbName in $(echo $DELETE_DBLIST | sed 's/,/ /g')
do
  su -m $OSUSER -c "$MARIADB_CMD -e \"drop database $dbName;\""
  if [ $? -ne 0 ]; then
    echo "ERRORMSG: failed to drop database $dbName"
    /act/custom_apps/mariadb/clone/ACT_MARIADB_premount.sh
    #cleanUpMount
    exit 1
  fi
done
#------------------------------------------------------------

if [ "$APPREMOUNT" = "TRUE" ]; then
  TARGET_DB_NAME=$TARGET_DB_NAME_orig
fi

mkdir -p /act/touch/$ACT_JOBNAME
chown -R $OSUSER:$OSGROUP /act/touch/$ACT_JOBNAME
#find /act -type d -exec chmod 755 {} +
remount_config

# Remove temp files
removeFile $CONFIG_FILE_LOC_orig
removeFile $CONFIG_FILE_LOC
removeFile $RESET_CREDS

exit 0
