#!/bin/sh

SOCKETFILE=$1
DB_NAME=$2

#change permissions on log mount point
OSGROUP=`id -gn $OSUSER`
chown -R $OSUSER:$OSGROUP $LOG_BKP_MNTPT
log_mnt_bs=`echo $LOG_BKP_MNTPT | cut -d/ -f2`
if [ ! -z $log_mnt_bs ]; then
  find /$log_mnt_bs -type d -exec chmod 755 {} +
fi

# Get Common functions
. /act/custom_apps/mariadb/act_mariadb_common_functions.sh

# Prepare MySQL Command
set +x
prepare_MARIADBCMD "$DBUSER" "$DBPASSWORD" "$SOCKETFILE" "$BASEDIR"
set -x

# Apply binlogs one by one
binLogs=`find $LOG_BKP_MNTPT/* -type f -newermt "$BEGIN_TIME" ! -newermt "$UNTIL_TIME" | sort | awk '{print $NF}' `
for binLog in $binLogs
do
  recoveryBinLog "$binLog" "$UNTIL_TIME" "$DB_NAME"
  if [ $? -ne 0 ]; then
    echo "ERRORMSG: Failed to recover MariaDB server @$binLog !"
    exit 1
  fi
done

#Apply last log file
llf=`find $LOG_BKP_MNTPT/* -type f -newermt "$UNTIL_TIME" |sort | awk '{print $NF}' |xargs| awk '{print $1}'`
if [ ! -z "$llf" ]; then
  recoveryBinLog "$llf" "$UNTIL_TIME" "$DB_NAME"
  if [ $? -ne 0 ]; then
    echo "ERRORMSG: Failed to recover MariaDB server @$binLog !"
    exit 1
  fi
fi

echo "MariaDB recovered successfully"
exit 0
