#!/bin/sh

set -x
OSUSER=$OSUSER
DBUSER=$DBUSER
set +x
DBPASSWORD="$DBPASSWORD"
set -x
BASEDIR=$BASEDIR
SOCKETFILE=$SOCKET_FILE
SRV_TYPE=$SRV_TYPE
DATADIR=$DATADIR
PORT=$PORT
CONFIG_FILE=$CONFIG_FILE

# Get Common functions
. /act/custom_apps/mariadb/act_mariadb_common_functions.sh

# Prepare MySQL Command
set +x
prepare_MARIADBCMD "$DBUSER" "$DBPASSWORD" "$SOCKETFILE" "$BASEDIR"
set -x

# Check server running or not
checkMySQL
if [ $? -ne 0 ]; then
  echo "FYI: MariaDB is not running. Proceeding to restore...."
  exit 0
fi

## Shutdown Server
su -m $OSUSER -c "$MARIADB_ADMIN shutdown"
retval=$?

if [ $retval -ne 0 ]; then
  echo "ERRORMSG: Failed to shutdown the mariadb server with socket $SOCKETFILE"
  exit 1
fi
sleep 30

# Check server shutdowned or not
isSrvRunning=`ps -ef | grep "mysqld\|mariadbd" | grep -w $PORT | wc -l`
if [ $isSrvRunning -gt 0 ]; then
  echo "ERRORMSG: Failed to shutdown the MariaDB server !"
  exit 1
fi

#Check with netstat for port number as well
isSrvRunning=`netstat -nalp | grep "mysqld\|mariadbd" | grep -w LISTEN | awk '{print $4}' | cut -d: -f4 | grep -w $PORT | wc -l`
if [ $isSrvRunning -gt 0 ]; then
  echo "ERRORMSG: Failed to shutdown the MariaDB server !"
  exit 1
fi

echo "Maira server shutdown successfull"

exit 0
