#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
#                  !!!Actifio Private Script. DO NOT MODIFY!!!
#
# ==============================================================================#

usage() {
  echo "Usage: "
  echo "/act/custom_apps/maxdb/CALL_ACT_MAXDB_lvm_migrate.sh \"\" \"<OSUSER> <TARGET_SERVER_NAME> <TARGET_DB_USER> <TARGET_DBUSER_PASSWD/null> <LOCAL_PRG_PATH> <DATAVOL_DISK_MAPPING>\""
  echo "Example: "
  echo "/act/custom_apps/maxdb/CALL_ACT_MAXDB_lvm_migrate.sh \"\" \"sdb XYZ dbm dbm /opt/sdb/MaxDB /chtst/mdata:/dev/mapper/vg1-lv7::/chtst/mlog:/dev/mapper/vg1-lv8\" "
}

isProvided() {
  local varName=$1
  local varVal=$2
  if [ -z "$varVal" ]; then
    echo "ERRORMSG: $varName is empty."
    usage
    exit 1
  fi
}

set -x

APPREMOUNT="FALSE"

#All the required arguments will be passed as single argument (second).
INPUT_VALUES=$2

#To tracke the arguments inside the second argument
count=1

#Read the arguments
for value in ${INPUT_VALUES}
do
  if [ "$value" = "null" ]; then
      value=
  fi

  if [ "$count" -eq 1 ]; then
     OSUSER=$value
  elif [ "$count" -eq 2 ]; then
     TARGET_SERVER_NAME=$value
  elif [ "$count" -eq 3 ]; then
     TARGET_DB_USER=$value
  elif [ "$count" -eq 4 ]; then
     TARGET_DBUSER_PASSWD="$value"
  elif [ "$count" -eq 5 ]; then
     LOCAL_PRG_PATH=$value
  elif [ "$count" -eq 6 ]; then
     DATAVOL_DISK_MAPPING=$value
  fi

  count=$(($count+1))
done

OSUSER=$OSUSER
TARGET_SERVER_NAME=$TARGET_SERVER_NAME
TARGET_DB_USER=$TARGET_DB_USER
set +x
TARGET_DBUSER_PASSWD="$TARGET_DBUSER_PASSWD"
set -x
LOCAL_PRG_PATH=$LOCAL_PRG_PATH
DATAVOL_DISK_MAPPING=$DATAVOL_DISK_MAPPING
if [ ! -z "$ACT_JOBNAME" ]; then
  JOBID=$ACT_JOBNAME
else
  JOBID=JOB_12345
fi

isProvided OSUSER $OSUSER
isProvided TARGET_SERVER_NAME $TARGET_SERVER_NAME
isProvided TARGET_DB_USER $TARGET_DB_USER
isProvided LOCAL_PRG_PATH $LOCAL_PRG_PATH
isProvided DATAVOL_DISK_MAPPING $DATAVOL_DISK_MAPPING

/act/custom_apps/maxdb/lvm_migrate/ACT_MAXDB_lvm_migrate_newTarget.sh OSUSER=$OSUSER DBSID=$TARGET_SERVER_NAME DBUSER=$TARGET_DB_USER DBPASSWORD="$TARGET_DBUSER_PASSWD" JOBID=$JOBID LOCAL_PRG_PATH=$LOCAL_PRG_PATH DATAVOL_DISK_MAPPING=$DATAVOL_DISK_MAPPING
if [ $? -ne 0 ]; then
  echo "ERRORMSG: Fail to migrate applicatoin from Actifio storage to Target storage."
  exit 1
fi

exit 0
