#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
#                  !!!Actifio Private Script. DO NOT MODIFY!!!
#
# ==============================================================================#

usage() {
  echo "Usage: "
  echo "/act/custom_apps/maxdb/CALL_ACT_MAXDB_mountrecover.sh \"\" \"<OSUSER> <TARGET_SERVER_NAME> <TARGET_DB_USER> <TARGET_DBUSER_PASSWD/null> <LOCAL_PRG_PATH> <TARGET_MNT_PNT> [ <LOG_BKP_MNTPT> <UNTIL_TIME> ]\""
}

isProvided() {
  local varName=$1
  local varVal=$2
  if [ -z "$varVal" ]; then
    echo "ERRORMSG: $varName is empty."
    usage
    exit 1
  fi
}

set -x

#All the required arguments will be passed as single argument (second).
INPUT_VALUES=$2

#To tracke the arguments inside the second argument
count=1

#Read the arguments
for value in ${INPUT_VALUES}; do

  if [ "$value" = "null" ]; then
    value=
  fi

  if [ "$count" -eq 1 ]; then
    OSUSER=$value
  elif [ "$count" -eq 2 ]; then
    TARGET_SERVER_NAME=$value
  elif [ "$count" -eq 3 ]; then
    TARGET_DB_USER=$value
  elif [ "$count" -eq 4 ]; then
    TARGET_DBUSER_PASSWD="$value"
  elif [ "$count" -eq 5 ]; then
    LOCAL_PRG_PATH=$value
  elif [ "$count" -eq 6 ]; then
    TARGET_MNT_PNT=$value
  elif [ "$count" -eq 7 ]; then
    LOG_BKP_MNTPT=$value
  elif [ "$count" -eq 8 ]; then
    UNTIL_TIME=$value
  fi

  # Increase the count to read next argument
  count=$(($count+1))

done



OSUSER=$OSUSER                                  # (User need to give)
TARGET_SERVER_NAME=$TARGET_SERVER_NAME          # (User need to give)
TARGET_DB_USER=$TARGET_DB_USER                  # (User need to give)
TARGET_DBUSER_PASSWD="$TARGET_DBUSER_PASSWD"    # (User need to give)
TARGET_MNT_PNT=$TARGET_MNT_PNT                  # Target mount point provided during simple mount (User need to give)
LOG_BKP_MNTPT=$LOG_BKP_MNTPT                    # Archive log location (User need to give)
UNTIL_TIME="$UNTIL_TIME"                        # Recover time (User need to give)
UNTIL_TIME=`echo $UNTIL_TIME | sed 's/-/ /3'`

SOURCE_DBSID=$SOURCE_DBSID                      # source user-database name (Connector can pass)
MANIFEST_FILE_LOC=$MANIFEST_FILE_LOC            # ManifestFile (Connector can pass)
BEGIN_TIME="$BEGIN_TIME"                        # (Connector can pass)
SRC_DB_VERSION=$SRC_DB_VERSION                  # (Connector can pass)


if [ ! -z "$ACT_JOBNAME" ]; then
  JOBID=$ACT_JOBNAME
else
  JOBID=JOB_12345
fi

isProvided OSUSER $OSUSER
isProvided TARGET_SERVER_NAME $TARGET_SERVER_NAME
isProvided TARGET_DB_USER $TARGET_DB_USER
isProvided SRC_DB_VERSION $SRC_DB_VERSION
isProvided LOCAL_PRG_PATH $LOCAL_PRG_PATH
isProvided MANIFEST_FILE_LOC $MANIFEST_FILE_LOC
isProvided TARGET_MNT_PNT $TARGET_MNT_PNT
isProvided SOURCE_DBSID $SOURCE_DBSID
if [ ! -z "$UNTIL_TIME" ]; then
  isProvided LOG_BKP_MNTPT $LOG_BKP_MNTPT
  isProvided BEGIN_TIME "$BEGIN_TIME"
fi


echo "***** Calling /act/custom_apps/maxdb/clone/ACT_MAXDB_mountrecover.sh for MountRecovery *****"

/act/custom_apps/maxdb/clone/ACT_MAXDB_mountrecover.sh OSUSER=$OSUSER TARGET_SERVER_NAME=$TARGET_SERVER_NAME TARGET_DB_USER=$TARGET_DB_USER SRC_DB_VERSION=$SRC_DB_VERSION LOCAL_PRG_PATH=$LOCAL_PRG_PATH MANIFEST_FILE_LOC=$MANIFEST_FILE_LOC TARGET_MNT_PNT=$TARGET_MNT_PNT SOURCE_DBSID=$SOURCE_DBSID TARGET_DBUSER_PASSWD="$TARGET_DBUSER_PASSWD" LOG_BKP_MNTPT=$LOG_BKP_MNTPT UNTIL_TIME="$UNTIL_TIME" BEGIN_TIME="$BEGIN_TIME" JOBID=$JOBID


if [ $? -ne 0 ]; then
  echo "ERRORMSG: MountRecover operation failed"
  exit 1
fi

exit 0
