#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
#                  !!!Actifio Private Script. DO NOT MODIFY!!!
#
# ==============================================================================#

usage() {
  echo "Usage: "
  echo "/act/custom_apps/maxdb/CALL_ACT_MAXDB_newtargetdumprestore.sh \"\" \"<OSUSER> <LOCAL_PRG_PATH> <TARGET_SERVER_NAME> <TARGET_DB_USER> <TARGET_DBUSER_PASSWD/null> <DBADMIN_PWD> <DATA_MNT_PNT> <LOG_MNT_PNT> [ <UNTIL_TIME> ]\" "
  exit 1
}

isProvided() {
  local varName=$1
  local varVal=$2
  if [ -z "$varVal" ]; then
    echo "ERRORMSG: $varName is empty."
    usage
    exit 1
  fi
}

set -x
echo "***************** POSTSKJOB_TYPE= $ACT_JOBTYPE *********************"

if [ "$ACT_JOBTYPE" = "unmount" ] || [ "$ACT_MULTI_OPNAME" = "unmount" ] ; then
   echo "NO-OP for post-script when unmount"
   exit 0
fi
if [ "$ACT_JOBTYPE" = "mount" ] || [ "$ACT_MULTI_OPNAME" = "mount" ] ; then
   if [ "$ACT_PHASE" = "pre" ] ; then
        echo "** No op for pre during unmount **"
      exit
   fi
   if [ "$ACT_PHASE" = "post" ] ; then
        echo "************************* start post during mount ************************"

INPUT_VALUES=$2
count=1
IFS=" "

for value in ${INPUT_VALUES}; do

  if [ "$value" = "null" ]; then
    value=
  fi

  if [ "$count" -eq 1 ]; then
    OSUSER=$value
  elif [ "$count" -eq 2 ]; then
    LOCAL_PRG_PATH=$value
  elif [ "$count" -eq 3 ]; then
    TARGET_SERVER_NAME=$value
  elif [ "$count" -eq 4 ]; then
    TARGET_DB_USER=$value
  elif [ "$count" -eq 5 ]; then
    TARGET_DBUSER_PASSWD="$value"
  elif [ "$count" -eq 6 ]; then
    DBADMIN_PWD=$value
  elif [ "$count" -eq 7 ]; then
    DATA_MNT_PNT=$value
  elif [ "$count" -eq 8 ]; then
    LOG_MNT_PNT=$value
  elif [ "$count" -eq 9 ]; then
    UNTIL_TIME=$value
  fi

  count=$(($count+1))

done

OSUSER=$OSUSER                                          #User will provide
LOCAL_PRG_PATH=$LOCAL_PRG_PATH                          #User will provide
TARGET_SERVER_NAME=$TARGET_SERVER_NAME                  #User will provide
TARGET_DB_USER=$TARGET_DB_USER                          #User will provide
TARGET_DBUSER_PASSWD="$TARGET_DBUSER_PASSWD"            #User will provide
DATA_MNT_PNT=$DATA_MNT_PNT                              #User will provide
LOG_MNT_PNT=$LOG_MNT_PNT                                #User will provide
DBADMIN_PWD=$DBADMIN_PWD                                #User will provide
UNTIL_TIME="$UNTIL_TIME"                                #User will provide
UNTIL_TIME=`echo $UNTIL_TIME | sed 's/-/ /3'`

DUMPBKPLOC=$DUMPBKPLOC                                  #Connector can provide
LOG_BKP_MNTPT=$LOG_BKP_MNTPT                            #Connector can provide
SRC_DB_VERSION=$SRC_DB_VERSION                          #Connector can provide
MANIFEST_FILE_LOC=$MANIFEST_FILE_LOC                    #Connector can provide
BEGIN_TIME="$BEGIN_TIME"                                #Connector can provide
SRC_DBSID=$SRC_DBSID                                    #Connector can provide


set +x
isProvided OSUSER $OSUSER
isProvided TARGET_SERVER_NAME $TARGET_SERVER_NAME
isProvided TARGET_DB_USER $TARGET_DB_USER
isProvided DATA_MNT_PNT $DATA_MNT_PNT
isProvided LOG_MNT_PNT $LOG_MNT_PNT
isProvided DBADMIN_PWD $DBADMIN_PWD

isProvided SRC_DBSID $SRC_DBSID
isProvided MANIFEST_FILE_LOC $MANIFEST_FILE_LOC
isProvided SRC_DB_VERSION $SRC_DB_VERSION
isProvided DUMPBKPLOC $DUMPBKPLOC

if [ ! -z "$UNTIL_TIME" ]; then
  isProvided LOG_BKP_MNTPT $LOG_BKP_MNTPT
  isProvided BEGIN_TIME "$BEGIN_TIME"
fi

if [ ! -z "$ACT_JOBNAME" ]; then
  JOBID=$ACT_JOBNAME
else
  JOBID=JOB_54321
fi

set -x

echo "********** call MAXDB recovery ************k"

/act/custom_apps/maxdb/dump/Act_Maxdb_dumpRestore_newTarget.sh OSUSER=$OSUSER LOCAL_PRG_PATH=$LOCAL_PRG_PATH SRC_DBSID=$SRC_DBSID TARGET_SERVER_NAME=$TARGET_SERVER_NAME TARGET_DB_USER=$TARGET_DB_USER TARGET_DBUSER_PASSWD="$TARGET_DBUSER_PASSWD" MANIFEST_FILE_LOC=$MANIFEST_FILE_LOC SRC_DB_VERSION=$SRC_DB_VERSION DUMPBKPLOC=$DUMPBKPLOC JOBID=$JOBID LOG_MNT_PNT=$LOG_MNT_PNT DATA_MNT_PNT=$DATA_MNT_PNT DBADMIN_PWD=$DBADMIN_PWD LOG_BKP_MNTPT=$LOG_BKP_MNTPT BEGIN_TIME="$BEGIN_TIME" UNTIL_TIME="$UNTIL_TIME"
retval=$?

if [ $retval -ne 0 ]; then
    echo "ERRORMSG: fail to perform dump restore new target"
    exit $retval
fi

echo "********** end MAXDB recover with exit code: $retval ************"
exit 0
fi
fi

