#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#

set -x
OSUSER=$OSUSER
DBSID=$DBSID
SRC_BACKUP_USER=$SRC_BACKUP_USER
set +x
SRC_USER_PASSWD="$SRC_USER_PASSWD"
set -x
LOCAL_PRG_PATH=$LOCAL_PRG_PATH
ACT_JOBNAME=$JOBID

. /act/custom_apps/maxdb/act_maxdb_common_func.sh

DATE=`date`
export PATH=$LOCAL_PRG_PATH/bin:$PATH

#Convert the DBSID in Upper case
DBSID=`echo $DBSID | tr "[:lower:]" "[:upper:]"`

# Prepare variables
tmp_loc=/act/touch/$ACT_JOBNAME
freeze_info=/act/touch/frz_info_${DBSID}.txt
if  [ -e $freeze_info ]; then
  echo "Database is already freezed"
  exit 0
fi

mkdir -p $tmp_loc
chown -R $OSUSER:$OSGROUP $tmp_loc
OUTPUT_FILE=$tmp_loc/OUTPUT.log

#prepare MAXDB_KEY
set +x
prepareMaxdbKey "$SRC_BACKUP_USER" "$SRC_USER_PASSWD"
set -x

#Get archivelog location
set +x
getAutologbkpLoc "$OSUSER" "$DBSID" "$MAXDB_KEY"
set -x
echo "ArchiveLog_Loc_base is: $ArchiveLog_Loc_base"

#Switch log to get latest logs
set +x
su -m $OSUSER -c "dbmcli -d $DBSID  $MAXDB_KEY -o $OUTPUT_FILE -uUTL -c backup_start $AUTOLOG_TMPLT LOG"
retval=$?
set -x

if [ $retval -ne 0 ]; then
  isNoLogToSave=`grep "No more log to save" $OUTPUT_FILE | wc -l`
  if [ $isNoLogToSave -ne 1 ]; then
    echo "ERRORMSG: fail to trigger autolog backup template"
    exit 1
  fi
fi

echo ".............DATE  $DATE  Freezing the Database $DBSID"

set +x
su -m $OSUSER -c "dbmcli -d $DBSID $MAXDB_KEY -uUTL -c util_execute suspend logwriter"
retval=$?
set -x

if [ $retval -ne 0 ]; then 
  echo "ERRORMSG: Freeze Failed"
  exit 1
fi

touch $freeze_info
echo "Freeze success"

exit 0
