#!/bin/sh
set -x
OSUSER=$OSUSER
DBSID=$DBSID
SRC_BACKUP_USER=$SRC_BACKUP_USER
set +x
SRC_USER_PASSWD="$SRC_USER_PASSWD"
set -x
LOCAL_PRG_PATH=$LOCAL_PRG_PATH
export PATH=$LOCAL_PRG_PATH/bin:$PATH
CHILD=$CHILD
. /act/custom_apps/maxdb/act_maxdb_common_func.sh

isVarNull OSUSER $OSUSER
isVarNull DBSID $DBSID
isVarNull SRC_BACKUP_USER $SRC_BACKUP_USER
#isVarNull SRC_USER_PASSWD $SRC_USER_PASSWD
isVarNull LOCAL_PRG_PATH $LOCAL_PRG_PATH

#Convert the DBSID in Upper case
DBSID=`echo $DBSID | tr "[:lower:]" "[:upper:]"`

#prepare MAXDB_KEY
set +x
prepareMaxdbKey "$SRC_BACKUP_USER" "$SRC_USER_PASSWD"
set -x

#check the password authentication
set +x
su -m $OSUSER -c "dbmcli -d $DBSID $MAXDB_KEY bye"
retval=$?
set -x

if [ $retval -gt 0 ]; then
  set +x
  if [ -z "$SRC_USER_PASSWD" ]; then
    echo "ERRORMSG: User Authentication Failed. Please check userkey"
  else
    echo "ERRORMSG: User Authentication Failed. Please check username and password"
  fi
  set -x
  exit 1
fi

#Check if this is child backup 

if [ "$CHILD" = "TRUE" ]; then

  #check if this first lvm backup of the child database
  AUTOLOG_BKP_TEMP_NAME=`echo ACT_AUTOLOGBKP_${DBSID}_TEMP`
  FULL_BKP_TEMP_NAME=`echo ACT_MAXDB_${DBSID}_FULL`
  set +x
  IsLogBkpTempExist=`su -m $OSUSER -c "dbmcli -d $DBSID $MAXDB_KEY -uUTL -c backup_template_show all"  | grep "$AUTOLOG_BKP_TEMP_NAME" | wc -l` 
  IsFullBkpTempExist=`su -m $OSUSER -c "dbmcli -d $DBSID $MAXDB_KEY -uUTL -c backup_template_show all"  | grep "$FULL_BKP_TEMP_NAME" | wc -l`
  isHistLoss=`su -m $OSUSER -c "dbmcli -d $DBSID $MAXDB_KEY -uUTL -c backup_history_list -I" | grep -vw "OK\|END" | head -1 | grep "HISTLOST" | wc -l`
  set -x

  if [ $IsLogBkpTempExist -eq 0 ]; then
     Flag=1
  else
     Flag=0
  fi

  if [ $IsLogBkpTempExist -eq 0 ] || [ $isHistLoss -gt 0 ]; then
    export OSUSER=$OSUSER
    export DBSID=$DBSID
    export SRC_BACKUP_USER=$SRC_BACKUP_USER
    set +x
    export SRC_USER_PASSWD="$SRC_USER_PASSWD"
    set -x
    export LOCAL_PRG_PATH=$LOCAL_PRG_PATH
    export PATH=$LOCAL_PRG_PATH/bin:$PATH

    /act/custom_apps/maxdb/clone/ACT_MAXDB_postmount_Protection.sh  
    retval=$?
    Flag=1
    if [ $retval -gt 0 ]; then
      echo "ERRORMSG: First Time Dump Backup Failed for the child database $DBSID "
      exit 1
    fi
  fi

  if [ $Flag -eq 0 ]; then
    #Check DB_STATE
    set +x
    getDB_State "$OSUSER" "$DBSID" "$MAXDB_KEY"
    set -x
    echo "Database status is : $DB_STATE"
    if [ !  "$DB_STATE" = "ONLINE" ]; then
      set +x
      su -m $OSUSER -c "dbmcli -d $DBSID $MAXDB_KEY -uUTL -c db_online"
      retval=$?
      set -x
      if [ $retval -ne 0 ]; then
        echo "ERRORMSG: Unable to bring the database in Online Mode Before Enabling the autolog"
        exit 1
      fi
    fi
  
    #check if the auto_save is off
    set +x
    AUTOSAVE_SATUS=`su -m $OSUSER -c "dbmcli -d $DBSID $MAXDB_KEY -uUTL -c autolog_show" | grep -v "OK"`
    set -x
    if [ ! "$AUTOSAVE_SATUS" = "AUTOSAVE IS ON" ]; then
      echo "Enabling the autolog backup...."
      set +x
      su -m $OSUSER -c "dbmcli -d $DBSID $MAXDB_KEY -uUTL -c autolog_on $AUTOLOG_BKP_TEMP_NAME"
      retval=$?
      set -x
      if [ $retval -ne 0 ]; then
        echo "ERRORMSG: Unable to bring the autolog backup on"
        exit 1
      fi
    else
      echo "AUTOSAVE is already on"   
    fi
  fi
fi
exit 0
