#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#
set -x
OSUSER=$OSUSER
DBSID=$DBSID
SRC_BACKUP_USER=$SRC_BACKUP_USER
set +x
SRC_USER_PASSWD="$SRC_USER_PASSWD"
set -x
LOCAL_PRG_PATH=$LOCAL_PRG_PATH
SRC_DB_VERSION=$SRC_DB_VERSION
ACT_JOBNAME=$JOBID
ENDPIT=$ENDPIT
DELETE_LOGFILES_HOURS=$DELETE_LOGFILES_HOURS

#Set Environment Variable
export PATH=$LOCAL_PRG_PATH/bin:$PATH


#Check if Autolog backup is on
set +x
AUTOLOG_BKP_STATE=`dbmcli -d $DBSID -u $SRC_BACKUP_USER,$SRC_USER_PASSWD autolog_show | grep -vw "OK"`
retval=$?
set -x

if [ $retval -ne 0 ]; then
  echo "ERRORMSG: fail to get autolog state"
  exit 1
fi

if [ "$AUTOLOG_BKP_STATE" = "AUTOSAVE IS OFF" ]; then
  echo "$AUTOLOG_BKP_STATE"
  echo "ERRORMSG: Autolog Backup is off"
fi

#Find The backup location of autolog

#Get backup template
set +x
AUTOLOG_TMPLT=`dbmcli -d $DBSID -u $SRC_BACKUP_USER,$SRC_USER_PASSWD backup_history_list -c label,media,action -I | grep LOG_ | grep -w "SAVE" | head -1 | cut -d'|' -f2`
retval=$?
set -x

if [ $retval -ne 0 ]; then
  echo "ERRORMSG: Fail to get log backup template"
  exit 1
fi
echo "INFOMSG: Auto log backup template: $AUTOLOG_TMPLT"

#Get archivelog location
set +x
ArchiveLog_Loc=`dbmcli -d $DBSID -u $SRC_BACKUP_USER,$SRC_USER_PASSWD backup_template_show NAME $AUTOLOG_TMPLT |grep LOCATION | awk '{print $NF}'`
retval=$?
set -x

if [ $retval -ne 0 ]; then
  echo "ERRORMSG: Fail to get log backup location"
  exit 1
fi

if [ "${ArchiveLog_Loc:0:1}" != "/" ]; then
  set +x
  runDir=`dbmcli -d $DBSID -u $SRC_BACKUP_USER,$SRC_USER_PASSWD param_directget RUNDIRECTORY | grep -v "OK" | awk '{ print $NF }'`
  set -x
  ArchiveLog_Loc=$runDir/$ArchiveLog_Loc
fi
ArchiveLog_Dir=`dirname $ArchiveLog_Loc`
ArchiveLog_baseName=`basename $ArchiveLog_Loc`
echo "Log backup location: $ArchiveLog_Loc.*"

# Check Archive directory exist or not
if [ -z "$ArchiveLog_Dir" ] || [ ! -d "$ArchiveLog_Dir" ]; then
   echo "ERRORMSG: Fail to find Archivelog directory location"
   exit 1
fi

#Delete the log backup
systemdate="$ENDPIT"
vdate=`echo $systemdate | awk '{print $1}'`
vtime=`echo $systemdate | awk '{print $2}'`
FROM_TIME=`date -d "$vtime $vdate -$DELETE_LOGFILES_HOURS hours" +"%Y-%m-%d %H:%M:%S"`
find $ArchiveLog_Dir ! -newermt "$FROM_TIME" -type f -name $ArchiveLog_baseName.* | xargs rm -f

exit 0
