#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#
set -x
OSUSER=$OSUSER
DBSID=$DBSID
SRC_BACKUP_USER=$SRC_BACKUP_USER
set +x
SRC_USER_PASSWD="$SRC_USER_PASSWD"
set -x
ACT_JOBNAME=$JOBID
#MAXDB_BACKUPPATH=$MAXDB_BACKUPPATH
DUMPSCHEDULE=$DUMPSCHEDULE
LOCAL_PRG_PATH=$MAXDB_HOME

. /act/custom_apps/maxdb/act_maxdb_common_func.sh

#Set Environment Variable 
OSGROUP=`id -gn $OSUSER`

#set the Path
if [ -z $LOCAL_PRG_PATH ]; then

   Local_soft_loc=`ps -eaf | grep "/pgm/kernel" | grep -vw grep | awk -F"/pgm/kernel" '{print $1}' | grep -v awk | awk '{print $NF}' | uniq | head -1`
  if [ -z "$Local_soft_loc" ]; then
     echo "ERRORMSG: Fail to find MaxDB_Home as no instance is running on this host."
     exit 1
  else
     LOCAL_PRG_PATH=$Local_soft_loc
  fi
fi

export PATH=$LOCAL_PRG_PATH/bin:$PATH

#Change DBSID in Upper Case
DBSID=`echo $DBSID | tr "[:lower:]" "[:upper:]"`

#Prepare variables
DATE=`date +%Y%m%d_%H%M%S`

if [ "$DUMPSCHEDULE" = "F" ]; then
  DUMPSCHEDULE_DB="F"
fi

# Create or Modify Existing Backup Template 
create_BKP_Templ() {
  set +x
  su -m $OSUSER -c "dbmcli -d $DBSID $MAXDB_KEY backup_template_create $BKP_TEMPL_NAME to FILE $BACKUP_FILE_NAME  overwrite  CONTENT $TMPL_TYPE"
  retval=$?
  set -x

  if [ $retval -ne 0 ]; then
    echo "ERRORMSG: Backup Template Creation Failed...."
    exit 1
  fi
}

# Backup Database
backup_DB() {
  echo " Backup starrted..."
  set +x
  su -m $OSUSER -c "dbmcli -d $DBSID $MAXDB_KEY -uUTL -c backup_start $BKP_TEMPL_NAME $BKP_TYPE AUTOIGNORE"
  retval=$?
  set -x

  if [ $retval -ne 0 ]; then
    echo "ERRORMSG: DB Dump Full Backup Failed." 
    exit 1
  fi
}

#prepare MAXDB_KEY
set +x
prepareMaxdbKey "$SRC_BACKUP_USER" "$SRC_USER_PASSWD"
set -x

if [ "$DUMPSCHEDULE_DB" = "F" ]; then
  Flag=Full
  BKP_TYPE=DATA
  TMPL_TYPE=DATA
  BKP_TEMPL_NAME=ACT_MAXDB_${DBSID}_NULL
fi

#Create BackupFile based on Backup Location :
BACKUP_FILE_NAME=/dev/null
echo "Backup File is :  $BACKUP_FILE_NAME "

#create template
create_BKP_Templ

#Take backup
backup_DB
echo "Backup completed successfully..."

exit 0
