#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#

set -x
OSUSER=$OSUSER
DBSID=$DBSID
SRC_BACKUP_USER=$SRC_BACKUP_USER
set +x
SRC_USER_PASSWD=$SRC_USER_PASSWD
set -x
LOCAL_PRG_PATH=$MAXDB_HOME
ACT_JOBNAME=$JOBID

. /act/custom_apps/maxdb/act_maxdb_common_func.sh

OSGROUP=`id -gn $OSUSER`

#set the Path
if [ -z $LOCAL_PRG_PATH ]; then

   Local_soft_loc=`ps -eaf | grep "/pgm/kernel" | grep -vw grep | awk -F"/pgm/kernel" '{print $1}' | grep -v awk | awk '{print $NF}' | uniq | head -1`
  if [ -z "$Local_soft_loc" ]; then
     echo "ERRORMSG: Fail to find MaxDB_Home as no instance is running on this host."
     exit 1
  else
     LOCAL_PRG_PATH=$Local_soft_loc
  fi
fi

export PATH=$LOCAL_PRG_PATH/bin:$PATH

#Convert the DBSID in Upper case
DBSID=`echo $DBSID | tr "[:lower:]" "[:upper:]"`

#prepare MAXDB_KEY
  set +x
  prepareMaxdbKey "$SRC_BACKUP_USER" "$SRC_USER_PASSWD"
  set -x


#-------------------------------------------------------------------------------

#Please Trigger a Temporary full dump based backup to enable the  autolog :

export DBSID=$DBSID
export SRC_BACKUP_USER=$SRC_BACKUP_USER
set +x
export SRC_USER_PASSWD=$SRC_USER_PASSWD
set -x
export $JOBID
export DUMPSCHEDULE=F


/act/custom_apps/maxdb/clone/ACT_MAXDB_dump.sh
  retval=$?

  if [ $retval -ne 0 ]; then
    echo "ERRORMSG: Full Dump backup failed after. Please check."
    exit 1
  fi

#Create log backup Template
  AUTOLOG_BKP_TEMP_NAME=ACT_AUTOLOGBKP_${DBSID}_TEMP
  set +x
  CHILD_BKP_MNT=`su -m $OSUSER -c "dbmcli -d $DBSID $MAXDB_KEY -uUTL -c param_getvolsall" | grep -v "OK\|UseMirroredLog\|MaxLogVolumes\|MaxDataVolumes" | grep "DataVolumeName0001" | awk '{print $4}' |cut -d'/' -f2-3`
  ste -x
  FIN_CHLD_BKP_LOC=/$CHILD_BKP_MNT/$DBSID/LOG
  AUTOLOG_BKP_FILE=$FIN_CHLD_BKP_LOC/AUTOLOG_${DBSID}_BKP.dat

  if [ ! -d $FIN_CHLD_BKP_LOC ]; then
     mkdir -p $FIN_CHLD_BKP_LOC
  fi

  find /$CHILD_BKP_MNT -type d -exec chmod 755 {} +
  CHILD_BKP_MNT_BASE=`dirname /$CHILD_BKP_MNT`
  chown -R $OSUSER:$OSGROUP $CHILD_BKP_MNT_BASE

  set +x
  su -m $OSUSER -c "dbmcli -d $DBSID $MAXDB_KEY -uUTL -c backup_template_create $AUTOLOG_BKP_TEMP_NAME to file $AUTOLOG_BKP_FILE content log"
  retval=$?
  set -x

  if [ $retval -ne 0 ]; then
    echo "ERRORMSG: Failed to create Autolog backup template post appaware mount"
    exit 1
  fi


#Disable the autolog overwrite feature
  set +x
  su -m $OSUSER -c "dbmcli -d $DBSID $MAXDB_KEY -uUTL -c db_execute SET LOG AUTO OVERWRITE OFF"
  retval=$?
  set -x

  if [ $retval -ne 0 ]; then
    echo "ERRORMSG: Unable to change Autolg Overwrite to OFF"
    exit 1
  fi


#Set the Log backup Interval if Not set

  if [ x"$INTERVAL"="x" ]; then
     INTERVAL=3600
  fi

#Check DB_STATE
  set +x
  getDB_State "$OSUSER" "$DBSID" "$MAXDB_KEY"
  set -x
  echo "$DB_STATE"

  if [ !  "$DB_STATE" = "ONLINE" ]; then

   set +x
   su -m $OSUSER -c "dbmcli -d $DBSID $MAXDB_KEY -uUTL -c db_online"
   retval=$?
   set -x    

    if [ $retval -ne 0 ]; then
      echo "ERRORMSG: Unable to bring the database in Online Mode Before Enabling the autolog"
      exit 1
    fi
  
  fi 

#Check the Autolog Backup state:

  set +x
  AUTOLOLOG_STATUS=`su -m $OSUSER -c "dbmcli -d $DBSID $MAXDB_KEY -uUTL -c autolog_show" | grep -v "OK"`
  set -x 
  echo "Autolog Backup status is : $AUTOLOLOG_STATUS "   
  if [ ! "$AUTOLOLOG_STATUS" = "AUTOSAVE IS ON" ]; then
    
#Enable the Autolog Backup
  set +x
  su -m $OSUSER -c "dbmcli -d $DBSID $MAXDB_KEY -uUTL -c autolog_on $AUTOLOG_BKP_TEMP_NAME INTERVAL $INTERVAL"
  retval=$?
  set -x

    if [ $retval -ne 0 ]; then
      echo "ERRORMSG: Failed to  enable Autolog Backup"
      exit 1
    fi
  fi
exit 0


