#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#
set -x
OSUSER=$OSUSER
TARGET_SERVER_NAME=$TARGET_SERVER_NAME
TARGET_DB_USER=$TARGET_DB_USER
set +x 
TARGET_DBUSER_PASSWD=$TARGET_DBUSER_PASSWD
set -x 
TARGET_MNT_PNT=$TARGET_MNT_PNT
MANIFEST_FILE_LOC=$MANIFEST_FILE_LOC
LOCAL_PRG_PATH=$MAXDB_HOME
SRC_DB_VERSION=$SRC_DB_VERSION
LOG_BKP_MNTPT=$LOG_BKP_MNTPT
BEGIN_TIME=$BEGIN_TIME
UNTIL_TIME=$UNTIL_TIME
ACT_JOBNAME=$JOBID
APPREMOUNT=$APPREMOUNT

# If it's a premount_test failure, don't run unmount.
ACT_PREMOUNT_FAILURE_FILE=/act/touch/premount_test_failure_$ACT_JOBNAME
if [ -e $ACT_PREMOUNT_FAILURE_FILE ]; then
  echo "INFOMSG: It's a premount-test failure. No unmount required."
  exit 0
fi

#hidden file to handel Mount and Migrate
MAXDB_MIGRATE_CONF=/act/touch/.ACT_MAXDB_migrate_$TARGET_SERVER_NAME.conf

#Check unmout database required or not
if [ -f $MAXDB_MIGRATE_CONF ]; then
  PVMOVE_STATUS=`cat $MAXDB_MIGRATE_CONF | awk -F "=" '{print $2}'`
  if [ "$PVMOVE_STATUS" = "YES" ]; then
    echo "INFOMSG: PVMOVE is completed. Unmount delete will proceed!"
    exit 0
  else
    echo "ERRORMSG: PVMOVE is in progress. Unmount delete cannot be done!"
    exit 1
  fi
fi

. /act/custom_apps/maxdb/act_maxdb_common_func.sh

#set the path 
if [ -z $LOCAL_PRG_PATH ]; then

   Local_soft_loc=`ps -eaf | grep "/pgm/kernel" | grep -vw grep | awk -F"/pgm/kernel" '{print $1}' | grep -v awk | awk '{print $NF}' | uniq | head -1`
  if [ -z "$Local_soft_loc" ]; then
     echo "ERRORMSG: Fail to find MaxDB_Home as no instance is running on this host."
     exit 1
  else
   LOCAL_PRG_PATH=$Local_soft_loc
  fi
fi

export PATH=$LOCAL_PRG_PATH/bin:$PATH

#Convert the TARGET_SERVER_NAME in upper case 
TARGET_SERVER_NAME=`echo $TARGET_SERVER_NAME | tr "[:lower:]" "[:upper:]"`

#prepare MAXDB_KEY
set +x
prepareMaxdbKey "$TARGET_DB_USER" "$TARGET_DBUSER_PASSWD"
set -x

#Check if the DB Instance is already exist :
isDB_exists=`dbmcli db_enum | grep -w $TARGET_SERVER_NAME | wc -l`
if ! [ $isDB_exists -gt 0 ]; then
  echo "DB $TARGET_SERVER_NAME does not exist"
  exit 0
fi

# Check dbState
set +x
dbState=`su -m $OSUSER -c "dbmcli -d $TARGET_SERVER_NAME $MAXDB_KEY db_state" | grep -vw "OK\|State" | xargs`
retval=$?
set -x

if [ $retval -ne 0 ]; then
  echo "ERRORMSG: fail to get db state"
  exit 1
fi

if ! [ "$dbState" = "OFFLINE" ]; then
  set +x
  su -m $OSUSER -c "dbmcli -d $TARGET_SERVER_NAME $MAXDB_KEY db_offline"
  retval=$?
  set -x

  if [ $retval -ne 0 ]; then
    echo "ERRORMSG:  Fail to make db offline"
    exit 1
  fi
fi

exit 0
