#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#

set -x
OSUSER=$OSUSER
DBSID=$DBSID
SRC_BACKUP_USER=$TARGET_DB_USER
set +x
SRC_USER_PASSWD="$TARGET_DBUSER_PASSWD"
set -x
LOCAL_PRG_PATH=$LOCAL_PRG_PATH
UNTIL_TIME=$UNTIL_TIME
LOG_BKP_MNTPT=$LOG_BKP_MNTPT
ACT_JOBNAME=$JOBID

. /act/custom_apps/maxdb/act_maxdb_common_func.sh

isVarNull OSUSER $OSUSER
isVarNull DBSID $DBSID
isVarNull SRC_BACKUP_USER $SRC_BACKUP_USER
isVarNull LOCAL_PRG_PATH $LOCAL_PRG_PATH

export PATH=$LOCAL_PRG_PATH/bin:$PATH
OSGROUP=`id -gn $OSUSER`

#Check the No of characters in DB Name
getDBName_charCount $DBSID

#Convert the DBSID in Upper case
DBSID=`echo $DBSID | tr "[:lower:]" "[:upper:]"`

#Prepare MAXDB_KEY
set +x
prepareMaxdbKey "$SRC_BACKUP_USER" "$SRC_USER_PASSWD"
set -x

#Check if the DB Instance  does not  exist
isDB_exists=`dbmcli db_enum | grep -w $DBSID | wc -l`

if [ $isDB_exists -eq 0 ]; then
  echo "ERRORMSG: Database $DBSID does not exist"
  exit 1
fi

#check the password authentication
set +x
su -m $OSUSER -c "dbmcli -d $DBSID $MAXDB_KEY bye"
retval=$?
set -x

if [ $retval -gt 0 ]; then
  set +x
  if [ -z "$SRC_USER_PASSWD" ]; then
    echo "ERRORMSG: DB Login Failed. Please enter the valid userkey "
  else
    echo "ERRORMSG: DB Login Failed. Please enter the correct username and password"
  fi
  set -x
  exit 1
fi

# Set database in admin state
set +x
su -m $OSUSER -c "dbmcli -d $DBSID $MAXDB_KEY db_admin"
retval=$?
set -x

if [ $retval -ne 0 ]; then
  echo "ERRORMSG: Failed to put database in admin mode"
  exit 1
fi
