#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#
set -x
OSUSER=$OSUSER
SRC_DBSID=$SRC_DBSID
TARGET_SERVER_NAME=$TARGET_SERVER_NAME
TARGET_DB_USER=$TARGET_DB_USER
set +x
TARGET_DBUSER_PASSWD="$TARGET_DBUSER_PASSWD"
set -x
LOCAL_PRG_PATH=$LOCAL_PRG_PATH
BEGIN_TIME=$BEGIN_TIME
UNTIL_TIME=$UNTIL_TIME
LOG_BKP_MNTPT=$LOG_BKP_MNTPT
DUMPBKPLOC=$DUMPBKPLOC
ACT_JOBNAME=$JOBID

. /act/custom_apps/maxdb/act_maxdb_common_func.sh

#Set Path Variable
export PATH=$LOCAL_PRG_PATH/bin:$PATH

#Convert TARGET_SERVER_NAME to upper case
TARGET_SERVER_NAME=`echo $TARGET_SERVER_NAME | tr "[:lower:]" "[:upper:]"`

#prepare MAXDB_KEY
set +x
prepareMaxdbKey "$TARGET_DB_USER" "$TARGET_DBUSER_PASSWD"
set -x

#Create temp dir
tmp_loc=/act/touch/$ACT_JOBNAME
if [ ! -d $tmp_loc ]; then
  mkdir -p $tmp_loc
fi
#find /act -type d -exec chmod 755 {} +

#Change permissions
OSGROUP=`id -gn $OSUSER`
chown -R $OSUSER:$OSGROUP $LOG_BKP_MNTPT
chown -R $OSUSER:$OSGROUP $tmp_loc
chmod -R 755 $tmp_loc
# prepare required flages, files
REC_OUTPUT=$tmp_loc/RECOVERY_OUTPUT.log
REC_INPUT=$tmp_loc/RECOVERY_INPUT.sql
echo "db_connect" > $REC_INPUT
UN_TM=`echo $UNTIL_TIME | sed 's/-//g' | sed 's/://g'`
flagR=0

#Clear log area
set +x
su -m $OSUSER -c "dbmcli -d $TARGET_SERVER_NAME $MAXDB_KEY -uUTL -c db_execute clear log"
retval=$?
set -x

if [ $retval -ne 0 ]; then
  echo "ERRORMSG: fail to clear log area"
  exit 1
fi

##############################
#get log bkp files 
#############################
logbkpFiles=`find $LOG_BKP_MNTPT/$SRC_DBSID/LOG -type f -newermt "$BEGIN_TIME" | sort`

if [ -z "$logbkpFiles" ]; then
  echo "No Log file to recover"
  exit 0
fi

#Prepare recovery script to recover in one session
for logFile in $logbkpFiles
do
  echo "backup_template_create act_maxdb_Log_rst_tmplt to FILE $logFile CONTENT LOG" >> $REC_INPUT
  if [ $flagR -eq 0 ]; then
    echo "recover_start act_maxdb_Log_rst_tmplt LOG until $UN_TM" >> $REC_INPUT
    flagR=1
  else
    echo "recover_replace act_maxdb_Log_rst_tmplt $logFile" >> $REC_INPUT
  fi
done
echo "recover_ignore" >> $REC_INPUT

#set the Proper permission to input file

chown -R $OSUSER:$OSGROUP $tmp_loc
chmod -R 755 $tmp_loc

#Recover the database with on session
set +x
su -m $OSUSER -c "dbmcli -d $TARGET_SERVER_NAME $MAXDB_KEY -i $REC_INPUT -o $REC_OUTPUT"
set -x

#Check for error
isErr=`grep ERR $REC_OUTPUT | wc -l`
if [ $isErr -gt 0 ]; then
  set +x
  dbState=`su -m $OSUSER -c "dbmcli -d $TARGET_SERVER_NAME $MAXDB_KEY db_state" | grep -vw "OK\|State" | xargs`
  set -x

  if ! [ "$dbState" = "ONLINE" ]; then
    echo "ERRORMSG: Fail to recover the database"
    cat $REC_OUTPUT
    exit 1
  fi
fi


#Remove temp files
#rm -rf $tmp_loc
