#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#
set -x

config_file=/act/custom_apps/maxdb/dump/Act_Maxdb_dumpRestore_newTarget.conf

usage() {
  echo "Usage: "
  echo "/act/custom_apps/maxdb/dump/Act_Maxdb_dumpRestore_newTarget.sh OSUSER=<OSUSER> LOCAL_PRG_PATH=<LOCAL_PRG_PATH> TARGET_SERVER_NAME=<TARGET_SERVER_NAME> TARGET_DB_USER=<TARGET_DB_USER> TARGET_DBUSER_PASSWD=<TARGET_DBUSER_PASSWD/null> SRC_DBSID=<SRC_DBSID> DATA_MNT_PNT=<DATA_MNT_PNT> LOG_MNT_PNT=<LOG_MNT_PNT> DBADMIN_PWD=<DBADMIN_PWD> MANIFEST_FILE_LOC=<MANIFEST_FILE_LOC> SRC_DB_VERSION=<SRC_DB_VERSION> DUMPBKPLOC=<DUMPBKPLOC> [ UNTIL_TIME=<UNTIL_TIME> BEGIN_TIME=<BEGIN_TIME> LOG_BKP_MNTPT=<LOG_BKP_MNTPT> ]"
  exit 1
}

isProvided() {
  local varName=$1
  local varVal=$2
  if [ -z "$varVal" ]; then
    echo "ERRORMSG: $varName is empty."
    usage
    exit 1
  fi
}

if [ $# -eq 0 ]; then
 if [ ! -f $config_file ]; then
   echo "ERRORMSG: $config_file Config file is missing. Please create a config file $config_file and update the required parameter."
   echo "Usage of the script will be like this :  sh /act/custom_apps/maxdb/dump/Act_Maxdb_dumpRestore_newTarget.sh"
   echo "Config file should look like this: For example,  cat $config_file"
   echo "OSUSER=sdb"
   echo "SRC_DBSID=SRCDB"
   echo "TARGET_SERVER_NAME=TRGDB"
   echo "TARGET_DB_USER=DBM"
   echo "TARGET_DBUSER_PASSWD=welcome1"
   echo "DBADMIN_PWD=DBADMIN"
   echo "LOG_MNT_PNT=/log"
   echo "DATA_MNT_PNT=/data"
   echo "MANIFEST_FILE_LOC=/act/tmpdata/Job_0374074/Manifest_File_SRCDB"
   echo "SRC_DB_VERSION=7.9.09"
   echo "LOG_BKP_MNTPT=/mnt_archivelog"
   echo "BEGIN_TIME='2019-11-19 16:13:23'"
   echo "UNTIL_TIME='2019-11-19 18:50:43'"
   echo "DUMPBKPLOC=/mntpt"
   exit 1
 else
   source /act/custom_apps/maxdb/dump/Act_Maxdb_dumpRestore_newTarget.conf
   export OSUSER
   export SRC_DBSID
   export TARGET_SERVER_NAME
   export TARGET_DB_USER
   export TARGET_DBUSER_PASSWD
   export DBADMIN_PWD
   export LOG_MNT_PNT
   export DATA_MNT_PNT
   export MANIFEST_FILE_LOC
   export LOCAL_PRG_PATH 
   export SRC_DB_VERSION
   export LOG_BKP_MNTPT
   export BEGIN_TIME
   export UNTIL_TIME 
   export DUMPBKPLOC
 fi
else
  for ARGUMENT in "$@"
    do
       ARGUMENT="${ARGUMENT%\"}"
       ARGUMENT="${ARGUMENT#\"}"
       argLft=`echo $ARGUMENT|cut -d= -f1`
       argRit=`echo $ARGUMENT|cut -d= -f2`
       export "$argLft=$argRit"
    done

 isProvided OSUSER $OSUSER
 isProvided TARGET_SERVER_NAME $TARGET_SERVER_NAME
 isProvided TARGET_DB_USER $TARGET_DB_USER 
 isProvided DBADMIN_PWD $DBADMIN_PWD
 isProvided SRC_DBSID $SRC_DBSID
 isProvided DBADMIN_PWD $DBADMIN_PWD
 isProvided DATA_MNT_PNT $DATA_MNT_PNT
 isProvided LOG_MNT_PNT $LOG_MNT_PNT
 isProvided MANIFEST_FILE_LOC $MANIFEST_FILE_LOC
 isProvided LOCAL_PRG_PATH $LOCAL_PRG_PATH
 isProvided SRC_DB_VERSION $SRC_DB_VERSION
 isProvided DUMPBKPLOC $DUMPBKPLOC
  
   if [ ! -z "$UNTIL_TIME" ]; then
     isProvided BEGIN_TIME $BEGIN_TIME
     isProvided LOG_BKP_MNTPT $LOG_BKP_MNTPT
   fi
fi

if [ ! -z "$ACT_JOBNAME" ]; then
  JOBID=$ACT_JOBNAME
else
  JOBID=JOB_54321
  export JOBID
fi

#Predumpresore Phase start

 /act/custom_apps/maxdb/dump/Act_Maxdb_predumprestore_newTarget.sh
 retval=$?
 
 if [ $retval -ne 0 ]; then
  echo "ERRORMSG: PredumpResore phase ended with error"
  exit 1
 else
   echo "Predump Restore Phase completed successfully. Starting Dump Restore Phase"
   /act/custom_apps/maxdb/dump/Act_Maxdb_dbconfig_newTarget.sh
   retval=$?

   if [ $retval -ne 0 ]; then   
     echo "ERRORMSG: DumpRestore on new target failed"
     exit 1
   fi
 fi

 exit 0

