#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#
set -x
OSUSER=$OSUSER
TARGET_SERVER_NAME=$TARGET_SERVER_NAME
TARGET_DB_USER=$TARGET_DB_USER
set +x
TARGET_DBUSER_PASSWD=$TARGET_DBUSER_PASSWD
set -x
LOCAL_PRG_PATH=$LOCAL_PRG_PATH
UNTIL_TIME=$UNTIL_TIME
LOG_BKP_MNTPT=$LOG_BKP_MNTPT
ACT_JOBNAME=$JOBID

. /act/custom_apps/maxdb/act_maxdb_common_func.sh

isVarNull OSUSER $OSUSER
isVarNull TARGET_SERVER_NAME $TARGET_SERVER_NAME
isVarNull TARGET_DB_USER $TARGET_DB_USER
#isVarNull LOCAL_PRG_PATH $LOCAL_PRG_PATH


  #LOCAL_PRG_PATH=`dbmcli -d $TARGET_SERVER_NAME dbm_version INSTROOT | grep -vw "OK"`
   LOCAL_PRG_PATH=`dbmcli dbm_version INSTROOT | grep -vw "OK"`
  
  export PATH=$LOCAL_PRG_PATH/bin:$PATH
  OSGROUP=`id -gn $OSUSER`

#Check the No of characters in DB Name
  getDBName_charCount $TARGET_SERVER_NAME

#Convert the TARGET_SERVER_NAME in Upper case
  TARGET_SERVER_NAME=`echo $TARGET_SERVER_NAME | tr "[:lower:]" "[:upper:]"`

#Check if the DB Instance is already exist
  isDB_exists=`dbmcli db_enum | grep -w $TARGET_SERVER_NAME | wc -l`

if [ $isDB_exists -gt 0 ]; then
   echo "Database $TARGET_SERVER_NAME already exist"

  #Prepare MAXDB_KEY
  set +x
  prepareMaxdbKey "$TARGET_DB_USER" "$TARGET_DBUSER_PASSWD"
  set -x

#check the password authentication
  set +x
  su -m $OSUSER -c "dbmcli -d $TARGET_SERVER_NAME $MAXDB_KEY bye"
  retval=$?
  set -x

  if [ $retval -gt 0 ]; then
    set +x
    if [ -z "$TARGET_DBUSER_PASSWD" ]; then
      echo "ERRORMSG: DB Login Failed. Please enter the valid userkey "
    else
      echo "ERRORMSG: DB Login Failed. Please enter the correct username and password"
    fi
    set -x
    exit 1
  fi

# Set database in admin state
  set +x
  su -m $OSUSER -c "dbmcli -d $TARGET_SERVER_NAME $MAXDB_KEY db_admin"
  retval=$?
  set -x

  if [ $retval -ne 0 ]; then
    echo "ERRORMSG: Failed to put database in admin mode"
    exit 1
  fi

else
  set +x
  isVarNull TARGET_DBUSER_PASSWD "$TARGET_DBUSER_PASSWD"
  set -x
fi
