#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#
set -x
OSUSER=$OSUSER
TARGET_SERVER_NAME=$TARGET_SERVER_NAME
TARGET_DB_USER=$TARGET_DB_USER
set +x
TARGET_DBUSER_PASSWD="$TARGET_DBUSER_PASSWD"
set -x 
TARGET_MNT_PNT=$TARGET_MNT_PNT
MANIFEST_FILE_LOC=$MANIFEST_FILE_LOC
LOCAL_PRG_PATH=$LOCAL_PRG_PATH
SRC_DB_VERSION=$SRC_DB_VERSION
LOG_BKP_MNTPT=$LOG_BKP_MNTPT
BEGIN_TIME=$BEGIN_TIME
UNTIL_TIME=$UNTIL_TIME
ACT_JOBNAME=$JOBID

. /act/custom_apps/maxdb/act_maxdb_common_func.sh


#prepare MAXDB_KEY
set +x
prepareMaxdbKey "$TARGET_DB_USER" "$TARGET_DBUSER_PASSWD"
set -x


#Convert TARGET_SERVER_NAME  to uppercase 

  TARGET_SERVER_NAME=`echo "$TARGET_SERVER_NAME" | tr "[:lower:]" "[:upper:]"`
  echo "$TARGET_SERVER_NAME"

#---------------------------------------------------------------------------
# Update the Parameter file with the new Log and DATA Volume
#---------------------------------------------------------------------------
Update_data_log_loc() {
  vol_name=$1
  file_name=$2

  set +x
  su -m $OSUSER -c "dbmcli -d $TEMP_INSTANCE $MAXDB_KEY param_put $vol_name  $file_name"
  retval=$?
  set -x

  if [ $retval -ne 0 ]; then
    echo " Parameter file update failed for Data and Log Location"
    exit 1
  fi
}
#---------------------------------------------------------------------------


#---------------------------------------------------------------------------
# Clear the  info of  Log and DATA Volume from Prameter  file 
#---------------------------------------------------------------------------
del_data_log_vol() {
  vol_no=$1
  vol_type=$2

  set +x
   su -m $OSUSER -c "dbmcli -d $TARGET_SERVER_NAME $MAXDB_KEY param_delvolume $vol_no $vol_type"
   retval=$?
  set -x

  if [ $retval -ne 0 ]; then
    echo " Clearing of Data and Log Location in to the parameter file failed"    
  fi
}

#---------------------------------------------------------------------------
# Function: drop_Temp_Instance() : To drop Temporary Instance
#---------------------------------------------------------------------------

#Drop the Temp Instance :

drop_Temp_Instance(){
  TEMP_INSTANCE=$1
  set +x
   su -m $OSUSER -c "dbmcli -d $TEMP_INSTANCE $MAXDB_KEY db_drop"
   retval=$?
  set -x

  if [ $retval -ne 0 ]; then
   echo "ERRORMSG: Temp DB  Instance Failed to drop"
  exit 1
  fi
}
#---------------------------------------------------------------------------

  tmp_loc=/act/touch/$ACT_JOBNAME
  mkdir -p $tmp_loc
  #find /act -type d -exec chmod 755 {} +
  chmod -R 755 $tmp_loc
  chown -R $OSUSER:$OSGRPUSR $tmp_loc

  OSGRPUSR=`id -Gn $OSUSER`
  export PATH=$LOCAL_PRG_PATH/bin:$PATH

  INDEP_DATA_PATH=`dbmcli dbm_getpath IndepDataPath | grep -v -w "OK"`

  TGT_DB_VERSION=`dbmcli dbm_version VERSION | grep -v -w "OK"`
if ! [ "$TGT_DB_VERSION" = "$SRC_DB_VERSION" ]; then
  echo "ERRORMSG: Target DB has different version from source"
exit 1
fi

  #Check if the DB Instance is already exists :
  isDB_exists=`dbmcli db_enum | grep -w $TARGET_SERVER_NAME | wc -l`
  if [ $isDB_exists -eq 0 ]; then 
    echo "ERRORMSG: Target server Does not exits"
  exit 1
  fi
 
#Check if Config Directory already exist
if [ ! -d $INDEP_DATA_PATH/config ]; then
  mkdir -p $INDEP_DATA_PATH/config
fi

#Create Temp Instnace :
  TEMP_INSTANCE=${TARGET_SERVER_NAME}_TEMP
  set +x
   su -m $OSUSER -c "dbmcli db_create $TEMP_INSTANCE $TARGET_DB_USER,'$TARGET_DBUSER_PASSWD'"
  set -x 

#Copy the Config file
  cp $MANIFEST_FILE_LOC $INDEP_DATA_PATH/config/$TEMP_INSTANCE
retval=$?
if [ $retval -ne 0 ]; then
  echo "ERRORMSG: Unable to find the Manifest File"
  #set +x
   drop_Temp_Instance $TEMP_INSTANCE 
  set -x 
exit 1
fi

chown -R $OSUSER:$OSGRPUSR $INDEP_DATA_PATH/config/$TEMP_INSTANCE

##Chekc if RunDirectry already Exist 
  TRG_RUNDIRECTORY=$INDEP_DATA_PATH/wrk/$TARGET_SERVER_NAME
if [ ! -d $TRG_RUNDIRECTORY ]; then
   mkdir -p $TRG_RUNDIRECTORY 
fi
chown -R $OSUSER:$OSGRPUSR $TRG_RUNDIRECTORY

#Login the Temp instance to get the source file details :

  SRC_VOLINFO=$tmp_loc/SRC_VOLINFO
  set +x
   su -m $OSUSER -c "dbmcli -d $TEMP_INSTANCE $MAXDB_KEY -o $SRC_VOLINFO param_getvolsall"
   retval=$?
  set -x

if [ $retval -ne 0 ]; then
  echo "ERRORMSG: Unable to find the Temp Instane Deatils."
  #set +x
   drop_Temp_Instance $TEMP_INSTANCE 
  set -x
exit 1
fi



#Login the Target Instance to get Target file details :
  TRG_VOLINFO=$tmp_loc/TRG_VOLINFO
  set +x
   su -m $OSUSER -c "dbmcli -d $TARGET_SERVER_NAME $MAXDB_KEY -o $TRG_VOLINFO param_getvolsall"
   retval=$?
  set -x

if [ $retval -ne 0 ]; then
  echo "ERRORMSG: Unable to find the Target Instane Deatils."
  #set +x
   drop_Temp_Instance $TEMP_INSTANCE
  set -x 
exit 1
fi

OLD_RUNDIRECTORY=`strings $MANIFEST_FILE_LOC | grep -wA1 RUNDIRECTORY | tail -1 | cut -c2-`
set +x
TRG_OLD_RUNDIRECTORY=`su $OSUSER -c "dbmcli -d $TARGET_SERVER_NAME $MAXDB_KEY param_directget RUNDIRECTORY" | grep -v "OK" | awk '{ print $NF }' `
set -x


#Get the Target location of datafile and logfile 

  SRC_VOLINFO1=$tmp_loc/SRC_VOLINFO.tmp
  TRG_VOLINFO1=$tmp_loc/TRG_VOLINFO.tmp
  SRC_VOLINFO2=$tmp_loc/SRC_VOLINFO2.tmp

  cat $SRC_VOLINFO | grep -vw "OK\|UseMirroredLog\|MaxLogVolumes\|MaxDataVolumes" >$SRC_VOLINFO1
  rm -f $SRC_VOLINFO1.tmp
  while read line
  do
    filePath=`echo $line | awk '{print $4}'`
    if [ "${filePath:0:1}" != "/" ]; then
      filePath=$OLD_RUNDIRECTORY/$filePath
    fi
    colOne=`echo $line | awk '{print $1}'`
    colTwo=`echo $line | awk '{print $2}'`
    colThree=`echo $line | awk '{print $3}'`
    colFive=`echo $line | awk '{print $5}'`
    echo "$colOne $colTwo $colThree $filePath $colFive" >> $SRC_VOLINFO1.tmp
  done < $SRC_VOLINFO1
  mv $SRC_VOLINFO1.tmp $SRC_VOLINFO1

  cat $TRG_VOLINFO | grep -vw "OK\|UseMirroredLog\|MaxLogVolumes\|MaxDataVolumes" >$TRG_VOLINFO1
  rm -f $TRG_VOLINFO1.tmp
  while read line
  do
    filePath=`echo $line | awk '{print $4}'`
    if [ "${filePath:0:1}" != "/" ]; then
      filePath=$TRG_OLD_RUNDIRECTORY/$filePath
    fi
    colOne=`echo $line | awk '{print $1}'`
    colTwo=`echo $line | awk '{print $2}'`
    colThree=`echo $line | awk '{print $3}'`
    colFive=`echo $line | awk '{print $5}'`
    echo "$colOne $colTwo $colThree $filePath $colFive" >> $TRG_VOLINFO1.tmp
  done < $TRG_VOLINFO1
  mv $TRG_VOLINFO1.tmp $TRG_VOLINFO1

  TRG_DATA_DIR=`dirname $(cat $TRG_VOLINFO1 | grep "DataVolumeName" | awk '{print $4}' | head -1)` 
  TRG_LOG_DIR=`dirname $(cat $TRG_VOLINFO1 | grep "LogVolumeName" | awk '{print $4}' | head -1)`

#unalias cp command
  unalias cp

  cp $SRC_VOLINFO1 $SRC_VOLINFO2

#Clean the Traget Data and Log files

  cat $TRG_VOLINFO1 |  awk '{ print "rm -f " $4}'> $tmp_loc/del_trg_file.sh
  sh $tmp_loc/del_trg_file.sh
  retval=$?

if [ $retval -ne 0 ]; then
  echo "ERROSMSG: Failed to clear the target datafile and log files"
  #set +x
  drop_Temp_Instance $TEMP_INSTANCE 
  set -x
exit 1
fi

#Copy the Mounted datafiles to Target Directory

  SRC_DATA_INFO=$tmp_loc/SRC_DATA_INFO
  SRC_LOG_INFO=$tmp_loc/SRC_LOG_INFO

  cat $SRC_VOLINFO1 | grep "DataVolumeName" | awk '{print $4}'>$SRC_DATA_INFO
while read line 
do
  src_db_file=`echo $line`
  mount_db_file=$TARGET_MNT_PNT$src_db_file
  if [ ! -e "$mount_db_file" ]; then
    echo "ERRORMSG: Data volume file $mount_db_file not available"
    exit 1
  fi
  cp $mount_db_file $TRG_DATA_DIR
done < $SRC_DATA_INFO

  cat $SRC_VOLINFO1 | grep "LogVolumeName" | awk '{print $4}'>$SRC_LOG_INFO
while read line 
do
  src_log_file=`echo $line`
  mount_log_file=$TARGET_MNT_PNT$src_log_file
  if [ ! -e "$mount_log_file" ]; then
    echo "ERRORMSG: Data volume file $mount_db_file not available"
    exit 1
  fi
  cp $mount_log_file $TRG_LOG_DIR
done < $SRC_LOG_INFO

#set the ownership to the data and log files 

  chown -R $OSUSER:$OSGRPUSR  $TRG_LOG_DIR
  chown -R $OSUSER:$OSGRPUSR  $TRG_DATA_DIR 

#update the volume name and target file in temp file 

while read line 
do
  src_data_dir=`dirname $(echo $line)`
  src_data_dir_sed=`echo $src_data_dir | sed 's./.\\\/.g'`
  trg_data_dir_sed=`echo $TRG_DATA_DIR | sed 's./.\\\/.g'`
  sed -i "s.$src_data_dir_sed.$trg_data_dir_sed.g" $SRC_VOLINFO2
done <$SRC_DATA_INFO

while read line 
do
  src_log_dir=`dirname $(echo $line)`
  src_log_dir_sed=`echo $src_log_dir | sed 's./.\\\/.g'`
  trg_log_dir_sed=`echo $TRG_LOG_DIR | sed 's./.\\\/.g'`
  sed -i "s.$src_log_dir_sed.$trg_log_dir_sed.g" $SRC_VOLINFO2
done < $SRC_LOG_INFO

#Clean the Target datafile and logfile info from parameter file

#clean(){
#while read line
#do
#  vol_name=`echo $line | grep "VolumeName" | awk '{ print $1 }'`
#  vol_no=`echo ${vol_name: -1}`
# First_char_vol_name=`echo $vol_name | cut -c1`
#  if [ "$First_char_vol_name" = "D" ]; then 
#     vol_type=DATA
#  else
#     vol_type=LOG
#  fi
#  del_data_log_vol $vol_no $vol_type
#done < $TRG_VOLINFO1
#}

# Update DATA and LOG volume path in parameter file Temp DB instance 

while read line 
do
  vol_name=`echo $line | grep "VolumeName" | awk '{ print $1 }'`
  trg_file_name=`echo $line | grep "VolumeName" | awk '{ print $4}'` 
  Update_data_log_loc $vol_name $trg_file_name
done < $SRC_VOLINFO2

#Update the TragetRunDirectory in Temp db Instance 

  set +x
  su -m $OSUSER -c "dbmcli -d $TEMP_INSTANCE $MAXDB_KEY param_put RUNDIRECTORY $TRG_RUNDIRECTORY"
  retval=$?
  set -x

if [ $retval -ne 0 ]; then
  echo "ERRORMSG: Failed to update the rundirectory in temp instance" 
  #set +x
  drop_Temp_Instance $TEMP_INSTANCE 
  set -x
exit 1
fi

#Repalce the Target config file from Temp Config file

  mv $INDEP_DATA_PATH/config/$TARGET_SERVER_NAME $INDEP_DATA_PATH/config/${TARGET_SERVER_NAME}_old
  mv $INDEP_DATA_PATH/config/$TEMP_INSTANCE $INDEP_DATA_PATH/config/$TARGET_SERVER_NAME

  chown -R $OSUSER:$OSGRPUSR $INDEP_DATA_PATH/config/$TARGET_SERVER_NAME 

# Start Instance in admin mode
  set +x
  su -m $OSUSER -c "dbmcli -d $TARGET_SERVER_NAME $MAXDB_KEY db_admin"
  retval=$?
  set -x

if [ $retval -ne 0 ]; then
  echo "ERRORMSG: Database Instance Failed to admin Mode"
  #set +x
  drop_Temp_Instance $TEMP_INSTANCE 
  set -x
exit 1 
fi

#Recovery database if needed
if [ ! -z "$UNTIL_TIME" ]; then
  set +x
  su -m $OSUSER -c "dbmcli -d $TARGET_SERVER_NAME $MAXDB_KEY db_admin"
  retval=$?
  set -x

  if [ $retval -ne 0 ]; then
    echo "ERRORMSG: Fail to set database in admin mode"
    #set +x
    drop_Temp_Instance $TEMP_INSTANCE 
    set -x
  exit 1  
  fi

/act/custom_apps/maxdb/restore/ACT_MAXDB_Restore_recovery_newTarget.sh
  if [ $? -ne 0 ]; then
    echo "ERRORMSG: Fail to recovery database "
    #set +x
    drop_Temp_Instance $TEMP_INSTANCE
    set -x
  exit 1  
  fi
fi

# Bring the DB online
  set +x
  su -m $OSUSER -c "dbmcli -d $TARGET_SERVER_NAME $MAXDB_KEY db_online"
  retval=$?
  set -x

if [ $retval -ne 0 ]; then
  echo "ERRORMSG: Database Instance Failed to start"
  
#Updating the Target server with old configuration

while read line
do
  vol_name=`echo $line | grep "VolumeName" | awk '{ print $1 }'`
  trg_file_name=`echo $line | grep "VolumeName" | awk '{ print $2}'`
  Update_data_log_loc $vol_name $trg_file_name
  done < $TRG_VOLINFO1

  #set +x
  drop_Temp_Instance $TEMP_INSTANCE
  set -x
exit 1
fi

#Drop the Temp Instance :

  #set +x
  drop_Temp_Instance $TEMP_INSTANCE 
  set -x

exit 0

