#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#

OSUSER=$OSUSER
TARGET_SERVER_NAME=$TARGET_SERVER_NAME
TARGET_DB_USER=$TARGET_DB_USER
set +x
TARGET_DBUSER_PASSWD="$TARGET_DBUSER_PASSWD"
set -x
TARGET_MNT_PNT=$TARGET_MNT_PNT
MANIFEST_FILE_LOC=$MANIFEST_FILE_LOC
LOCAL_PRG_PATH=$LOCAL_PRG_PATH
SRC_DB_VERSION=$SRC_DB_VERSION
LOG_BKP_MNTPT=$LOG_BKP_MNTPT
BEGIN_TIME=$BEGIN_TIME
UNTIL_TIME=$UNTIL_TIME
ACT_JOBNAME=$JOBID

. /act/custom_apps/maxdb/act_maxdb_common_func.sh

#prepare MAXDB_KEY
set +x
prepareMaxdbKey "$TARGET_DB_USER" "$TARGET_DBUSER_PASSWD"
set -x

#Check the No of characters in DB Name
getDBName_charCount $TARGET_SERVER_NAME

#check the Null value

IsVarNull(){
  local var_name=$1
  local value=$2

 if [ -z $value ]; then
   echo "Please provide the value of $var_name in either config file or command line argument"
   echo "Usage of the script is, for example: sh /act/custom_apps/maxdb/restore/ACT_MAXDB_lvmRestore_newTarget.sh OSUSER=sdb TARGET_SERVER_NAME=TMS TARGET_DB_USER=dbm TARGET_DBUSER_PASSWD=welcome123 MANIFEST_FILE_LOC=/act/tmpdata/Job_0818287/Manifest_File_SLD SRC_DB_VERSION=7.9.09 SRC_DBSID=PQR LOG_BKP_MNTPT=/mnt_archivelog JOBID=Job_123456 BEGIN_TIME="2019-12-29 13:23:35" UNTIL_TIME="2019-12-29 13:23:35" TARGET_MNT_PNT=/mntpt"
 exit 1
 fi
}


  IsVarNull OSUSER $OSUSER
  IsVarNull TARGET_SERVER_NAME $TARGET_SERVER_NAME
  IsVarNull TARGET_DB_USER $TARGET_DB_USER
  set +x
  #IsVarNull TARGET_DBUSER_PASSWD $TARGET_DBUSER_PASSWD
  set -x
  IsVarNull TARGET_MNT_PNT $TARGET_MNT_PNT
  IsVarNull MANIFEST_FILE_LOC $MANIFEST_FILE_LOC
  #IsVarNull LOCAL_PRG_PATH $LOCAL_PRG_PATH
  IsVarNull SRC_DB_VERSION $SRC_DB_VERSION

if [ ! -z "$UNTIL_TIME" ]; then
  IsVarNull LOG_BKP_MNTPT $LOG_BKP_MNTPT
fi

isDBExist=`su -m $OSUSER -c "dbmcli db_enum" | grep -w "$TARGET_SERVER_NAME" | wc -l`

  #Shutdown the Traget server 
  set +x
  DB_STATE=`su -m $OSUSER -c "dbmcli -d $TARGET_SERVER_NAME $MAXDB_KEY db_state" | grep -vw "OK\|State"`
  set -x
  echo "DATABASE STATE is $DB_STATE"
  if [ "$DB_STATE" = "ONLINE" ] ||  [ "$DB_STATE" = "ADMIN" ]; then     
     set +x  
     su -m $OSUSER -c "dbmcli -d $TARGET_SERVER_NAME $MAXDB_KEY db_offline"
     retval=$?
     set -x
     if [ $retval -ne 0 ]; then
       echo "ERRORMSG :Failed the stop the Target database $TARGET_SERVER_NAME"
       exit 1
     fi
  fi
exit 0 
