#!/bin/sh

set -x
OSUSER=$OSUSER
DBUSER=$DBUSER
set +x
DBPASSWORD="$DBPASSWORD"
set -x
BASEDIR=$BASEDIR
SOCKETFILE=$SOCKET_FILE
SRV_TYPE=$SRV_TYPE
PORTNO=$PORTNO

# Get Common functions
. /act/custom_apps/mysql/act_mysql_common_functions.sh

###########function: startPos()
startPos() {
  local cmdP=$1

  su -m $OSUSER -c "$MYSQL_CMD -e \"$cmdP;\" " > $STARTPOS_FILE
  retval=$?

  return $retval
}
#################################

## Set tmploc
tmploc="/act/touch"
if [ ! -d $tmploc ]; then mkdir $tmploc ; fi
chmod 755 $tmploc
STARTPOS_FILE=$tmploc/STARTPOS_FILE_$JOBID.txt

# Prepare MySQL Command
set +x
prepare_MYSQLCMD "$DBUSER" "$DBPASSWORD" "$SOCKETFILE" "$BASEDIR"
set -x

## Freeze MySQL
if [ "$SRV_TYPE" != "Slave" ]; then
  su -m $OSUSER -c "$MYSQL_CMD -e \"FLUSH TABLES WITH READ LOCK;select 'ACT___bkp_$PORTNO';select sleep(150);\" &"
  retval=$?
else
  execMySQL "STOP SLAVE"
  retval=$?
fi

if [ $retval -ne 0 ]; then
  echo "ERRORMSG: Failed to freeze mysql server"
  exit 1
fi

## Find logfile, Position
if [ "$SRV_TYPE" != "Slave" ]; then
  startPos "show master status "
  retval=$?
else
  startPos "show slave status \G"
  retval=$?
fi

if [ $retval -ne 0 ]; then
  echo "ERRORMSG: Failed to find current logfile, position of mysql server"
  exit 1
fi

echo "MySQL freezed successfully"
exit 0
