#!/bin/sh

set -x
SRC_DATADIR=$SRC_DATADIR
SRC_VERSION=$SRC_VERSION
SRC_TMPDIR=$SRC_TMPDIR
MESSAGES_DIR=$MESSAGES_DIR
TARGET_MNT_PNT=$TARGET_MNT_PNT
BASEDIR=$BASEDIR
PORT=$PORT
OSUSER=$OSUSER
DBUSER=$DBUSER
set +x
DBPASSWORD=$DBPASSWORD
set -x
BEGIN_TIME=$BEGIN_TIME
UNTIL_TIME=$UNTIL_TIME
LOG_BKP_MNTPT=$LOG_BKP_MNTPT

SOCKFILE=$1

# Get Common functions
. /act/custom_apps/mysql/act_mysql_common_functions.sh

# Set env
set +x
prepare_MYSQLCMD "$DBUSER" "$DBPASSWORD" "$SOCKFILE" "$BASEDIR"
set -x

# Apply binlogs one by one
binLogs=`find $LOG_BKP_MNTPT/* -type f -newermt "$BEGIN_TIME" ! -newermt "$UNTIL_TIME" | sort | awk '{print $NF}' `
for binLog in $binLogs
do
  recoveryBinLog "$binLog" "$UNTIL_TIME"
  if [ $? -ne 0 ]; then
    echo "ERRORMSG: Failed to recover MySQL server @$binLog !"
    exit 1
  fi
done

#Apply last log file
llf=`find $LOG_BKP_MNTPT/* -type f -newermt "$UNTIL_TIME" |sort | awk '{print $NF}' |xargs| awk '{print $1}'`
if [ ! -z "$llf" ]; then
  recoveryBinLog "$llf" "$UNTIL_TIME"
  if [ $? -ne 0 ]; then
    echo "ERRORMSG: Failed to recover MySQL server @$binLog !"
    exit 1
  fi
fi

echo "MySQL recovered successfully"
exit 0
