#!/bin/sh

set -x
OSUSER=$OSUSER
DBUSER=$DBUSER
set +x
DBPASSWORD="$DBPASSWORD"
set -x
BASEDIR=$BASEDIR
SOCKETFILE=$SOCKET_FILE
SRV_TYPE=$SRV_TYPE
USER_DBLIST="$DB_LIST"
DATAVOLUMEOWNER=$DATAVOLUMEOWNER
DUMPBKPLOC=$TARGET_MNT_PNT

if [ "$DATAVOLUMEOWNER" = "" ]; then
  OSGROUP=`id -Gn $OSUSER`
  DATAVOLUMEOWNER=$OSUSER:$OSGROUP
fi

#--------------------------------------------------
# function: dumpDB_Restore()
#--------------------------------------------------
dumpDB_Restore() {
  echo "function call: dumpDB() ...."
  local dbName=$1
  local dmpLoc=$2

  dmpFiles=`ls -ltr $dmpLoc/* | tail -1 | awk '{print $NF}'`
  for dmpFile in $dmpFiles
  do
    echo "File: $dmpFile"
    su -m $OSUSER -c "$MYSQL_CMD -D $dbName < $dmpFile"
    retval=$?
  done

  return $retval
}
#--------------------------------------------------

OSGROUP=`id -gn $OSUSER`

# Get Common functions
. /act/custom_apps/mysql/act_mysql_common_functions.sh

isVarNull DUMPBKPLOC $DUMPBKPLOC

#Change mountpoint premissions
chown -R $OSUSER:$OSGROUP $DUMPBKPLOC
dump_mnt_bs=`echo $DUMPBKPLOC | cut -d/ -f2`
if [ ! -z $dump_mnt_bs ]; then
  find /$dump_mnt_bs -type d -exec chmod 755 {} +
fi

# Prepare MySQL Command
set +x
prepare_MYSQLCMD "$DBUSER" "$DBPASSWORD" "$SOCKETFILE" "$BASEDIR"
set -x

# call dump_restore for each database
for dbName in $(echo $USER_DBLIST | sed 's/,/ /g')
do
  #Create db
  isDB_exists $dbName
  if [ $? -ne 0 ]; then
    execMySQL "create database $dbName"
    retval=$?
    if [ $retval -ne 0 ]; then
      echo "ERRORMSG: Fail to create database $dbName"
      exit 1
    fi
  fi

  dumpDB_Restore $dbName $DUMPBKPLOC/$dbName
  if [ $? -ne 0 ]; then
    echo "ERRORMSG: failed to restore database $dbName"
    exit 1
  fi

  # Recover if needed
  if [ "$UNTIL_TIME" != "" ]; then
    /act/custom_apps/mysql/dump/ACT_MYSQL_RESTORE_recovery.sh $SOCKETFILE $dbName
    if [ $? -ne 0 ]; then
      echo "ERRORMSG: Failed to recover MySQL server @$binLog !"
      exit 1
    fi
  fi
done
