#!/bin/sh

set -x
OSUSER=$OSUSER
DBUSER=$DBUSER
set +x
DBPASSWORD="$DBPASSWORD"
set -x
BASEDIR=$BASEDIR
SOCKETFILE=$SOCKET_FILE
SRV_TYPE=$SRV_TYPE
USER_DBLIST="$DB_LIST"
DATAVOLUMEOWNER=$DATAVOLUMEOWNER
DUMPBKPLOC=$TARGET_MNT_PNT

#--------------------------------------------------
# function: dropDB()
#--------------------------------------------------
dropDB() {
  local dbName=$1

  #drop database
  su -m $OSUSER -c "$MYSQL_CMD -e \"drop database $dbName ;\" "
  retval=$?
  if [ $retval -ne 0 ]; then
    #remove the database directory
    local dataDir=`getMySqlVarValue datadir`
    if [ -z "$dataDir" ]; then
      return 1
    fi
    if [ ! -z $dbName ]; then
      rm -f $dataDir/$dbName/*
    fi
    rmdir $dataDir/$dbName
  fi

  #create database
  su -m $OSUSER -c "$MYSQL_CMD -e \"create database $dbName ;\" "
  return $?
}
#--------------------------------------------------

#--------------------------------------------------
# function: isDB_exists()
#--------------------------------------------------
isDB_exists() {
  local dbName=$1
  local dbexistsCount=`su -m $OSUSER -c "$MYSQL_CMD -e \"show databases;\" "|grep -w $dbName| wc -l`
  if [ $dbexistsCount -eq 0 ]; then
    return 1
  else
    return 0
  fi
}
#--------------------------------------------------

# Get Common functions
. /act/custom_apps/mysql/act_mysql_common_functions.sh

isVarNull OSUSER $OSUSER
isVarNull SOCKETFILE $SOCKETFILE
isVarNull USER_DBLIST $USER_DBLIST

# Prepare MySQL Command
set +x
prepare_MYSQLCMD "$DBUSER" "$DBPASSWORD" "$SOCKETFILE" "$BASEDIR"
set -x

# call dump_restore for each database
for dbName in $(echo $USER_DBLIST | sed 's/,/ /g')
do
  isDB_exists $dbName
  if [ $? -ne 0 ]; then
    echo "DB $dbName already droped or never exists"
    continue
  fi

  dropDB $dbName
  if [ $? -ne 0 ]; then
    echo "ERRORMSG: failed to drop database $dbName"
    exit 1
  fi
done
