#!/bin/sh

set -x
OSUSER=$OSUSER
DBUSER=$DBUSER
set +x
DBPASSWORD="$DBPASSWORD"
set -x
BASEDIR=$BASEDIR
SOCKETFILE=$SOCKET_FILE
SRV_TYPE=$SRV_TYPE
USER_DBLIST="$USER_DBLIST"
DATAVOLUMEOWNER=$DATAVOLUMEOWNER

DUMPSCHEDULE=$DUMPSCHEDULE
DUMPBKPLOC=$DUMPBKPLOC

if [ "$DATAVOLUMEOWNER" = "" ]; then
  OSGROUP=`id -Gn $OSUSER`
  DATAVOLUMEOWNER=$OSUSER:$OSGROUP
fi

if [ "x$DUMPBKPLOC" = "x" ]; then
  echo "ERRORMSG: DUMPBKPLOC is not provided"
  exit 1
fi

chown $DATAVOLUMEOWNER $DUMPBKPLOC

#--------------------------------------------------
# function: dumpDB()
#--------------------------------------------------
dumpDB() {
  echo "function call: dumpDB() ...."
  local dbName=$1
  local dmpLoc=$2

  dmpLoc=$dmpLoc/$dbName
  if [ ! -d $dmpLoc ]; then
     mkdir -p $dmpLoc
     chown -R $DATAVOLUMEOWNER $dmpLoc
  fi

  tsname=`date +%Y%m%d`
  tsname1=`date +%H%M%S`

  lf="$dbName"_dumpbkp"$DF"_"$tsname"_"$tsname1"

  su -m $OSUSER -c "$MYSQL_DMP_CMD --databases $dbName > $dmpLoc/$lf.sql"
  retval=$?

  return $retval
}
#--------------------------------------------------

# Get Common functions
. /act/custom_apps/mysql/act_mysql_common_functions.sh

# Prepare MySQL Command
set +x
prepare_MYSQLCMD "$DBUSER" "$DBPASSWORD" "$SOCKETFILE" "$BASEDIR"
set -x

# call dump for each database
for dbName in $(echo $USER_DBLIST | sed 's/,/ /g')
do
  dumpDB $dbName $DUMPBKPLOC
  if [ $? -ne 0 ]; then
    echo "ERRORMSG: dump for database $dbName failed"
    exit 1
  fi
done

echo "INFOMSG: Dump backup successful."
PORTNO=`getMySqlVarValue port`
echo "DBSID: mysqld_$PORTNO $DBSID BACKUPTYPE: Full BACKUPID:  END TIME: `date +%Y-%m-%d` `date +%H:%M:%S.%N` STATUS: successful"

exit 0
