#!/bin/sh

set -x
OSUSER=$OSUSER
DBUSER=$DBUSER
set +x
DBPASSWORD="$DBPASSWORD"
set -x
BASEDIR=$BASEDIR
SOCKETFILE=$SOCKET_FILE
SRV_TYPE=$SRV_TYPE
DATADIR=$SRC_DATADIR
PORT=$PORT
CONFIG_FILE=$CONFIG_FILE

# Get Common functions
. /act/custom_apps/mysql/act_mysql_common_functions.sh

# Prepare MySQL Command
set +x
prepare_MYSQLCMD "$DBUSER" "$DBPASSWORD" "$SOCKETFILE" "$BASEDIR"
set -x

# Check server running or not
checkMySQL
if [ $? -ne 0 ]; then
  echo "FYI: MySQL is not running. Proceeding to restore...."
  exit 0
fi

## Shutdown Server
su -m $OSUSER -c "$MYSQL_ADMIN shutdown"
retval=$?

if [ $retval -ne 0 ]; then
  echo "ERRORMSG: Failed to shutdown the mysql server with socket $SOCKETFILE"
  exit 1
fi
sleep 30

# Check server shutdowned or not
isSrvRunning=`ps -ef | grep mysqld | grep -w "\-\-datadir=$DATADIR" | wc -l `
if [ $isSrvRunning -eq 1 ]; then
  echo "ERRORMSG: Failed to shutdown the MySQL server !"
  exit 1
fi

#Check with port number as well
if [ ! -z "$PORT" ]; then
  isSrvRunning=`netstat -nalp | grep mysqld | grep -w LISTEN | awk '{print $4}' | cut -d: -f4 | grep -w $PORT | wc -l`
  if [ $isSrvRunning -eq 1 ]; then
    echo "ERRORMSG: Failed to shutdown the MySQL server !"
    exit 1
  fi
fi

echo "MySQL server shutdown successfull"

exit 0
