#!/bin/sh

set -x
OSUSER=$OSUSER
PG_HOME=$BASEDIR
DBUSER=$DBUSER
set +x
DBPASSWD="$DBPASSWORD"
set -x
PORT=$PORT
IS_SLAVE=$ISSLAVE
VERSION=$SRC_VERSION
USER_DBLIST="$DB_LIST"
DUMPBKPLOC=$TARGET_MNT_PNT
SOCKET_DIR=$SOCKET_DIR

ACT_JOBNAME=$JOBID

if [ -z "$SOCKET_DIR" ]; then
  SOCKET_DIR=`grep "PORTNO=\"$PORT" /act/custom_apps/POSTGRESQL.xml | awk -F" SOCKET_DIR=" '{print $2}' | awk '{print $1}' | sed 's/"//g'`
fi

#Get common functions
. /act/custom_apps/postgresql/act_postgresql_common_functions.sh

OSGROUP=`id -gn $OSUSER`

# Set environment for PostgreSQL
export PATH=$PG_HOME/bin:$PATH
export LD_LIBRARY_PATH=$PG_HOME/lib:$LD_LIBRARY_PATH

#Prepare db connection
set +x
prepareConn "$PORT" "$DBUSER" "$DBPASSWD" "$DBNAME" "$SOCKET_DIR"
set -x

SINGLE_TRANS=" --single-transaction "

#Restore database one by one
for dbName in $(echo $USER_DBLIST | sed 's/,/ /g' )
do
  echo "Restoring database $dbName ....."
  export PGDATABASE=$dbName
  su $OSUSER -c "$PSQL --set ON_ERROR_STOP=on $SINGLE_TRANS < $DUMPBKPLOC/$dbName.dmp"
  if [ $? -ne 0 ]; then
    echo "ERRORMSG: fail to restore database $dbName"
    exit 1
  fi
done
