#!/bin/sh

set -x
OSUSER=$OSUSER
PG_HOME=$BASEDIR
DBUSER=$DBUSER
set +x
DBPASSWD="$DBPASSWORD"
set -x
PORT=$PORTNO
IS_SLAVE=$ISSLAVE
VERSION=$VERSION
ACT_JOBNAME=$JOBID
SOCKET_DIR=$SOCKET_DIR

USER_DBLIST="$USER_DBLIST"
DUMPSCHEDULE=$DUMPSCHEDULE
DUMPBKPLOC=$DUMPBKPLOC

if [ -z "$SOCKET_DIR" ]; then
  SOCKET_DIR=`grep "PORTNO=\"$PORT" /act/custom_apps/POSTGRESQL.xml | awk -F" SOCKET_DIR=" '{print $2}' | awk '{print $1}' | sed 's/"//g'`
fi

#Get common functions
. /act/custom_apps/postgresql/act_postgresql_common_functions.sh

OSGROUP=`id -gn $OSUSER`

#Check dump location exist or not
isVarNull DUMPBKPLOC $DUMPBKPLOC
if [ ! -d "$DUMPBKPLOC" ]; then
  echo "ERRORMSG: $DUMPBKPLOC is not a directory"
  exit 1
fi

# Set environment for PostgreSQL
export PATH=$PG_HOME/bin:$PATH
export LD_LIBRARY_PATH=$PG_HOME/lib:$LD_LIBRARY_PATH

#Prepare db connection
set +x
prepareConn "$PORT" "$DBUSER" "$DBPASSWD" "$DBNAME" "$SOCKET_DIR"
set -x

#Get backup type
if [ "$DUMPSCHEDULE" = "F" ]; then
  DUMPSCHEDULE_DB="F"
else
  weekday=`date +%w`
  DUMPSCHEDULE_DB=`expr substr  "$DUMPSCHEDULE" $weekday 1`
fi
DUMPSCHEDULE_DB=F		# PostgreSQL dump is always Full

#Modify permission on DUMPBKPLOC
chown -R $OSUSER:$OSGROUP $DUMPBKPLOC

#Take dump backup for each database
for dbName in $(echo $USER_DBLIST | sed 's/,/ /g' )
do
  echo "Command: pg_dump $dbName > $DUMPBKPLOC/$dbName.dmp"
  su $OSUSER -c "pg_dump $dbName > $DUMPBKPLOC/$dbName.dmp"
  if [ $? -ne 0 ]; then
    echo "ERRORMSG: Fail to dump database: $dbName"
    exit 1
  fi
done
