#!/bin/sh

set -x
OSUSER=$OSUSER
PG_HOME=$BASEDIR
DBUSER=$DBUSER
set +x
DBPASSWD="$DBPASSWORD"
set -x
PORT=$PORTNO
IS_SLAVE=$ISSLAVE
VERSION=$VERSION
ACT_JOBNAME=$JOBID
SOCKET_DIR=$SOCKET_DIR

USER_DBLIST="$USER_DBLIST"
DUMPSCHEDULE=$DUMPSCHEDULE
DUMPBKPLOC=$DUMPBKPLOC

if [ -z "$SOCKET_DIR" ]; then
  SOCKET_DIR=`grep "PORTNO=\"$PORT" /act/custom_apps/POSTGRESQL.xml | awk -F" SOCKET_DIR=" '{print $2}' | awk '{print $1}' | sed 's/"//g'`
fi

#Get common functions
. /act/custom_apps/postgresql/act_postgresql_common_functions.sh

# Set environment for PostgreSQL
export PATH=$PG_HOME/bin:$PATH
export LD_LIBRARY_PATH=$PG_HOME/lib:$LD_LIBRARY_PATH

#Prepare db connection
set +x
prepareConn "$PORT" "$DBUSER" "$DBPASSWD" "$DBNAME" "$SOCKET_DIR"
set -x

DBSIZE_Total=0
#Check database exists or not
for dbName in $(echo $USER_DBLIST |  sed 's/,/ /g')
do
  isDB_exists=`su $OSUSER -c "$PSQL -c \"select datname from pg_database;\" " | grep -v "Warning: your password will expire in" | grep -w "$dbName" | wc -l`
  if [ $isDB_exists -lt 1 ]; then
    echo "ERRORMSG: Database $dbName not found"
    exit 1
  fi
  dbSize=`su $OSUSER -c "$PSQL -c \"SELECT pg_database_size('$dbName') ;\" " | grep -v "Warning: your password will expire in"`
  DBSIZE_Total=`expr $dbSize + $DBSIZE_Total`
done

#Get backup type
if [ "$DUMPSCHEDULE" = "F" ]; then
  DUMPSCHEDULE_DB="F"
else
  weekday=`date +%w`
  DUMPSCHEDULE_DB=`expr substr  "$DUMPSCHEDULE" $weekday 1`
fi

echo "DBDUMPSIZE=$DBSIZE_Total"
DUMPSCHEDULE_DB=F		# PostgreSQL dump is always Full
echo "DBDUMPTYPE=$DUMPSCHEDULE_DB"

exit 0
