#!/bin/sh

set -x
OSUSER=$OSUSER
PG_HOME=$BASEDIR
DBUSER=$DBUSER
set +x
DBPASSWD="$DBPASSWORD"
set -x
PORT=$PORT
PG_DATA=$SRC_DATADIR
IS_SLAVE=$ISSLAVE
VERSION=$VERSION
SOCKET_DIR=$SOCKET_DIR
ACT_JOBNAME=$JOBID

if [ -z "$SOCKET_DIR" ]; then
  SOCKET_DIR=`grep "PORTNO=\"$PORT" /act/custom_apps/POSTGRESQL.xml | awk -F" SOCKET_DIR=" '{print $2}' | awk '{print $1}' | sed 's/"//g'`
fi

#Get common functions
. /act/custom_apps/postgresql/act_postgresql_common_functions.sh

# Set environment for PostgreSQL
export PATH=$PG_HOME/bin:$PATH
export LD_LIBRARY_PATH=$PG_HOME/lib:$LD_LIBRARY_PATH

#Check if PostgreSQL running or not
foundInst=0
runningPG_list=`ps -ef | grep " postgres: "| grep -vw grep | awk '{print $3}'| sort | uniq | xargs`
for PG_PID in $runningPG_list
do
  tmpPGDATA_PGDATA_onCmdLine=`ps -p $PG_PID -o cmd | grep " -D " | wc -l`
  if [ $PGDATA_onCmdLine -eq 0 ]; then
    tmpPGDATA=`xargs -0 -L1 -a /proc/$PG_PID/environ | grep -w "PGDATA=" | cut -d= -f2`
  else
    tmpPGDATA=`ps -p $PG_PID -o cmd | awk -F'-D ' 'NR==2{print $2}'`
  fi

  if [ "$tmpPGDATA" = "$PG_DATA" ]; then
    foundInst=1
    break
  fi
done

if [ $foundInst -eq 0 ]; then
  echo "INFOMSG: DB not running. Proceed to restore."
  exit 0
fi

#Prepare connection
set +x
prepareConn "$PORT" "$DBUSER" "$DBPASSWD" "$DBNAME" "$SOCKET_DIR"
set -x

#Check db connection
su $OSUSER -c "$PSQL -c \"select 1;\""
if [ $? -ne 0 ]; then
  echo "ERRORMSG: fail to connect to $PG_DATA with given credentials"
  exit 1
fi

#Shutdown PostgreSQL
su $OSUSER -c "pg_ctl stop -D $PG_DATA"
if [ $? -ne 0 ]; then
  echo "ERRORMSG: Fail to stop PostgreSQL"
  exit 1
fi
sleep 5
echo "PostgreSQL stopped successfully."
exit 0
