#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
#                  !!!Actifio Private Script. DO NOT MODIFY!!!
#
# ==============================================================================#

set -x

echo "***************** POSTSKJOB_TYPE= $ACT_JOBTYPE *********************"

if [ "$ACT_JOBTYPE" = "unmount" ] || [ "$ACT_MULTI_OPNAME" = "unmount" ] ; then
   echo "NO-OP for post-script when unmount"
   exit 0
fi
if [ "$ACT_JOBTYPE" = "mount" ] || [ "$ACT_MULTI_OPNAME" = "mount" ] ; then
   if [ "$ACT_PHASE" = "pre" ] ; then
        echo "** No op for pre during unmount **"
      exit
   fi
   if [ "$ACT_PHASE" = "post" ] ; then
        echo "************************* start post during mount ************************"

WPWD=/act/custom_apps/saphana/dump

DBSID=$2
DBPORT=$3
HANABACKUPPATH=$4
DBUSER=$5
HANAVERSION=$6
LOGMOUNTPATH=$7
RECOVERYTIME="$8"

if [ "$#" -lt 5 ]; then
      if [ -z "$DBSID" ] || [ -z "$DBPORT" ] || [ -z "$HANABACKUPPATH" ] || [ -z "$DBUSER" ] || [ -z "$HANAVERSION" ]; then
         echo "ERRORMSG: Required Parameters are missing, Please check the usage for details"
	 echo "/act/scripts/CALL_ACT_HANADB_newtargetdumprestore.sh <DBSID> <DB PORT> <HANA BACKUP PATH> <DB USER> <HANAVERSION> [LOGMOUNTPATH] [RECOVERYTIME]"
         exit 1 
      fi
fi

DBSID=`echo $DBSID |tr '[a-z]' '[A-Z]'`
DB_FS_MOUNTED_FLAG=`ls $HANABACKUPPATH`

if [ "$?" -gt 0 ]; then
   exit 0
fi 

echo "********** call HANA DB recovery ************"
$WPWD/ACT_HANADB_newtargetdumprestore.sh $DBSID $DBPORT $HANABACKUPPATH $DBUSER $HANAVERSION $LOGMOUNTPATH "$RECOVERYTIME"
retval=$?

if [ $retval -ne 0 ]; then
    echo "ERRORMSG: Failed to recover $DBSID database: "
    exit $retval
fi

echo "********** end HANA DB recover with exit code: $retval ************"
exit 0
fi
fi

