#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
#                  !!!Actifio Private Script. DO NOT MODIFY!!!
#
# ==============================================================================#

set -x

WPWD=/act/custom_apps/saphana/clone

DBSID=$2
DBUSER=$3
RECOVERYTIME="$4"

if [ "$#" -lt 1 ]; then
      echo "Some required parameters are missing, Please check the usage for details!"
      echo "/act/scripts/CALL_ACT_HANADB_lvmscaleout_recover.sh <DBSID> <DB USER> [RECOVERY TIME]"
      exit 1
fi
if [ -z "$DBSID" ]; then
   echo "ERRORMSG: DBSID is empty!"
   exit 1
fi


$WPWD/ACT_HANADB_saphana_scaleout_recover.sh $DBSID $DBUSER "$RECOVERYTIME"

retval=$?
if [ $retval -ne 0 ]; then
    echo "ERRORMSG: Failed to recover $DBSID database: check error messages for details."
    exit $retval
fi

exit 0

