#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#

set -x

WPWD=/act/custom_apps/saphana/clone

DBSID=$1
ACT_MOUNT_POINTS=$2
DBUSER=$3
HANAVERSION=$4
DATAPATH=$5
LOGPATH=$6
OLDDBSID=$7
LOGMOUNTPATH=$8
RECOVERYTIME="$9"

conffile=/act/custom_apps/saphana/clone/sourcePostMount.conf

if [ -z "$OLDDBSID" ]; then
   OLDDBSID=$DBSID
fi

APPREMOUNT="FALSE"

if [ "$#" -lt 6 ]; then
   if [ -f $conffile ]; then
      source $conffile
      if [ -z "$DBSID" ] || [ -z "$ACT_MOUNT_POINTS" ] || [ -z "$DBUSER" ] || [ -z "$HANAVERSION" ] || [ -z "$DATAPATH" ] || [ -z "$LOGPATH" ]; then
         echo "Some required parameters are missing, Please check the usage for details!"
         echo "./ACT_HANADB_sourceappmount.sh <DBSID> <TARGET MOUNT POINT> <DB USER> <HANA VERSION> <DATA PATH> <LOG PATH> [OLD DBSID] [LOGMOUNT PATH] [RECOVERY TIME]"
         exit 1
      fi
   else
      echo "Some required parameters are missing, Please check the usage for details!"
      echo "./ACT_HANADB_sourceappmount.sh <DBSID> <TARGET MOUNT POINT> <DB USER> <HANA VERSION> <DATA PATH> <LOG PATH> [OLD DBSID] [LOGMOUNT PATH] [RECOVERY TIME]"
      exit 1
   fi
fi

echo "********** call HANA DB recovery ************"
$WPWD/ACT_HANADB_premount.sh $DBSID
$WPWD/ACT_premount_test.sh $DBSID $HANAVERSION $DBUSER $DATAPATH $LOGPATH
$WPWD/ACT_HANADB_postmount.sh $DBSID $OLDDBSID $ACT_MOUNT_POINTS $DBUSER $HANAVERSION $APPREMOUNT $DATAPATH $LOGMOUNTPATH "$RECOVERYTIME"

retval=$?
if [ $retval -ne 0 ]; then
    echo "ERRORMSG: Failed to recover $DBSID database: check customapp-saphana.log for details."
    exit $retval
fi

exit 0


