#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#

set -x

WPWD=/act/custom_apps/saphana/clone

DBSID=$1
OLDDBSID=$2
ACT_MOUNT_POINTS=$3
DBUSER=$4
HANAVERSION=$5
APPREMOUNT=$6
DATAPATH="$7"
LOGMOUNTPATH="$8"
RECOVERYTIME="$9"

DBSID=`echo $DBSID | tr '[A-Z]' '[a-z]'`
#export ACT_JOBTYPE=mount
#export ACT_PHASE=post

#source /act/custom_apps/saphana/clone/mount_detail.txt

if [ -z $DBSID ]; then
echo "ERRORMSG: Post Mount: Database SID is not set "
exit 1
fi

dbsidadm=$DBSID"adm"
export dbsidadm
DATAVOLUMEOWNER=$dbsidadm":sapsys"
export DATAVOLUMEOWNER

if [ -f /act/touch/.hana_migrate_"$DBSID".conf ]; then
   rm -f /act/touch/.hana_migrate_"$DBSID".conf
fi

###### Added for replication cluster recovery ######
if [ -z "$CLUSTERTYPE" ]; then
   CLUSTERTYPE=`grep CLUSTERTYPE /act/touch/"$OLDDBSID"_mount_params | awk -F"=" '{print $2}'`
fi
if [ "$CLUSTERTYPE" = "replication" ]; then
   if [ -z "$CATALOGBACKUPPATH" ]; then
      CATALOGBACKUPPATH=`grep CATALOGBACKUPPATH /act/touch/"$OLDDBSID"_mount_params | awk -F"=" '{print $2}'`
   fi
   logdirpath=`dirname $CATALOGBACKUPPATH`
   logdir=`basename $CATALOGBACKUPPATH`
   if [ -d "$CATALOGBACKUPPATH" ] && [ ! -z "$LOGMOUNTPATH" ]; then
      tdate=`date +%Y%m%d%H%M%S`
      mv $CATALOGBACKUPPATH $logdirpath/$logdir'.'$tdate
      createdir=false
   fi
   if [ ! -d "$logdirpath" ]; then
      createdir=true
      mkdir -p $logdirpath
   fi
   if [ ! -z "$LOGMOUNTPATH" ]; then
      ln -s $LOGMOUNTPATH $logdirpath/$logdir
      chown -R $DATAVOLUMEOWNER $logdirpath
   fi
fi

echo "DATAVOLUMEOWNERNEW: $DATAVOLUMEOWNER "

if [ -z $ACT_MOUNT_POINTS ]; then
 echo "ERRORMSG: Post Mount: Failed to retrieve mount points. Recovery may fail"
 exit 1
else
 chown -R $DATAVOLUMEOWNER $ACT_MOUNT_POINTS
 if [ ! -z "$LOGMOUNTPATH" ]; then
 chown -R $DATAVOLUMEOWNER $LOGMOUNTPATH
 fi
fi

echo "********** call HANA DB recovery ************"

su - $dbsidadm -c "$WPWD/ACT_HANADB_saphana_recover.sh $DBSID $OLDDBSID $DBUSER $HANAVERSION $APPREMOUNT $DATAPATH $LOGMOUNTPATH \"$RECOVERYTIME\""

retval=$?

if [ "$createdir" = "true" ]; then
   if [ ! -z "$logdirpath" ]; then
      rm -rf $logdirpath
   fi
elif [ "$createdir" = "false" ]; then
     rm -f $logdirpath/$logdir
     mv $logdirpath/$logdir'.'$tdate $logdirpath/$logdir
fi

if [ $retval -ne 0 ]; then
    echo "ERRORMSG: Failed to recover $DBSID database: check customapp-saphana.log for details."
    exit $retval
fi

exit 0


