#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#

set -x

WPWD=/act/custom_apps/saphana/clone

#export ACT_JOBTYPE=unmount
#export ACT_PHASE=pre

dbsid=$1

dbsid=`echo $dbsid | tr '[A-Z]' '[a-z]'`
#/act/custom_apps/saphana/clone/HANADB_config.conf

if [ -z $dbsid ]; then
echo "ERRORMSG: Pre Mount: Database SID is not set!"
exit 1
fi

dbsidadm=$dbsid"adm"
export dbsidadm

if [ -f /act/touch/.hana_migrate_"$dbsid".conf ]; then
   PVMOVE_STATUS=`cat /act/touch/.hana_migrate_"$dbsid".conf | awk -F "=" '{print $2}'`
   if [ "$PVMOVE_STATUS" = "YES" ]; then
      exit 0
   else
      echo "ERRORMSG: PVMOVE is in progress. Unmount delete cannot be done!"
      exit 1
   fi
fi
echo "********** call HANA DB stop ************"
su - $dbsidadm -c "$WPWD/ACT_HANADB_saphana_stop.sh $dbsid"
retval=$?

if [ $retval -ne 0 ]; then
    echo "ERRORMSG: Pre Mount: Failed to stop HANA DB services. Please check!"
    exit $retval
fi

exit 0

