#!/bin/bash
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#


set -x

DATE=`date`
echo "$DATE"
dbsid=$1
db_list=$2

if [ -z "$db_list" ]; then
 echo "specific database recovery is running. No need to shutdown the enire HANA DB"
 exit 0
fi
INSTANCENUM=`env | grep TINSTANCE= | cut -d"=" -f2`

if [ -z "$INSTANCENUM" ]; then
   INSTANCENUM=`basename $DIR_INSTANCE | rev | cut -c 1-2 | rev`
fi

if [ -z "$INSTANCENUM" ]; then
   echo "ERRORMSG: Failed to get INSTANCE#, Please check!"
   exit 1
fi

echo "************************** sapcontrol GetSystemInstanceList  ******************"
sapcontrol -nr $INSTANCENUM -function GetSystemInstanceList

echo "************************** sapcontrol GetSystemInstanceList  ******************"
sapcontrol -nr $INSTANCENUM -function StopSystem HDB

waitfordbstop() {
  #Set a timeout of 8 minutes (8*6*10)
  waitFlag=true
  timeout=0
  while $waitFlag; do
    timeout=$((timeout+1))
    if [ $timeout -gt 20 ]; then
      echo "ERRORMSG: database is still running after 10 minutes of stop command!. Please check!"
      exit 1
    fi
    dbstopcnt=`sapcontrol -nr $INSTANCENUM -function GetSystemInstanceList | grep -Ei "GREEN|YELLOW" | wc -l`
    if [ $dbstopcnt -gt 0 ]; then
       echo "Waiting for database to be stop.."
       sleep 30
       continue
    else
      waitFlag=false
    fi
  done
  return 0
}

waitfordbstop

echo "************************** sapcontrol GetSystemInstanceList  ******************"
sapcontrol -nr $INSTANCENUM -function GetSystemInstanceList

echo "************************** Database stopped ******************"

exit 0

