#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#

set -x

WPWD=/act/custom_apps/saphana/dump

DBSID=$1
DBPORT=$2
DBUSER=$3
EXCLUDE_DB_LIST=$4
INCLUDE_DB_LIST=$5
HANAVERSION="$6"
HANABACKUPPATH=$7
RECOVERYTIME="$8"
LOGMOUNTPATH=$9

#export ACT_JOBTYPE=mount
#export ACT_PHASE=post

if [ -z $DBSID ]; then
echo "ERROR: Database SID is not set "
exit 1
fi

DBADM=`echo $DBSID | tr '[A-Z]' '[a-z]'`
DBADM=$DBADM'adm'

echo "********** call HANA DB recovery ************"

su - $DBADM -c "$WPWD/ACT_HANADB_RESTORE_saphana_recover.sh $DBSID $DBPORT $DBUSER \"$EXCLUDE_DB_LIST\" \"$INCLUDE_DB_LIST\" $HANAVERSION $HANABACKUPPATH \"$RECOVERYTIME\" $LOGMOUNTPATH" 

retval=$?

if [ $retval -ne 0 ]; then
    echo "ERRORMSG: Failed to recover $DBSID database: check customapp-saphana.log for details"
    exit $retval
fi

echo "********** end HANA DB recover with exit code: $retval ************"
exit 0


