#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#

set -x

WPWD=/act/custom_apps/saphana/dump
DBSID=$1
DBUSER=$2
DBPORT=$3
HANAVERSION=$4
USESYSTEMDBKEY=$5
PRETDBUSER=$6

isempty()
{
   INPUT_VAR_NAME=$1
   INPUT_VAR_VALUE=$2
   if [ -z "$INPUT_VAR_VALUE" ]; then
       echo "ERRORMSG: Parameter $INPUT_VAR_NAME is empty. Please check!!"
       exit 1
   fi
}
###### END ##########

isempty DBSID $DBSID
isempty DBUSER $DBUSER
isempty DBPORT $DBPORT
isempty HANAVERSION $HANAVERSION
isempty USESYSTEMDBKEY $USESYSTEMDBKEY
isempty PRETDBUSER $PRETDBUSER
isempty DUMPSCHEDULE $DUMPSCHEDULE

dbsidadm=$DBSID"adm"
export dbsidadm

FAIL_MSG=/act/touch/FAIL_MSG
DBSID=`echo $DBSID | tr '[a-z]' '[A-Z]'`

if [ "$DUMPSCHEDULE" = "F" ]; then
    TYPE="F"
elif [ "$PREVDBFULLDUMPSAMEDAY" = "TRUE" ]; then
    TYPE="I"
else
    TYPE=${DUMPSCHEDULE:`date +%w`:1}
fi

if [ -z $DBSID ]; then
echo "ERRORMSG: Database SID is not set!"
exit 1
fi

DBSIZE=`su - $dbsidadm -c "$WPWD/act_saphana_dumpsize.sh $DBSID $DBUSER $DBPORT $HANAVERSION $PRETDBUSER $USESYSTEMDBKEY $TYPE"`
retval=$?

if [ $retval -ne 0 ]; then
   errorstring=`cat $FAIL_MSG/"$DBSID"_error_msg | xargs |awk -F"rc=" '{print $2}'`
   if [ -z "$errorstring" ]; then
      errorstring=`tail -c100 $FAIL_MSG/"$DBSID"_error_msg`
   fi
   echo "ERRORMSG: Failed to get the DB Size for $DBSID,Error:$errorstring,Please check customapp-saphana.log for details!"
   if [ -d "$FAIL_MSG" ]; then
      rm -f $FAIL_MSG/*
   fi
    exit $retval
fi

DBSIZEFULL=`echo ${DBSIZE} |awk '{print $1}' | sed -e 's/^[ \t]*//'`
DBSIZEINCR=`echo ${DBSIZE} |awk '{print $2}' | sed -e 's/^[ \t]*//'`

if [ -z "$DBSIZEINCR" ]; then
   DBSIZEINCR=0
fi
echo DBDUMPSIZEFULL=$DBSIZEFULL
echo DBDUMPSIZEINCR=$DBSIZEINCR
echo "DBDUMPTYPE=$TYPE"

exit 

