#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#

set -x

WPWD=/act/custom_apps/saphana/dump

DBSID=$1
DBPORT=$2
HANABACKUPPATH=$3
DBUSER=$4
HANAVERSION=$5
LOGMOUNTPATH=$6
RECOVERYTIME="$7"

conffile=/act/custom_apps/saphana/dump/restoreDumpToNewTarget.conf

EXCLUDE_DB_LIST="null"
INCLUDE_DB_LIST="null"


if [ "$#" -lt 5 ]; then
   if [ -f $conffile ]; then
      source $conffile
      if [ -z "$DBSID" ] || [ -z "$DBPORT" ] || [ -z "$HANABACKUPPATH" ] || [ -z "$DBUSER" ] || [ -z "$HANAVERSION" ]; then
         echo "ERRORMSG: Required Parameters are missing, Please check the usage for details"
	 echo "./ACT_HANADB_newtargetdumprestore.sh <DBSID> <DB PORT> <HANA BACKUP PATH> <DB USER> <HANAVERSION> [LOGMOUNTPATH] [RECOVERYTIME]"
         exit 1 
      fi
   else
         echo "ERRORMSG: Required Parameters are missing, Please check the usage for details"
	 echo "./ACT_HANADB_newtargetdumprestore.sh <DBSID> <DB PORT> <HANA BACKUP PATH> <DB USER> <HANAVERSION> [LOGMOUNTPATH] [RECOVERYTIME]"
         exit 1

   fi        
fi

echo "********** call HANA DB recovery ************"

DBADM=`echo $DBSID | tr '[A-Z]' '[a-z]'`
DBADM=$DBADM'adm'

su - $DBADM -c "$WPWD/ACT_HANADB_RESTORE_newtargetsaphana_recover.sh $DBSID $DBPORT $DBUSER \"$EXCLUDE_DB_LIST\" \"$INCLUDE_DB_LIST\" $HANAVERSION $HANABACKUPPATH \"$RECOVERYTIME\" $LOGMOUNTPATH"

retval=$?

if [ $retval -ne 0 ]; then
    echo "ERRORMSG: Failed to recover $DBSID database: "
    exit $retval
fi

echo "********** end HANA DB recover with exit code: $retval ************"
exit 0


