#!/bin/bash
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#

set -x
DBSID=$1
userstorekey=$2
USESYSTEMDBKEY=$3
PRETDBUSER=$4

dbuser=$DBSID'adm'

USESYSTEMDBKEY=`echo $USESYSTEMDBKEY | tr '[A-Z]' '[a-z]'`
tdate=`date +%Y%m%d%H%M%S`
FILELOC="/act/touch/"
if [ ! -d "$FILELOC" ]; then
   mkdir -p $FILELOC
   chmod 755 $FILELOC
else
   chmod 755 $FILELOC
fi
DBSID=`echo $DBSID | tr '[a-z]' '[A-z]'`
FILE_NAME=$FILELOC/hanabackupdblist.log
BACKUP_XML=$FILELOC/backupstatus.xml
DBADM=`echo $DBSID | tr '[A-Z]' '[a-z]'`
DBADM=$DBADM'adm'
if [ ! -d /act/touch/FAIL_MSG ]; then
   mkdir -p /act/touch/FAIL_MSG
   chown "$DBADM":sapsys /act/touch/FAIL_MSG
else
   rm -f /act/touch/FAIL_MSG/*
   chown "$DBADM":sapsys /act/touch/FAIL_MSG
fi
if [ ! -f "$FILE_NAME" ]; then
   touch $FILE_NAME
   chown "$DBADM":sapsys $FILE_NAME
   chmod 755 $FILE_NAME
fi

if [ ! -f "$BACKUP_XML" ]; then
   touch $BACKUP_XML
   chown "$DBADM":sapsys $BACKUP_XML
   chmod 755 $BACKUP_XML
fi



keystore=`su - $dbuser -c 'cd exe ; hdbuserstore list '`
retval=$?
if [ $retval -ne 0 ]; then
  echo "ERRORMSG: can not connect to check the key store!"
  exit 1
fi
keycount=`echo $keystore | grep -w $userstorekey | wc -l`
if [ $keycount -eq 0 ]; then
  echo "ERRORMSG: keystore does not exists!"
  exit 1
fi

globalpath=`su - $dbuser -c 'echo $DIR_INSTANCE'`
globalpath=`dirname $globalpath`

SSLENFORCE=`grep "sslenforce" $globalpath/SYS/global/hdb/custom/config/global.ini`
SSLENFORCE=`echo $SSLENFORCE | awk -F "=" '{print $2}'|xargs`

if [ "$SSLENFORCE" = "true" ]; then
   SECUDIR=`su - $dbuser -c 'echo $SECUDIR'`
   hdbsql="hdbsql -e -sslprovider commoncrypto -sslkeystore $SECUDIR/sapsrv.pse -ssltruststore $SECUDIR/sapsrv.pse"
else
   hdbsql="hdbsql"
fi


if [ "$USESYSTEMDBKEY" = "false" ]; then
   SQL="select database_name from m_databases"
   dbnames=`su - $dbuser -c "$hdbsql -U $userstorekey -a -j -x $SQL"`
   for tsid in ${dbnames}; do
     tsid=`echo $tsid | sed s'/"//g'`
     if [ "$tsid" = "SYSTEMDB" ]; then
        :
     else
         tenantkey=$PRETDBUSER$tsid
         tenantkeycount=`echo $keystore | grep -w $tenantkey | wc -l`
         if [ "$tenantkeycount" -eq 0 ]; then
            echo "ERRORMSG: keystore $tenantkey does not exists!"
            exit 1
         fi
     fi
   done
fi
