#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#

set +x

ACT_MOUNT_POINT=$1

if [ "$#" -lt 1 ]; then
   echo "USAGE: ./ACT_HANADB_deviceDetails.sh <ACT MOUNT POINT>"
   exit 1
fi
echo " "
fileloc=/act/touch/vgname_$ACT_MOUNT_POINT.txt
count=0
echo "PV Name         PV Size"
vgs | grep $ACT_MOUNT_POINT|grep -iv TransactionLog > $fileloc
while read x
do
  x=`echo $x | awk '{print $1":"$5}'`
  vg_export_flag=`echo $x | awk -F ":" '{print $2}' | grep "x" |wc -l`  ## Check of the VG is exported
  if [ "$vg_export_flag" -gt 0 ]; then
     :
  else
     vgname=`echo $x | awk -F ":" '{print $1}'`
     #pvname=`vgdisplay -v $vgname  | grep -w "PV Name" | awk '{print $3}'`
      for pvname in $(vgdisplay -v $vgname  | grep -w "PV Name" | awk '{print $3}'); do
         count=$(($count+1))
         pvsize=`lsblk -n -i -o SIZE /dev/mapper/"$vgname"-act_staging_vol`
         echo "$pvname         $pvsize"
      done
  fi
done < $fileloc

echo "========================"
echo "Total # of devices: $count"

echo " "

exit 0
