#!/bin/sh

WPWD=/act/custom_apps/saphana/acthanadbm/
cd /act/custom_apps/saphana/acthanadbm/

APP=$1
TARGET_MNT_PT=$2
DEVICE_NAMES="$3"
SOURCE_HOST=$4
TARGET_HOST=$5
AGM=$6
TARGETDBSID=$7

if [ "$#" -lt 6 ]; then
   echo "ERRORMSG: One of the required parameter is missing. Please check the usage!"
   echo "./ACT_HANADB_migratePostRecovery.sh <APP> <TARGET MOUNT POINT> <DEVICE NAMES> <SOURCE HOST> <TARGET HOST> <AGM IP> [TARGET DBSID]"
   exit 1
fi

if [ "$TARGET_HOST" = "$SOURCE_HOST" ]; then
    TARGETDBSID=$APP
else
   if [ -z "$TARGETDBSID" ]; then
      echo "Please provide the TARGET DBSID parameter!"
      exit 1
   fi
fi

echo "*************** Starting Storage Migration ****************"

/act/custom_apps/saphana/lvm_migrate/ACT_DB_pvmove.sh $TARGETDBSID $TARGET_MNT_PT "$DEVICE_NAMES"
retval=$?
if [ "$retval" -gt 0 ]; then
   echo "ERRORMSG: PVMOVE operation failed. Please check logs for details!"
   exit 1
fi
echo "*************** Storage Migration completed successfully ***************"

echo "*************** Starting UNMOUNT + DELETE Operation ****************"
/act/custom_apps/saphana/acthanadbm/actHANADBM.pl --type unmountdelete --appName $APP --sourceHost $SOURCE_HOST --targetHost $TARGET_HOST --targetAppName $TARGET_MNT_PT --AGM $AGM --wait yes
retval=$?
if [ "$retval" -gt 0 ]; then
   echo "ERRORMSG: Unmount Delete  operation failed. Please check logs for details!"
   exit 1
fi

echo "*************** All the operations completed successfully. Please verify the application! ****************"

exit 0
