set -x

DATE=`date`
echo "$DATE"

DBSID=$1
DBUSER=$2
HANAVERSION="$3"
RECOVERYTIME="$4"
LOGPATH="$5"
DATAPATH="$6"

dbsid=$DBSID
echo "tstamp:$RECOVERYTIME"
x=`grep python_support $HOME/.sapenv.sh | awk -F"=" '{print $NF}' | awk '{print $NF}' | awk -F"'" '{print $1}'`
PYTHONPATH=${x/\$SAPSYSTEMNAME/$SAPSYSTEMNAME}

echo "pythonpath is: ***** $PYTHONPATH *************"

globalpath=`echo $DIR_INSTANCE`
globalpath=`dirname $globalpath`

SSLENFORCE=`grep "sslenforce" $globalpath/SYS/global/hdb/custom/config/global.ini`
SSLENFORCE=`echo $SSLENFORCE | awk -F "=" '{print $2}'|xargs`

if [ "$SSLENFORCE" = "true" ]; then
   hdbsql="hdbsql -e -sslprovider commoncrypto -sslkeystore $SECUDIR/sapsrv.pse -ssltruststore $SECUDIR/sapsrv.pse"
else
   hdbsql="hdbsql"
fi

DBADM=`echo $DBSID | tr '[A-Z]' '[a-z]'`
DBADM=$DBADM'adm'

waitforhdbnameserver() {
  #Set a timeout of 8 minutes (8*6*10)
  waitFlag=true
  timeout=0
  count=30
  if [ "$HANAVERSION" = "1.0" ]; then
     count=90
  fi
  while $waitFlag; do
    timeout=$((timeout+1))
    if [ $timeout -gt $count ]; then
      echo "ERRORMSG: hdbnameserver did not come up after 10 minutes!. Please check!"
      exit 1
    fi
    nameserverProcess=`ps -ef | grep -i hdbnameserver | grep -v grep | grep -i $DBADM`
    if [ -z "$nameserverProcess" ]; then
       echo "Waiting for hdbnameserver process to be up..."
       sleep 30
       continue
    else
      hdbpreprocessorProcess=`ps -ef | grep -i hdbpreprocessor | grep -v grep | grep -i $DBADM`
      if [ -z "$hdbpreprocessorProcess" ]; then
        echo "Waiting for hdbnameserver process to be up..."
        sleep 30
        continue
      else
        sleep 30
        dbnames=`$hdbsql -U $DBUSER -x "select database_name from m_databases"`
        if [ $? -ne 0 ]; then
         echo "Not yet able to execute db select query on m_databases..Retry"
         waitFlag=true
        else
         waitFlag=false
        fi
      fi
      sleep 30
      #waitFlag=false
    fi
  done
  return 0
}


if [ -z $PYTHONPATH ]; then
echo "ERRORMSG: PYTHONPATH-- path for recoverSys.py is not set "
exit 1
fi

echo "************************** running HDB info  ******************"
HDB info

echo "************************** running recoverSys.py  ******************"

if [ ! -z $LOGPATH ]; then
  LOGPATHCHECK=`echo $LOGPATH | rev |awk -F"," '{ print $1}' |rev`
  checklogs=`find $LOGPATHCHECK/ -name "log_backup*" | wc -l`
   if [ "$checklogs" -eq 0 ]; then
   RECOVERYTIME=''
   fi
fi

if [ ! -z "$RECOVERYTIME" ]; then
	if [ "$HANAVERSION" = "1.0" ]; then
          LOG_BKP_PATH=""
          for path in $( echo $LOGPATH | tr ',' ' ')
            do
              if [ -z "$LOG_BKP_PATH" ]; then
                 LOG_BKP_PATH=\'$path/SYSTEMDB\'
              else
                 LOG_BKP_PATH=$LOG_BKP_PATH','\'$path/SYSTEMDB\'
              fi
            done
		HDBSettings.sh $PYTHONPATH/recoverSys.py --command="RECOVER DATABASE UNTIL TIMESTAMP '$RECOVERYTIME' CLEAR LOG USING DATA PATH ('$DATAPATH') USING LOG PATH ($LOG_BKP_PATH) USING SNAPSHOT CHECK ACCESS USING FILE"
	else
          CATALOGPATH=`echo $LOGPATH | rev |awk -F"," '{ print $1}' |rev`
          CATALOGPATH=$CATALOGPATH"/SYSTEMDB/"
          LOG_BKP_PATH=""
          for path in $( echo $LOGPATH | tr ',' ' ')
            do
              if [ -z "$LOG_BKP_PATH" ]; then
                 LOG_BKP_PATH=\'$path/SYSTEMDB\'
              else
                 LOG_BKP_PATH=$LOG_BKP_PATH','\'$path/SYSTEMDB\'
              fi
            done
		HDBSettings.sh $PYTHONPATH/recoverSys.py --command="RECOVER DATABASE UNTIL TIMESTAMP '$RECOVERYTIME' CLEAR LOG USING CATALOG PATH ('$CATALOGPATH') USING DATA PATH ('$DATAPATH') USING LOG PATH ($LOG_BKP_PATH) USING SNAPSHOT CHECK ACCESS USING FILE"
	fi
else
HDBSettings.sh $PYTHONPATH/recoverSys.py --command="RECOVER DATA USING SNAPSHOT CLEAR LOG"
fi

retval=$?

if [ $retval -ne 0 ]; then
    echo "ERRORMSG: Failed to recover database $dbsid: check check customapp-saphana.log for details!"
    exit $retval
fi

HDB start
waitforhdbnameserver

echo "************************** running HDB info  ******************"
HDB info

if [ "$HANAVERSION" = "2.0" ]; then

DBSID=`echo $DBSID | tr '[a-z]' '[A-Z]'`

if [ ! -z "$RECOVERYTIME" ]; then
for i in ${dbnames}; do
     TSID=`echo $i |awk -F '"' '{print $2}'`
     if [ $i = "DATABASE_NAME" ]; then
                :
     elif [ $TSID = "SYSTEMDB" ]; then
                :
     else
	TSID=`echo $i |awk -F '"' '{print $2}'`
        CATALOGPATH=`echo $LOGPATH | rev |awk -F"," '{ print $1}' |rev`
        CATALOGPATH=$CATALOGPATH"/DB_"$TSID"/"
        LOG_BKP_PATH=""
        for path in $( echo $LOGPATH | tr ',' ' ')
          do
            if [ -z "$LOG_BKP_PATH" ]; then
              LOG_BKP_PATH=\'$path/DB_$TSID\'
            else
              LOG_BKP_PATH=$LOG_BKP_PATH','\'$path/DB_$TSID\'
            fi
          done
        if [ -d "$CATALOGPATH" ]; then
           CATALOGPATH=`echo $LOGPATH | rev |awk -F"," '{ print $1}' |rev`  
           CATALOGPATH=$CATALOGPATH"/DB_"$TSID"/"
           LOG_BKP_PATH=""
           for path in $( echo $LOGPATH | tr ',' ' ')
            do
            if [ -z "$LOG_BKP_PATH" ]; then
              LOG_BKP_PATH=\'$path/DB_$TSID\'
            else
              LOG_BKP_PATH=$LOG_BKP_PATH','\'$path/DB_$TSID\'
            fi
            done
        else
           CATALOGPATH=`echo $LOGPATH | rev |awk -F"," '{ print $1}' |rev`
           CATALOGPATH=$CATALOGPATH"/DB_"$OLDDBSID"/"
           LOG_BKP_PATH=""
           for path in $( echo $LOGPATH | tr ',' ' ')
            do
            if [ -z "$LOG_BKP_PATH" ]; then
              LOG_BKP_PATH=\'$path/DB_$OLDDBSID\'
            else
              LOG_BKP_PATH=$LOG_BKP_PATH','\'$path/DB_$OLDDBSID\'
            fi
            done
           if [ -d "$CATALOGPATH" ]; then
             echo "$CATALOGPATH for $TSID could not found. $TSID recovery will not be recovered."
             exit 1
           fi
        fi

         waitforhdbnameserver
	 STOPSQL="ALTER SYSTEM STOP DATABASE $TSID"
         SQL="RECOVER DATABASE FOR $TSID UNTIL TIMESTAMP '$RECOVERYTIME' CLEAR LOG USING CATALOG PATH ('$CATALOGPATH') USING DATA PATH ('$DATAPATH') USING LOG PATH ($LOG_BKP_PATH) USING SNAPSHOT CHECK ACCESS USING FILE"
echo "********** recovering HANA TENANT DB recover:DBUSER=$DBUSER and dbsid=$dbsid ************"
	$hdbsql -U $DBUSER -a -j $STOPSQL
        retval=$?
        if [ $retval -ne 0 ]; then
           echo "ERRORMSG: Failed to stop $TSID: check customapp-saphana.log for details."
           exit $retval
        fi

        $hdbsql -U $DBUSER -a -j $SQL
        retval=$?
	if [ $retval -ne 0 ]; then
    		echo "ERRORMSG: Recovery: Failed to recover Tenant database $TSID: check customapp-saphana.log for details"
    		exit $retval
	fi
      fi
done


echo "************************** running HDB info  ******************"
HDB info
fi


for i in ${dbnames}; do
     TSID=`echo $i |awk -F '"' '{print $2}'`
     if [ $i = "DATABASE_NAME" ]; then
                :
     elif [ $TSID = "SYSTEMDB" ]; then
                :
     else
        TSID=`echo $i |awk -F '"' '{print $2}'`

	echo "********** starting HANA TENANT DB recover:DBUSER=$DBUSER and dbsid=$TSID ************"
	SQL="alter system start database $TSID"
	$hdbsql -U $DBUSER -a -j $SQL
	retval=$?


        if [ $retval -ne 0 ]; then
           echo "ERRORMSG: Failed to start saphana tenant database $dbsid!"
           exit 1
        fi
     fi
done  
echo "********** end HANA TENANT DB recover ************"
echo "************************** running HDB info  ******************"
HDB info
fi
echo "************************** Database recovery complete ******************"

exit 0

