#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#

set -x

WPWD=/act/custom_apps/saphana/restore

#export ACT_JOBTYPE=unmount
#export ACT_PHASE=pre

dbsid=$1

if [ -z $dbsid ]; then
echo "ERRORMSG: Database SID is not set "
exit 1
fi

dbsidadm=$dbsid"adm"
export dbsidadm

usercount=`su - $dbsidadm -c 'ls | wc -l'`
retval=$?
if [ $retval -ne 0 ]; then
  echo "ERRORMSG: $dbsid does not exists, please check!"
  exit 1
fi

keystore=`su - $dbsidadm -c 'cd exe ; hdbuserstore list '`
retval=$?
if [ $retval -ne 0 ]; then
  echo "ERRORMSG: can not connect to check the key store!"
  exit 1
fi

keycount=`echo $keystore | grep -iw $DBUSER | wc -l`
if [ $keycount -eq 0 ]; then
  echo "ERRORMSG: USERSTOREKEY does not exists!"
  exit 1
fi

echo "********** call HANA DB stop ************"
su - $dbsidadm -c "$WPWD/ACT_HANADB_RESTORE_saphana_stop.sh $dbsid"
retval=$?

if [ $retval -ne 0 ]; then
    echo "ERRORMSG: Pre restore: Failed to stop $dbsid: Please check logs for details!"
    exit $retval
fi

exit 0

