#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#

#Prepare env
for ARGUMENT in "$@"
do
   ARGUMENT="${ARGUMENT%\"}"
   ARGUMENT="${ARGUMENT#\"}"
   argLft=`echo $ARGUMENT|cut -d= -f1`
   argRit=`echo $ARGUMENT|cut -d= -f2`
   export "$argLft=$argRit"
done

usage() {
  echo "Usage: "
  echo "/act/custom_apps/sybase/clone/ACT_SYBASE_mountrecover.sh MANIFEST_FILE_LOC=<MANIFEST_FILE_LOC> TARGET_MNT_PNT=<TARGET_MNT_PNT> TARGET_SERVER_NAME=<TARGET_SERVER_NAME> TARGET_DB_USER=<TARGET_DB_USER> SRC_DBNAME=<SRC_DBNAME> TARGET_DBNAME_LIST=<TARGET_DBNAME_LIST> [ TARGET_DBUSER_PASSWD=<TARGET_DBUSER_PASSWD> | TARGET_DBUSER_OTHERCRED=<TARGET_DBUSER_OTHERCRED> ] [ LOG_BKP_MNTPT=<LOG_BKP_MNTPT> UNTIL_TIME=\"<UNTIL_TIME>\" BEGIN_TIME=\"<$BEGIN_TIME>\" ] [ JOBID=<JOBID> ]"
}

isProvided() {
  local varName=$1
  local varVal=$2
  if [ -z "$varVal" ]; then
    echo "ERRORMSG: $varName is empty."
    usage
    exit 1
  fi
}

isProvided MANIFEST_FILE_LOC $MANIFEST_FILE_LOC
isProvided TARGET_MNT_PNT $TARGET_MNT_PNT
isProvided TARGET_SERVER_NAME $TARGET_SERVER_NAME
isProvided TARGET_DB_USER $TARGET_DB_USER
isProvided SRC_DBNAME $SRC_DBNAME
isProvided TARGET_DBNAME_LIST $TARGET_DBNAME_LIST
if [ ! -z "$UNTIL_TIME" ]; then
  isProvided LOG_BKP_MNTPT $LOG_BKP_MNTPT
  isProvided BEGIN_TIME "$BEGIN_TIME"
fi

set -x
if [ -z "$JOBID" ]; then
  if [ -z "$ACT_JOBNAME" ]; then
    export JOBID=Job_mountrecover
  else
    export JOBID=$ACT_JOBNAME
  fi
fi

#Premount-test
/act/custom_apps/sybase/clone/ACT_SYBASE_premount_test.sh
if [ $? -ne 0 ]; then
  echo "ERRORMSG: premount_test failed"
  exit 1
fi

#Postmount
/act/custom_apps/sybase/clone/ACT_SYBASE_postmount.sh
if [ $? -ne 0 ]; then
  echo "ERRORMSG: Postmount failed"
  exit 1
else
  echo "INFOMSG: Mount recovery is successful"
fi
