#!/bin/sh

set -x
MANIFEST_FILE_LOC=$MANIFEST_FILE_LOC
TARGET_MNT_PNT=$TARGET_MNT_PNT
TARGET_SERVER_NAME=$TARGET_SERVER_NAME
TARGET_DB_USER=$TARGET_DB_USER
set +x
TARGET_DBUSER_PASSWD_orig="$TARGET_DBUSER_PASSWD"
TARGET_DBUSER_PASSWD=`printf '%q' $TARGET_DBUSER_PASSWD`
set -x
TARGET_DBUSER_OTHERCRED=$TARGET_DBUSER_OTHERCRED
SRC_DBNAME=$SRC_DBNAME
TARGET_DBNAME_LIST=$TARGET_DBNAME_LIST
LOG_BKP_MNTPT=$LOG_BKP_MNTPT
BEGIN_TIME=$BEGIN_TIME
UNTIL_TIME=$UNTIL_TIME
INDIVIDUAL=$INDIVIDUAL
ACT_JOBNAME=$JOBID
APPREMOUNT=$APPREMOUNT

if [ "$APPREMOUNT" = "TRUE" ]; then
  /act/custom_apps/sybase/clone/ACT_SYBASE_remount.sh
  exit $?
fi

if [ -z $INDIVIDUAL ]; then
  INDIVIDUAL=YES
fi

tmp_loc=/act/tmpdata/$ACT_JOBNAME/tempDir
if [ ! -d "$tmp_loc" ]; then
   mkdir -p $tmp_loc
   chmod 755 $tmp_loc
   chmod 755 $tmp_loc/..
fi

if [ ! -d /act/touch/$ACT_JOBNAME ]; then
  mkdir -p /act/touch/$ACT_JOBNAME
  chmod 755 /act/touch/$ACT_JOBNAME
fi


#####function: Create the config file for remount
remount_config() {
  config_file=/act/touch/$ACT_JOBNAME/REMOUNT_CONFIG
  echo "OLD_MOUNT=$TARGET_MNT_PNT" > $config_file
  for dbname in $(echo $TARGET_DBNAME_LIST | sed 's/,/ /g')
  do
    SOURCE_DB=`echo $dbname |awk -F":" '{print $1}'`
    TARGET_DB=`echo $dbname |awk -F":" '{print $2}'`
    if [ -z "$TARGET_DB" ]; then
       TARGET_DB=$SOURCE_DB
    fi
    if [ -z "$remount_db_list" ]; then
       remount_db_list="$SOURCE_DB":"$TARGET_DB"
    else
       remount_db_list="$remount_db_list","$SOURCE_DB":"$TARGET_DB"
    fi
  done
  echo "REMOUNT_DB_LIST=$remount_db_list" >> $config_file
}


#####function: getDBlist()( Get list of databases from Manifest file )
getDBlist() {
  db_list=""
  db_names=`awk '/database/{flag=1; next} /device/{flag=0} flag' $MF_DETAILS`
  for i in $db_names
  do
   if [ -z "$db_list" ]; then
     db_list=$i
    else
      db_list=$db_list,$i
    fi
  done
  echo "Database list: $db_list"
}


#####function: getDB_Delelet_List() (Get list of databases not present in $SRC_DBNAME but in Manifest file)
getDB_Delelet_List() {
  DELETE_DBS=""
  for delDb in $db_names
  do
    flag=1
    for db in $(echo $SRC_DBNAME | sed "s/,/ /g")
    do
      if [ "$delDb" == "$db" ]; then
          flag=0
          break
      fi
    done
    if [ "$flag" == "1" ]; then
      DELETE_DBS="$DELETE_DBS "$delDb
    fi
  done
  echo "Database need to delete after mount are: $DELETE_DBS"
}


#####function: unmountDBs()(  Unmount unwanted database )
unmountDBs() {
  echo " Unmounting database: $DELETE_DBS"
  for dbDel in $DELETE_DBS
  do
    x=$dbDel'_act'
    set +x
    su -m $OSUSER -c "$SYBASE_SQLD/bin/isql -w 2000 -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X --retserverror" <<EOF
use master
go
unmount database $x to '$tmp_loc/unmount_$ACT_JOBNAME_$dbDel'
go
EOF
    set -x
    rm -f $tmp_loc/unmount_$ACT_JOBNAME_$dbDel
  done
}


#Find OS user and group for TARGET_SERVER_NAME
OSUSER=`ps -ef | grep -i "bin/dataserver"| grep $TARGET_SERVER_NAME | grep -v -w grep | awk '{print $1}'|uniq|xargs`
OSGROUP=`id -gn $OSUSER`

#---------------------------------------------
#Get the password
#---------------------------------------------
set +x
if [ ! -z "$TARGET_DBUSER_OTHERCRED" ]; then
  TARGET_DBUSER_PASSWD=`su - $OSUSER -c "$TARGET_DBUSER_OTHERCRED"`
  if [ $? -ne 0 ]; then
    echo "ERRORMSG: Fail to get password from the password function: $TARGET_DBUSER_OTHERCRED "
    exit 1
  else
    TARGET_DBUSER_PASSWD=`printf '%q' $TARGET_DBUSER_PASSWD`
  fi
fi
set -x
#---------------------------------------------

#Change $tmp_loc  owner
chown -R $OSUSER:$OSGROUP $tmp_loc
chown -R $OSUSER:$OSGROUP $TARGET_MNT_PNT

#Child restore
if [ "$ACT_MOUNT_REPLACERESTORE" = "TRUE" ]; then
   TARGET_MNT_PNT=
fi

#Find SQLD location for target server
SYBASE_ASE_location=`ps -ef | grep "bin/dataserver"|grep $TARGET_SERVER_NAME | grep -v -w grep | awk -F'bin/dataserver' '{print $1}' | grep -v -w awk | awk '{print $NF}' | head -1`
syb_home=$SYBASE_ASE_location/..
syb_ocs=`cat $syb_home/SYBASE.sh | grep SYBASE_OCS | grep -v export `
syb_ocs=`echo $syb_ocs | awk -F "=" '{print $2}'`
syb_ocs=`echo $syb_ocs |sed 's/"//g'`
SYBASE_SQLD=$syb_home/$syb_ocs

#set env
set +x
. $SYBASE_SQLD/../SYBASE.sh
set -x

#Prepare nessesary variables
MF_DETAILS="$tmp_loc/MF_DETAILS_$ACT_JOBNAME.txt"
MF_DEVICE_DETAILS="$tmp_loc/MF_DEVICE_DETAILS_$ACT_JOBNAME.txt"
newDBlist=""

#Change MANIFEST_FILE permissions
for MANIFEST_FILE in $(echo $MANIFEST_FILE_LOC | sed 's/,/ /g')
do

  #MANIFEST_FILE=$MANIFEST_FILE_LOC
  chown -R $OSUSER:$OSGROUP $MANIFEST_FILE
  MANIFEST_BASE_DIR=`echo $MANIFEST_FILE | cut -d/ -f2`
  if [ "$MANIFEST_BASE_DIR" != "" ]; then
    find /$MANIFEST_BASE_DIR -type d -exec chmod 755 {} +
  fi


  ##### Get the Database and Device information from Manifest file created during the backup
  echo "Listing databases and devices.."
  set +x
  su -m $OSUSER -c "$SYBASE_SQLD/bin/isql -w 2000 -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X -e -n -b -o $MF_DETAILS --retserverror" <<EOF
set nocount on
go
use master
go
mount database all from '$MANIFEST_FILE' with listonly
go
quit
EOF
  retval=$?
  set -x

  if [ $retval -gt 0 ]; then
    echo "ERRORMSG: MOUNT LISTONLY Command failed!"
    if [ -e $MF_DETAILS ]; then
      cat $MF_DETAILS
      rm -f $MF_DETAILS
    fi
    exit 1
  fi

  getDBlist

  ## Check this manifest file is part of SRC_DBNAME or not
  if [ "$INDIVIDUAL" != "NO" ]; then
    indFlag=0
    for db in $(echo $SRC_DBNAME | sed 's/,/ /g')
    do
      if [ "$db_list" = "$db" ]; then
        indFlag=1; break;
      fi
    done

    if [ "$indFlag" = "0" ]; then
      continue;
    fi
  fi

  if [ "$INDIVIDUAL" = "NO" ]; then
    getDB_Delelet_List
  fi


  ##### Get the device list from Manifest_file
  sed '1,/device/d' $MF_DETAILS > $MF_DEVICE_DETAILS
  if [ ! -z "$TARGET_MNT_PNT" ]; then
    fmtTMP=`echo $TARGET_MNT_PNT | sed 's./.\\\/.g'`
    sed -i "s.'.${fmtTMP}." $MF_DEVICE_DETAILS
    sed -i "s/^.*$/'&/" $MF_DEVICE_DETAILS
  fi
  echo "Devices list: "
  cat $MF_DEVICE_DETAILS


  ##### Prepare isql format for using devicelist
  devicedetails=
  set +x
  while read line
  do
    logical_dev_name=`echo $line | awk -F"=" '{print $2}'`
    physical_dev_name=`echo $line | awk -F"=" '{print $1}'`

    if [ -z "$devicedetails" ]; then
      devicedetails="$logical_dev_name as $physical_dev_name"
    else
      devicedetails="$devicedetails,$logical_dev_name as $physical_dev_name"
    fi
  done<$MF_DEVICE_DETAILS
  set -x
  echo "Device details:$devicedetails"


  ##### rename databases as needed
  db_details=""
  for odb in $(echo $db_list | sed "s/,/ /g")
  do
    db_newName=
    db_flag=0

    #find newName
    for dbR in $(echo $TARGET_DBNAME_LIST | sed "s/,/ /g")
    do
      db_n=`echo $dbR |awk -F":" '{print $2}'`
      db_o=`echo $dbR |awk -F":" '{print $1}'`
      if [ "$db_o" = "$odb" ]; then
        if [ "$db_n" != "" ]; then
          db_newName=$db_n
          newDBlist="$newDBlist,$db_newName"
        else
          db_newName=$odb'_act'
        fi
        db_flag=1
        break
      fi
    done

    if [ $db_flag -eq 0 ]; then
      db_newName=$odb'_act'
    fi

    #Add to list
    if [ -z "$db_details" ]; then
      db_details="$odb as $db_newName"
    else
      db_details="$db_details, $odb as $db_newName"
    fi
  done

  ##### Mount Database
  echo "mount database $db_details from Manifest.. using $devicedetails"
  set +x
  su -m $OSUSER -c "$SYBASE_SQLD/bin/isql -w 2000 -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X --retserverror" <<EOF
use master
go
mount database $db_details from '$MANIFEST_FILE'
using $devicedetails
go
EOF
  retval=$?
  set -x

  if [ $retval -gt 0 ]; then
    echo "ERRORMSG: Mount database command failed!"
    set +x
    TARGET_DBUSER_PASSWD="$TARGET_DBUSER_PASSWD_orig"
    set -x
    /act/custom_apps/sybase/clone/ACT_SYBASE_premount.sh
    exit 1
  fi

  if [ $INDIVIDUAL = "NO" ]; then
    unmountDBs
  fi
done



##### Performing Log Recovery
if [ "$UNTIL_TIME" != "" ]; then
 /act/custom_apps/sybase/clone/ACT_SYBASE_recover.sh $OSUSER $SYBASE_SQLD
 if [ "$?" -gt 0 ]; then
   echo "ERRORMSG: Failed to recover databases"
   set +x
   TARGET_DBUSER_PASSWD="$TARGET_DBUSER_PASSWD_orig"
   set -x
   /act/custom_apps/sybase/clone/ACT_SYBASE_premount.sh
   exit 1
 fi
fi


sleep 30
##### Bring databases online
for i in $(echo $newDBlist | sed "s/,/ /g")
do
  set +x
  su -m $OSUSER -c "$SYBASE_SQLD/bin/isql -w 2000 -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X --retserverror" <<EOF
use master
go
dbcc traceon (7436)
go
online database $i
go
dbcc traceoff (7436)
go
EOF
  retval=$?
  set -x
  
  if [ $retval -gt 0 ]; then
   echo "ERRORMSG: Online database command failed!."
   set +x
   TARGET_DBUSER_PASSWD="$TARGET_DBUSER_PASSWD_orig"
   set -x
   /act/custom_apps/sybase/clone/ACT_SYBASE_premount.sh
   exit 1
  fi
done

##### Create remount config
remount_config

##### Remove temp files
if [ -e $MF_DEVICE_DETAILS ]; then
 rm -f $MF_DEVICE_DETAILS
fi

if [ -e $MF_DETAILS ]; then
 rm -f $MF_DETAILS
fi

exit $retval
