#!/bin/sh

set -x
TARGET_SERVER_NAME=$TARGET_SERVER_NAME
TARGET_DB_USER=$TARGET_DB_USER
set +x
#TARGET_DBUSER_PASSWD=`printf '%q' $TARGET_DBUSER_PASSWD`
set -x
TARGET_DBUSER_OTHERCRED=$TARGET_DBUSER_OTHERCRED
SRC_DBNAME=$SRC_DBNAME
LOG_BKP_MNTPT=$LOG_BKP_MNTPT
BEGIN_TIME=$BEGIN_TIME
UNTIL_TIME=$UNTIL_TIME

OSUSER=$1
SYBASE_SQLD=$2

OSGROUP=`id -gn $OSUSER`

#---------------------------------------------
#Get the password
#---------------------------------------------
#set +x
#if [ ! -z "$TARGET_DBUSER_OTHERCRED" ]; then
#  TARGET_DBUSER_PASSWD=`su - $OSUSER -c "$TARGET_DBUSER_OTHERCRED"`
#  if [ $? -ne 0 ]; then
#    echo "ERRORMSG: Fail to get password from the password function: $TARGET_DBUSER_OTHERCRED "
#    exit 1
#  else
#    TARGET_DBUSER_PASSWD=`printf '%q' $TARGET_DBUSER_PASSWD`
#  fi
#fi
set -x
#---------------------------------------------

#Change permissions to LOG_BKP_MNTPT
chown -R $OSUSER:$OSGROUP $LOG_BKP_MNTPT
LOG_BKP_MNTPT_BASE=`echo $LOG_BKP_MNTPT | cut -d/ -f2`
if [ "$LOG_BKP_MNTPT" != "" ]; then
  find /$LOG_BKP_MNTPT_BASE -type d -exec chmod 755 {} +
fi

#Set sybase env
set +x
. $SYBASE_SQLD/../SYBASE.sh
set -x
rollforwardtime=$UNTIL_TIME
UNTIL_TIME=`echo $UNTIL_TIME| sed 's/:\| \|-//g' `

######Function for log recovery
logSetRecovery() {

    db=$1
    logBkpSet=$2

    #logBkpSetEndTime=`echo $logBkpSet | cut -d_ -f3,4 | sed "s/_//g"`
    logBkpSetEndTime=`stat $LOG_BKP_MNTPT/$db/$logBkpSet* | grep "Modify: "| awk '{print $2$3}' | sed 's/-\|://g' |cut -d. -f1 | sort | uniq | tail -1`
    logBkpSet="$LOG_BKP_MNTPT/$db/$logBkpSet"

    loadTranStmt=""
    breakFlag="false"

    ####Prepare command 'load transaction'
    for fileName in $(ls $logBkpSet*)
    do
      if [ "$loadTranStmt" = "" ]; then
        loadTranStmt="load transaction $dbACT from \"$fileName\""
      else
        loadTranStmt="$loadTranStmt stripe on \"$fileName\" "
      fi
    done

    # If until_time is in current logBkpSet
    if [ $UNTIL_TIME -le $logBkpSetEndTime ]; then
      #rollforwardtime=`date -d "${UNTIL_TIME:0:8} ${UNTIL_TIME:8:2}:${UNTIL_TIME:10:2}:${UNTIL_TIME:12:2}" +"%Y-%m-%d %H:%M:%S"`
      loadTranStmt="$loadTranStmt with until_time=\"$rollforwardtime\" "
      breakFlag="true"
    fi

    #Run the recovery with backupset
    echo "COMMAND: $loadTranStmt"
    set +x
    su -m $OSUSER -c "$SYBASE_SQLD/bin/isql -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X --retserverror " <<EOF
use master
go
$loadTranStmt
go
EOF
    retval=$?
    set -x

    return "$retval"
}
###############################



#####Function to find new-name of the database
newNameFind() {
  db=$1
  for dbR in $(echo $TARGET_DBNAME_LIST | sed "s/,/ /g")
  do
    db_n=`echo $dbR | cut -d: -f2`
    db_o=`echo $dbR | cut -d: -f1`
    if [ "$db_o" = "$db" ]; then
      if [ "$db_n" != "" ]; then
        dbACT=$db_n
      fi
      break
    fi
  done
}
###############################



### Recovery for each database
for db in $(echo $SRC_DBNAME | sed "s/,/ /g")
do

  #Find logBackupSets for database
  #logBkpSets=`ls -ltr $LOG_BKP_MNTPT/$db/ | grep -vw total |awk '{print $NF}' | cut -d_ -f1,2,3,4 | uniq`
  logBkpSets=`find $LOG_BKP_MNTPT/$db/ -newermt "$BEGIN_TIME" | sort | sed 's/\// /g' | awk '{print $NF}' | cut -d_ -f1,2,3,4 | uniq | grep -vw $db`

  #find new-name of the database
  dbACT=
  newNameFind $db

  ## if database has no new-name, it is not required
  if [ -z $dbACT ]; then
    continue
  fi

  ## Recover every log_backpu_set
  echo "Recovery start for database $dbACT ....."
  for logBkpSet in $logBkpSets
  do
      breakFlag="flaseeeee"
      logSetRecovery $db $logBkpSet
      retval=$?
      if [ "$breakFlag" = "true" ]; then
	break
      fi
  done

  if [ "$retval" -gt 0 ]; then
    echo "ERRORMSG: Failed to recover database $db"
    exit 1
  fi

done

exit 0
