#!/bin/sh

set -x
MANIFEST_FILE_LOC=$MANIFEST_FILE_LOC
TARGET_MNT_PNT=$TARGET_MNT_PNT
TARGET_SERVER_NAME=$TARGET_SERVER_NAME
TARGET_DB_USER=$TARGET_DB_USER
set +x
TARGET_DBUSER_PASSWD=`printf '%q' $TARGET_DBUSER_PASSWD`
set -x
TARGET_DBUSER_OTHERCRED=$TARGET_DBUSER_OTHERCRED
ACT_JOBNAME=$JOBID

SRC_DBNAME=$SRC_DBNAME
TARGET_DBNAME_LIST=$TARGET_DBNAME_LIST
CONFIG_FILE_LOC=$CONFIG_FILE_LOC

#----------------------------------------------------------------------
# function: getCurrectEnvRemnt() Get Valuse for OLD_MNT_PNT, SRC_DBNAME, TARGET_DBNAME_LIST
#----------------------------------------------------------------------
getCurrectEnvRemnt() {

  local fmName=`grep REMOUNT_DB_LIST $CONFIG_FILE_LOC | cut -d"=" -f2`
  local flName=$TARGET_DBNAME_LIST

  local newSRCDB=
  local newTRGDB=

  #Get fName:mName:lName
  for dbName in $(echo $SRC_DBNAME | sed 's/,/ /g')
  do
    local fName=$dbName
    local mName=
    local lName=
    local flag=0

    #Get mName
    for ocf in $(echo $fmName | sed 's/,/ /g')
    do
      p_db=`echo $ocf | cut -d: -f1`
      pr_db=`echo $ocf| cut -d: -f2`

      if [ -z $pr_db ]; then
        echo "ERRORMSG: $CONFIG_FILE_LOC is not in required format"
        exit 1
      fi

      if [ "$p_db" = "$fName" ]; then
        mName=$pr_db
        flag=1
        break
      fi
    done

    if [ $flag -ne 1 ]; then
      continue
    fi

    #Get lName
    for ncf in $(echo $flName | sed 's/,/ /g')
    do
      p_db=`echo $ncf | cut -d: -f1`
      n_db=`echo $ncf | cut -d: -f2`

      if [ -z $n_db ]; then
        continue
      fi

      if [ "$p_db" = "$fName" ]; then
        lName=$n_db
        flag=1
        break
      fi
    done

    if [ $flag -ne 1 ]; then
      continue
    fi

    if [ -z $mName ] || [ -z $lName ]; then
      continue
    fi

    echo "Combination of parent, old name and new name = $fName:$mName:$lName"
    if [ -z $newSRCDB ]; then
      newSRCDB=$mName
      newTRGDB=$mName:$lName
    else
      newSRCDB="$newSRCDB,$mName"
      newTRGDB="$newTRGDB",$mName:$lName
    fi
  done

  echo "newSRCDB=$newSRCDB newTRGDB=$newTRGDB"

  OLD_MNT_PNT=`grep OLD_MOUNT $CONFIG_FILE_LOC | cut -d"=" -f2`
  SRC_DBNAME=$newSRCDB
  TARGET_DBNAME_LIST_ORIG=$TARGET_DBNAME_LIST
  TARGET_DBNAME_LIST=$newTRGDB

  echo "OLD_MNT_PNT=$OLD_MNT_PNT SRC_DBNAME=$SRC_DBNAME TARGET_DBNAME_LIST=$TARGET_DBNAME_LIST"
}
#----------------------------------------------------------------------

tmp_loc=/act/tmpdata/$ACT_JOBNAME/tempDir
if [ ! -d "$tmp_loc" ]; then
   mkdir -p $tmp_loc
   chmod 755 $tmp_loc
   chmod 755 $tmp_loc/..
fi

if [ ! -d /act/touch/$ACT_JOBNAME ]; then
  mkdir -p /act/touch/$ACT_JOBNAME
  chmod 755 /act/touch/$ACT_JOBNAME
fi

#find /act -type d -exec chmod 755 {} +


#----------------------------------------------------------------------
# function: remount_config()
#----------------------------------------------------------------------
remount_config() {
  config_file=/act/touch/$ACT_JOBNAME/REMOUNT_CONFIG
  echo "OLD_MOUNT=$TARGET_MNT_PNT" > $config_file
  for dbname in $(echo $TARGET_DBNAME_LIST_ORIG | sed 's/,/ /g')
  do
    SOURCE_DB=`echo $dbname |awk -F":" '{print $1}'`
    TARGET_DB=`echo $dbname |awk -F":" '{print $2}'`
    if [ -z "$TARGET_DB" ]; then
       TARGET_DB=$SOURCE_DB
    fi
    if [ -z "$remount_db_list" ]; then
       remount_db_list="$SOURCE_DB":"$TARGET_DB"
    else
       remount_db_list="$remount_db_list","$SOURCE_DB":"$TARGET_DB"
    fi
  done
  echo "REMOUNT_DB_LIST=$remount_db_list" >> $config_file
}
#----------------------------------------------------------------------


#----------------------------------------------------------------------
# function: getDBlist()
#----------------------------------------------------------------------
getDBlist() {
  db_list=""
  local db_names=`awk '/database/{flag=1; next} /device/{flag=0} flag' $MF_DETAILS`
  for i in $db_names
  do
   if [ -z "$db_list" ]; then
     db_list=$i
    else
      db_list=$db_list,$i
    fi
  done
  echo "Database list: $db_list"
}
#----------------------------------------------------------------------


#use REMOUNT_CONFIG and get the proper values
getCurrectEnvRemnt

#Find OS user and group for TARGET_SERVER_NAME
OSUSER=`ps -ef | grep -i "bin/dataserver"| grep $TARGET_SERVER_NAME | grep -v -w grep | awk '{print $1}'|uniq|xargs`
OSGROUP=`id -gn $OSUSER`

#Change $tmp_loc  owner
chown -R $OSUSER:$OSGROUP $tmp_loc


#---------------------------------------------
#Get the password
#---------------------------------------------
set +x
if [ ! -z "$TARGET_DBUSER_OTHERCRED" ]; then
  TARGET_DBUSER_PASSWD=`su - $OSUSER -c "$TARGET_DBUSER_OTHERCRED"`
  if [ $? -ne 0 ]; then
    echo "ERRORMSG: Fail to get password from the password function: $TARGET_DBUSER_OTHERCRED "
    exit 1
  else
    TARGET_DBUSER_PASSWD="'$TARGET_DBUSER_PASSWD'"
  fi
fi
set -x
#---------------------------------------------

#Find SQLD location for target server
SYBASE_ASE_location=`ps -ef | grep "bin/dataserver"|grep $TARGET_SERVER_NAME | grep -v -w grep | awk -F'bin/dataserver' '{print $1}' | grep -v -w awk | awk '{print $NF}' | head -1`
syb_home=$SYBASE_ASE_location/..
syb_ocs=`cat $syb_home/SYBASE.sh | grep SYBASE_OCS | grep -v export `
syb_ocs=`echo $syb_ocs | awk -F "=" '{print $2}'`
syb_ocs=`echo $syb_ocs |sed 's/"//g'`
SYBASE_SQLD=$syb_home/$syb_ocs

#set env
set +x
. $SYBASE_SQLD/../SYBASE.sh
set -x

#Prepare nessesary variables
MF_DETAILS="$tmp_loc/MF_DETAILS_$ACT_JOBNAME.txt"
MF_DEVICE_DETAILS="$tmp_loc/MF_DEVICE_DETAILS_$ACT_JOBNAME.txt"
newDBlist=""

#Change MANIFEST_FILE permissions
MANIFEST_FILE=$MANIFEST_FILE_LOC
chown -R $OSUSER:$OSGROUP $MANIFEST_FILE
MANIFEST_BASE_DIR=`echo $MANIFEST_FILE | cut -d/ -f2`
if [ "$MANIFEST_BASE_DIR" != "" ]; then
  find /$MANIFEST_BASE_DIR -type d -exec chmod 755 {} +
fi

##### Get the Database and Device information from Manifest file created during the backup
echo "Listing databases and devices.."
set +x
su -m $OSUSER -c "$SYBASE_SQLD/bin/isql -w 2000 -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X -e -n -b -o $MF_DETAILS --retserverror" <<EOF
set nocount on
go
use master
go
mount database all from '$MANIFEST_FILE' with listonly
go
quit
EOF
retval=$?
set -x

if [ $retval -gt 0 ]; then
  echo "ERRORMSG: MOUNT LISTONLY Command failed!"
  if [ -e $MF_DETAILS ]; then
    cat $MF_DETAILS
    rm -f $MF_DETAILS
  fi
  exit 1
fi

getDBlist

##### Get the device list from Manifest_file
sed '1,/device/d' $MF_DETAILS > $MF_DEVICE_DETAILS
if [ ! -z "$TARGET_MNT_PNT" ] && [ "$TARGET_MNT_PNT" != "$OLD_MNT_PNT" ]; then
  fmtTMP=`echo $TARGET_MNT_PNT | sed 's./.\\\/.g'`
  fmtOldMP=`echo $OLD_MNT_PNT | sed 's./.\\\/.g'`
  sed -i "s.${fmtOldMP}.${fmtTMP}." $MF_DEVICE_DETAILS
fi
echo "Devices list: "
cat $MF_DEVICE_DETAILS


##### Change owner of device mount points
for dbFile in $(cat $MF_DEVICE_DETAILS | awk '{print $1}' | sed "s/'//g")
do
  mntPartition=`df -P $dbFile | tail -1 | awk '{print $NF}'`
  mntPartRoot=`echo $mntPartition | cut -d/ -f2`
  chown -R $OSUSER:$OSGROUP $mntPartition
  if [ ! -z $mntPartRoot ];then
    find /$mntPartRoot -type d -exec chmod 755 {} +
  fi
done


##### Prepare isql format for using devicelist
devicedetails=
while read line
do
  logical_dev_name=`echo $line | awk -F"=" '{print $2}'`
  physical_dev_name=`echo $line | awk -F"=" '{print $1}'`

  if [ -z "$devicedetails" ]; then
    devicedetails="$logical_dev_name as $physical_dev_name"
  else
    devicedetails="$devicedetails,$logical_dev_name as $physical_dev_name"
  fi
done<$MF_DEVICE_DETAILS
echo "DD:$devicedetails"


##### rename databases as needed
db_details=""
for odb in $(echo $db_list | sed "s/,/ /g")
do
  db_newName=
  db_flag=0

  #find newName
  for dbR in $(echo $TARGET_DBNAME_LIST | sed "s/,/ /g")
  do
    db_n=`echo $dbR |awk -F":" '{print $2}'`
    db_o=`echo $dbR |awk -F":" '{print $1}'`
    if [ "$db_o" = "$odb" ]; then
      if [ "$db_n" != "" ]; then
        db_newName=$db_n
        newDBlist="$newDBlist,$db_newName"
      else
        db_newName=$odb
        newDBlist="$newDBlist,$db_newName"
      fi
      db_flag=1
      break
    fi
  done

  if [ $db_flag -eq 0 ]; then
    db_newName=$odb
    newDBlist="$newDBlist,$db_newName"
  fi

  #Add to list
  if [ -z "$db_details" ]; then
    db_details="$odb as $db_newName"
  else
    db_details="$db_details, $odb as $db_newName"
  fi
done


##### Mount Database
echo "mount database $db_details from Manifest.. using $devicedetails"
set +x
su -m $OSUSER -c "$SYBASE_SQLD/bin/isql -w 2000 -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X --retserverror" <<EOF
use master
go
mount database $db_details from '$MANIFEST_FILE' using $devicedetails
go
EOF
retval=$?
set -x

if [ $retval -gt 0 ]; then
  echo "ERRORMSG: Mount database command failed!"
  exit 1
fi

##### Bring databases online
for i in $(echo $newDBlist | sed "s/,/ /g")
do
  set +x
  su -m $OSUSER -c "$SYBASE_SQLD/bin/isql -w 2000 -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X --retserverror" <<EOF
use master
go
online database $i
go
EOF
  retval=$?
  set -x
  
  if [ $retval -gt 0 ]; then
   echo "ERRORMSG: Online database command failed!."
   exit 1
  fi
done

##### Create remount config
remount_config

##### Remove temp files
if [ -e $MF_DEVICE_DETAILS ]; then
 rm -f $MF_DEVICE_DETAILS
fi

if [ -e $MF_DETAILS ]; then
 rm -f $MF_DETAILS
fi

exit $retval
