#!/bin/sh

set -x
OSUSER=$SYBOSUSER
SRC_SYBASE_SQLD=$SRC_SYBASE_SQLD
SRC_BACKUP_USER=$TARGET_DB_USER
set +x
SRC_USER_PASSWD="$TARGET_DBUSER_PASSWD"
set -x
SRC_USER_OTHERCRED=$TARGET_DBUSER_OTHERCRED
SRC_SERVER_NAME=$ACT_NAME
DUMPBKPLOC=$TARGET_MNT_PNT
USER_DBLIST="$SRC_DBNAME"
UNTIL_TIME=$UNTIL_TIME
BEGIN_TIME=$BEGIN_TIME
LOG_BKP_MNTPT=$LOG_BKP_MNTPT

dbName=$1


######Function for log recovery
logSetRecovery() {

    db=$1
    logBkpSet=$2

    #logBkpSetEndTime=`echo $logBkpSet | cut -d_ -f3,4 | sed "s/_//g"`
    logBkpSetEndTime=`stat $LOG_BKP_MNTPT/$db/$logBkpSet* | grep "Modify: "| awk '{print $2$3}' | sed 's/-\|://g' |cut -d. -f1 | sort | uniq | tail -1`
    logBkpSet="$LOG_BKP_MNTPT/$db/$logBkpSet"

    loadTranStmt=""
    breakFlag="false"

    ####Prepare command 'load transaction'
    for fileName in $(ls $logBkpSet*)
    do
      if [ "$loadTranStmt" = "" ]; then
        loadTranStmt="load transaction $db from \"$fileName\""
      else
        loadTranStmt="$loadTranStmt stripe on \"$fileName\" "
      fi
    done

    # If until_time is in current logBkpSet
    if [ $UNTIL_TIME -le $logBkpSetEndTime ]; then
      #rollforwardtime=`date -d "${UNTIL_TIME:0:8} ${UNTIL_TIME:8:2}:${UNTIL_TIME:10:2}:${UNTIL_TIME:12:2}" +"%Y-%m-%d %H:%M:%S"`
      loadTranStmt="$loadTranStmt with until_time=\"$rollforwardtime\" "
      breakFlag="true"
    fi

    #Run the recovery with backupset
    echo "COMMAND: $loadTranStmt"
    set +x
    su -m $OSUSER -c "$SRC_SYBASE_SQLD/bin/isql -U$SRC_BACKUP_USER -P$SRC_USER_PASSWD -S$SRC_SERVER_NAME -X --retserverror " <<EOF
$loadTranStmt
go
EOF
    retval=$?
    set -x

    return "$retval"
}
###############################


# Change permissions to LOG_BKP_MNTPT
OSGROUP=`id -gn $OSUSER`
chown -R $OSUSER:$OSGROUP $LOG_BKP_MNTPT
LOG_BKP_MNTPT_BASE=`echo $LOG_BKP_MNTPT | cut -d/ -f2`
if [ "$LOG_BKP_MNTPT" != "" ]; then
  find /$LOG_BKP_MNTPT_BASE -type d -exec chmod 755 {} +
fi

#Set sybase env
set +x
. $SRC_SYBASE_SQLD/../SYBASE.sh
set -x
rollforwardtime=$UNTIL_TIME
UNTIL_TIME=`echo $UNTIL_TIME| sed 's/:\| \|-//g' `


#Find logBackupSets for database
#logBkpSets=`ls -l $LOG_BKP_MNTPT/$dbName/ | grep -vw total |awk '{print $NF}' | cut -d_ -f1,2,3,4 | uniq`
logBkpSets=`find $LOG_BKP_MNTPT/$dbName/ -newermt "$BEGIN_TIME" | sort | sed 's/\// /g' | awk '{print $NF}' | cut -d_ -f1,2,3,4 | uniq | grep -vw $dbName`


# Recover every log_backpu_set
for logBkpSet in $logBkpSets
do
      breakFlag="flaseeeee"
      logSetRecovery $dbName $logBkpSet
      retval=$?
      if [ "$breakFlag" = "true" ]; then
	break
      fi
done


# Return recovery status
if [ "$retval" -gt 0 ]; then
  #echo "ERRORMSG: Failed to recover database $dbName "
  exit 1
else
  exit 0
fi

