#!/bin/sh

#Prepare env
for ARGUMENT in "$@"
do
   ARGUMENT="${ARGUMENT%\"}"
   ARGUMENT="${ARGUMENT#\"}"
   argLft=`echo $ARGUMENT|cut -d= -f1`
   argRit=`echo $ARGUMENT|cut -d= -f2`
   export "$argLft=$argRit"
done

usage() {
  echo "Usage: "
  echo "/act/custom_apps/sybase/dump/ACT_SYBASE_dumprestore_newTarget.sh SYBOSUSER=<SYBOSUSER> SRC_SYBASE_SQLD=<SRC_SYBASE_SQLD> TARGET_DB_USER=<TARGET_DB_USER> [ TARGET_DBUSER_PASSWD=<TARGET_DBUSER_PASSWD> | TARGET_DBUSER_OTHERCRED=<TARGET_DBUSER_OTHERCRED> ] ACT_NAME=<ACT_NAME> TARGET_MNT_PNT=<TARGET_MNT_PNT> SRC_DBNAME=<SRC_DBNAME> UNTIL_TIME=\"<UNTIL_TIME>\" BEGIN_TIME=\"<BEGIN_TIME>\" LOG_BKP_MNTPT=<LOG_BKP_MNTPT> SRC_PAGE_SIZE=<SRC_PAGE_SIZE>"
  echo ""
  echo "Example: "
  echo "/act/custom_apps/sybase/dump/ACT_SYBASE_dumprestore_newTarget.sh "
  echo ""
}

isProvided() {
  local varName=$1
  local varVal=$2
  if [ -z "$varVal" ]; then
    echo "ERRORMSG: $varName is empty."
    usage
    exit 1
  fi
}

isProvided SYBOSUSER $SYBOSUSER
isProvided SRC_SYBASE_SQLD $SRC_SYBASE_SQLD
isProvided TARGET_DB_USER $TARGET_DB_USER
isProvided ACT_NAME $ACT_NAME
isProvided TARGET_MNT_PNT $TARGET_MNT_PNT
isProvided SRC_DBNAME $SRC_DBNAME
isProvided SRC_PAGE_SIZE $SRC_PAGE_SIZE
if [ ! -z "$UNTIL_TIME" ]; then
  isProvided LOG_BKP_MNTPT $LOG_BKP_MNTPT
  isProvided BEGIN_TIME "$BEGIN_TIME"
fi

set -x

#Pre-Restore-Test




#Pre-Restore
/act/custom_apps/sybase/dump/ACT_SYBASE_predumprestore.sh
if [ $? -ne 0 ]; then
  echo "ERRORMSG: Fail to prepare restore"
  exit 1
fi


#Post-Restore-Test
set +x
. $SRC_SYBASE_SQLD/../SYBASE.sh
set -x

if [ ! -z "$TARGET_DBUSER_OTHERCRED" ]; then
  TARGET_DBUSER_PASSWD=`su - $OSUSER -c "$TARGET_DBUSER_OTHERCRED"`
  if [ $? -ne 0 ]; then
    echo "ERRORMSG: Fail to get password from the password function: $TARGET_DBUSER_OTHERCRED "
    exit 1
  else
    TARGET_DBUSER_PASSWD=`printf '%q' $TARGET_DBUSER_PASSWD`
  fi
fi

#get target server page size
set +x
TARGET_PAGE_SIZE=`su -m $SYBOSUSER -c "isql -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$ACT_NAME -X -n -b --retserverror" <<EOF | grep -v "Your password will expire in" | xargs
set nocount on
go
use master
go
SELECT @@maxpagesize
go
EOF`
retval=$?
set -x

retval=`echo $TARGET_PAGE_SIZE | grep -w "Msg" | grep -w "Level" | grep -w "State" | wc -l`
if [ $retval -ne 0 ]; then
  echo "ERRORMSG: Failed to find the current page_size of target server ($TARGET_SERVER_NAME)"
  exit 1
fi

#get source server page size
SRC_PAGE_SIZE=$SRC_PAGE_SIZE
if [ -z "$SRC_PAGE_SIZE" ]; then
  SRC_PAGE_SIZE=4096
fi

if [ $TARGET_PAGE_SIZE -ne $SRC_PAGE_SIZE ]; then
  echo "ERRORMSG: Cannot proceed to dump restore as target server page_size($TARGET_PAGE_SIZE) is not equals to source server page_size($SRC_PAGE_SIZE)."
  exit 1
fi




#Post-Restore
/act/custom_apps/sybase/dump/ACT_SYBASE_dumprestore.sh
if [ $? -ne 0 ]; then
  echo "ERRORMSG: Fail to retore database"
  exit 1
fi
