#!/bin/sh

set -x
OSUSER=$SYBOSUSER
SRC_SYBASE_SQLD=$SRC_SYBASE_SQLD
SRC_BACKUP_USER=$TARGET_DB_USER
set +x
SRC_USER_PASSWD=`printf '%q' $TARGET_DBUSER_PASSWD`
set -x
SRC_USER_OTHERCRED=$TARGET_DBUSER_OTHERCRED
SRC_SERVER_NAME=$ACT_NAME
DUMPBKPLOC=$TARGET_MNT_PNT
USER_DBLIST="$SRC_DBNAME"
UNTIL_TIME=$UNTIL_TIME
LOG_BKP_MNTPT=$LOG_BKP_MNTPT
tmp_loc=/act/tmpdata/$JOBID/tempDir


if [ ! -d $tmp_loc ]; then
  mkdir -p $tmp_loc
fi

if [ "$OSUSER" = "" ]; then
  echo "ERRORMSG: OSUSER is not provided"
  exit 1
fi

if [ "$SRC_SYBASE_SQLD" = "" ]; then
  echo "ERRORMSG: SRC_SYBASE_SQLD is not provided"
  exit 1
fi

if [ "$SRC_BACKUP_USER" = "" ]; then
  echo "ERRORMSG: SRC_BACKUP_USER is not provided"
  exit 1
fi

set +x
if [ "$SRC_USER_PASSWD" = "" ]; then
  echo "ERRORMSG: SRC_USER_PASSWD is not provided"
  exit 1
fi
set -x

if [ "$SRC_SERVER_NAME" = "" ]; then
  echo "ERRORMSG: SRC_SERVER_NAME is not provided"
  exit 1
fi

#if [ "$DUMPBKPLOC" = "" ]; then
#  echo "ERRORMSG: DUMPBKPLOC is not provided"
#  exit 1
#fi

if [ "$USER_DBLIST" = "" ]; then
  echo "ERRORMSG: USER_DBLIST is not provided"
  exit 1
fi

#if [ "$UNTIL_TIME" != "" ] && [ "$LOG_BKP_MNTPT" = "" ]; then
#  echo "ERRORMSG: LOG_BKP_MNTPT is not provided"
#  exit 1
#fi


#---------------------------------------------
#Get the password
#---------------------------------------------
set +x
if [ ! -z "$SRC_USER_OTHERCRED" ]; then
  SRC_USER_PASSWD=`su - $OSUSER -c "$SRC_USER_OTHERCRED"`
  if [ $? -ne 0 ]; then
    echo "ERRORMSG: Fail to get password from the password function: $SRC_USER_OTHERCRED "
    exit 1
  else
    SRC_USER_PASSWD="'$SRC_USER_PASSWD'"
  fi
fi
set -x
#---------------------------------------------

#--------------------------------------------------
# function: offlineDB()
#--------------------------------------------------
offlineDB() {
  local dbName=$1
  local spidList=

  set +x
  spidList=`su -m $SYBOSUSER -c "isql -S$SRC_SERVER_NAME -U$SRC_BACKUP_USER -P$SRC_USER_PASSWD -X -n -b -w 1000 --retserverror " <<EOF | grep -v "Your password will expire in" | grep $dbName | awk '{print $2}'
set nocount on
go
use master
go
sp_who
go
EOF`
  retval=$?
  set -x

  retval=`echo $spidList | grep -w "Msg" | grep -w "Level" | grep -w "State" | wc -l`
  if [ $retval -ne 0 ]; then
    echo "ERRORMSG: Failed to get current connections to the database $dbName"
    return 1
  fi

  # Kill the connections
  echo "FYI: Killing Connections $spidList in database $dbName"
  for conn_id in $spidList
  do
    set +x
    su -m $SYBOSUSER -c "isql -S$SRC_SERVER_NAME -U$SRC_BACKUP_USER -P$SRC_USER_PASSWD -X -n -b -w 1000 --retserverror " <<EOF
use master
go
kill $conn_id
go
EOF
    retval=$?
    set -x

    if [ $retval -ne 0 ]; then
      echo "ERRORMSG: Failed to kill session $conn_id of database $dbName"
      return 1
    fi
  done

  return 0
}
#--------------------------------------------------

# set env
set +x
. $SRC_SYBASE_SQLD/../SYBASE.sh
set -x



# Get current database present
set +x
existingDBs=`su -m $SYBOSUSER -c "isql -S$SRC_SERVER_NAME -U$SRC_BACKUP_USER -P$SRC_USER_PASSWD -X -n -b -w 1000 --retserverror " <<EOF | grep -v "Your password will expire in"
set nocount on
go
use master
go
select distinct name from master..sysdatabases where name not in ('master','model','pubs2','pubs3','sybmgmtdb','sybpcidb','sybsystemdb','sybsystemprocs','tempdb','sybsecurity','saptools','saptempdb') and name not like '%pubs%'
go
EOF`
retval=$?
set -x

retval=`echo $existingDBs | grep -w "Msg" | grep -w "Level" | grep -w "State" | wc -l`
if [ $retval -ne 0 ]; then
  echo "ERRORMSG: Failed to get current user database list"
  exit 1
fi



# Check USER_DBLIST exists or not
for dbName in $(echo $USER_DBLIST | sed "s/,/ /g")
do
  flag=f

  for db in $existingDBs
  do
    if [ "$db" = "$dbName" ]; then
      flag=t
      break
    fi
  done

  if [ "$flag" != "t" ]; then
    echo "WARNINGMSG: database $dbName is not exists"
    continue
  fi

  offlineDB $dbName
  if [ $? -ne 0 ]; then
    echo "ERRORMSG: Failed to make db $dbName offline"
    exit 1
  fi
done

exit 0
