#!/bin/sh

set -x

OSUSER=$SYBOSUSER
SRC_SYBASE_SQLD=$SRC_SYBASE_SQLD
SRC_BACKUP_USER=$SRC_BACKUP_USER
set +x
SRC_USER_PASSWD=`printf '%q' $SRC_USER_PASSWD`
set -x
SRC_USER_OTHERCRED=$SRC_USER_OTHERCRED
SRC_SERVER_NAME=$SRC_SERVER_NAME
DUMPBKPLOC=$DUMPBKPLOC
DATAVOLUMEOWNER=$DATAVOLUMEOWNER
USER_DBLIST="$USER_DBLIST"
STRIPEON=$STRIPEON
DUMPSCHEDULE=$DUMPSCHEDULE
COMPRESSION_LEVEL=$COMPRESSION_LEVEL

if [ -z $DATAVOLUMEOWNER ]; then
  OSGROUP=`id $OSUSER | awk '{print $NF}' |cut -d'(' -f2 | cut -d')' -f1`
  DATAVOLUMEOWNER="$OSUSER:$OSGROUP"
fi

if [ -z "$COMPRESSION_LEVEL" ]; then
  COMPRESSION_LEVEL=0
fi

#----------------------------------------------------------------------
#Get dump history
#----------------------------------------------------------------------
getLogDumpHist() {
  local tStmp=$1
  local outFile=$2
  local dmpTyp=$3

  set +x
  dumpHistory=`su -m $OSUSER -c "$SRC_SYBASE_SQLD/bin/isql -U$SRC_BACKUP_USER -P$SRC_USER_PASSWD -S$SRC_SERVER_NAME -X -n -b -w 10000 --retserverror" <<EOF | grep -v "Your password will expire in"
set nocount on
go
use master
go
sp_dump_history 'list', @dump_type = '$dmpTyp'
go
retval=$?
EOF`
  set -x

  set +x
  retval=`echo $dumpHistory | grep -w "Msg" | grep -w "Level" | grep -w "State" | wc -l`
  set -x
  if [ $retval -ne 0 ]; then
    echo "WARNINGMSG: Fail to get dump history"
    return 1
  fi

  set +x
  echo -e "Dump history: \n $dumpHistory" | grep $tStmp >> $outFile
  set -x

  return 0
}
#----------------------------------------------------------------------

#---------------------------------------------
#Get the password
#---------------------------------------------
set +x
if [ ! -z "$SRC_USER_OTHERCRED" ]; then
  SRC_USER_PASSWD=`su - $OSUSER -c "$SRC_USER_OTHERCRED"`
  if [ $? -ne 0 ]; then
    echo "ERRORMSG: Fail to get password from the password function: $SRC_USER_OTHERCRED "
    exit 1
  else
    SRC_USER_PASSWD="'$SRC_USER_PASSWD'"
  fi
fi
set -x
#---------------------------------------------

# Validate DUMPBKPLOC
if [ -z "$DUMPBKPLOC" ]; then
  echo "ERRORMSG: DUMPBKPLOC not provided"
  exit 1
elif [ ! -d "$DUMPBKPLOC" ]; then
  echo "ERRORMSG: DUMPBKPLOC ($DUMPBKPLOC) is not a directory"
  exit 1
fi

#----------------------------------------------------------------------
# function: isIncDmpAlw()
#----------------------------------------------------------------------
isIncDmpAlw() {
  set +x
  isIncAlw=`su -m $OSUSER -c "$SRC_SYBASE_SQLD/bin/isql -U$SRC_BACKUP_USER -P$SRC_USER_PASSWD -S$SRC_SERVER_NAME -X -n -w 1000 --retserverror" << EOF | grep -v "Your password will expire in"
use master
go
sp_helpdb $dbname
go
EOF`
  retval=$?
  set -x

  retval=`echo $isIncAlw | grep -w "Msg" | grep -w "Level" | grep -w "State" | wc -l`
  if [ $retval -ne 0 ]; then
    return 1
  fi

  isIncAlw=`echo $isIncAlw | grep "allow incremental dumps" | wc -l`
  return 0
}
#----------------------------------------------------------------------


#----------------------------------------------------------------------
# function: setAlwIncDmps()
#----------------------------------------------------------------------
setAlwIncDmps() {
  local dbName=$1

  set +x
  isIncAlw=`su -m $OSUSER -c "$SRC_SYBASE_SQLD/bin/isql -U$SRC_BACKUP_USER -P$SRC_USER_PASSWD -S$SRC_SERVER_NAME -X -n -w 1000 --retserverror" << EOF | grep -v "Your password will expire in"
use master
go
sp_dboption $dbName, 'allow incremental dumps', true
go
EOF`
  retval=$?
  set -x

  retval=`echo $isIncAlw | grep -w "Msg" | grep -w "Level" | grep -w "State" | wc -l`
  return $retval
}
#----------------------------------------------------------------------

## Change owner to mounted log backup location
chown -R $DATAVOLUMEOWNER $DUMPBKPLOC

set +x
source $SRC_SYBASE_SQLD/../SYBASE.sh
set -x

echo "USER_DBLIST: $USER_DBLIST"

#Prepare vars
if [ "$DUMPSCHEDULE" = "F" ]; then
  DUMPSCHEDULE_DB="F"
elif [ -z "$DUMPSCHEDULE" ]; then
  DUMPSCHEDULE_DB="I"
elif [ "$PREVDBFULLDUMPSAMEDAY" = "TRUE" ]; then
  DUMPSCHEDULE_DB="I"
else
  DUMPSCHEDULE_DB=${DUMPSCHEDULE:`date +%w`:1}
fi

if [ "$DUMPSCHEDULE_DB" = "F" ]; then
  BACKUPTYPE=Full
  dump_typee=DATABASE
else
  BACKUPTYPE=Incr
  dump_typee=CUMULATIVE
fi

dbdumploc_tmp=$DUMPBKPLOC
dumpHistFile=/act/touch/dumpHist_$JOBID.txt
echo > $dumpHistFile

#Create backupstatus.xml to tracke individual db backup status (success or fail)
if [ ! -d /act/tmpdata/$JOBID ]; then
  mkdir -p /act/tmpdata/$JOBID
fi
DUMP_STATUS_XML=/act/tmpdata/$JOBID/backupstatus.xml
echo "<tenants>" > $DUMP_STATUS_XML

#Flags to trace overall backup
ALL_BKP_SUCCESS=TRUE
SOME_BKP_SUCCESS=FALSE

#Start dump backup for each database
for dbname in $(echo $USER_DBLIST | sed "s/,/ /g")
do

  DUMPBKPLOC=$dbdumploc_tmp
  DUMPBKPLOC=$DUMPBKPLOC/$dbname
  if [ ! -d $DUMPBKPLOC ]; then
     mkdir -p $DUMPBKPLOC
     chown -R $DATAVOLUMEOWNER $DUMPBKPLOC
  fi

  # Find incremental backup allowd or not
  isIncAlw="FF"
  isIncDmpAlw
  if [ $? -ne 0 ]; then
    echo "WARNINGMSG: Failed to find the option status (allow incremental dumps) ."
    echo "<tenant name=\"$dbname\" status=\"failed\" error=\"Failed to find the option status (allow incremental dumps) \" />" >> $DUMP_STATUS_XML
    ALL_BKP_SUCCESS=FALSE
    continue
  fi

  if [ "$isIncAlw" != "1" ]; then
    echo "FYI: 'allow incremental dumps' not set. Changing the status to true"
    setAlwIncDmps $dbname
    if [ $? -ne 0 ]; then
      echo "WARNINGMSG: Failed to set 'allow incremental dumps' true to database $dbname"
      echo "<tenant name=\"$dbname\" status=\"failed\" error=\"Failed to set 'allow incremental dumps' true\"/>" >> $DUMP_STATUS_XML
      ALL_BKP_SUCCESS=FALSE
      continue
    fi
    DUMPSCHEDULE_DB="F"
  fi
  
  DF="F"
  FULL_BKP=`ls -l $DUMPBKPLOC/"$dbname"_dumpbkp"$DF"*`
  if [ -z "$FULL_BKP" ]; then
     DUMPSCHEDULE_DB="F"
  fi
  tsname=`date +%Y%m%d`
  tsname1=`date +%H%M%S`

  if [ "$DUMPSCHEDULE_DB" = "F" ]; then
    echo "FYI: Full backup ....."
    a="dump database $dbname to"
    DF="F"
  else
    echo "FYI: Cumulative backup ....."
    a="dump database $dbname cumulative to"
    DF="I"
  fi

  lf="$dbname"_dumpbkp"$DF"_"$tsname"_"$tsname1"
  if [ -z "$STRIPEON" ]; then
    STRIPEON=4
  fi

  b=""
  c="STRIPE ON"
  #Iterating on number of STRIPE ON
  for (( j=1;  j<= $STRIPEON; ++j ))
  do
      if [ "$STRIPEON" -le "9" ]; then
        if [ "$j" -eq "$STRIPEON" ];then
          b=`echo "$b \"$DUMPBKPLOC"/"$lf"_S0"$j"-0"$STRIPEON".dump"\""`
        else
          b=`echo "$b \"$DUMPBKPLOC"/"$lf"_S0"$j"-0"$STRIPEON".dump"\" $c"`
        fi
      else
          if [ "$j" -le "9" ];then
           if [ "$j" -eq "$STRIPEON" ];then
             b=`echo "$b \"$DUMPBKPLOC"/"$lf"_S0"$j"-"$STRIPEON".dump"\""`
           else
             b=`echo "$b \"$DUMPBKPLOC"/"$lf"_S0"$j"-"$STRIPEON".dump"\" $c"`
           fi
          else
           if [ "$j" -eq "$STRIPEON" ];then
            b=`echo "$b \"$DUMPBKPLOC"/"$lf"_S"$j"-"$STRIPEON".dump"\" "`
           else
             b=`echo "$b \"$DUMPBKPLOC"/"$lf"_S"$j"-"$STRIPEON".dump"\" $c"`
           fi
          fi
      fi
   done

  if [ -f $DUMPBKPLOC/syb_backup_dump ]; then
     rm -f $DUMPBKPLOC/syb_backup_dump
  fi
  echo "$a" "$b" >> $DUMPBKPLOC/syb_backup_dump
  echo "with compression = $COMPRESSION_LEVEL" >> $DUMPBKPLOC/syb_backup_dump
  echo go >> $DUMPBKPLOC/syb_backup_dump
  chown $DATAVOLUMEOWNER $DUMPBKPLOC/syb_backup_dump

  echo "Running dump backup for database $dbname from script ...... "
  set +x
  su -m $OSUSER -c "$SRC_SYBASE_SQLD/bin/isql -U$SRC_BACKUP_USER -P$SRC_USER_PASSWD -S$SRC_SERVER_NAME -X --retserverror -i $DUMPBKPLOC/syb_backup_dump "
  retval=$?
  set -x
  if [ "$retval" -gt 0 ]; then
     echo "WARNINGMSG: Failed to perform dump backup for the database $dbname. Please check the logs!"
     echo "<tenant name=\"$dbname\" status=\"failed\" error=\"Dump command failed\"/>" >> $DUMP_STATUS_XML
     ALL_BKP_SUCCESS=FALSE
     continue
  fi

  if [ -f $DUMPBKPLOC/syb_backup_dump ]; then
     rm -f $DUMPBKPLOC/syb_backup_dump
  fi

  getLogDumpHist $lf $dumpHistFile $dump_typee
  if [ "$retval" -gt 0 ]; then
     echo "WARNINGMSG: Failed to perform dump backup for the database $dbname. Please check the logs!"
     echo "<tenant name=\"$dbname\" status=\"failed\" error=\"Dump status not found in sp_dump_history\"/>" >> $DUMP_STATUS_XML
     ALL_BKP_SUCCESS=FALSE
     continue
  fi

  #As backup success, update DUMP_STATUS_XML and flag SOME_BKP_SUCCESS
  echo "<tenant name=\"$dbname\" status=\"success\" />" >> $DUMP_STATUS_XML
  SOME_BKP_SUCCESS=TRUE

done 

echo "</tenants>" >> $DUMP_STATUS_XML

echo "Dump history:"
cat $dumpHistFile
rm $dumpHistFile

if [ "$SOME_BKP_SUCCESS" = "FALSE" ]; then
  echo "ERRORMSG: Dump backup failed for all selected databases."
  exit 1
fi

if [ "$ALL_BKP_SUCCESS" = "FALSE" ]; then
  echo "WARNINGMSG: Some of the database backups failed."
else
  echo "INFOMSG: Dump backup successful for all the selected databases."
fi

echo "INFOMSG: Dump backup completed."
echo "DBSID: $SRC_SERVER_NAME BACKUPTYPE: $BACKUPTYPE END TIME: `date +%Y-%m-%d` `date +%H:%M:%S.%N` STATUS: successful"

exit 0
