#!/bin/sh

#Prepare env
for ARGUMENT in "$@"
do
   ARGUMENT="${ARGUMENT%\"}"
   ARGUMENT="${ARGUMENT#\"}"
   argLft=`echo $ARGUMENT|cut -d= -f1`
   argRit=`echo $ARGUMENT|cut -d= -f2`
   export "$argLft=$argRit"
done

set -x
OSUSER=$OSUSER
TARGET_SYBASE_SQLD=$TARGET_SYBASE_SQLD
TARGET_MNT_PNT=$TARGET_MNT_PNT
TARGET_SERVER_NAME=$TARGET_SERVER_NAME
TARGET_DB_USER=$TARGET_DB_USER
set +x
TARGET_DBUSER_PASSWD=`printf '%q' $TARGET_DBUSER_PASSWD`
set -x
TARGET_DBUSER_OTHERCRED=$TARGET_DBUSER_OTHERCRED
SRC_DBNAME=$SRC_DBNAME

LOG_BKP_MNTPT=$LOG_BKP_MNTPT
BEGIN_TIME=$BEGIN_TIME
UNTIL_TIME=$UNTIL_TIME
ACT_JOBNAME=$JOBID

#---------------------------------------------
#Get the password
#---------------------------------------------
set +x
if [ ! -z "$TARGET_DBUSER_OTHERCRED" ]; then
  TARGET_DBUSER_PASSWD=`su - $OSUSER -c "$TARGET_DBUSER_OTHERCRED"`
  if [ $? -ne 0 ]; then
    echo "ERRORMSG: Fail to get password from the password function: $TARGET_DBUSER_OTHERCRED "
    exit 1
  else
    TARGET_DBUSER_PASSWD="'$TARGET_DBUSER_PASSWD'"
  fi
fi
set -x
#---------------------------------------------


MANIFEST_FILE_LOC=$(find /act/tmpdata/$ACT_JOBNAME/ -iname Manifest_File_*_${SRC_DBNAME} )
if [ -z "$MANIFEST_FILE_LOC" ]; then
  echo "ERRORMSG: No Manifest file found for database $SRC_DBNAME at location /act/tmpdir/$ACT_JOBNAME"
  exit 1
fi


tmp_loc=/act/touch/$ACT_JOBNAME/tempDir
if [ ! -d "$tmp_loc" ]; then
   mkdir -p $tmp_loc
fi

if [ ! -d /act/touch/$ACT_JOBNAME ]; then
  mkdir -p /act/touch/$ACT_JOBNAME
fi

find /act -type d -exec chmod 755 {} +

#MANIFEST_FILE_BASE=$TARGET_MNT_PNT$MANIFEST_FILE_LOC
#MANIFEST_FILE_LOC=$MANIFEST_FILE_LOC"/Manifest_File_"$SRC_DBNAME".dat"

#------------------------------------------------------------
# function unmountDB()
#------------------------------------------------------------
unmountDB() {
  local srcDB=$1
  local UNMNT_FILE=$2

  set +x
  su -m $OSUSER -c "isql -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X --retserverror" <<EOF
use master
go
unmount database $srcDB to '$UNMNT_FILE'
go
EOF
  retval=$?
  set -x

  if [ $retval -gt "0" ]; then
    echo "ERRORMSG: Unmount database command Failed!"
    #exit 1
    dropDB
  fi
}
#------------------------------------------------------------


#------------------------------------------------------------
# function dropDB()
#------------------------------------------------------------
dropDB() {
  echo "Droping database: $srcDB"
  set +x
  su -m $OSUSER -c "isql -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X --retserverror -n -b -w 2000 -o $tmp_loc/dbdetails" <<EOF
set nocount on
go
use master
go
select db.name,db.dbid,u.vdevno,dv.name,dv.phyname from sysdatabases db, sysusages u, sysdevices dv where db.dbid=u.dbid and u.vdevno=dv.vdevno
go
EOF
  retval=$?
  set -x

  drpDev=`grep -w $srcDB $tmp_loc/dbdetails| awk '{print $4}' |xargs`
  echo "Droping device: $drpDev"

  set +x
  su -m $OSUSER -c "isql -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X --retserverror -n -b -w 2000 -o $tmp_loc/dbdetails" <<EOF
use master
go
drop database $srcDB
go
EOF
  retval=$?
  set -x

  if [ $retval -ne 0 ]; then
    echo "ERRORMSG: Fail to drop database $srcDB"
    #exit 1
  fi

  for lDev in $drpDev
  do
    set +x
    su -m $OSUSER -c "isql -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X --retserverror -n -b -w 2000 -o $tmp_loc/dbdetails" <<EOF
use master
go
sp_dropdevice $lDev
go
EOF
    retval=$?
    set -x

    if [ $retval -ne 0 ]; then
      echo "ERRORMSG: Fail to drop device $lDev"
      #exit 1
    fi
  done
}
#------------------------------------------------------------


#------------------------------------------------------------
# function dbDetails()
#------------------------------------------------------------
dbDetails() {
  set +x
  su -m $OSUSER -c "isql -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X -e -n -b -w 2000 -o $DB_DETAILS --retserverror" <<EOF
set nocount on
go
use master
go
select db.name,db.dbid,u.vdevno,dv.name,dv.phyname from sysdatabases db, sysusages u, sysdevices dv Where db.dbid=u.dbid and u.vdevno=dv.vdevno
go
EOF
  retval=$?
  set -x

  if [ $retval -gt 0 ]; then
    echo "ERRORMSG: fail to get db details"
    exit 1
  fi
}
#------------------------------------------------------------

#Find OS user and group for TARGET_SERVER_NAME
OSGROUP=`id -gn $OSUSER`


#set env
set +x
. $TARGET_SYBASE_SQLD/../SYBASE.sh
set -x


#Change $tmp_loc owner
chown -R $OSUSER:$OSGROUP $tmp_loc
chown $OSUSER:$OSGROUP $MANIFEST_FILE_LOC


#Tempfiles, variables
UNMNT_SRC_MF="$tmp_loc/UNMOUNT_SOURCE"
MF_DETAILS="$tmp_loc/MF_DETAILS"
DB_DETAILS="$tmp_loc/DB_DETAILS"


#get db details before unmount
dbDetails
grep -w $SRC_DBNAME $DB_DETAILS | awk '{print $1" "$4" "$5}' | sort | uniq > $DB_DETAILS.tmp
mv $DB_DETAILS.tmp $DB_DETAILS


#Unmount the databases
srcDB=$SRC_DBNAME
echo "Unmounting $srcDB to ${UNMNT_SRC_MF}_${srcDB}"
unmountDB "$srcDB" "${UNMNT_SRC_MF}_${srcDB}"

#copy datafile
srcDFiles=`cat $DB_DETAILS | awk '{print $3}'`
for dbF in $srcDFiles
do
  echo "Coping $dbF from $TARGET_MNT_PNT$dbF"
  cp -p $TARGET_MNT_PNT$dbF $dbF
done




#mount database
echo -e "Command: \n mount database \n $DBLIST_CMD \n from '$MANIFEST_FILE_LOC' \n using \n $DEV_LIST_CMD "
set +x
su -m $OSUSER -c "isql -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X --retserverror" <<EOF
use master
go
mount database $SRC_DBNAME from '$MANIFEST_FILE_LOC'
go
EOF
retval=$?
set -x

if [ $retval -ne 0 ]; then
  echo "ERRORMSG: fail to mount databases"
  exit 1
fi





#Recover database if needed
if [ ! -z "$UNTIL_TIME" ]; then
  export SYBOSUSER=$OSUSER
  export SRC_SYBASE_SQLD=$TARGET_SYBASE_SQLD
  export ACT_NAME=$TARGET_SERVER_NAME
  /act/custom_apps/sybase/dump/ACT_SYBASE_RESTORE_recovery.sh $SRC_DBNAME
  if [ $? -ne 0 ]; then
    echo "ERRORMSG: Failed to recover database $SRC_DBNAME"
    exit 1
  fi
fi





sleep 30
#online database
set +x
su -m $OSUSER -c "isql -U$TARGET_DB_USER -P$TARGET_DBUSER_PASSWD -S$TARGET_SERVER_NAME -X --retserverror" <<EOF
use master
go
online database $SRC_DBNAME
go
EOF
retval=$?
set -x

if [ $retval -gt 0 ]; then
  echo "ERRORMSG: Online database command failed!."
  exit 1
fi



#Remove temp files
if [ -z $ACT_JOBNAME ]; then
  rm -rf /act/touch/$ACT_JOBNAME/tempDir
else
 rm -rf /act/touch/$ACT_JOBNAME
fi

exit 0
