#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
#                  !!!Actifio Private Script. DO NOT MODIFY!!!
#
# ==============================================================================#

usage() {
  echo "Usage: "
  echo "/act/custom_apps/sybaseiq/CALL_ACT_SYBASEIQ_lvm_migrate.sh \"\" \"<DATAVOL_DISK_MAPPING> <newDBNAME> <DBA_USER> <DBA_PASSWD/null> \""
}

isProvided() {
  local varName=$1
  local varVal=$2
  if [ -z "$varVal" ]; then
    echo "ERRORMSG: $varName is empty."
    usage
    exit 1
  fi
}

set -x

APPREMOUNT="FALSE"
INPUT_VALUES=$2
count=1
IFS=" "


for value in ${INPUT_VALUES}; do

  if [ "$value" = "null" ]; then
    value=
  fi

  if [ "$count" -eq 1 ]; then
    DATAVOL_DISK_MAPPING=$value
  elif [ "$count" -eq 2 ]; then
    newDBNAME=$value
  elif [ "$count" -eq 3 ]; then
    DBA_USER=$value
  elif [ "$count" -eq 4 ]; then
    DBA_PASSWD=$value
  fi

  count=$(($count+1))

done


DATAVOL_DISK_MAPPING=$DATAVOL_DISK_MAPPING
newDBNAME=$newDBNAME
DBA_USER=$DBA_USER
DBA_PASSWD=$DBA_PASSWD
if [ ! -z "$ACT_JOBNAME" ]; then
  JOBID=$ACT_JOBNAME
fi

isProvided DATAVOL_DISK_MAPPING $DATAVOL_DISK_MAPPING
isProvided newDBNAME $newDBNAME
isProvided DBA_USER $DBA_USER


echo "***** Calling lvm_migrate (/act/custom_apps/sybaseiq/lvm_migrate/ACT_SYBASEIQ_lvm_migrate_newTarget.sh) *****"
/act/custom_apps/sybaseiq/lvm_migrate/ACT_SYBASEIQ_lvm_migrate_newTarget.sh DATAVOL_DISK_MAPPING=$DATAVOL_DISK_MAPPING newDBNAME=$newDBNAME DBA_USER=$DBA_USER DBA_PASSWD=$DBA_PASSWD
if [ $? -ne 0 ]; then
  echo "ERRORMSG: Fail to migrate applicatoin from Actifio storage to Target storage."
  exit 1
fi

exit 0
