#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
#                  !!!Actifio Private Script. DO NOT MODIFY!!!
#
# ==============================================================================#

usage() {
  echo "Usage: "
  echo "/act/custom_apps/sybaseiq/CALL_ACT_SYBASEIQ_mountrecover.sh \"\" \"<OSUSER> <SRC_DB_NAME> <TGT_DB_NAME> <SYBIQ_HOME> <VERSION> <DBA_USER> <DBA_PASSWD/null> \" "
}

isProvided() {
  local varName=$1
  local varVal=$2
  if [ -z "$varVal" ]; then
    echo "ERRORMSG: $varName is empty."
    usage
    exit 1
  fi
}

set -x

INPUT_VALUES=$2
count=1
IFS=" "


for value in ${INPUT_VALUES}; do

  if [ "$value" = "null" ]; then
    value=
  fi

  if [ "$count" -eq 1 ]; then
    OSUSER=$value
  elif [ "$count" -eq 2 ]; then
    SRC_DB_NAME=$value
  elif [ "$count" -eq 3 ]; then
    TGT_DB_NAME=$value 
  elif [ "$count" -eq 4 ]; then
    SYBIQ_HOME=$value
  elif [ "$count" -eq 5 ]; then
    VERSION=$value
  elif [ "$count" -eq 6 ]; then
    SRC_DB_DBA_USER=$value
  elif [ "$count" -eq 7 ]; then
    SRC_DB_DBA_PWD=$value
  fi

  count=$(($count+1))

done



OSUSER=$OSUSER
SRC_DB_NAME=$SRC_DB_NAME
TGT_DB_NAME=$TGT_DB_NAME
SYBIQ_HOME=$SYBIQ_HOME
VERSION=$VERSION
SRC_DB_DBA_USER=$SRC_DB_DBA_USER	#equals to target utility db username
SRC_DB_DBA_PWD=$SRC_DB_DBA_PWD		#equals to target utility db password

CATALOG_DB_FILE=$CATALOG_DB_FILE	#Connector can provide
TARGET_MNT=$TARGET_MNT			#Connector can provide
INCR_BKP_LOC=$INCR_BKP_LOC		#Connector can provide

if [ ! -z "$ACT_JOBNAME" ]; then
  JOBID=$ACT_JOBNAME
fi

set +x
isProvided OSUSER $OSUSER
isProvided CATALOG_DB_FILE $CATALOG_DB_FILE
isProvided SRC_DB_NAME $SRC_DB_NAME
isProvided TGT_DB_NAME $TGT_DB_NAME
isProvided TARGET_MNT $TARGET_MNT
isProvided SRC_DB_DBA_USER $SRC_DB_DBA_USER
isProvided SYBIQ_HOME $SYBIQ_HOME
isProvided VERSION $VERSION
isProvided INCR_BKP_LOC $INCR_BKP_LOC
set -x


echo "***** Calling /act/custom_apps/sybaseiq/clone/ACT_SYBASEIQ_mountrecover.sh for MountRecovery *****"
/act/custom_apps/sybaseiq/clone/ACT_SYBASEIQ_mountrecover.sh OSUSER=$OSUSER CATALOG_DB_FILE=$CATALOG_DB_FILE SRC_DB_NAME=$SRC_DB_NAME TGT_DB_NAME=$TGT_DB_NAME TARGET_MNT=$TARGET_MNT SRC_DB_DBA_USER=$SRC_DB_DBA_USER SRC_DB_DBA_PWD=$SRC_DB_DBA_PWD SYBIQ_HOME=$SYBIQ_HOME VERSION=$VERSION INCR_BKP_LOC=$INCR_BKP_LOC JOBID=$JOBID
if [ $? -ne 0 ]; then
  echo "ERRORMSG: MountRecover operation failed"
  exit 1
fi
