#!/bin/sh

set -x
OSUSER=$OSUSER
SYBIQ_HOME=$SYBIQ_HOME
version=$VERSION
SRC_DB_DBA_USER=$SRC_DB_DBA_USER
set +x
SRC_DB_DBA_PWD=$SRC_DB_DBA_PWD
set -x
DB_NAME=$ACT_NAME
DBCATALOGFILE=$DBCATALOGFILE
ACT_JOBNAME=$JOBID

. /act/custom_apps/sybaseiq/act_sybaseiq_common_functions.sh

prepareTmpLoc
OSGROUP=`id -gn $OSUSER`
chown -R $OSUSER:$OSGROUP $tmp_loc

########SET  env########
set +x
. $SYBIQ_HOME/$version/$version.sh
set -x

echo "No cleanup required"
exit 0

set +x
prepareConnString "$SRC_DB_DBA_USER" "$SRC_DB_DBA_PWD" "$DB_NAME"
set -x

#Un-Freeze
DATA_LOC=`dirname $DBCATALOGFILE`
FULL_BKP_FILE=$DATA_LOC/FULL_VIR_DEC
INC_BKP_FILE=$DATA_LOC/INC_BKP

set +x
su -m $OSUSER -c "dbisql -nogui -c '$CONN_STR' $HOST_PORT_OPT " <<EOF
BACKUP DATABASE INCREMENTAL SINCE FULL TO '$INC_BKP_FILE'
exit
EOF
retval=$?
set -x

if [ $retval -ne 0 ]; then
  echo "ERRORMSG: Fail to freeze (not able to take full_vir_dec backup)"
  exit 1
fi

exit 0
