#!/bin/sh


set -x
OSUSER=$OSUSER
SYBIQ_HOME=$SYBIQ_HOME
version=$VERSION
SRC_DB_DBA_USER=$SRC_DB_DBA_USER
set +x
SRC_DB_DBA_PWD=$SRC_DB_DBA_PWD
set -x
DB_NAME=$ACT_NAME
DB_ENG=$DB_ENG
PORTNO=$PORTNO
LOG_RETENTION=$DELETE_LOGFILES_HOURS

########SET  env########
set +x
. $SYBIQ_HOME/$version/$version.sh
set -x

. /act/custom_apps/sybaseiq/act_sybaseiq_common_functions.sh

#Get vals from SYBASEIQ.xml for now
if [ -z "$DB_ENG" ]; then
  DB_ENG=`grep "name=\"$DB_NAME\" " /act/custom_apps/SYBASEIQ.xml | awk -F"DB_ENG=" '{print $2}' | awk '{print $1}' |sed 's."..g'`
fi
if [ -z "$PORTNO" ]; then
  PORTNO=`grep "name=\"$DB_NAME\" " /act/custom_apps/SYBASEIQ.xml | awk -F"PORTNO=" '{print $2}' | awk '{print $1}' |sed 's."..g'`
fi

#Finding pitr log location
touch /act/touch/$DB_NAME.pitrstatus.txt
touch /act/touch/$DB_NAME.pitrlogfile.txt
chown -R $OSUSER:$OSGROUP /act/touch

set +x
prepareConnString "$SRC_DB_DBA_USER" "$SRC_DB_DBA_PWD" "$DB_NAME" "$DB_ENG" "$PORTNO"
set -x

su -m $OSUSER -c  "dbisql -nogui -onerror exit $HOST_PORT_OPT \"select db_property('IQPointInTimeRecoveryLogStatus');OUTPUT TO \"/act/touch/$DB_NAME.pitrstatus.txt\" format ascii;exit;\""

if [ $? -eq 0 ];then
  echo "INFOMSG: Database $DB_NAME connection is successful"
else
  echo "ERRORMSG: Failed to connect  database  $DB_NAME ! please check logs"
  exit 1
fi

su -m $OSUSER -c  "dbisql -nogui -onerror exit $HOST_PORT_OPT \"select db_property('IQPointInTimeRecoveryLogFilename');OUTPUT TO \"/act/touch/$DB_NAME.pitrlogfile.txt\" format ascii;exit;\""

PITR_STATUS=`cat /act/touch/$DB_NAME.pitrstatus.txt | grep -w On |wc -l`
PITR_LOGFILE_TMP=`cat /act/touch/$DB_NAME.pitrlogfile.txt | sed "s/'//g"`

if [ $PITR_STATUS -ne 1 ]; then
  echo "ERRORMSG:  Point In Time Recovery is not enabled for Database $DB_NAME ! Please check logs for more details"
  exit 1
else
  echo "continue"
fi

PITRLOG=`dirname $PITR_LOGFILE_TMP`

#Deleting PITR logfiles
LOG_RETENTION_MINS=`expr $LOG_RETENTION "*" 60`
find ${PITRLOG} -name *.iqlog -type f -mmin +$LOG_RETENTION_MINS -print -exec rm -f {} \;

#Deleting Tempfiles
rm -f /act/touch/$DB_NAME.pitrstatus.txt
rm -f /act/touch/$DB_NAME.pitrlogfile.txt


exit 0
