#!/bin/sh

set -x
OSUSER=$OSUSER
SYBIQ_HOME=$SYBIQ_HOME
version=$VERSION
SRC_DB_DBA_USER=$SRC_DB_DBA_USER
set +x
SRC_DB_DBA_PWD=$SRC_DB_DBA_PWD
set -x
DB_NAME=$ACT_NAME
DB_ENG=$DB_ENG
PORTNO=$PORTNO
DBCATALOGFILE=$DBCATALOGFILE
ACT_JOBNAME=$JOBID
CHILD=$CHILD

. /act/custom_apps/sybaseiq/act_sybaseiq_common_functions.sh

#Get vals from SYBASEIQ.xml for now
if [ -z "$DB_ENG" ]; then
  DB_ENG=`grep "name=\"$DB_NAME\" " /act/custom_apps/SYBASEIQ.xml | awk -F"DB_ENG=" '{print $2}' | awk '{print $1}' |sed 's."..g'`
fi
if [ -z "$PORTNO" ]; then
  PORTNO=`grep "name=\"$DB_NAME\" " /act/custom_apps/SYBASEIQ.xml | awk -F"PORTNO=" '{print $2}' | awk '{print $1}' |sed 's."..g'`
fi

prepareTmpLoc
OSGROUP=`id -gn $OSUSER`
chown -R $OSUSER:$OSGROUP $tmp_loc

########SET  env########
set +x
. $SYBIQ_HOME/$version/$version.sh
set -x

PWDS=/act/custom_apps/sybaseiq


set +x
prepareConnString "$SRC_DB_DBA_USER" "$SRC_DB_DBA_PWD" "$DB_NAME" "$DB_ENG" "$PORTNO"
set -x

#Freeze
DATA_LOC=`dirname $DBCATALOGFILE`

# Log switch
switchLog $DATA_LOC
if [ $? -ne 0 ] ; then
    echo "ERRORMSG: Failed to switch log before backup"
   exit 1
fi

FULL_BKP_FILE=$DATA_LOC/FULL_VIR_DEC
set +x
su -m $OSUSER -c "dbisql -nogui -c '$CONN_STR' $HOST_PORT_OPT " <<EOF
BACKUP DATABASE FULL VIRTUAL DECOUPLED TO '$FULL_BKP_FILE'
exit
EOF
retval=$?
set -x
if [ $retval -ne 0 ]; then
  echo "ERRORMSG: Fail to freeze (not able to take full_vir_dec backup)"
  exit 1
fi

##finding iqfiles
set +x
su -m $OSUSER -c "dbisql -nogui -c '$CONN_STR' $HOST_PORT_OPT \"select dbf.dbfile_name,dbf.file_name,dbs.dbspace_name from SYS.SYSDBSPACE dbs, SYS.SYSDBFILE dbf where dbf.dbspace_id=dbs.dbspace_id and dbs.dbspace_name not in ('system','temporary');\"" | awk '{print $1,$2,$3}' |tail -n+3 |head -n-3 > $DATA_LOC/config.txt
retval=$?
set -x
if [ $retval -ne 0 ]; then
  echo "ERRORMSG: Fail to get iqfiles"
  exit 1
fi
cat $DATA_LOC/config.txt | grep -vw IQ_SYSTEM_LOG > $DATA_LOC/config_new.txt
mv $DATA_LOC/config_new.txt $DATA_LOC/config.txt

##finding iqlogfile
IQ_SYSTEM_LOG=`su -m $OSUSER -c "dblog $DBCATALOGFILE" | grep "is using log file"|awk '{print $NF}' | sed 's."..g'`
if [ $? -ne 0 ]; then
  echo "ERRORMSG: Fail to get iq log file"
  exit 1
fi
echo "IQ_SYSTEM_LOG $IQ_SYSTEM_LOG" >> $DATA_LOC/config.txt

#Find the PITR location
set +x
echo "Running SQL: select db_property('IQPointInTimeRecoveryLogFilename') "
IQ_PITR_LOC___ACT=`su $OSUSER -c "dbisql -nogui -c '$CONN_STR' $HOST_PORT_OPT \"select db_property('IQPointInTimeRecoveryLogFilename')\" " | awk 'NR==3{print $1}'`
retval=$?
set -x

if [ $retval -ne 0 ]; then
  echo "ERRORMSG: Fail to get IQPointInTimeRecoveryLogFilename"
  exit 1
fi

IQ_PITR_LOC___ACT=`dirname $IQ_PITR_LOC___ACT`
echo "IQ_PITR_LOC___ACT $IQ_PITR_LOC___ACT" >> $DATA_LOC/config.txt

if [ "$CHILD" = "TRUE" ]; then
  sync
  sleep 10
fi

exit 0
