#!/bin/sh

set -x
OSUSER=$OSUSER
SYBIQ_HOME=$SYBIQ_HOME
version=$VERSION
SRC_DB_DBA_USER=$SRC_DB_DBA_USER
set +x
SRC_DB_DBA_PWD=$SRC_DB_DBA_PWD
set -x
DB_NAME=$ACT_NAME
DB_ENG=$DB_ENG
PORTNO=$PORTNO
DBCATALOGFILE=$DBCATALOGFILE

########SET  env########
set +x
. $SYBIQ_HOME/$version/$version.sh
set -x

PWDS=/act/custom_apps/sybaseiq

. /act/custom_apps/sybaseiq/act_sybaseiq_common_functions.sh

#Get vals from SYBASEIQ.xml for now
if [ -z "$DB_ENG" ]; then
  DB_ENG=`grep "name=\"$DB_NAME\" " /act/custom_apps/SYBASEIQ.xml | awk -F"DB_ENG=" '{print $2}' | awk '{print $1}' |sed 's."..g'`
fi
if [ -z "$PORTNO" ]; then
  PORTNO=`grep "name=\"$DB_NAME\" " /act/custom_apps/SYBASEIQ.xml | awk -F"PORTNO=" '{print $2}' | awk '{print $1}' |sed 's."..g'`
fi

isVarNull OSUSER $OSUSER
isVarNull SYBIQ_HOME $SYBIQ_HOME
isVarNull version $version
isVarNull SRC_DB_DBA_USER $SRC_DB_DBA_USER
set +x
isVarNull SRC_DB_DBA_PWD $SRC_DB_DBA_PWD
set -x
isVarNull DB_NAME $DB_NAME
isVarNull DB_ENG $DB_ENG
isVarNull DBCATALOGFILE $DBCATALOGFILE
isVarNull PORTNO $PORTNO

#Check connections
set +x
prepareConnString "$SRC_DB_DBA_USER" "$SRC_DB_DBA_PWD" "$DB_NAME" "$DB_ENG" "$PORTNO"
set -x

set +x
su -m $OSUSER -c "dbisql -nogui -c '$CONN_STR' $HOST_PORT_OPT \"exit\" "
retval=$?
set -x

if [ $retval -ne 0 ]; then
  echo "ERRORMSG: Given username or password is wrong. Please check"
  exit 1
fi

exit 0
