#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#

#Prepare env
for ARGUMENT in "$@"
do
   ARGUMENT="${ARGUMENT%\"}"
   ARGUMENT="${ARGUMENT#\"}"
   argLft=`echo $ARGUMENT|cut -d= -f1`
   argRit=`echo $ARGUMENT|cut -d= -f2`
   export "$argLft=$argRit"
done

usage() {
  echo "Usage: "
  echo "/act/custom_apps/sybaseiq/clone/ACT_SYBASEIQ_mountrecover.sh OSUSER=<OSUSER> CATALOG_DB_FILE=<CATALOG_DB_FILE> SYBIQ_HOME=<SYBIQ_HOME> VERSION=<VERSION> SRC_DB_NAME=<SRC_DB_NAME> TGT_DB_NAME=<TGT_DB_NAME> TARGET_MNT=<TARGET_MNT> INCR_BKP_LOC=<INCR_BKP_LOC> SRC_DB_DBA_USER=<SRC_DB_DBA_USER> [ SRC_DB_DBA_PWD=<SRC_DB_DBA_PWD> ]"
}

isProvided() {
  local varName=$1
  local varVal=$2
  if [ -z "$varVal" ]; then
    echo "ERRORMSG: $varName is empty."
    usage
    exit 1
  fi
}

isProvided OSUSER $OSUSER
isProvided CATALOG_DB_FILE $CATALOG_DB_FILE
isProvided TARGET_MNT $TARGET_MNT
isProvided SRC_DB_NAME $SRC_DB_NAME
isProvided TGT_DB_NAME $TGT_DB_NAME
isProvided SYBIQ_HOME $SYBIQ_HOME
isProvided VERSION $VERSION
isProvided INCR_BKP_LOC $INCR_BKP_LOC
isProvided SRC_DB_DBA_USER $SRC_DB_DBA_USER

set -x
if [ -z "$JOBID" ]; then
  if [ -z "$ACT_JOBNAME" ]; then
    export JOBID=Job_mountrecover
  else
    export JOBID=$ACT_JOBNAME
  fi
fi

#Premount-test
/act/custom_apps/sybaseiq/clone/ACT_SYBASEIQ_premounttest.sh
if [ $? -ne 0 ]; then
  echo "ERRORMSG: premount_test failed"
  exit 1
fi

#Postmount
/act/custom_apps/sybaseiq/clone/ACT_SYBASEIQ_postmount.sh
if [ $? -ne 0 ]; then
  echo "ERRORMSG: Postmount failed"
  exit 1
else
  echo "INFOMSG: Mount recovery is successful"
fi

#Remove temp dirs
if [ -d "/act/touch/$JOBID" ]; then
  rm -rf /act/touch/$JOBID/*
  rmdir /act/touch/$JOBID
fi
