#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================
set -x
OSUSER=$OSUSER
TARGET_MNT=$TARGET_MNT
RECOVERY_TIME=$RECOVERY_TIME
utilitydbuser=$SRC_DB_DBA_USER
set +x
utilitydbpwd=$SRC_DB_DBA_PWD
set -x
SYBIQ_HOME=$SYBIQ_HOME
version=$VERSION
SRC_DB_DBA_USER=$SRC_DB_DBA_USER
set +x
SRC_DB_DBA_PWD=$SRC_DB_DBA_PWD
set -x
DB_NAME=$ACT_NAME
DB_ENG=$DB_ENG
PORTNO=$PORTNO
CATALOG_DB_FILE=$CATALOG_DB_FILE 
PITR_LOG=$PITR_LOG
LOG_BKP_MNTPT=$LOG_BKP_MNTPT

. /act/custom_apps/sybaseiq/act_sybaseiq_common_functions.sh

#Get vals from SYBASEIQ.xml for now
if [ -z "$DB_ENG" ]; then
  DB_ENG=`grep "name=\"$DB_NAME\" " /act/custom_apps/SYBASEIQ.xml | awk -F"DB_ENG=" '{print $2}' | awk '{print $1}' |sed 's."..g'`
fi
if [ -z "$PORTNO" ]; then
  PORTNO=`grep "name=\"$DB_NAME\" " /act/custom_apps/SYBASEIQ.xml | awk -F"PORTNO=" '{print $2}' | awk '{print $1}' |sed 's."..g'`
fi

########SET  env##############
set +x
. $SYBIQ_HOME/$version/$version.sh
set -x
##############################

OSGROUP=`id -ngr $OSUSER`

if [ ! -d /act/touch ];then
  mkdir -p /act/touch
fi

touch /act/touch/restore.sql
touch /act/touch/stopdb.sql
chown -R $OSUSER:$OSGROUP /act/touch
if [ ! -z "$LOG_BKP_MNTPT" ]; then
   chown -R $OSUSER:$OSGROUP $LOG_BKP_MNTPT
fi

dbname=$DB_NAME
dbfile=$CATALOG_DB_FILE
#RESTORE TYPE
RESTORE_TYPE=`ls -ltr $TARGET_MNT/$DB_NAME | grep -v PITR | tail -1 | awk '{print $9}' |xargs`
if [ "$RESTORE_TYPE" = "FULL" ];then
  RESTORE_TYPE=F
else
  RESTORE_TYPE=I
fi 

#Prepare connection string for utility_db
set +x
prepareConnString "$utilitydbuser" "$utilitydbpwd" "utility_db" "utility_db"
set -x

###################  RESTORE ################################  
#connecting to utility server and restoring database
if [ "$RESTORE_TYPE" = "I" ] && [ ! -z "$RECOVERY_TIME" ] ;then
  filename_tmp=`ls -ltr $TARGET_MNT/$DB_NAME/FULL | tail -1 | awk '{print $(NF)}'`
  filename=`echo ${filename_tmp:0:-2}`
  filename_tmp2=`ls -ltr $TARGET_MNT/$DB_NAME/INCR | tail -1 | awk '{print $(NF)}'`
  filename2=`echo ${filename_tmp2:0:-2}`
  echo " RESTORE DATABASE '$dbfile' FROM '$TARGET_MNT/$DB_NAME/FULL/$filename' overwrite existing ; " > /act/touch/restore.sql
  echo "RESTORE DATABASE '$dbfile' FROM '$TARGET_MNT/$DB_NAME/INCR/$filename2' RECOVER UNTIL TIMESTAMP '$RECOVERY_TIME' USING LOG PATH  '$LOG_BKP_MNTPT/$DB_NAME/PITR/'  overwrite existing clear log;" >> /act/touch/restore.sql
  echo "exit;" >> /act/touch/restore.sql
  set +x
  output=`su -m $OSUSER -c "dbisql -nogui -onerror exit -c '$CONN_STR' $HOST_PORT_OPT /act/touch/restore.sql"`
  retval=$?
  set -x
  echo "$output"
  if [ "$retval" -eq 0 ]; then
    echo "INFOMSG: sybaseiq FileSystem recovery completed for $dbname"
  else
    echo "ERRORMSG: sybaseiq FileSystem recovery failed because of $output for $dbname"
    exit $retval
  fi
elif [ "$RESTORE_TYPE" = "I" ] && [ -z "$RECOVERY_TIME" ];then
  filename_tmp=`ls -ltr $TARGET_MNT/$DB_NAME/FULL | tail -1 | awk '{print $(NF)}'`
  filename=`echo ${filename_tmp:0:-2}`
  filename_tmp2=`ls -ltr $TARGET_MNT/$DB_NAME/INCR | tail -1 | awk '{print $(NF)}'`
  filename2=`echo ${filename_tmp2:0:-2}`
  echo " RESTORE DATABASE '$dbfile' from '$TARGET_MNT/$DB_NAME/FULL/$filename' overwrite existing; " > /act/touch/restore.sql
  echo " RESTORE DATABASE '$dbfile' from '$TARGET_MNT/$DB_NAME/INCR/$filename2' overwrite existing clear log; " >> /act/touch/restore.sql
  echo "exit;" >> /act/touch/restore.sql
  set +x 
  output=`su -m $OSUSER -c "dbisql -nogui -onerror exit -c '$CONN_STR' $HOST_PORT_OPT /act/touch/restore.sql"`
  retval=$?
  set -x
  echo "$output"
  if [ "$retval" -eq 0 ]; then
    echo "INFOMSG: sybaseiq FileSystem recovery completed for $dbname"
  else
    echo "ERRORMSG: sybaseiq FileSystem recovery failed because of $output for $dbname"
    exit $retval
  fi
fi

if [ "$RESTORE_TYPE" = "F" ] && [ ! -z "$RECOVERY_TIME" ];then
  filename_tmp=`ls -ltr $TARGET_MNT/$DB_NAME/FULL | tail -1 | awk '{print $(NF)}'`
  filename=`echo ${filename_tmp:0:-2}`
  echo "RESTORE DATABASE '$dbfile' FROM '$TARGET_MNT/$DB_NAME/FULL/$filename' RECOVER UNTIL TIMESTAMP '$RECOVERY_TIME' USING LOG PATH  '$LOG_BKP_MNTPT/$DB_NAME/PITR/'  overwrite existing clear log;" > /act/touch/restore.sql
  echo "exit;" >> /act/touch/restore.sql
  set +x
  output=`su -m $OSUSER -c "dbisql -nogui -onerror exit -c '$CONN_STR' $HOST_PORT_OPT /act/touch/restore.sql"`
  retval=$?
  set -x
  echo "$output"
  if [ $retval -eq 0 ]; then
    echo "INFOMSG: sybaseiq FileSystem recovery completed for $dbname"
  else
    echo "ERRORMSG: sybaseiq FileSystem recovery failed because of $output for $dbname"
    exit $retval
  fi
elif [ "$RESTORE_TYPE" = "F" ] && [  -z "$RECOVERY_TIME" ];then
  filename_tmp=`ls -ltr $TARGET_MNT/$DB_NAME/FULL | tail -1 | awk '{print $(NF)}'`
  filename=`echo ${filename_tmp:0:-2}`
  echo " RESTORE DATABASE '$dbfile' from '$TARGET_MNT/$DB_NAME/FULL/$filename' overwrite existing clear log; " > /act/touch/restore.sql
  echo "exit;" >> /act/touch/restore.sql
  set +x
  output=`su -m $OSUSER -c "dbisql -nogui -onerror exit -c '$CONN_STR' $HOST_PORT_OPT /act/touch/restore.sql"`
  retval=$?
  set -x
  echo "$output"
  if [ $retval -eq 0 ]; then
    echo "INFOMSG: sybaseiq FileSystem recovery completed for $dbname"
  else
    echo "ERRORMSG: sybaseiq FileSystem recovery failed because of $output for $dbname"
    exit $retval
  fi
fi 

#Deleting temp files
rm -f /act/touch/restore.sql
rm -f /act/touch/stopdb.sql 


#Start databases
su -m $OSUSER -c "start_iq -n $DB_ENG $dbfile -x tcpip{port=$PORTNO}"
if [ $? -ne 0 ]; then
  echo "ERRORMSG: Fail to start database after restore"
  exit 1
fi


exit 0
