#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================
set -x
for ARGUMENT in "$@"
do
   ARGUMENT="${ARGUMENT%\"}"
   ARGUMENT="${ARGUMENT#\"}"
   argLft=`echo $ARGUMENT|cut -d= -f1`
   argRit=`echo $ARGUMENT|cut -d= -f2`
   export "$argLft=$argRit"
done

OSUSER=$OSUSER
TARGET_MNT=$TARGET_MNT
RECOVERY_TIME=$RECOVERY_TIME
utilitydbuser=$SRC_DB_DBA_USER
utilitydbpwd=$SRC_DB_DBA_PWD
SYBIQ_HOME=$SYBIQ_HOME
version=$VERSION
SRC_DB_DBA_USER=$SRC_DB_DBA_USER
SRC_DB_DBA_PWD=$SRC_DB_DBA_PWD
DB_NAME=$ACT_NAME
CATALOG_DB_FILE=$CATALOG_DB_FILE 
PITR_LOG=$PITR_LOG
LOG_BKP_MNTPT=$LOG_BKP_MNTPT


########SET  env##############
set +x
. $SYBIQ_HOME/$version/$version.sh
set -x
##############################

OSGROUP=`id -ngr $OSUSER`

if [ ! -d /act/touch ];then
  mkdir -p /act/touch
fi

touch /act/touch/restore.sql
touch /act/touch/stopdb.sql
chown -R $OSUSER:$OSGROUP /act/touch
chown -R $OSUSER:$OSGROUP $LOG_BKP_MNTPT
chown -R $OSUSER:$OSGROUP $TARGET_MNT
chmod -R 775 `dirname $CATALOG_DB_FILE`
chown -R $OSUSER:$OSGROUP `dirname $CATALOG_DB_FILE`
   dbname=$DB_NAME
   dbfile=$CATALOG_DB_FILE
#RESTORE TYPE
   RESTORE_TYPE=`ls -ltr $TARGET_MNT/$DB_NAME | grep -v PITR | tail -1 | awk '{print $9}' |xargs`
  
   if [ "$RESTORE_TYPE" = "FULL" ];then
          RESTORE_TYPE=F
   else
          RESTORE_TYPE=I
   fi 

#checking utility server status
util_status=`ps -ef | grep iqsrv | grep -w utility_db | wc -l`
if [ "$util_status" -eq 0 ] ; then
     echo "ERRORMSG : utility server is not running ! please check logs"
     exit 1
else
     echo " exit;" > /act/touch/exit.sql
     chown -R $OSUSER:$OSGROUP /act/touch/exit.sql
     su -m $OSUSER  -c "dbisql -nogui -onerror exit -c 'uid=$utilitydbuser;pwd=$utilitydbpwd;dbn=utility_db;eng=utility_db;' \"/act/touch/exit.sql\" "
     if [ $? -eq 0 ];then
         echo "utility database connection is success"
     else
     echo "ERRORMSG: Failed to connect utility database ! please check logs for more Details"
     exit 1
     fi
fi


###################  RESTORE ################################  
  #connecting to utility server and restoring database
  if [ "$RESTORE_TYPE" = "I" ] && [ ! -z "$RECOVERY_TIME" ] ;then
    filename_tmp=`ls -ltr $TARGET_MNT/$DB_NAME/FULL | tail -1 | awk '{print $(NF)}'`
    filename=`echo ${filename_tmp:0:-2}`
    filename_tmp2=`ls -ltr $TARGET_MNT/$DB_NAME/INCR | tail -1 | awk '{print $(NF)}'`
    filename2=`echo ${filename_tmp2:0:-2}`
    echo " RESTORE DATABASE '$dbfile' FROM '$TARGET_MNT/$DB_NAME/FULL/$filename' overwrite existing ; " > /act/touch/restore.sql
    echo "RESTORE DATABASE '$dbfile' FROM '$TARGET_MNT/$DB_NAME/INCR/$filename2' RECOVER UNTIL TIMESTAMP '$RECOVERY_TIME' USING LOG PATH  '$LOG_BKP_MNTPT/$DB_NAME/PITR/'  overwrite existing clear log;" >> /act/touch/restore.sql
    echo "exit;" >> /act/touch/restore.sql
    set +x
    output=`su -m $OSUSER -c "dbisql -nogui -onerror exit -c 'uid=$utilitydbuser;pwd=$utilitydbpwd;eng=utility_db;dbn=utility_db;'  /act/touch/restore.sql"`
    retval=$?
    set -x
    echo "$output"
       if [ "$retval" -eq 0 ]
       then
         echo "sybaseiq FileSystem recovery completed for $dbname"
       else
         echo "ERRORMSG: sybaseiq FileSystem recovery failed because of $output for $dbname"
         exit $retval
       fi
  elif [ "$RESTORE_TYPE" = "I" ] && [ -z "$RECOVERY_TIME" ];then
       filename_tmp=`ls -ltr $TARGET_MNT/$DB_NAME/FULL | tail -1 | awk '{print $(NF)}'`
       filename=`echo ${filename_tmp:0:-2}`
       filename_tmp2=`ls -ltr $TARGET_MNT/$DB_NAME/INCR | tail -1 | awk '{print $(NF)}'`
       filename2=`echo ${filename_tmp2:0:-2}`
       echo " RESTORE DATABASE '$dbfile' from '$TARGET_MNT/$DB_NAME/FULL/$filename' overwrite existing; " > /act/touch/restore.sql
       echo " RESTORE DATABASE '$dbfile' from '$TARGET_MNT/$DB_NAME/INCR/$filename2' overwrite existing clear log; " >> /act/touch/restore.sql
       echo "exit;" >> /act/touch/restore.sql
       set +x 
      output=`su -m $OSUSER -c "dbisql -nogui -onerror exit -c 'uid=$utilitydbuser;pwd=$utilitydbpwd;eng=utility_db;dbn=utility_db;'  /act/touch/restore.sql"`
       retval=$?
       set -x
       echo "$output"
       if [ "$retval" -eq 0 ]
       then
         echo "sybaseiq FileSystem recovery completed for $dbname"
       else
         echo "ERRORMSG: sybaseiq FileSystem recovery failed because of $output for $dbname"
         exit $retval
       fi
  fi

  if [ "$RESTORE_TYPE" = "F" ] && [ ! -z "$RECOVERY_TIME" ];then
       filename_tmp=`ls -ltr $TARGET_MNT/$DB_NAME/FULL | tail -1 | awk '{print $(NF)}'`
       filename=`echo ${filename_tmp:0:-2}`
       echo "RESTORE DATABASE '$dbfile' FROM '$TARGET_MNT/$DB_NAME/FULL/$filename' RECOVER UNTIL TIMESTAMP '$RECOVERY_TIME' USING LOG PATH  '$LOG_BKP_MNTPT/$DB_NAME/PITR/'  overwrite existing clear log;" > /act/touch/restore.sql
       echo "exit;" >> /act/touch/restore.sql
       set +x
      output=`su -m $OSUSER -c "dbisql -nogui -onerror exit -c 'uid=$utilitydbuser;pwd=$utilitydbpwd;eng=utility_db;dbn=utility_db;'  /act/touch/restore.sql"`
       retval=$?
       set -x
       echo "$output"
       if [ $retval -eq 0 ]
       then
         echo "sybaseiq FileSystem recovery completed for $dbname"
       else
         echo "ERRORMSG: sybaseiq FileSystem recovery failed because of $output for $dbname"
         exit $retval
       fi
       
  elif [ "$RESTORE_TYPE" = "F" ] && [  -z "$RECOVERY_TIME" ];then

       filename_tmp=`ls -ltr $TARGET_MNT/$DB_NAME/FULL | tail -1 | awk '{print $(NF)}'`
       filename=`echo ${filename_tmp:0:-2}`
       echo " RESTORE DATABASE '$dbfile' from '$TARGET_MNT/$DB_NAME/FULL/$filename' overwrite existing clear log; " > /act/touch/restore.sql
       echo "exit;" >> /act/touch/restore.sql
       set +x
       output=`su -m $OSUSER -c "dbisql -nogui -onerror exit -c 'uid=$utilitydbuser;pwd=$utilitydbpwd;eng=utility_db;dbn=utility_db;'  /act/touch/restore.sql"`
       retval=$?
       set -x
       echo "$output"
       if [ $retval -eq 0 ]
       then
         echo "sybaseiq FileSystem recovery completed for $dbname"
       else
         echo "ERRORMSG: sybaseiq FileSystem recovery failed because of $output for $dbname"
         exit $retval
       fi
  fi 

   #Deleting temp files
    rm -f /act/touch/restore.sql
    rm -f /act/touch/stopdb.sql 
    rm -f /act/touch/exit.sql
 
#Start databases
  eng_name=`echo "$CATALOG_DB_FILE" | cut -d "." -f1`
  eng=`basename $eng_name`
  su -m $OSUSER -c "start_iq -n $eng  $dbfile"

exit 0
