#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================
set -x
OSUSER=$OSUSER
utilitydbuser=$SRC_DB_DBA_USER
set +x
utilitydbpwd=$SRC_DB_DBA_PWD
set -x
SYBIQ_HOME=$SYBIQ_HOME
version=$VERSION
SRC_DB_DBA_USER=$SRC_DB_DBA_USER
set +x
SRC_DB_DBA_PWD=$SRC_DB_DBA_PWD
set -x
DB_NAME=$ACT_NAME
DB_ENG=$DB_ENG
PORTNO=$PORTNO

. /act/custom_apps/sybaseiq/act_sybaseiq_common_functions.sh

#Get vals from SYBASEIQ.xml for now
if [ -z "$DB_ENG" ]; then
  DB_ENG=`grep "name=\"$DB_NAME\" " /act/custom_apps/SYBASEIQ.xml | awk -F"DB_ENG=" '{print $2}' | awk '{print $1}' |sed 's."..g'`
fi
if [ -z "$PORTNO" ]; then
PORTNO=`grep "name=\"$DB_NAME\" " /act/custom_apps/SYBASEIQ.xml | awk -F"PORTNO=" '{print $2}' | awk '{print $1}' |sed 's."..g'`
fi
   
########SET  env########
set +x
. $SYBIQ_HOME/$version/$version.sh
set -x

OSGROUP=`id -ngr $OSUSER`

if [ ! -d /act/touch ];then
  mkdir -p /act/touch
fi

#touch /act/touch/stopdb.sql
chown -R $OSUSER:$OSGROUP /act/touch


#check DB status
DB_STATUS=`ps -ef | grep iqsrv | grep -w $DB_NAME | wc -l`
if [ "$DB_STATUS" -eq 0 ];then
  echo "Database $DB_NAME is not running"
else
  set +x 
  output=`su -m $OSUSER -c  "dbstop -c  'uid=$SRC_DB_DBA_USER;pwd=$SRC_DB_DBA_PWD;eng=$DB_ENG;dbn=$DB_NAME;unc=yes' -y"`
  retval=$?
  set -x
  if [ "$retval" -eq 0 ];then
    echo " Database $DB_NAME stopped successfully !"
  else
    echo "ERRORMSG:Failed to shutdown Database $DB_NAME because of $output"
    exit 1
  fi
fi


#checking utility server status
util_status=`ps -ef | grep iqsrv | grep -w utility_db | wc -l`
if [ "$util_status" -eq 0 ] ; then
  echo "ERRORMSG : utility server is not running ! please check logs"
  exit 1
fi

echo " exit;" > /act/touch/exit.sql
chown -R $OSUSER:$OSGROUP /act/touch/exit.sql
set +x
prepareConnString "$SRC_DB_DBA_USER" "$SRC_DB_DBA_PWD" "utility_db" "utility_db"
set +x
su -m $OSUSER  -c "dbisql -nogui -onerror exit -c '$CONN_STR' $HOST_PORT_OPT \"/act/touch/exit.sql\" "
set -x
if [ $? -eq 0 ];then
  echo "INFOMSG: utility database connection is success"
else
  echo "ERRORMSG: Failed to connect utility database ! please check logs for more Details"
  exit 1
fi

#Deleting tempfiles
rm -f /act/touch/stopdb.sql
rm -f /act/touch/exit.sql


exit 0
