#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================
set -x
OSUSER=$OSUSER
SRC_DB_DBA_USER=$SRC_DB_DBA_USER
set +x
SRC_DB_DBA_PWD=$SRC_DB_DBA_PWD
set -x
SRC_DB_ENG=$SRC_DB_NAME
DUMPSCHEDULE=$DUMPSCHEDULE
TARGET_MNT=$DUMPBKPLOC
DB_NAME=$ACT_NAME
DB_ENG=$DB_ENG
PORTNO=$PORTNO
SYBIQ_HOME=$SYBIQ_HOME
version=$VERSION

. /act/custom_apps/sybaseiq/act_sybaseiq_common_functions.sh

#Get vals from SYBASEIQ.xml for now
if [ -z "$DB_ENG" ]; then
  DB_ENG=`grep "name=\"$DB_NAME\" " /act/custom_apps/SYBASEIQ.xml | awk -F"DB_ENG=" '{print $2}' | awk '{print $1}' |sed 's."..g'`
fi
if [ -z "$PORTNO" ]; then
  PORTNO=`grep "name=\"$DB_NAME\" " /act/custom_apps/SYBASEIQ.xml | awk -F"PORTNO=" '{print $2}' | awk '{print $1}' |sed 's."..g'`
fi

###########SET  env###########
set +x
. $SYBIQ_HOME/$version/$version.sh
set -x

if [ ! -d /act/touch ] ; then
  mkdir -p /act/touch
fi


#create sql file
createsqlfile(){
  if [ "$BACKUP_FLAG" = "full" ];then
    echo " backup database $BACKUP_FLAG to '$TARGET_MNT/$DB_NAME/FULL/FULL_$DT.dump'; " > /act/touch/backup.sql
    echo "exit;" >> /act/touch/backup.sql
  else
    echo " backup database $BACKUP_FLAG to '$TARGET_MNT/$DB_NAME/INCR/INCR_$DT.dump'; " > /act/touch/backup.sql
    echo "exit;" >> /act/touch/backup.sql
  fi
}

#DUMP
if [ "$DUMPSCHEDULE" = "F" ]; then
  DUMPSCHEDULE="F"
elif [ "$PREVDBFULLDUMPSAMEDAY" = "TRUE" ]; then
  DUMPSCHEDULE="I"
else
  weekday=`date +%w`
  DUMPSCHEDULE=`expr substr  "$DUMPSCHEDULE" $weekday 1`
fi

#creating database backup directories on $TARGET_MNT
if [ ! -d $TARGET_MNT/$DB_NAME ]; then
  mkdir -p $TARGET_MNT/$DB_NAME/FULL
  mkdir -p $TARGET_MNT/$DB_NAME/INCR
  mkdir -p $TARGET_MNT/$DB_NAME/PITR
fi

TARGET_MNT_TMP=$TARGET_MNT/$DB_NAME
CHECK_FULL_BKP=`ls $TARGET_MNT_TMP/FULL |wc -l`

if [ "$CHECK_FULL_BKP" -eq 0 ]; then
  DUMPSCHEDULE=F
fi

DT=`date +%Y%m%d_%H:%M:%S`

#Change ownership of new loaction
OSGROUP=`id -gnr $OSUSER`
touch /act/touch/backup.sql
chown -R $OSUSER:$OSGROUP $TARGET_MNT
chown -R $OSUSER:$OSGROUP /act/touch/backup.sql

# Prepare DB connection
set +x
prepareConnString "$SRC_DB_DBA_USER" "$SRC_DB_DBA_PWD" "$DB_NAME" "$DB_ENG" "$PORTNO"
set -x

# Log switch
switchLog $TARGET_MNT/$DB_NAME/PITR
if [ $? -ne 0 ] ; then
   echo "ERRORMSG: Failed to switch log before backup"
   exit 1
fi

#Backup
if [ "$DUMPSCHEDULE" = "F" ]; then
  BACKUP_FLAG=full
  createsqlfile
  set +x
  output=`su -m $OSUSER -c "dbisql -nogui -onerror exit -c '$CONN_STR' $HOST_PORT_OPT /act/touch/backup.sql"`
  retval=$?
  set -x
  echo " $output"
  if [ "$retval" -eq 0 ];then
    echo "Database $DB_NAME full backup completed successfully"
  else
    echo "ERRORMSG: Failed to take Full Backup for $DB_NAME because of $output"
    exit $retval
  fi  
elif [ "$DUMPSCHEDULE" = "I" ]; then
  BACKUP_FLAG="incremental since full"
  createsqlfile
  set +x 
  output=`su -m $OSUSER -c "dbisql -nogui -onerror exit -c '$CONN_STR' $HOST_PORT_OPT /act/touch/backup.sql"`
  retval=$?
  set -x
  echo "$output"
  if [ "$retval" -eq 0 ];
    then
    echo "Database $DB_NAME Incremental backup completed successfully"
  else
    echo "ERRORMSG: Failed to take Incremental Backup for $DB_NAME because of $output"
    exit $retval
  fi 
fi   

#Deleting Temp Backup sqlfile
rm -f /act/touch/backup.sql


exit 0
