#!/bin/sh

set -x
OSUSER=$OSUSER
SYBIQ_HOME=$SYBIQ_HOME
version=$VERSION
SRC_DB_NAME=$SRC_DB_NAME
DBCATALOGFILE=$CATALOG_DB_FILE
ACT_JOBNAME=$JOBID
utilitydbuser=$SRC_DB_DBA_USER
set +x
utilitydbpwd=$SRC_DB_DBA_PWD
set -x
FULL_VIR_BKP_LOC=$FULL_VIR_BKP_LOC
INCR_BKP_LOC=$INCR_BKP_LOC

#FULL_VIR_BKP_LOC=`echo ${FULL_VIR_BKP_LOC:0:-2}`
#INCR_BKP_LOC=`echo ${INCR_BKP_LOC:0:-2}`

#Get envdetails
OSGROUP=`id -gn $OSUSER`
IQSRV_CMD=`ps -A -o command | grep iqsrv | awk '{print $1}' | sort|uniq |grep -v grep`
SYBIQ_HOME=`dirname $IQSRV_CMD`
SYBIQ_HOME=$SYBIQ_HOME/../..
version=`echo $IQSRV_CMD| rev| cut -d/ -f3| rev`

########SET  env########
set +x
. $SYBIQ_HOME/$version/$version.sh
set -x

. /act/custom_apps/sybaseiq/act_sybaseiq_common_functions.sh

#Get vals from SYBASEIQ.xml for now
if [ -z "$DB_ENG" ]; then
  DB_ENG=`grep "name=\"$SRC_DB_NAME\" " /act/custom_apps/SYBASEIQ.xml | awk -F"DB_ENG=" '{print $2}' | awk '{print $1}' |sed 's."..g'`
fi
if [ -z "$PORTNO" ]; then
  PORTNO=`grep "name=\"$SRC_DB_NAME\" " /act/custom_apps/SYBASEIQ.xml | awk -F"PORTNO=" '{print $2}' | awk '{print $1}' |sed 's."..g'`
fi


#Check db running or not
isDB_running $SRC_DB_NAME
if [ $? -ne 0 ]; then
  echo "Database is not running"
  exit 0
fi

if [ "$TLS_ENABLED" = "TRUE" ]; then
  TLS_ENC="Encryption=TLS(trusted_certificates=NONE)"
else
  TLS_ENC=
fi

#Stop database
set +x
su -m $OSUSER -c "dbstop -c 'uid=$SRC_DB_DBA_USER;pwd=$SRC_DB_DBA_PWD;eng=$DB_ENG;dbn=$SRC_DB_NAME;unc=yes;$TLS_ENC' -y"
retval=$?
set -x

if [ $retval -ne 0 ];then
  echo "ERRORMSG: Fail to shutdown the database $SRC_DB_NAME"
  exit 1
else
  echo "Successfully stoped database $SRC_DB_NAME"
fi

exit 0
