#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================
set -x

set -x
OSUSER=$OSUSER
SYBIQ_HOME=$SYBIQ_HOME
version=$VERSION
SRC_DB_NAME=$SRC_DB_NAME
TGT_DB_NAME=$TGT_DB_NAME
CATALOG_DB_FILE=$CATALOG_DB_FILE
ACT_JOBNAME=$JOBID
TARGET_MNT=$TARGET_MNT
utilitydbuser=$SRC_DB_DBA_USER
set +x
utilitydbpwd=$SRC_DB_DBA_PWD
set -x
FULL_VIR_BKP_LOC=$FULL_VIR_BKP_LOC
INCR_BKP_LOC=$INCR_BKP_LOC
DB_ENG=$DB_ENG
PORTNO=$PORTNO


#Get envdetails
OSGROUP=`id -gn $OSUSER`
IQSRV_CMD=`ps -A -o command | grep iqsrv | awk '{print $1}' | sort|uniq |grep -v grep`
SYBIQ_HOME=`dirname $IQSRV_CMD`
SYBIQ_HOME=$SYBIQ_HOME/../..
version=`echo $IQSRV_CMD| rev| cut -d/ -f3| rev`

########SET  env########
set +x
. $SYBIQ_HOME/$version/$version.sh
set -x

OSGROUP=`id -ngr $OSUSER`

. /act/custom_apps/sybaseiq/act_sybaseiq_common_functions.sh

#Get vals from SYBASEIQ.xml for now
if [ -z "$DB_ENG" ]; then
  DB_ENG=`grep "name=\"$DB_NAME\" " /act/custom_apps/SYBASEIQ.xml | awk -F"DB_ENG=" '{print $2}' | awk '{print $1}' |sed 's."..g'`
fi
if [ -z "$PORTNO" ]; then
  PORTNO=`grep "name=\"$DB_NAME\" " /act/custom_apps/SYBASEIQ.xml | awk -F"PORTNO=" '{print $2}' | awk '{print $1}' |sed 's."..g'`
fi

#Check db running or not
isDB_running $TGT_DB_NAME
if [ $? -eq 0 ]; then
  DB_EXISTS=YES
else
  DB_EXISTS=NO
fi

#checking utility server status
util_status=`ps -ef | grep iqsrv | grep -w utility_db | wc -l`
if [ "$util_status" -eq 0 ] ; then
  echo "ERRORMSG : utility server is not running ! please check logs"
  exit 1
fi

#Prepare connection string
set +x
prepareConnString "$utilitydbuser" "$utilitydbpwd" "utility_db" "utility_db"
set -x

#Check utility server credientials
set +x
su -m $OSUSER  -c "dbisql -nogui -onerror exit -c \"$CONN_STR\" $HOST_PORT_OPT \"exit;\" "
retval=$?
set -x

if [ $retval -ne 0 ];then
  echo "ERRORMSG: Failed to connect utility database ! please check logs for more Details"
  exit 1
fi

exit 0
