#!/bin/sh

#Prepare env
for ARGUMENT in "$@"
do
   ARGUMENT="${ARGUMENT%\"}"
   ARGUMENT="${ARGUMENT#\"}"
   argLft=`echo $ARGUMENT|cut -d= -f1`
   argRit=`echo $ARGUMENT|cut -d= -f2`
   export "$argLft=$argRit"
done

usage() {
  echo "Usage: "
  echo "/act/custom_apps/sybaseiq/restore/act_sybaseiq_lvm_customdb_recovery.sh TARGET_MNT=<TARGET_MNT> OSUSER=<OSUSER> CATALOG_DB_FILE=<CATALOG_DB_FILE> INCR_BKP_LOC=<INCR_BKP_LOC> SRC_DB_DBA_USER=<SRC_DB_DBA_USER> SRC_DB_DBA_PWD=<SRC_DB_DBA_PWD> [ LOG_BKP_MNTPT=<LOG_BKP_MNTPT> RECOVERY_TIME=\"<RECOVERY_TIME>\" ] [ JOBID=<JOBID> ]"
}

isProvided() {
  local varName=$1
  local varVal=$2
  if [ -z "$varVal" ]; then
    echo "ERRORMSG: $varName is empty."
    usage
    exit 1
  fi
}

isProvided TARGET_MNT $TARGET_MNT
isProvided OSUSER $OSUSER
isProvided CATALOG_DB_FILE $CATALOG_DB_FILE
isProvided SRC_DB_DBA_USER $SRC_DB_DBA_USER
isProvided SRC_DB_DBA_PWD $SRC_DB_DBA_PWD
isProvided INCR_BKP_LOC $INCR_BKP_LOC
if [ ! -z "$RECOVERY_TIME" ];then
  LOG_BKP_MNTPT=$LOG_BKP_MNTPT
fi

SRC_DB_NAME=`echo $CATALOG_DB_FILE | awk -F"/" '{print $NF}' | cut -d. -f1`
export SRC_DB_NAME=$SRC_DB_NAME

set -x

#Get envdetails
OSGROUP=`id -gn $OSUSER`
IQSRV_CMD=`ps -A -o command | grep iqsrv | awk '{print $1}' | sort|uniq |grep -v grep`
SYBIQ_HOME=`dirname $IQSRV_CMD`
SYBIQ_HOME=$SYBIQ_HOME/../..
version=`echo $IQSRV_CMD| rev| cut -d/ -f3| rev`
DATA_LOC=`dirname $CATALOG_DB_FILE`
FULL_VIR_BKP_LOC=$DATA_LOC/FULL_VIR_DEC

#Copy files back to source
while read line; do
  logicName=`echo $line | awk '{print $1}'`
  if [ "$logicName" = "IQ_PITR_LOC___ACT" ]; then
    continue
  fi
  origFile=`echo $line | awk '{print $2}'`
  if [ "${origFile:0:1}" != "/"  ]; then
    origFile=$DATA_LOC/$origFile
  fi
  mntFile=$TARGET_MNT$origFile

  cp -p $TARGET_MNT$origFile $origFile
  if [ $? -ne 0 ]; then
    echo "ERRORMSG: Fail to restore file $origFile"
    exit 1
  fi

  chown $OSUSER:$OSGROUP $origFile
done < $TARGET_MNT$DATA_LOC/config.txt

cp -p $TARGET_MNT$DATA_LOC/config.txt $DATA_LOC/
if [ $? -ne 0 ]; then
  echo "ERRORMSG: Fail to copy files"
  exit 1
fi
cp -p $TARGET_MNT$DATA_LOC/FULL_VIR_DEC* $DATA_LOC/
if [ $? -ne 0 ];then
  echo "ERRORMSG: Fail to copy files"
  exit 1
fi

chown -R $OSUSER:$OSGROUP $DATA_LOC

#Call postrestore script
/act/custom_apps/sybaseiq/restore/ACT_SYBASEIQ_postrestore.sh
if [ $? -ne 0 ]; then
  echo "ERRORMSG: Fail to restore database on newTarget"
  exit 1
fi
