#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
#                  !!!Actifio Private Script. DO NOT MODIFY!!!
#
# ==============================================================================#

usage() {
  echo "Usage: "
  echo "/act/custom_apps/db2/CALL_ACT_DB2_lvm_migrate.sh \"\" \" <TARGET_DBNAME_LIST> <JOBID> <SOURCE_INSTANCE> <DATAVOL_DISK_MAPPING> <ARCHIVELOG_LOC>\""
}

isProvided() {
  local varName=$1
  local varVal=$2
  if [ -z "$varVal" ]; then
    echo "ERRORMSG: $varName is empty."
    usage
    exit 1
  fi
}

set -x

APPREMOUNT="FALSE"

TARGET_DBNAME_LIST=$2
JOBID=$3
SOURCE_INSTANCE=$4
DATAVOL_DISK_MAPPING=$5
ARCHIVELOG_LOC=$6

DATAVOL_DISK_MAPPING=$DATAVOL_DISK_MAPPING
SOURCE_INSTANCE=$SOURCE_INSTANCE
TARGET_DBNAME_LIST=$TARGET_DBNAME_LIST
JOBID=$JOBID
OSUSER=$SOURCE_INSTANCE
ARCHIVELOG_LOC=$ARCHIVELOG_LOC


isProvided DATAVOL_DISK_MAPPING $DATAVOL_DISK_MAPPING
isProvided JOBID $JOBID
isProvided ARCHIVELOG_LOC $ARCHIVELOG_LOC
isProvided TARGET_DBNAME_LIST $TARGET_DBNAME_LIST

if [ ! -d "$ARCHIVELOG_LOC" ];then
     mkdir -p $ARCHIVELOG_LOC
fi
 
TARGET_DBNAME_LIST=`echo $TARGET_DBNAME_LIST | sed 's/::/,/g'`
DATAVOL_DISK_MAPPING=`echo $DATAVOL_DISK_MAPPING| sed 's/::/,/g'`
export SOURCE_INSTANCE
export OSUSER

echo "***** Calling lvm_migrate (/act/custom_apps/db2/restore/ACT_DB2_lvm_migrate_newtarget.sh) *****"
/act/custom_apps/db2/restore/ACT_DB2_lvm_migrate_newtarget.sh TARGET_DBNAME_LIST=$TARGET_DBNAME_LIST JOBID=$JOBID DATAVOL_DISK_MAPPING=$DATAVOL_DISK_MAPPING  ARCHIVELOG_LOC=$ARCHIVELOG_LOC
if [ $? -ne 0 ]; then
  echo "ERRORMSG: Fail to migrate applicatoin from Actifio storage to Target storage."
  exit 1
fi

exit 0
