#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
#                  !!!Actifio Private Script. DO NOT MODIFY!!!
#
# ==============================================================================#

isProvided() {
  local varName=$1
  local varVal=$2
  if [ -z "$varVal" ]; then
    echo "ERRORMSG: $varName is empty."
    usage
    exit 1
  fi
}

usage() {
  echo "Usage: "
  echo "/act/custom_apps/db2/CALL_ACT_DB2_newtargetdumprestore.sh \"\" \"  <DB_LIST> <TARGET_MNT>   [ <UNTIL_TIME> ]\" "
  exit 1 
}

set -x

echo "***************** POSTSKJOB_TYPE= $ACT_JOBTYPE *********************"

if [ "$ACT_JOBTYPE" = "unmount" ] || [ "$ACT_MULTI_OPNAME" = "unmount" ] ; then
   echo "NO-OP for post-script when unmount"
   exit 0
fi
if [ "$ACT_JOBTYPE" = "mount" ] || [ "$ACT_MULTI_OPNAME" = "mount" ] ; then
   if [ "$ACT_PHASE" = "pre" ] ; then
        echo "** No op for pre during unmount **"
      exit
   fi
   if [ "$ACT_PHASE" = "post" ] ; then
        echo "************************* start post during mount ************************"

DB_LIST=$2
TARGET_MNT=$3
UNTIL_TIME=$4

DB_LIST=`echo $DB_LIST |sed 's/::/,/g'`

SOURCE_INSTANCE=$SOURCE_INSTANCE	
DB_LIST=$DB_LIST		
TARGET_MNT=$TARGET_MNT	
ARCHIVELOG_MNT=$ARCHIVELOG_MNT		
SOURCE_LOGARCHMETH1=$SOURCE_LOGARCHMETH1
UNTIL_TIME=$UNTIL_TIME		


set +x
isProvided DB_LIST $DB_LIST
isProvided TARGET_MNT $TARGET_MNT

JOBID=$ACT_JOBNAME
export JOBID
export ACT_JOBNAME


if [ ! -z "$UNTIL_TIME" ]; then
  isProvided UNTIL_TIME $UNTIL_TIME
fi
set -x


echo "********** call DB2 recovery ************"
/act/custom_apps/db2/dump/ACT_DB2_dumprestore_newTarget.sh  TARGET_MNT=$TARGET_MNT DB_LIST=$DB_LIST   UNTIL_TIME=$UNTIL_TIME
retval=$?

if [ $retval -ne 0 ]; then
    echo "ERRORMSG: fail to perform dump restore new target"
    exit $retval
fi

echo "********** end DB2  recover with exit code: $retval ************"
exit 0
fi
fi

