#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
#                  !!!Actifio Private Script. DO NOT MODIFY!!!
#
# ==============================================================================#

set -x

WPWD=/act/custom_apps/saphana/lvm_migrate
JOB_PHASE=$1
DBSID=$2
PROD_DATAVOL=$3
PROD_LOGVOL=$4

echo "********* Job Phase is: $JOB_PHASE *************"

if [ ! -z "$DBSID" ] && [ ! -z "$PROD_DATAVOL" ] && [ ! -z "$PROD_LOGVOL" ]; then
   $WPWD/ACT_HANADB_lvm_migrate.sh $DBSID $PROD_DATAVOL $PROD_LOGVOL
   retval=$?
else
  echo "ERRORMSG: Required input parameters are missing. Please check the usage!"
  echo "$WPWD/ACT_HANADB_lvm_migrate.sh <dbsid> <PROD DATA VOLUME> <PROD LOG COLUME>"
   exit 1
fi

if [ $retval -ne 0 ]; then
    echo "ERRORMSG: Migration Failed: check error messages for details."
    exit $retval
fi

exit 0
