#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
#                  !!!Actifio Private Script. DO NOT MODIFY!!!
#
# ==============================================================================#

set -x

WPWD=/act/custom_apps/saphana/clone

DBSID=$2
ACT_MOUNT_POINTS=$3
DBUSER=$4
HANAVERSION=$5
LOGMOUNTPATH=$6
RECOVERYTIME="$7"

PARAMETER_FILE=/act/touch/"$DBSID"_mount_params

if [ -f "/act/touch/"$ACT_JOBNAME"_mount_params" ]; then
   rm -f /act/touch/"$ACT_JOBNAME"_mount_params
fi

if [ -f "$PARAMETER_FILE" ]; then
   source $PARAMETER_FILE
else
   exit 0
fi

if [ -z "$OLDDBSID" ]; then
   OLDDBSID=$DBSID
fi
APPREMOUNT="FALSE"

if [ "$#" -lt 1 ]; then
      echo "Some required parameters are missing, Please check the usage for details!"
      echo "/act/scripts/CALL_ACT_HANADB_mountrecover.sh <DBSID> <TARGET MOUNT POINT> <DB USER> <HANA VERSION> <DATA PATH> <LOG PATH> <SOURCE LOCATION> [OLD DBSID] [LOGMOUNT PATH] [RECOVERY TIME]"
      exit 1
fi


$WPWD/ACT_HANADB_mountrecover.sh $DBSID $ACT_MOUNT_POINTS $DBUSER $HANAVERSION $DATAVOLPATH $LOGVOLPATH $OLDDBSID $LOGMOUNTPATH "$RECOVERYTIME"

retval=$?
if [ $retval -ne 0 ]; then
    echo "ERRORMSG: Failed to recover $DBSID database: check error messages for details."
    exit $retval
fi

exit 0

