#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
#                  !!!Actifio Private Script. DO NOT MODIFY!!!
#
# ==============================================================================#

set -x

WPWD=/act/custom_apps/saphana/clone
PARAMETER_FILE=/act/touch/"$ACT_JOBNAME"_mount_params

DBSID=$2
ACT_MOUNT_POINTS=$3
DBUSER=$4
HANAVERSION=$5
SOURCE_TARGET_DEST=$6
LOGMOUNTPATH=$7
RECOVERYTIME="$8"

if [ -z "$OLDDBSID" ]; then
   OLDDBSID=$DBSID
fi

if [ -f "$PARAMETER_FILE" ]; then
   source $PARAMETER_FILE
   rm -rf $PARAMETER_FILE
else
   exit 0
fi

APPREMOUNT="FALSE"

if [ "$#" -lt 1 ]; then
      echo "Some required parameters are missing, Please check the usage for details!"
      echo "./CALL_ACT_HANADB_newtargetrestore.sh <DBSID> <TARGET MOUNT POINT> <DB USER> <HANA VERSION> <DATA PATH> <LOG PATH> <SOURCE LOCATION> [OLD DBSID] [LOGMOUNT PATH] [RECOVERY TIME]"
      exit 1
fi

osuser=$DBSID'adm'
OLDDBSID_TEMP=`echo $OLDDBSID | tr '[a-z]' '[A-Z]'`

datapath=`dirname $DATAVOLPATH`
logpath=`dirname $LOGVOLPATH`

target_datapath=`echo $SOURCE_TARGET_DEST|awk -F":" '{print $1}'`
target_logpath=`echo $SOURCE_TARGET_DEST|awk -F":" '{print $2}'`

if [ ! -z "$target_datapath" ] && [ ! -z "$target_logpath" ]; then
   if [ -d $target_datapath/$OLDDBSID_TEMP ] || [ -d $target_logpath/$OLDDBSID_TEMP ]; then
          rm -rf $target_datapath/$OLDDBSID_TEMP
          rm -rf $target_logpath/$OLDDBSID_TEMP
   fi
fi
mkdir -p $target_datapath $target_logpath
cp -Rv $datapath/* $target_datapath/
cp -Rv $logpath/* $target_logpath/

newmount_data=`echo $target_datapath |awk -F "/" '{print $2}'`
newmount_log=`echo $target_logpath |awk -F "/" '{print $2}'`
if [ ! -z "$newmount_data" ]; then
   chown -R $osuser:sapsys /"$newmount_data"
fi
if [ ! -z "$newmount_log" ]; then
   chown -R $osuser:sapsys /"$newmount_log"
fi

if [ $? -gt 0 ]; then
   echo "ERRORMSG: Found error copy process, please check the error messages!"
   exit 1
fi


target_datapath=$target_datapath/$OLDDBSID_TEMP
target_logpath=$target_logpath/$OLDDBSID_TEMP

$WPWD/ACT_HANADB_mountrecover.sh $DBSID $target_datapath $DBUSER $HANAVERSION $target_datapath $target_logpath $OLDDBSID $LOGMOUNTPATH "$RECOVERYTIME"

retval=$?
if [ $retval -ne 0 ]; then
    echo "ERRORMSG: Failed to recover $DBSID database: check error messages for details."
    exit $retval
fi

exit 0

