#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
#                  !!!Actifio Private Script. DO NOT MODIFY!!!
#
# ==============================================================================#

export COLUMNS=4000
unset LANG
unset LC_ALL

usage() {
  echo "Usage: "
  echo "/act/scripts/CALL_ACT_SYBASE_lvm_migrate.sh \"\" <DATAVOL_DISK_MAPPING> <TARGET_SERVER_NAME> <TARGET_DBNAME_LIST> <TARGET_DB_USER> <TARGET_DBUSER_PASSWD/null> <TARGET_DBUSER_OTHERCRED/null> <JOBID>"
}

isProvided() {
  local varName=$1
  local varVal=$2
  if [ -z "$varVal" ]; then
    echo "ERRORMSG: $varName is empty."
    usage
    exit 1
  fi
}

set -x

APPREMOUNT="FALSE"
#PARAMETER_FILE=/act/touch/"$ACT_JOBNAME"_mount_params

# Read the arguments
DATAVOL_DISK_MAPPING=$2
TARGET_SERVER_NAME=$3
TARGET_DBNAME_LIST=$4
TARGET_DB_USER=$5
set +x
TARGET_DBUSER_PASSWD=$6
set -x
TARGET_DBUSER_OTHERCRED=$7
JOBID=$8


set +x
isProvided DATAVOL_DISK_MAPPING $DATAVOL_DISK_MAPPING
isProvided TARGET_SERVER_NAME $TARGET_SERVER_NAME
isProvided TARGET_DB_USER $TARGET_DB_USER
isProvided TARGET_DBNAME_LIST $TARGET_DBNAME_LIST
isProvided JOBID $JOBID
if [ -z "$TARGET_DBUSER_PASSWD" ] && [ -z "$TARGET_DBUSER_OTHERCRED" ]; then
  echo "ERRORMSG: Both TARGET_DBUSER_PASSWD and TARGET_DBUSER_OTHERCRED are not provided. Need at least one of these two."
  exit 1
fi
set -x

#Update DATAVOL_DISK_MAPPING, to make it comma(,) seperated insteadn of double colone(::) seperated
DATAVOL_DISK_MAPPING=`echo $DATAVOL_DISK_MAPPING |sed 's/::/,/g'`
TARGET_DBNAME_LIST=`echo $TARGET_DBNAME_LIST |sed 's/::/,/g'`

#As db names in upper case with appaware mount, converting to upper case from user input
#TARGET_DBNAME_LIST=`echo $TARGET_DBNAME_LIST | tr 'a-z' 'A-Z' `

echo "***** Calling lvm_migrate (/act/custom_apps/sybase/lvm_migrate/ACT_SYBASE_lvm_migrate_newTarget.sh) *****"
set +x
/act/custom_apps/sybase/lvm_migrate/ACT_SYBASE_lvm_migrate_newTarget.sh TARGET_SERVER_NAME=$TARGET_SERVER_NAME TARGET_DB_USER=$TARGET_DB_USER TARGET_DBUSER_PASSWD=$TARGET_DBUSER_PASSWD TARGET_DBNAME_LIST=$TARGET_DBNAME_LIST JOBID=$JOBID DATAVOL_DISK_MAPPING=$DATAVOL_DISK_MAPPING TARGET_DBUSER_OTHERCRED=$TARGET_DBUSER_OTHERCRED
if [ $? -ne 0 ]; then
  echo "ERRORMSG: Fail to migrate applicatoin from Actifio storage to Target storage."
  exit 1
fi
set -x

exit 0
