#!/bin/sh


conffile="/act/scripts/act_sybase_lvm_singledb_restore_config.conf"

echo -e '#Sybase DB/Logbackup Specific Params' > $conffile
for ARGUMENT in "$@"
do
   ARGUMENT="${ARGUMENT%\"}"
   ARGUMENT="${ARGUMENT#\"}"
   passwdstrCheck=`echo $ARGUMENT | grep -i "password\|passwd"`
   if [ -z "$passwdstrCheck" ]; then
     echo -e $ARGUMENT >> $conffile
   else
     export $ARGUMENT
   fi
done

source $conffile

set -x
OSUSER=$OSUSER
TARGET_SYBASE_SQLD=$TARGET_SYBASE_SQLD
TARGET_MNT_PNT=$TARGET_MNT_PNT
TARGET_SERVER_NAME=$TARGET_SERVER_NAME
TARGET_DB_USER=$TARGET_DB_USER
set +x
TARGET_DBUSER_PASSWD=$TARGET_DBUSER_PASSWD
set -x
SRC_DBNAME=$SRC_DBNAME

LOG_BKP_MNTPT=$LOG_BKP_MNTPT
#BEGIN_TIME=$BEGIN_TIME
UNTIL_TIME=$UNTIL_TIME
if [ -z "$ACT_JOBNAME" ]; then
  ACT_JOBNAME=$JOBID
fi

set +x
if [ -z "$TARGET_DBUSER_PASSWD" ]; then
  TARGET_DBUSER_PASSWD=`su - $OSUSER -c "/sybase/"$TARGET_SERVER_NAME"/dba/bin/dbbp MaGiCpW"`
  if [ -z "$TARGET_DBUSER_PASSWD" ]; then
    echo " Error : ISQL Password cannot be empty."
    exit 1
  fi
fi

TARGET_ESC_PASSWD=`printf '%q' "$TARGET_DBUSER_PASSWD"`
set -x

MANIFEST_FILE_LOC=$(find $TARGET_MNT_PNT/ -iname manifest_file_$SRC_DBNAME.dat -printf "%T+\t%p\n" | sort | tail -n 1 | awk -F" " '{print $NF}' | rev | cut -d"/" -f2-  | rev)
if [ -z "$MANIFEST_FILE_LOC" ]; then
    echo "Error: No Manifest file found at location $TARGET_MNT_PT"
    exit 1
fi

tmp_loc=/act/touch/$ACT_JOBNAME/tempDir
if [ ! -d "$tmp_loc" ]; then
   mkdir -p $tmp_loc
fi

find /act -type d -exec chmod 755 {} +

#MANIFEST_FILE_BASE=$TARGET_MNT_PNT$MANIFEST_FILE_LOC
MANIFEST_FILE_LOC=$MANIFEST_FILE_LOC"/Manifest_File_"$SRC_DBNAME".dat"

#------------------------------------------------------------
# function unmountDB()
#------------------------------------------------------------
unmountDB() {
  set +x
  su - $OSUSER -c "isql -U$TARGET_DB_USER -P$TARGET_ESC_PASSWD -S$TARGET_SERVER_NAME -X --retserverror" <<EOF
use master
go
unmount database $srcDB to '$UNMNT_SRC_MF$srcDB'
go
EOF
  retval=$?
  set -x

  if [ $retval -gt "0" ]; then
    echo "ERRORMSG: Unmount database command Failed!"
    #exit 1
    dropDB
  fi
}
#------------------------------------------------------------

#------------------------------------------------------------
# function dropDB()
#------------------------------------------------------------
dropDB() {
  echo "Droping database: $srcDB"
  set +x
  su - $OSUSER -c "isql -U$TARGET_DB_USER -P$TARGET_ESC_PASSWD -S$TARGET_SERVER_NAME -X --retserverror -n -b -w 2000 -o $tmp_loc/dbdetails" <<EOF
use master
go
set nocount on
go
select db.name,db.dbid,u.vdevno,dv.name,dv.phyname from sysdatabases db, sysusages u, sysdevices dv where db.dbid=u.dbid and u.vdevno=dv.vdevno
go
EOF
  retval=$?
  set -x

  drpDev=`grep -w $srcDB $tmp_loc/dbdetails| awk '{print $4}' |xargs`
  echo "Droping device: $drpDev"

  set +x
  su - $OSUSER -c "isql -U$TARGET_DB_USER -P$TARGET_ESC_PASSWD -S$TARGET_SERVER_NAME -X --retserverror -n -b -w 2000 -o $tmp_loc/dbdetails" <<EOF
use master
go
drop database $srcDB
go
EOF
  retval=$?
  set -x

  if [ $retval -ne 0 ]; then
    echo "ERRORMSG: Fail to drop database $srcDB"
    #exit 1
  fi

  for lDev in $drpDev
  do
    set +x
    su - $OSUSER -c "isql -U$TARGET_DB_USER -P$TARGET_ESC_PASSWD -S$TARGET_SERVER_NAME -X --retserverror -n -b -w 2000 -o $tmp_loc/dbdetails" <<EOF
use master
go
sp_dropdevice $lDev
go
EOF
    retval=$?
    set -x

    if [ $retval -ne 0 ]; then
      echo "ERRORMSG: Fail to drop device $lDev"
      #exit 1
    fi
  done
}
#------------------------------------------------------------

#------------------------------------------------------------
# function dbDetails()
#------------------------------------------------------------
dbDetails() {
  set +x
  su - $OSUSER -c "isql -U$TARGET_DB_USER -P$TARGET_ESC_PASSWD -S$TARGET_SERVER_NAME -X -e -n -b -w 2000 -o $DB_DETAILS --retserverror" <<EOF
use master
go
set nocount on
go
select db.name,db.dbid,u.vdevno,dv.name,dv.phyname from sysdatabases db, sysusages u, sysdevices dv Where db.dbid=u.dbid and u.vdevno=dv.vdevno
go
EOF
  retval=$?
  set -x

  if [ $retval -gt 0 ]; then
    echo "ERRORMSG: fail to get db details"
    exit 1
  fi
}
#------------------------------------------------------------

#Find OS user and group for TARGET_SERVER_NAME
OSGROUP=`id -gn $OSUSER`

#Change $tmp_loc owner
chown -R $OSUSER:$OSGROUP $tmp_loc
chown $OSUSER:$OSGROUP $MANIFEST_FILE_LOC


#Tempfiles, variables
UNMNT_SRC_MF="$tmp_loc/UNMOUNT_SOURCE"
UNMNT_UNWNT_MF="$tmp_loc/UNMOUNT_UNWNT"
MF_DETAILS="$tmp_loc/MF_DETAILS"
DB_DETAILS="$tmp_loc/DB_DETAILS"
UNWANTED_DBS=



#get db details before unmount
dbDetails
grep -w $SRC_DBNAME $DB_DETAILS | awk '{print $1" "$4" "$5}' | sort | uniq > $DB_DETAILS.tmp
mv $DB_DETAILS.tmp $DB_DETAILS



#Unmount the databases
srcDB=$SRC_DBNAME
echo "Unmounting $srcDB to $UNMNT_SRC_MF$srcDB"
unmountDB



#copy datafile
srcDFiles=`cat $DB_DETAILS | awk '{print $3}'`
for dbF in $srcDFiles
do
  #mountDbf=$(find $TARGET_MNT_PNT/ -iname $dbF | rev | cut -d"/" -f1 | rev)
  echo "Coping $dbF from $TARGET_MNT_PNT$dbF"
  cp -p $TARGET_MNT_PNT$dbF $dbF
done




#Get manifest file details
set +x
su - $OSUSER -c "isql -U$TARGET_DB_USER -P$TARGET_ESC_PASSWD -S$TARGET_SERVER_NAME -X -e -n -b -w 2000 -o $MF_DETAILS --retserverror" <<EOF
use master
go
mount database all from '$MANIFEST_FILE_LOC' with listonly
go
EOF
retval=$?
set -x

if [ $retval -ne 0 ]; then
  echo "ERRORMSG: failed at mount with listonly step"
  exit 1
fi

echo "Manifest file details: "
cat $MF_DETAILS




#Prepare statement for DBLIST_CMD
db_names=`awk '/database/{flag=1; next} /device/{flag=0} flag' $MF_DETAILS`
for i in $db_names
do
  dbPrefix=act__
  if [ "$i" = "$SRC_DBNAME" ]; then
    dbPrefix=
  fi

  if [ -z "$DBLIST_CMD" ]; then
    DBLIST_CMD="$i as $dbPrefix$i"
  else
    DBLIST_CMD="$DBLIST_CMD,$i as $dbPrefix$i"
  fi

  #Also prepare unwanted db list
  if [ ! -z $dbPrefix ]; then
    UNWANTED_DBS="$UNWANTED_DBS,$dbPrefix$i"
  fi
done
echo "DBLIST_CMD: $DBLIST_CMD"



#Prepare statement for DEV_LIST_CMD
DEV_LIST_CMD=
sed '1,/device/d' $MF_DETAILS | sed "s.'..g" > $MF_DETAILS.txt
while read devDt
do
  phyFile=`echo $devDt | cut -d= -f1|xargs`
  logDev=`echo $devDt | cut -d= -f2 |xargs`
  phyPrefix=$TARGET_MNT_PNT

  for srcDFile in $srcDFiles
  do
    if [ "$phyFile" = "$srcDFile" ]; then
      phyPrefix=
      break
    fi
  done

  if [ "$DEV_LIST_CMD" = "" ]; then
    DEV_LIST_CMD="$logDev as '$phyPrefix$phyFile'"
  else
    DEV_LIST_CMD="$DEV_LIST_CMD,$logDev as '$phyPrefix$phyFile'"
  fi
done < $MF_DETAILS.txt
echo "DEV_LIST_CMD: $DEV_LIST_CMD"
echo
echo




#mount database
echo -e "Command: \n mount database \n $DBLIST_CMD \n from '$MANIFEST_FILE_LOC' \n using \n $DEV_LIST_CMD "
set +x
su - $OSUSER -c "isql -U$TARGET_DB_USER -P$TARGET_ESC_PASSWD -S$TARGET_SERVER_NAME -X --retserverror" <<EOF
use master
go
mount database $DBLIST_CMD from '$MANIFEST_FILE_LOC' using $DEV_LIST_CMD
go
EOF
retval=$?
set -x

if [ $retval -ne 0 ]; then
  echo "ERRORMSG: fail to mount databases"
  exit 1
fi





#Recover database if needed
if [ "$LOG_RECOVERY" = "YES" ]; then
  SYBASERESTORECONFIG=/act/scripts/act_sybase_lvm_restore_config.conf

  cat /act/scripts/act_sybase_lvm_singledb_restore_config.conf > /act/scripts/act_sybase_lvm_restore_config.conf


  echo -e "LOG_BKP_MNTPT='$LOG_BKP_MNTPT'" >> $SYBASERESTORECONFIG
  #echo -e "MANIFEST_FILE_LOC='/$MANIFEST_FILE_LOC'" >> $SYBASERESTORECONFIG
  echo -e "LOG_RECOVERY='$LOG_RECOVERY'" >> $SYBASERESTORECONFIG
  echo -e "UNTIL_TIME='$UNTIL_TIME'" >> $SYBASERESTORECONFIG
  echo -e "TARGET_MNT_PNT='$TARGET_MNT_PNT'" >> $SYBASERESTORECONFIG
  echo -e "DATABASE_NAME='$SRC_DBNAME'" >> $SYBASERESTORECONFIG

  chmod -R 755 $SYBASERESTORECONFIG

  touch /var/act/log/UDSAgent-"$TARGET_SERVER_NAME"_recovery.log
  chmod 777 /var/act/log/UDSAgent-"$TARGET_SERVER_NAME"_recovery.log
  touch /var/act/log/UDSAgent-trans_log_sql.log
  chmod 777 /var/act/log/UDSAgent-trans_log_sql.log

  cp -r /act/act_scripts/sybase/automation/Restore/act_sybase_logrecovery.sh /act/scripts/
  chmod -R 755 /act/scripts/act_sybase_logrecovery.sh
  echo $TARGET_DBUSER_PASSWD | su - $OSUSER -c "/act/scripts/act_sybase_logrecovery.sh"
  retval=$?
  chmod 644 /var/act/log/UDSAgent-"$TARGET_SERVER_NAME"_recovery.log
  chmod 644 /var/act/log/UDSAgent-trans_log_sql.log
  if [ $retval -gt 0 ]; then
    echo "***** ERRORMSG: Error when applying log Recovery *****"
    exit 1
  fi
fi





sleep 30
#online database
set +x
su - $OSUSER -c "isql -U$TARGET_DB_USER -P$TARGET_ESC_PASSWD -S$TARGET_SERVER_NAME -X --retserverror" <<EOF
use master
go
online database $SRC_DBNAME
go
EOF
retval=$?
set -x

if [ $retval -gt 0 ]; then
  echo "ERRORMSG: Online database command failed!."
  exit 1
fi



#Remove temp files
if [ ! -z $ACT_JOBNAME ]; then
  rm -rf /act/touch/$ACT_JOBNAME
fi

exit 0
